/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.eventbalg.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.eventbalg.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.MULTI_COMMENT; break;
                                case 0: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.FORMULA; break;
                                case 4: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.MULTI_COMMENT; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.LABEL; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.LABEL; break;
                            }
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.FORMULA; break;
                                case 2: state = State.FORMULA; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.FORMULA; break;
                            }
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TCommentStart(text, line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TMultiCommentStart(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TMultiCommentBody(text, line, pos); }
    Token new5(  int line,   int pos) { return new TStar(line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TSlash(text, line, pos); }
    Token new7(  String text,   int line,   int pos) { return new TMultiCommentEnd(text, line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TAt(text, line, pos); }
    Token new9(  int line,   int pos) { return new TComma(line, pos); }
    Token new10(  int line,   int pos) { return new TParanl(line, pos); }
    Token new11(  int line,   int pos) { return new TParanr(line, pos); }
    Token new12(  int line,   int pos) { return new TReturns(line, pos); }
    Token new13(  int line,   int pos) { return new TColon(line, pos); }
    Token new14(  int line,   int pos) { return new TSemicolon(line, pos); }
    Token new15(  String text,   int line,   int pos) { return new TBcmeq(text, line, pos); }
    Token new16(  int line,   int pos) { return new TEqual(line, pos); }
    Token new17(  int line,   int pos) { return new TOrdinary(line, pos); }
    Token new18(  int line,   int pos) { return new TConvergent(line, pos); }
    Token new19(  int line,   int pos) { return new TAnticipated(line, pos); }
    Token new20(  int line,   int pos) { return new TMachine(line, pos); }
    Token new21(  int line,   int pos) { return new TRefines(line, pos); }
    Token new22(  int line,   int pos) { return new TSees(line, pos); }
    Token new23(  int line,   int pos) { return new TVariables(line, pos); }
    Token new24(  int line,   int pos) { return new TInvariants(line, pos); }
    Token new25(  int line,   int pos) { return new TTheorem(line, pos); }
    Token new26(  int line,   int pos) { return new TEvents(line, pos); }
    Token new27(  int line,   int pos) { return new TVariant(line, pos); }
    Token new28(  int line,   int pos) { return new TInvariant(line, pos); }
    Token new29(  int line,   int pos) { return new TEnd(line, pos); }
    Token new30(  int line,   int pos) { return new TContext(line, pos); }
    Token new31(  int line,   int pos) { return new TExtends(line, pos); }
    Token new32(  int line,   int pos) { return new TSets(line, pos); }
    Token new33(  int line,   int pos) { return new TConstants(line, pos); }
    Token new34(  int line,   int pos) { return new TAxioms(line, pos); }
    Token new35(  int line,   int pos) { return new TEvent(line, pos); }
    Token new36(  int line,   int pos) { return new TAny(line, pos); }
    Token new37(  String text,   int line,   int pos) { return new TWhere(text, line, pos); }
    Token new38(  int line,   int pos) { return new TWith(line, pos); }
    Token new39(  String text,   int line,   int pos) { return new TThen(text, line, pos); }
    Token new40(  int line,   int pos) { return new TDo(line, pos); }
    Token new41(  int line,   int pos) { return new TAssert(line, pos); }
    Token new42(  int line,   int pos) { return new TAssign(line, pos); }
    Token new43(  int line,   int pos) { return new TReturn(line, pos); }
    Token new44(  int line,   int pos) { return new TAlgorithm(line, pos); }
    Token new45(  int line,   int pos) { return new TWhile(line, pos); }
    Token new46(  int line,   int pos) { return new TIf(line, pos); }
    Token new47(  int line,   int pos) { return new TElse(line, pos); }
    Token new48(  int line,   int pos) { return new TProcedure(line, pos); }
    Token new49(  int line,   int pos) { return new TPrecondition(line, pos); }
    Token new50(  int line,   int pos) { return new TPostcondition(line, pos); }
    Token new51(  int line,   int pos) { return new TImplementation(line, pos); }
    Token new52(  int line,   int pos) { return new TTyping(line, pos); }
    Token new53(  String text,   int line,   int pos) { return new TPrimitive(text, line, pos); }
    Token new54(  int line,   int pos) { return new TVar(line, pos); }
    Token new55(  int line,   int pos) { return new TType(line, pos); }
    Token new56(  int line,   int pos) { return new TInit(line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TLabel(text, line, pos); }
    Token new59(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TFormula(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {40, 40, 3}, {41, 41, 4}, {44, 44, 5}, {47, 47, 6}, {58, 58, 7}, {59, 59, 8}, {61, 61, 9}, {64, 64, 10}, {65, 65, 11}, {66, 66, 12}, {67, 72, 11}, {73, 73, 13}, {74, 77, 11}, {78, 78, 14}, {79, 90, 11}, {95, 95, 15}, {97, 97, 16}, {98, 98, 17}, {99, 99, 18}, {100, 100, 19}, {101, 101, 20}, {102, 104, 21}, {105, 105, 22}, {106, 108, 21}, {109, 109, 23}, {110, 110, 21}, {111, 111, 24}, {112, 112, 25}, {113, 113, 21}, {114, 114, 26}, {115, 115, 27}, {116, 116, 28}, {117, 117, 21}, {118, 118, 29}, {119, 119, 30}, {120, 122, 21}, {127, 160, 1}, {170, 170, 31}, {181, 181, 32}, {186, 186, 33}, {192, 214, 34}, {216, 246, 35}, {248, 501, 36}, {506, 535, 37}, {592, 680, 38}, {688, 696, 39}, {699, 705, 40}, {720, 721, 41}, {736, 740, 42}, {890, 890, 43}, {902, 902, 44}, {904, 906, 45}, {908, 908, 46}, {910, 929, 47}, {931, 974, 48}, {976, 982, 49}, {986, 986, 50}, {988, 988, 51}, {990, 990, 52}, {992, 992, 53}, {994, 1011, 54}, {1025, 1036, 55}, {1038, 1103, 56}, {1105, 1116, 57}, {1118, 1153, 58}, {1168, 1220, 59}, {1223, 1224, 60}, {1227, 1228, 61}, {1232, 1259, 62}, {1262, 1269, 63}, {1272, 1273, 64}, {1329, 1366, 65}, {1369, 1369, 66}, {1377, 1415, 67}, {1488, 1514, 68}, {1520, 1522, 69}, {1569, 1594, 70}, {1600, 1610, 71}, {1649, 1719, 72}, {1722, 1726, 73}, {1728, 1742, 74}, {1744, 1747, 75}, {1749, 1749, 76}, {1765, 1766, 77}, {2309, 2361, 78}, {2365, 2365, 79}, {2392, 2401, 80}, {2437, 2444, 81}, {2447, 2448, 82}, {2451, 2472, 83}, {2474, 2480, 84}, {2482, 2482, 85}, {2486, 2489, 86}, {2524, 2525, 87}, {2527, 2529, 88}, {2544, 2545, 89}, {2565, 2570, 90}, {2575, 2576, 91}, {2579, 2600, 92}, {2602, 2608, 93}, {2610, 2611, 94}, {2613, 2614, 95}, {2616, 2617, 96}, {2649, 2652, 97}, {2654, 2654, 98}, {2674, 2676, 99}, {2693, 2699, 100}, {2701, 2701, 101}, {2703, 2705, 102}, {2707, 2728, 103}, {2730, 2736, 104}, {2738, 2739, 105}, {2741, 2745, 106}, {2749, 2749, 107}, {2784, 2784, 108}, {2821, 2828, 109}, {2831, 2832, 110}, {2835, 2856, 111}, {2858, 2864, 112}, {2866, 2867, 113}, {2870, 2873, 114}, {2877, 2877, 115}, {2908, 2909, 116}, {2911, 2913, 117}, {2949, 2954, 118}, {2958, 2960, 119}, {2962, 2965, 120}, {2969, 2970, 121}, {2972, 2972, 122}, {2974, 2975, 123}, {2979, 2980, 124}, {2984, 2986, 125}, {2990, 2997, 126}, {2999, 3001, 127}, {3077, 3084, 128}, {3086, 3088, 129}, {3090, 3112, 130}, {3114, 3123, 131}, {3125, 3129, 132}, {3168, 3169, 133}, {3205, 3212, 134}, {3214, 3216, 135}, {3218, 3240, 136}, {3242, 3251, 137}, {3253, 3257, 138}, {3294, 3294, 139}, {3296, 3297, 140}, {3333, 3340, 141}, {3342, 3344, 142}, {3346, 3368, 143}, {3370, 3385, 144}, {3424, 3425, 145}, {3585, 3630, 146}, {3632, 3632, 147}, {3634, 3635, 148}, {3648, 3654, 149}, {3713, 3714, 150}, {3716, 3716, 151}, {3719, 3720, 152}, {3722, 3722, 153}, {3725, 3725, 154}, {3732, 3735, 155}, {3737, 3743, 156}, {3745, 3747, 157}, {3749, 3749, 158}, {3751, 3751, 159}, {3754, 3755, 160}, {3757, 3758, 161}, {3760, 3760, 162}, {3762, 3763, 163}, {3773, 3773, 164}, {3776, 3780, 165}, {3782, 3782, 166}, {3804, 3805, 167}, {3904, 3911, 168}, {3913, 3945, 169}, {4256, 4293, 170}, {4304, 4342, 171}, {4352, 4441, 172}, {4447, 4514, 173}, {4520, 4601, 174}, {7680, 7835, 175}, {7840, 7929, 176}, {7936, 7957, 177}, {7960, 7965, 178}, {7968, 8005, 179}, {8008, 8013, 180}, {8016, 8023, 181}, {8025, 8025, 182}, {8027, 8027, 183}, {8029, 8029, 184}, {8031, 8061, 185}, {8064, 8116, 186}, {8118, 8124, 187}, {8126, 8126, 188}, {8130, 8132, 189}, {8134, 8140, 190}, {8144, 8147, 191}, {8150, 8155, 192}, {8160, 8172, 193}, {8178, 8180, 194}, {8182, 8188, 195}, {8206, 8207, 1}, {8232, 8233, 1}, {8319, 8319, 196}, {8450, 8450, 197}, {8455, 8455, 198}, {8458, 8467, 199}, {8469, 8469, 200}, {8472, 8477, 201}, {8484, 8484, 202}, {8486, 8486, 203}, {8488, 8488, 204}, {8490, 8497, 205}, {8499, 8504, 206}, {8788, 8788, 207}, {12293, 12293, 208}, {12337, 12341, 209}, {12353, 12436, 210}, {12443, 12446, 211}, {12449, 12538, 212}, {12540, 12542, 213}, {12549, 12588, 214}, {12593, 12686, 215}, {19968, 40869, 216}, {44032, 55203, 217}, {63744, 64045, 218}, {64256, 64262, 219}, {64275, 64279, 220}, {64287, 64296, 221}, {64298, 64310, 222}, {64312, 64316, 223}, {64318, 64318, 224}, {64320, 64321, 225}, {64323, 64324, 226}, {64326, 64433, 227}, {64467, 64829, 228}, {64848, 64911, 229}, {64914, 64967, 230}, {65008, 65019, 231}, {65136, 65138, 232}, {65140, 65140, 233}, {65142, 65276, 234}, {65313, 65338, 235}, {65345, 65370, 236}, {65382, 65470, 237}, {65474, 65479, 238}, {65482, 65487, 239}, {65490, 65495, 240}, {65498, 65500, 241}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8233, -2}, },
            {},
            {},
            {},
            {},
            {{42, 42, 242}, {47, 47, 243}, },
            {{61, 61, 244}, },
            {},
            {{62, 62, 245}, },
            {},
            {{39, 39, 246}, {48, 57, 247}, {65, 90, 248}, {95, 95, 249}, {97, 122, 250}, {170, 170, 251}, {181, 181, 252}, {186, 186, 253}, {192, 214, 254}, {216, 246, 255}, {248, 501, 256}, {506, 535, 257}, {592, 680, 258}, {688, 696, 259}, {699, 705, 260}, {720, 721, 261}, {736, 740, 262}, {890, 890, 263}, {902, 902, 264}, {904, 906, 265}, {908, 908, 266}, {910, 929, 267}, {931, 974, 268}, {976, 982, 269}, {986, 986, 270}, {988, 988, 271}, {990, 990, 272}, {992, 992, 273}, {994, 1011, 274}, {1025, 1036, 275}, {1038, 1103, 276}, {1105, 1116, 277}, {1118, 1153, 278}, {1168, 1220, 279}, {1223, 1224, 280}, {1227, 1228, 281}, {1232, 1259, 282}, {1262, 1269, 283}, {1272, 1273, 284}, {1329, 1366, 285}, {1369, 1369, 286}, {1377, 1415, 287}, {1488, 1514, 288}, {1520, 1522, 289}, {1569, 1594, 290}, {1600, 1610, 291}, {1632, 1641, 292}, {1649, 1719, 293}, {1722, 1726, 294}, {1728, 1742, 295}, {1744, 1747, 296}, {1749, 1749, 297}, {1765, 1766, 298}, {1776, 1785, 299}, {2309, 2361, 300}, {2365, 2365, 301}, {2392, 2401, 302}, {2406, 2415, 303}, {2437, 2444, 304}, {2447, 2448, 305}, {2451, 2472, 306}, {2474, 2480, 307}, {2482, 2482, 308}, {2486, 2489, 309}, {2524, 2525, 310}, {2527, 2529, 311}, {2534, 2543, 312}, {2544, 2545, 313}, {2565, 2570, 314}, {2575, 2576, 315}, {2579, 2600, 316}, {2602, 2608, 317}, {2610, 2611, 318}, {2613, 2614, 319}, {2616, 2617, 320}, {2649, 2652, 321}, {2654, 2654, 322}, {2662, 2671, 323}, {2674, 2676, 324}, {2693, 2699, 325}, {2701, 2701, 326}, {2703, 2705, 327}, {2707, 2728, 328}, {2730, 2736, 329}, {2738, 2739, 330}, {2741, 2745, 331}, {2749, 2749, 332}, {2784, 2784, 333}, {2790, 2799, 334}, {2821, 2828, 335}, {2831, 2832, 336}, {2835, 2856, 337}, {2858, 2864, 338}, {2866, 2867, 339}, {2870, 2873, 340}, {2877, 2877, 341}, {2908, 2909, 342}, {2911, 2913, 343}, {2918, 2927, 344}, {2949, 2954, 345}, {2958, 2960, 346}, {2962, 2965, 347}, {2969, 2970, 348}, {2972, 2972, 349}, {2974, 2975, 350}, {2979, 2980, 351}, {2984, 2986, 352}, {2990, 2997, 353}, {2999, 3001, 354}, {3047, 3055, 355}, {3077, 3084, 356}, {3086, 3088, 357}, {3090, 3112, 358}, {3114, 3123, 359}, {3125, 3129, 360}, {3168, 3169, 361}, {3174, 3183, 362}, {3205, 3212, 363}, {3214, 3216, 364}, {3218, 3240, 365}, {3242, 3251, 366}, {3253, 3257, 367}, {3294, 3294, 368}, {3296, 3297, 369}, {3302, 3311, 370}, {3333, 3340, 371}, {3342, 3344, 372}, {3346, 3368, 373}, {3370, 3385, 374}, {3424, 3425, 375}, {3430, 3439, 376}, {3585, 3630, 377}, {3632, 3632, 378}, {3634, 3635, 379}, {3648, 3654, 380}, {3664, 3673, 381}, {3713, 3714, 382}, {3716, 3716, 383}, {3719, 3720, 384}, {3722, 3722, 385}, {3725, 3725, 386}, {3732, 3735, 387}, {3737, 3743, 388}, {3745, 3747, 389}, {3749, 3749, 390}, {3751, 3751, 391}, {3754, 3755, 392}, {3757, 3758, 393}, {3760, 3760, 394}, {3762, 3763, 395}, {3773, 3773, 396}, {3776, 3780, 397}, {3782, 3782, 398}, {3792, 3801, 399}, {3804, 3805, 400}, {3872, 3881, 401}, {3904, 3911, 402}, {3913, 3945, 403}, {4256, 4293, 404}, {4304, 4342, 405}, {4352, 4441, 406}, {4447, 4514, 407}, {4520, 4601, 408}, {7680, 7835, 409}, {7840, 7929, 410}, {7936, 7957, 411}, {7960, 7965, 412}, {7968, 8005, 413}, {8008, 8013, 414}, {8016, 8023, 415}, {8025, 8025, 416}, {8027, 8027, 417}, {8029, 8029, 418}, {8031, 8061, 419}, {8064, 8116, 420}, {8118, 8124, 421}, {8126, 8126, 422}, {8130, 8132, 423}, {8134, 8140, 424}, {8144, 8147, 425}, {8150, 8155, 426}, {8160, 8172, 427}, {8178, 8180, 428}, {8182, 8188, 429}, {8319, 8319, 430}, {8450, 8450, 431}, {8455, 8455, 432}, {8458, 8467, 433}, {8469, 8469, 434}, {8472, 8477, 435}, {8484, 8484, 436}, {8486, 8486, 437}, {8488, 8488, 438}, {8490, 8497, 439}, {8499, 8504, 440}, {12293, 12293, 441}, {12337, 12341, 442}, {12353, 12436, 443}, {12443, 12446, 444}, {12449, 12538, 445}, {12540, 12542, 446}, {12549, 12588, 447}, {12593, 12686, 448}, {19968, 40869, 449}, {44032, 55203, 450}, {63744, 64045, 451}, {64256, 64262, 452}, {64275, 64279, 453}, {64287, 64296, 454}, {64298, 64310, 455}, {64312, 64316, 456}, {64318, 64318, 457}, {64320, 64321, 458}, {64323, 64324, 459}, {64326, 64433, 460}, {64467, 64829, 461}, {64848, 64911, 462}, {64914, 64967, 463}, {65008, 65019, 464}, {65136, 65138, 465}, {65140, 65140, 466}, {65142, 65276, 467}, {65296, 65305, 468}, {65313, 65338, 469}, {65345, 65370, 470}, {65382, 65470, 471}, {65474, 65479, 472}, {65482, 65487, 473}, {65490, 65495, 474}, {65498, 65500, 475}, },
            {{39, 57, -13}, {65, 78, 248}, {79, 79, 476}, {80, 90, 248}, {95, 65500, -13}, },
            {{39, 57, -13}, {65, 77, 248}, {78, 78, 477}, {79, 90, 248}, {95, 65500, -13}, },
            {{39, 57, -13}, {65, 65, 478}, {66, 90, 248}, {95, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 95, -13}, {97, 107, 250}, {108, 108, 479}, {109, 109, 250}, {110, 110, 480}, {111, 114, 250}, {115, 115, 481}, {116, 119, 250}, {120, 120, 482}, {121, 122, 250}, {170, 65500, -13}, },
            {{39, 95, -13}, {97, 100, 250}, {101, 101, 483}, {102, 122, 250}, {170, 65500, -13}, },
            {{39, 95, -13}, {97, 110, 250}, {111, 111, 484}, {112, 122, 250}, {170, 65500, -13}, },
            {{39, 110, -20}, {111, 111, 485}, {112, 65500, -20}, },
            {{39, 107, -18}, {108, 108, 486}, {109, 109, 250}, {110, 110, 487}, {111, 117, 250}, {118, 118, 488}, {119, 119, 250}, {120, 120, 489}, {121, 65500, -18}, },
            {{39, 65500, -13}, },
            {{39, 95, -13}, {97, 101, 250}, {102, 102, 490}, {103, 108, 250}, {109, 109, 491}, {110, 110, 492}, {111, 122, 250}, {170, 65500, -13}, },
            {{39, 95, -13}, {97, 97, 493}, {98, 122, 250}, {170, 65500, -13}, },
            {{39, 95, -13}, {97, 113, 250}, {114, 114, 494}, {115, 122, 250}, {170, 65500, -13}, },
            {{39, 110, -20}, {111, 111, 495}, {112, 113, 250}, {114, 114, 496}, {115, 65500, -26}, },
            {{39, 100, -19}, {101, 101, 497}, {102, 65500, -19}, },
            {{39, 100, -19}, {101, 101, 498}, {102, 65500, -19}, },
            {{39, 95, -13}, {97, 103, 250}, {104, 104, 499}, {105, 120, 250}, {121, 121, 500}, {122, 122, 250}, {170, 65500, -13}, },
            {{39, 95, -13}, {97, 97, 501}, {98, 65500, -25}, },
            {{39, 103, -30}, {104, 104, 502}, {105, 105, 503}, {106, 122, 250}, {170, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {},
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{32, 32, 504}, },
            {{32, 32, 505}, },
            {},
            {},
            {},
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 78, -14}, {79, 79, 506}, {80, 65500, -14}, },
            {{39, 57, -13}, {65, 83, 248}, {84, 84, 507}, {85, 90, 248}, {95, 65500, -13}, },
            {{39, 83, -479}, {84, 84, 508}, {85, 65500, -479}, },
            {{39, 95, -13}, {97, 102, 250}, {103, 103, 509}, {104, 122, 250}, {170, 65500, -13}, },
            {{39, 95, -13}, {97, 115, 250}, {116, 116, 510}, {117, 120, 250}, {121, 121, 511}, {122, 65500, -30}, },
            {{39, 95, -13}, {97, 114, 250}, {115, 115, 512}, {116, 122, 250}, {170, 65500, -13}, },
            {{39, 95, -13}, {97, 104, 250}, {105, 105, 513}, {106, 65500, -32}, },
            {{39, 102, -481}, {103, 103, 514}, {104, 65500, -481}, },
            {{39, 95, -13}, {97, 109, 250}, {110, 110, 515}, {111, 65500, -24}, },
            {{39, 65500, -13}, },
            {{39, 114, -483}, {115, 115, 516}, {116, 65500, -483}, },
            {{39, 95, -13}, {97, 99, 250}, {100, 100, 517}, {101, 122, 250}, {170, 65500, -13}, },
            {{39, 100, -19}, {101, 101, 518}, {102, 65500, -19}, },
            {{39, 115, -482}, {116, 116, 519}, {117, 122, 250}, {170, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 95, -13}, {97, 111, 250}, {112, 112, 520}, {113, 122, 250}, {170, 65500, -13}, },
            {{39, 104, -484}, {105, 105, 521}, {106, 117, 250}, {118, 118, 522}, {119, 122, 250}, {170, 65500, -13}, },
            {{39, 95, -13}, {97, 98, 250}, {99, 99, 523}, {100, 122, 250}, {170, 65500, -13}, },
            {{39, 99, -489}, {100, 100, 524}, {101, 65500, -489}, },
            {{39, 114, -483}, {115, 115, 525}, {116, 65500, -483}, },
            {{39, 100, -19}, {101, 101, 526}, {102, 110, 250}, {111, 111, 527}, {112, 65500, -20}, },
            {{39, 101, -24}, {102, 102, 528}, {103, 115, 250}, {116, 116, 529}, {117, 65500, -491}, },
            {{39, 100, -19}, {101, 101, 530}, {102, 115, 250}, {116, 116, 531}, {117, 65500, -491}, },
            {{39, 100, -19}, {101, 101, 532}, {102, 65500, -19}, },
            {{39, 111, -493}, {112, 112, 533}, {113, 65500, -493}, },
            {{39, 113, -26}, {114, 114, 534}, {115, 65500, -26}, },
            {{39, 100, -19}, {101, 101, 535}, {102, 104, 250}, {105, 105, 536}, {106, 65500, -32}, },
            {{39, 115, -482}, {116, 116, 537}, {117, 65500, -491}, },
            {{32, 32, 504}, },
            {{32, 32, 505}, },
            {{39, 57, -13}, {65, 75, 248}, {76, 76, 538}, {77, 90, 248}, {95, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 39, 246}, {48, 48, 247}, {49, 49, 539}, {50, 57, 247}, {65, 65500, -13}, },
            {{39, 110, -20}, {111, 111, 540}, {112, 65500, -20}, },
            {{39, 104, -484}, {105, 105, 541}, {106, 65500, -32}, },
            {{39, 65500, -13}, },
            {{39, 100, -19}, {101, 101, 542}, {102, 104, 250}, {105, 105, 543}, {106, 65500, -32}, },
            {{39, 110, -20}, {111, 111, 544}, {112, 65500, -20}, },
            {{39, 104, -484}, {105, 105, 545}, {106, 65500, -32}, },
            {{39, 114, -483}, {115, 115, 546}, {116, 116, 547}, {117, 117, 250}, {118, 118, 548}, {119, 65500, -494}, },
            {{39, 100, -19}, {101, 101, 549}, {102, 65500, -19}, },
            {{39, 65500, -13}, },
            {{39, 109, -486}, {110, 110, 550}, {111, 65500, -24}, },
            {{39, 100, -19}, {101, 101, 551}, {102, 65500, -19}, },
            {{39, 107, -18}, {108, 108, 552}, {109, 122, 250}, {170, 65500, -13}, },
            {{39, 115, -482}, {116, 116, 553}, {117, 65500, -491}, },
            {{39, 95, -13}, {97, 97, 554}, {98, 65500, -25}, },
            {{39, 103, -30}, {104, 104, 555}, {105, 122, 250}, {170, 65500, -13}, },
            {{39, 104, -484}, {105, 105, 556}, {106, 65500, -32}, },
            {{39, 115, -482}, {116, 116, 557}, {117, 65500, -491}, },
            {{39, 98, -495}, {99, 99, 558}, {100, 65500, -495}, },
            {{39, 98, -495}, {99, 99, 559}, {100, 65500, -495}, },
            {{39, 104, -484}, {105, 105, 560}, {106, 65500, -32}, },
            {{39, 95, -13}, {97, 116, 250}, {117, 117, 561}, {118, 122, 250}, {170, 65500, -13}, },
            {{39, 114, -483}, {115, 115, 562}, {116, 65500, -483}, },
            {{39, 114, -483}, {115, 115, 563}, {116, 65500, -483}, },
            {{39, 109, -486}, {110, 110, 564}, {111, 111, 565}, {112, 65500, -20}, },
            {{39, 100, -19}, {101, 101, 566}, {102, 104, 250}, {105, 105, 567}, {106, 65500, -32}, },
            {{39, 104, -484}, {105, 105, 568}, {106, 65500, -32}, },
            {{39, 109, -486}, {110, 110, 569}, {111, 113, 250}, {114, 114, 570}, {115, 65500, -26}, },
            {{39, 107, -18}, {108, 108, 571}, {109, 65500, -522}, },
            {{39, 103, -30}, {104, 104, 572}, {105, 65500, -525}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 113, -26}, {114, 114, 573}, {115, 65500, -26}, },
            {{39, 98, -495}, {99, 99, 574}, {100, 65500, -495}, },
            {{39, 113, -26}, {114, 114, 575}, {115, 65500, -26}, },
            {{39, 102, -481}, {103, 103, 576}, {104, 65500, -481}, },
            {{39, 95, -13}, {97, 108, 250}, {109, 109, 577}, {110, 122, 250}, {170, 65500, -13}, },
            {{39, 109, -486}, {110, 110, 578}, {111, 65500, -24}, },
            {{39, 115, -482}, {116, 116, 579}, {117, 65500, -491}, },
            {{39, 100, -19}, {101, 101, 580}, {102, 65500, -19}, },
            {{39, 100, -19}, {101, 101, 581}, {102, 65500, -19}, },
            {{39, 65500, -13}, },
            {{39, 115, -482}, {116, 116, 582}, {117, 65500, -491}, },
            {{39, 109, -486}, {110, 110, 583}, {111, 65500, -24}, },
            {{39, 100, -19}, {101, 101, 584}, {102, 65500, -19}, },
            {{39, 65500, -13}, },
            {{39, 113, -26}, {114, 114, 585}, {115, 65500, -26}, },
            {{39, 104, -484}, {105, 105, 586}, {106, 65500, -32}, },
            {{39, 109, -486}, {110, 110, 587}, {111, 65500, -24}, },
            {{39, 98, -495}, {99, 99, 588}, {100, 65500, -495}, },
            {{39, 110, -20}, {111, 111, 589}, {112, 65500, -20}, },
            {{39, 100, -19}, {101, 101, 590}, {102, 65500, -19}, },
            {{39, 109, -486}, {110, 110, 591}, {111, 65500, -24}, },
            {{39, 113, -26}, {114, 114, 592}, {115, 65500, -26}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 113, -26}, {114, 114, 593}, {115, 65500, -26}, },
            {{39, 65500, -13}, },
            {{39, 109, -486}, {110, 110, 594}, {111, 65500, -24}, },
            {{39, 95, -13}, {97, 97, 595}, {98, 65500, -25}, },
            {{39, 65500, -13}, },
            {{39, 100, -19}, {101, 101, 596}, {102, 65500, -19}, },
            {{39, 100, -19}, {101, 101, 597}, {102, 65500, -19}, },
            {{39, 65500, -13}, },
            {{39, 104, -484}, {105, 105, 598}, {106, 65500, -32}, },
            {{39, 104, -484}, {105, 105, 599}, {106, 65500, -32}, },
            {{39, 115, -482}, {116, 116, 600}, {117, 65500, -491}, },
            {{39, 109, -486}, {110, 110, 601}, {111, 65500, -24}, },
            {{39, 114, -483}, {115, 115, 602}, {116, 65500, -483}, },
            {{39, 65500, -13}, },
            {{39, 95, -13}, {97, 97, 603}, {98, 65500, -25}, },
            {{39, 95, -13}, {97, 119, 250}, {120, 120, 604}, {121, 65500, -18}, },
            {{39, 113, -26}, {114, 114, 605}, {115, 65500, -26}, },
            {{39, 114, -483}, {115, 115, 606}, {116, 65500, -483}, },
            {{39, 99, -489}, {100, 100, 607}, {101, 65500, -489}, },
            {{39, 108, -546}, {109, 109, 608}, {110, 65500, -546}, },
            {{39, 104, -484}, {105, 105, 609}, {106, 65500, -32}, },
            {{39, 109, -486}, {110, 110, 610}, {111, 65500, -24}, },
            {{39, 95, -13}, {97, 97, 611}, {98, 65500, -25}, },
            {{39, 110, -20}, {111, 111, 612}, {112, 65500, -20}, },
            {{39, 109, -486}, {110, 110, 613}, {111, 65500, -24}, },
            {{39, 99, -489}, {100, 100, 614}, {101, 65500, -489}, },
            {{39, 100, -19}, {101, 101, 615}, {102, 65500, -19}, },
            {{39, 109, -486}, {110, 110, 616}, {111, 65500, -24}, },
            {{39, 100, -19}, {101, 101, 617}, {102, 65500, -19}, },
            {{39, 102, -481}, {103, 103, 618}, {104, 65500, -481}, },
            {{39, 95, -13}, {97, 97, 250}, {98, 98, 619}, {99, 109, 250}, {110, 110, 620}, {111, 65500, -24}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 115, -482}, {116, 116, 621}, {117, 65500, -491}, },
            {{39, 111, -493}, {112, 112, 622}, {113, 65500, -493}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 109, -486}, {110, 110, 623}, {111, 65500, -24}, },
            {{39, 115, -482}, {116, 116, 624}, {117, 65500, -491}, },
            {{39, 102, -481}, {103, 103, 625}, {104, 65500, -481}, },
            {{39, 65500, -13}, },
            {{39, 114, -483}, {115, 115, 626}, {116, 65500, -483}, },
            {{39, 100, -19}, {101, 101, 627}, {102, 65500, -19}, },
            {{39, 95, -13}, {97, 97, 628}, {98, 65500, -25}, },
            {{39, 100, -19}, {101, 101, 629}, {102, 65500, -19}, },
            {{39, 113, -26}, {114, 114, 630}, {115, 65500, -26}, },
            {{39, 109, -486}, {110, 110, 631}, {111, 65500, -24}, },
            {{39, 99, -489}, {100, 100, 632}, {101, 65500, -489}, },
            {{39, 116, -531}, {117, 117, 633}, {118, 65500, -531}, },
            {{39, 114, -483}, {115, 115, 634}, {116, 65500, -483}, },
            {{39, 65500, -13}, },
            {{39, 108, -546}, {109, 109, 635}, {110, 65500, -546}, },
            {{39, 65500, -13}, },
            {{39, 107, -18}, {108, 108, 636}, {109, 65500, -522}, },
            {{39, 115, -482}, {116, 116, 637}, {117, 65500, -491}, },
            {{39, 103, -30}, {104, 104, 638}, {105, 65500, -525}, },
            {{39, 95, -13}, {97, 97, 639}, {98, 65500, -25}, },
            {{39, 115, -482}, {116, 116, 640}, {117, 65500, -491}, },
            {{39, 65500, -13}, },
            {{39, 100, -19}, {101, 101, 641}, {102, 65500, -19}, },
            {{39, 65500, -13}, },
            {{39, 109, -486}, {110, 110, 642}, {111, 65500, -24}, },
            {{39, 109, -486}, {110, 110, 643}, {111, 65500, -24}, },
            {{39, 65500, -13}, },
            {{39, 95, -13}, {97, 120, 250}, {121, 121, 644}, {122, 65500, -30}, },
            {{39, 99, -489}, {100, 100, 645}, {101, 65500, -489}, },
            {{39, 104, -484}, {105, 105, 646}, {106, 65500, -32}, },
            {{39, 113, -26}, {114, 114, 647}, {115, 65500, -26}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 100, -19}, {101, 101, 648}, {102, 65500, -19}, },
            {{39, 65500, -13}, },
            {{39, 108, -546}, {109, 109, 649}, {110, 65500, -546}, },
            {{39, 115, -482}, {116, 116, 650}, {117, 65500, -491}, },
            {{39, 114, -483}, {115, 115, 651}, {116, 65500, -483}, },
            {{39, 109, -486}, {110, 110, 652}, {111, 65500, -24}, },
            {{39, 115, -482}, {116, 116, 653}, {117, 65500, -491}, },
            {{39, 115, -482}, {116, 116, 654}, {117, 65500, -491}, },
            {{39, 65500, -13}, },
            {{39, 104, -484}, {105, 105, 655}, {106, 65500, -32}, },
            {{39, 115, -482}, {116, 116, 656}, {117, 65500, -491}, },
            {{39, 100, -19}, {101, 101, 657}, {102, 65500, -19}, },
            {{39, 114, -483}, {115, 115, 658}, {116, 65500, -483}, },
            {{39, 65500, -13}, },
            {{39, 100, -19}, {101, 101, 659}, {102, 65500, -19}, },
            {{39, 65500, -13}, },
            {{39, 115, -482}, {116, 116, 660}, {117, 65500, -491}, },
            {{39, 95, -13}, {97, 97, 661}, {98, 65500, -25}, },
            {{39, 114, -483}, {115, 115, 662}, {116, 65500, -483}, },
            {{39, 115, -482}, {116, 116, 663}, {117, 65500, -491}, },
            {{39, 104, -484}, {105, 105, 664}, {106, 65500, -32}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
            {{39, 99, -489}, {100, 100, 665}, {101, 65500, -489}, },
            {{39, 65500, -13}, },
            {{39, 115, -482}, {116, 116, 666}, {117, 65500, -491}, },
            {{39, 65500, -13}, },
            {{39, 104, -484}, {105, 105, 667}, {106, 65500, -32}, },
            {{39, 110, -20}, {111, 111, 668}, {112, 65500, -20}, },
            {{39, 65500, -13}, },
            {{39, 104, -484}, {105, 105, 669}, {106, 65500, -32}, },
            {{39, 110, -20}, {111, 111, 670}, {112, 65500, -20}, },
            {{39, 109, -486}, {110, 110, 671}, {111, 65500, -24}, },
            {{39, 110, -20}, {111, 111, 672}, {112, 65500, -20}, },
            {{39, 109, -486}, {110, 110, 673}, {111, 65500, -24}, },
            {{39, 65500, -13}, },
            {{39, 109, -486}, {110, 110, 674}, {111, 65500, -24}, },
            {{39, 65500, -13}, },
            {{39, 65500, -13}, },
        }
        { // FORMULA
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 46, 3}, {47, 47, 4}, {48, 58, 3}, {59, 59, 5}, {60, 63, 3}, {64, 64, 6}, {65, 96, 3}, {97, 97, 7}, {98, 98, 8}, {99, 99, 9}, {100, 100, 10}, {101, 101, 11}, {102, 104, 3}, {105, 105, 12}, {106, 108, 3}, {109, 109, 13}, {110, 110, 3}, {111, 111, 14}, {112, 112, 15}, {113, 113, 3}, {114, 114, 16}, {115, 115, 17}, {116, 116, 18}, {117, 117, 3}, {118, 118, 19}, {119, 119, 20}, {120, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {{33, 46, 3}, {48, 58, 3}, {60, 63, 3}, {65, 126, 3}, {161, 8205, 3}, {8208, 8231, 3}, {8234, 65535, 3}, },
            {{42, 42, 21}, {47, 47, 22}, },
            {},
            {},
            {{33, 63, -5}, {65, 107, 3}, {108, 108, 23}, {109, 109, 3}, {110, 110, 24}, {111, 114, 3}, {115, 115, 25}, {116, 119, 3}, {120, 120, 26}, {121, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 100, 3}, {101, 101, 27}, {102, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 110, 3}, {111, 111, 28}, {112, 126, 3}, {161, 65535, -5}, },
            {{33, 110, -11}, {111, 111, 29}, {112, 65535, -11}, },
            {{33, 107, -9}, {108, 108, 30}, {109, 109, 3}, {110, 110, 31}, {111, 117, 3}, {118, 118, 32}, {119, 119, 3}, {120, 120, 33}, {121, 65535, -9}, },
            {{33, 63, -5}, {65, 101, 3}, {102, 102, 34}, {103, 108, 3}, {109, 109, 35}, {110, 110, 36}, {111, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 96, 3}, {97, 97, 37}, {98, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 113, 3}, {114, 114, 38}, {115, 126, 3}, {161, 65535, -5}, },
            {{33, 110, -11}, {111, 111, 39}, {112, 113, 3}, {114, 114, 40}, {115, 65535, -16}, },
            {{33, 100, -10}, {101, 101, 41}, {102, 65535, -10}, },
            {{33, 100, -10}, {101, 101, 42}, {102, 65535, -10}, },
            {{33, 63, -5}, {65, 103, 3}, {104, 104, 43}, {105, 120, 3}, {121, 121, 44}, {122, 126, 3}, {161, 65535, -5}, },
            {{33, 96, -15}, {97, 97, 45}, {98, 65535, -15}, },
            {{33, 103, -20}, {104, 104, 46}, {105, 105, 47}, {106, 126, 3}, {161, 65535, -5}, },
            {{32, 32, 48}, },
            {{32, 32, 49}, },
            {{33, 63, -5}, {65, 102, 3}, {103, 103, 50}, {104, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 115, 3}, {116, 116, 51}, {117, 120, 3}, {121, 121, 52}, {122, 65535, -20}, },
            {{33, 63, -5}, {65, 114, 3}, {115, 115, 53}, {116, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 104, 3}, {105, 105, 54}, {106, 65535, -22}, },
            {{33, 102, -25}, {103, 103, 55}, {104, 65535, -25}, },
            {{33, 63, -5}, {65, 109, 3}, {110, 110, 56}, {111, 65535, -14}, },
            {{33, 65535, -5}, },
            {{33, 114, -27}, {115, 115, 57}, {116, 65535, -27}, },
            {{33, 63, -5}, {65, 99, 3}, {100, 100, 58}, {101, 126, 3}, {161, 65535, -5}, },
            {{33, 100, -10}, {101, 101, 59}, {102, 65535, -10}, },
            {{33, 115, -26}, {116, 116, 60}, {117, 126, 3}, {161, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 63, -5}, {65, 111, 3}, {112, 112, 61}, {113, 126, 3}, {161, 65535, -5}, },
            {{33, 104, -28}, {105, 105, 62}, {106, 117, 3}, {118, 118, 63}, {119, 126, 3}, {161, 65535, -5}, },
            {{33, 63, -5}, {65, 98, 3}, {99, 99, 64}, {100, 126, 3}, {161, 65535, -5}, },
            {{33, 99, -33}, {100, 100, 65}, {101, 65535, -33}, },
            {{33, 114, -27}, {115, 115, 66}, {116, 65535, -27}, },
            {{33, 100, -10}, {101, 101, 67}, {102, 110, 3}, {111, 111, 68}, {112, 65535, -11}, },
            {{33, 101, -14}, {102, 102, 69}, {103, 115, 3}, {116, 116, 70}, {117, 65535, -35}, },
            {{33, 100, -10}, {101, 101, 71}, {102, 115, 3}, {116, 116, 72}, {117, 65535, -35}, },
            {{33, 100, -10}, {101, 101, 73}, {102, 65535, -10}, },
            {{33, 111, -37}, {112, 112, 74}, {113, 65535, -37}, },
            {{33, 113, -16}, {114, 114, 75}, {115, 65535, -16}, },
            {{33, 100, -10}, {101, 101, 76}, {102, 104, 3}, {105, 105, 77}, {106, 65535, -22}, },
            {{33, 115, -26}, {116, 116, 78}, {117, 65535, -35}, },
            {{32, 32, 48}, },
            {{32, 32, 49}, },
            {{33, 110, -11}, {111, 111, 79}, {112, 65535, -11}, },
            {{33, 104, -28}, {105, 105, 80}, {106, 65535, -22}, },
            {{33, 65535, -5}, },
            {{33, 100, -10}, {101, 101, 81}, {102, 104, 3}, {105, 105, 82}, {106, 65535, -22}, },
            {{33, 110, -11}, {111, 111, 83}, {112, 65535, -11}, },
            {{33, 104, -28}, {105, 105, 84}, {106, 65535, -22}, },
            {{33, 114, -27}, {115, 115, 85}, {116, 116, 86}, {117, 117, 3}, {118, 118, 87}, {119, 65535, -38}, },
            {{33, 100, -10}, {101, 101, 88}, {102, 65535, -10}, },
            {{33, 65535, -5}, },
            {{33, 109, -30}, {110, 110, 89}, {111, 65535, -14}, },
            {{33, 100, -10}, {101, 101, 90}, {102, 65535, -10}, },
            {{33, 107, -9}, {108, 108, 91}, {109, 126, 3}, {161, 65535, -5}, },
            {{33, 115, -26}, {116, 116, 92}, {117, 65535, -35}, },
            {{33, 96, -15}, {97, 97, 93}, {98, 65535, -15}, },
            {{33, 103, -20}, {104, 104, 94}, {105, 126, 3}, {161, 65535, -5}, },
            {{33, 104, -28}, {105, 105, 95}, {106, 65535, -22}, },
            {{33, 115, -26}, {116, 116, 96}, {117, 65535, -35}, },
            {{33, 98, -39}, {99, 99, 97}, {100, 65535, -39}, },
            {{33, 98, -39}, {99, 99, 98}, {100, 65535, -39}, },
            {{33, 104, -28}, {105, 105, 99}, {106, 65535, -22}, },
            {{33, 63, -5}, {65, 116, 3}, {117, 117, 100}, {118, 126, 3}, {161, 65535, -5}, },
            {{33, 114, -27}, {115, 115, 101}, {116, 65535, -27}, },
            {{33, 114, -27}, {115, 115, 102}, {116, 65535, -27}, },
            {{33, 109, -30}, {110, 110, 103}, {111, 111, 104}, {112, 65535, -11}, },
            {{33, 100, -10}, {101, 101, 105}, {102, 104, 3}, {105, 105, 106}, {106, 65535, -22}, },
            {{33, 104, -28}, {105, 105, 107}, {106, 65535, -22}, },
            {{33, 109, -30}, {110, 110, 108}, {111, 113, 3}, {114, 114, 109}, {115, 65535, -16}, },
            {{33, 107, -9}, {108, 108, 110}, {109, 65535, -63}, },
            {{33, 103, -20}, {104, 104, 111}, {105, 65535, -66}, },
            {{33, 113, -16}, {114, 114, 112}, {115, 65535, -16}, },
            {{33, 98, -39}, {99, 99, 113}, {100, 65535, -39}, },
            {{33, 113, -16}, {114, 114, 114}, {115, 65535, -16}, },
            {{33, 102, -25}, {103, 103, 115}, {104, 65535, -25}, },
            {{33, 63, -5}, {65, 108, 3}, {109, 109, 116}, {110, 126, 3}, {161, 65535, -5}, },
            {{33, 109, -30}, {110, 110, 117}, {111, 65535, -14}, },
            {{33, 115, -26}, {116, 116, 118}, {117, 65535, -35}, },
            {{33, 100, -10}, {101, 101, 119}, {102, 65535, -10}, },
            {{33, 100, -10}, {101, 101, 120}, {102, 65535, -10}, },
            {{33, 65535, -5}, },
            {{33, 115, -26}, {116, 116, 121}, {117, 65535, -35}, },
            {{33, 109, -30}, {110, 110, 122}, {111, 65535, -14}, },
            {{33, 100, -10}, {101, 101, 123}, {102, 65535, -10}, },
            {{33, 65535, -5}, },
            {{33, 113, -16}, {114, 114, 124}, {115, 65535, -16}, },
            {{33, 104, -28}, {105, 105, 125}, {106, 65535, -22}, },
            {{33, 109, -30}, {110, 110, 126}, {111, 65535, -14}, },
            {{33, 98, -39}, {99, 99, 127}, {100, 65535, -39}, },
            {{33, 110, -11}, {111, 111, 128}, {112, 65535, -11}, },
            {{33, 100, -10}, {101, 101, 129}, {102, 65535, -10}, },
            {{33, 109, -30}, {110, 110, 130}, {111, 65535, -14}, },
            {{33, 113, -16}, {114, 114, 131}, {115, 65535, -16}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 113, -16}, {114, 114, 132}, {115, 65535, -16}, },
            {{33, 65535, -5}, },
            {{33, 109, -30}, {110, 110, 133}, {111, 65535, -14}, },
            {{33, 96, -15}, {97, 97, 134}, {98, 65535, -15}, },
            {{33, 65535, -5}, },
            {{33, 100, -10}, {101, 101, 135}, {102, 65535, -10}, },
            {{33, 100, -10}, {101, 101, 136}, {102, 65535, -10}, },
            {{33, 65535, -5}, },
            {{33, 104, -28}, {105, 105, 137}, {106, 65535, -22}, },
            {{33, 104, -28}, {105, 105, 138}, {106, 65535, -22}, },
            {{33, 115, -26}, {116, 116, 139}, {117, 65535, -35}, },
            {{33, 109, -30}, {110, 110, 140}, {111, 65535, -14}, },
            {{33, 114, -27}, {115, 115, 141}, {116, 65535, -27}, },
            {{33, 65535, -5}, },
            {{33, 96, -15}, {97, 97, 142}, {98, 65535, -15}, },
            {{33, 63, -5}, {65, 119, 3}, {120, 120, 143}, {121, 65535, -9}, },
            {{33, 113, -16}, {114, 114, 144}, {115, 65535, -16}, },
            {{33, 114, -27}, {115, 115, 145}, {116, 65535, -27}, },
            {{33, 99, -33}, {100, 100, 146}, {101, 65535, -33}, },
            {{33, 108, -85}, {109, 109, 147}, {110, 65535, -85}, },
            {{33, 104, -28}, {105, 105, 148}, {106, 65535, -22}, },
            {{33, 109, -30}, {110, 110, 149}, {111, 65535, -14}, },
            {{33, 96, -15}, {97, 97, 150}, {98, 65535, -15}, },
            {{33, 110, -11}, {111, 111, 151}, {112, 65535, -11}, },
            {{33, 109, -30}, {110, 110, 152}, {111, 65535, -14}, },
            {{33, 99, -33}, {100, 100, 153}, {101, 65535, -33}, },
            {{33, 100, -10}, {101, 101, 154}, {102, 65535, -10}, },
            {{33, 109, -30}, {110, 110, 155}, {111, 65535, -14}, },
            {{33, 100, -10}, {101, 101, 156}, {102, 65535, -10}, },
            {{33, 102, -25}, {103, 103, 157}, {104, 65535, -25}, },
            {{33, 63, -5}, {65, 97, 3}, {98, 98, 158}, {99, 109, 3}, {110, 110, 159}, {111, 65535, -14}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 115, -26}, {116, 116, 160}, {117, 65535, -35}, },
            {{33, 111, -37}, {112, 112, 161}, {113, 65535, -37}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 109, -30}, {110, 110, 162}, {111, 65535, -14}, },
            {{33, 115, -26}, {116, 116, 163}, {117, 65535, -35}, },
            {{33, 102, -25}, {103, 103, 164}, {104, 65535, -25}, },
            {{33, 65535, -5}, },
            {{33, 114, -27}, {115, 115, 165}, {116, 65535, -27}, },
            {{33, 100, -10}, {101, 101, 166}, {102, 65535, -10}, },
            {{33, 96, -15}, {97, 97, 167}, {98, 65535, -15}, },
            {{33, 100, -10}, {101, 101, 168}, {102, 65535, -10}, },
            {{33, 113, -16}, {114, 114, 169}, {115, 65535, -16}, },
            {{33, 109, -30}, {110, 110, 170}, {111, 65535, -14}, },
            {{33, 99, -33}, {100, 100, 171}, {101, 65535, -33}, },
            {{33, 116, -72}, {117, 117, 172}, {118, 65535, -72}, },
            {{33, 114, -27}, {115, 115, 173}, {116, 65535, -27}, },
            {{33, 65535, -5}, },
            {{33, 108, -85}, {109, 109, 174}, {110, 65535, -85}, },
            {{33, 65535, -5}, },
            {{33, 107, -9}, {108, 108, 175}, {109, 65535, -63}, },
            {{33, 115, -26}, {116, 116, 176}, {117, 65535, -35}, },
            {{33, 103, -20}, {104, 104, 177}, {105, 65535, -66}, },
            {{33, 96, -15}, {97, 97, 178}, {98, 65535, -15}, },
            {{33, 115, -26}, {116, 116, 179}, {117, 65535, -35}, },
            {{33, 65535, -5}, },
            {{33, 100, -10}, {101, 101, 180}, {102, 65535, -10}, },
            {{33, 65535, -5}, },
            {{33, 109, -30}, {110, 110, 181}, {111, 65535, -14}, },
            {{33, 109, -30}, {110, 110, 182}, {111, 65535, -14}, },
            {{33, 65535, -5}, },
            {{33, 63, -5}, {65, 120, 3}, {121, 121, 183}, {122, 65535, -20}, },
            {{33, 99, -33}, {100, 100, 184}, {101, 65535, -33}, },
            {{33, 104, -28}, {105, 105, 185}, {106, 65535, -22}, },
            {{33, 113, -16}, {114, 114, 186}, {115, 65535, -16}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 100, -10}, {101, 101, 187}, {102, 65535, -10}, },
            {{33, 65535, -5}, },
            {{33, 108, -85}, {109, 109, 188}, {110, 65535, -85}, },
            {{33, 115, -26}, {116, 116, 189}, {117, 65535, -35}, },
            {{33, 114, -27}, {115, 115, 190}, {116, 65535, -27}, },
            {{33, 109, -30}, {110, 110, 191}, {111, 65535, -14}, },
            {{33, 115, -26}, {116, 116, 192}, {117, 65535, -35}, },
            {{33, 115, -26}, {116, 116, 193}, {117, 65535, -35}, },
            {{33, 65535, -5}, },
            {{33, 104, -28}, {105, 105, 194}, {106, 65535, -22}, },
            {{33, 115, -26}, {116, 116, 195}, {117, 65535, -35}, },
            {{33, 100, -10}, {101, 101, 196}, {102, 65535, -10}, },
            {{33, 114, -27}, {115, 115, 197}, {116, 65535, -27}, },
            {{33, 65535, -5}, },
            {{33, 100, -10}, {101, 101, 198}, {102, 65535, -10}, },
            {{33, 65535, -5}, },
            {{33, 115, -26}, {116, 116, 199}, {117, 65535, -35}, },
            {{33, 96, -15}, {97, 97, 200}, {98, 65535, -15}, },
            {{33, 114, -27}, {115, 115, 201}, {116, 65535, -27}, },
            {{33, 115, -26}, {116, 116, 202}, {117, 65535, -35}, },
            {{33, 104, -28}, {105, 105, 203}, {106, 65535, -22}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
            {{33, 99, -33}, {100, 100, 204}, {101, 65535, -33}, },
            {{33, 65535, -5}, },
            {{33, 115, -26}, {116, 116, 205}, {117, 65535, -35}, },
            {{33, 65535, -5}, },
            {{33, 104, -28}, {105, 105, 206}, {106, 65535, -22}, },
            {{33, 110, -11}, {111, 111, 207}, {112, 65535, -11}, },
            {{33, 65535, -5}, },
            {{33, 104, -28}, {105, 105, 208}, {106, 65535, -22}, },
            {{33, 110, -11}, {111, 111, 209}, {112, 65535, -11}, },
            {{33, 109, -30}, {110, 110, 210}, {111, 65535, -14}, },
            {{33, 110, -11}, {111, 111, 211}, {112, 65535, -11}, },
            {{33, 109, -30}, {110, 110, 212}, {111, 65535, -14}, },
            {{33, 65535, -5}, },
            {{33, 109, -30}, {110, 110, 213}, {111, 65535, -14}, },
            {{33, 65535, -5}, },
            {{33, 65535, -5}, },
        }
        { // LABEL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{10, 10, 3}, {13, 13, 3}, {33, 38, 3}, {39, 39, 4}, {40, 126, 3}, {161, 8205, 3}, {8208, 8231, 3}, {8234, 65535, 3}, },
            {{10, 65535, -4}, },
            {{10, 65535, -4}, },
        }
        { // COMMENT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 65535, 1}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 65535, 1}, },
            {},
        }
        { // MULTI_COMMENT
            {{0, 41, 1}, {42, 42, 2}, {43, 46, 1}, {47, 47, 3}, {48, 65535, 1}, },
            {{0, 41, 1}, {43, 46, 1}, {48, 65535, 1}, },
            {{47, 47, 4}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 59, 59, 10, 11, 9, -1, 13, 14, 16, 8, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 15, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 3, 0, 15, 12, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 40, 57, 57, 57, 57, 46, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 3, 0, 57, 53, 53, 57, 57, 36, 57, 57, 57, 57, 57, 29, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 54, 57, 57, 57, 53, 53, 57, 57, 57, 57, 57, 57, 57, 57, 57, 47, 57, 57, 57, 56, 57, 57, 57, 57, 57, 57, 57, 57, 22, 32, 39, 57, 55, 57, 57, 37, 57, 57, 38, 57, 57, 57, 57, 57, 39, 57, 57, 57, 35, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 57, 37, 45, 57, 57, 41, 42, 34, 57, 57, 57, 26, 57, 57, 57, 57, 57, 57, 57, 57, 57, 43, 57, 52, 57, 57, 57, 57, 57, 30, 57, 31, 57, 57, 20, 57, 57, 57, 57, 21, 25, 57, 27, 57, 57, 57, 57, 57, 57, 17, 57, 57, 57, 57, 44, 57, 33, 57, 57, 28, 57, 57, 48, 23, 57, 18, 57, 24, 57, 57, 19, 57, 57, 57, 57, 57, 49, 57, 50, 51, },
        // FORMULA
        {-1, 59, 59, 60, 6, 14, 8, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 3, 0, 60, 60, 60, 60, 60, 60, 40, 60, 60, 60, 60, 46, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 3, 0, 60, 60, 36, 60, 60, 60, 60, 60, 29, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 47, 60, 60, 60, 56, 60, 60, 60, 60, 60, 60, 60, 60, 22, 32, 39, 60, 55, 60, 60, 37, 60, 60, 38, 60, 60, 60, 60, 60, 39, 60, 60, 60, 35, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 60, 37, 45, 60, 60, 41, 42, 34, 60, 60, 60, 26, 60, 60, 60, 60, 60, 60, 60, 60, 60, 43, 60, 52, 60, 60, 60, 60, 60, 30, 60, 31, 60, 60, 20, 60, 60, 60, 60, 21, 25, 60, 27, 60, 60, 60, 60, 60, 60, 17, 60, 60, 60, 60, 44, 60, 33, 60, 60, 28, 60, 60, 48, 23, 60, 18, 60, 24, 60, 60, 19, 60, 60, 60, 60, 60, 49, 60, 50, 51, },
        // LABEL
        {-1, 59, 58, 58, 58, },
        // COMMENT
        {1, 1, 2, },
        // MULTI_COMMENT
        {4, 4, 5, 6, 7, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State FORMULA = new State(1);
        public final static State LABEL = new State(2);
        public final static State COMMENT = new State(3);
        public final static State MULTI_COMMENT = new State(4);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
