/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.eventbalg.core.parser.parser;

import de.be4.eventbalg.core.parser.lexer.*;
import de.be4.eventbalg.core.parser.node.*;
import de.be4.eventbalg.core.parser.analysis.*;
import java.util.*;
import de.hhu.stups.sablecc.patch.*;


import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings({"rawtypes","unchecked","unused"})
public class Parser implements IParser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList nodeList;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;
    
    private ArrayList firstPopped = null;
    private ArrayList lastPopped = null;
    private ITokenListContainer lex;

    public Parser(  Lexer lexer)
    {
        this.lexer = lexer;
        this.lex = lexer; 
    }
    
     
    private Map<PositionedNode, SourcecodeRange> mapping = new HashMap<PositionedNode, SourcecodeRange>();    
    public Map<PositionedNode, SourcecodeRange> getMapping() { 	return this.mapping; }

   private void checkResult(Object elementToCheck) {
       checkResult(elementToCheck, false);
   }

	 
	private void checkResult(Object elementToCheck, boolean slurp) {
		// nodes with no tokens or sub nodes at all may exist
		if (this.firstPopped == null) {
			return;
		}

		if (elementToCheck instanceof LinkedList) {
			/*
			 * special case: this is a list of nodes, for example an identifier
			 * list, so we don't want to check the list but the last element
			 * added to it
			 */
			final LinkedList nodeList = (LinkedList) elementToCheck;

			if (nodeList.size() > 0) {
				elementToCheck = nodeList.get(nodeList.size() - 1);
			} else {
				// no positions for empty lists...
				return;
			}
		}

		if (!(elementToCheck instanceof PositionedNode)) {
			throw new Error(
					"Unexpected elementToCheck (not instanceof PositionedNode): "
							+ elementToCheck.getClass().getSimpleName() + "/"
							+ elementToCheck);
		}

		if (!this.getMapping().containsKey(elementToCheck) || slurp ) {
			final PositionedNode node = (PositionedNode) elementToCheck;

			// dealing with a one-token element
			if (this.lastPopped == null) {
				this.lastPopped = this.firstPopped;
			}

			final int begin = findBeginPos(this.lastPopped, node);
			int end = findEndPos(this.firstPopped);
			if (end == -1) end = begin;
			final SourcecodeRange range = new SourcecodeRange(begin, end);

			this.getMapping().put(node, range);

			node.setStartPos(createBeginPos(begin));
			node.setEndPos(createEndPos(end));
		}
	}
	
	 
	private int findBeginPos(final ArrayList list,
			PositionedNode n) {
		Object first = list.get(0);
		if (!(first instanceof PositionedNode) && !(first instanceof IToken)) {
			List list2 = (List) first;

			if (list2.size() > 0) {
				first = list2.get(0);
			} else {
				/*
				 * Sometimes (haven't found out why) we get empty list here. In
				 * the only observed cases we were looking for the source range
				 * of the whole parse unit. Then the index is 0.
				 */
				return 0;
			}
		}

		if (first instanceof IToken) {
			return findIndex((IToken) first);
		}

		final PositionedNode node = (PositionedNode) first;
		final SourcecodeRange item = this.getMapping().get(node);
		if (item == null){
			System.err.println(n.getClass().getSimpleName() + " / " + node.getClass().getSimpleName() + ": " + node);
		}
		return item.getBeginIndex();
	}

	 
	private int findEndPos(final ArrayList list) {
		Object last = list.get(list.size() - 1);
		if (!(last instanceof PositionedNode) && !(last instanceof IToken)) {
			final List list2 = (List) last;
			last = list2.get(list2.size() - 1);
		}

		if (last instanceof IToken) {
			return findIndex((IToken) last);
		}

		final PositionedNode node = (PositionedNode) last;
		final SourcecodeRange item = this.getMapping().get(node);
		if (item == null)
			return -1;
		return item.getEndIndex();
	}

	private int findIndex(final IToken token) {
		final List<IToken> list = this.lex.getTokenList();

		for (int i = list.size() - 1; i >= 0; i--) {
			if (list.get(i) == token) {
				return i;
			}
		}

		return -1;
	}

	private SourcePosition createBeginPos(final int index) {
		final List<IToken> list = this.lex.getTokenList();
		final IToken token = list.get(index);
		return new SourcePosition(token.getLine(), token.getPos());
	}

	private SourcePosition createEndPos(final int index) {
		final List<IToken> list = this.lex.getTokenList();
		final IToken token = list.get(index);
		return new SourcePosition(token.getLine(), token.getPos()
				+ token.getText().length());
	}
	     
    private void push(int numstate, ArrayList listNode) throws ParserException, LexerException, IOException
    {
        this.nodeList = listNode;

        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) this.stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private ArrayList pop()
    {
    	ArrayList list = ((State) this.stack.previous()).nodes; 
		if (this.firstPopped == null) {
			this.firstPopped = list;
		} else {
			this.lastPopped = list;
		}
        return list;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }

     
    public Start parse() throws ParserException, LexerException, IOException
    {
    	this.getMapping().clear();
    
        push(0, null);
        List<Node> ign = null;
        while(true)
        {
            while(index(this.lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new LinkedList<Node>();
                }

                ign.add(this.lexer.next());
            }

            if(ign != null)
            {
                this.ignoredTokens.setIn(this.lexer.peek(), ign);
                ign = null;
            }

            this.last_pos = this.lexer.peek().getPos();
            this.last_line = this.lexer.peek().getLine();
            this.last_token = this.lexer.peek();

            int index = index(this.lexer.peek());
            this.action[0] = Parser.actionTable[state()][0][1];
            this.action[1] = Parser.actionTable[state()][0][2];

            int low = 1;
            int high = Parser.actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < Parser.actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > Parser.actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    this.action[0] = Parser.actionTable[state()][middle][1];
                    this.action[1] = Parser.actionTable[state()][middle][2];
                    break;
                }
            }

            switch(this.action[0])
            {
                case SHIFT:
		    {
		        ArrayList list = new ArrayList();
		        list.add(this.lexer.next());
                        push(this.action[1], list);
                    }
		    break;
                case REDUCE:
                    switch(this.action[1])
                    {
                    case 0: /* reduce AMachineParseUnit */
		    {
			ArrayList list = new0();
			push(goTo(0), list);
		    }
		    break;
                    case 1: /* reduce AContextParseUnit */
		    {
			ArrayList list = new1();
			push(goTo(0), list);
		    }
		    break;
                    case 2: /* reduce AProcedureParseUnit */
		    {
			ArrayList list = new2();
			push(goTo(0), list);
		    }
		    break;
                    case 3: /* reduce AAmachine1Machine */
		    {
			ArrayList list = new3();
			push(goTo(1), list);
		    }
		    break;
                    case 4: /* reduce AAmachine2Machine */
		    {
			ArrayList list = new4();
			push(goTo(1), list);
		    }
		    break;
                    case 5: /* reduce AAmachine3Machine */
		    {
			ArrayList list = new5();
			push(goTo(1), list);
		    }
		    break;
                    case 6: /* reduce AAmachine4Machine */
		    {
			ArrayList list = new6();
			push(goTo(1), list);
		    }
		    break;
                    case 7: /* reduce AAmachine5Machine */
		    {
			ArrayList list = new7();
			push(goTo(1), list);
		    }
		    break;
                    case 8: /* reduce AAmachine6Machine */
		    {
			ArrayList list = new8();
			push(goTo(1), list);
		    }
		    break;
                    case 9: /* reduce AAmachine7Machine */
		    {
			ArrayList list = new9();
			push(goTo(1), list);
		    }
		    break;
                    case 10: /* reduce AAmachine8Machine */
		    {
			ArrayList list = new10();
			push(goTo(1), list);
		    }
		    break;
                    case 11: /* reduce AAmachine9Machine */
		    {
			ArrayList list = new11();
			push(goTo(1), list);
		    }
		    break;
                    case 12: /* reduce AAmachine10Machine */
		    {
			ArrayList list = new12();
			push(goTo(1), list);
		    }
		    break;
                    case 13: /* reduce AAmachine11Machine */
		    {
			ArrayList list = new13();
			push(goTo(1), list);
		    }
		    break;
                    case 14: /* reduce AAmachine12Machine */
		    {
			ArrayList list = new14();
			push(goTo(1), list);
		    }
		    break;
                    case 15: /* reduce AAmachine13Machine */
		    {
			ArrayList list = new15();
			push(goTo(1), list);
		    }
		    break;
                    case 16: /* reduce AAmachine14Machine */
		    {
			ArrayList list = new16();
			push(goTo(1), list);
		    }
		    break;
                    case 17: /* reduce AAmachine15Machine */
		    {
			ArrayList list = new17();
			push(goTo(1), list);
		    }
		    break;
                    case 18: /* reduce AAmachine16Machine */
		    {
			ArrayList list = new18();
			push(goTo(1), list);
		    }
		    break;
                    case 19: /* reduce AAmachine17Machine */
		    {
			ArrayList list = new19();
			push(goTo(1), list);
		    }
		    break;
                    case 20: /* reduce AAmachine18Machine */
		    {
			ArrayList list = new20();
			push(goTo(1), list);
		    }
		    break;
                    case 21: /* reduce AAmachine19Machine */
		    {
			ArrayList list = new21();
			push(goTo(1), list);
		    }
		    break;
                    case 22: /* reduce AAmachine20Machine */
		    {
			ArrayList list = new22();
			push(goTo(1), list);
		    }
		    break;
                    case 23: /* reduce AAmachine21Machine */
		    {
			ArrayList list = new23();
			push(goTo(1), list);
		    }
		    break;
                    case 24: /* reduce AAmachine22Machine */
		    {
			ArrayList list = new24();
			push(goTo(1), list);
		    }
		    break;
                    case 25: /* reduce AAmachine23Machine */
		    {
			ArrayList list = new25();
			push(goTo(1), list);
		    }
		    break;
                    case 26: /* reduce AAmachine24Machine */
		    {
			ArrayList list = new26();
			push(goTo(1), list);
		    }
		    break;
                    case 27: /* reduce AAmachine25Machine */
		    {
			ArrayList list = new27();
			push(goTo(1), list);
		    }
		    break;
                    case 28: /* reduce AAmachine26Machine */
		    {
			ArrayList list = new28();
			push(goTo(1), list);
		    }
		    break;
                    case 29: /* reduce AAmachine27Machine */
		    {
			ArrayList list = new29();
			push(goTo(1), list);
		    }
		    break;
                    case 30: /* reduce AAmachine28Machine */
		    {
			ArrayList list = new30();
			push(goTo(1), list);
		    }
		    break;
                    case 31: /* reduce AAmachine29Machine */
		    {
			ArrayList list = new31();
			push(goTo(1), list);
		    }
		    break;
                    case 32: /* reduce AAmachine30Machine */
		    {
			ArrayList list = new32();
			push(goTo(1), list);
		    }
		    break;
                    case 33: /* reduce AAmachine31Machine */
		    {
			ArrayList list = new33();
			push(goTo(1), list);
		    }
		    break;
                    case 34: /* reduce AAmachine32Machine */
		    {
			ArrayList list = new34();
			push(goTo(1), list);
		    }
		    break;
                    case 35: /* reduce AAmachine33Machine */
		    {
			ArrayList list = new35();
			push(goTo(1), list);
		    }
		    break;
                    case 36: /* reduce AAmachine34Machine */
		    {
			ArrayList list = new36();
			push(goTo(1), list);
		    }
		    break;
                    case 37: /* reduce AAmachine35Machine */
		    {
			ArrayList list = new37();
			push(goTo(1), list);
		    }
		    break;
                    case 38: /* reduce AAmachine36Machine */
		    {
			ArrayList list = new38();
			push(goTo(1), list);
		    }
		    break;
                    case 39: /* reduce AAmachine37Machine */
		    {
			ArrayList list = new39();
			push(goTo(1), list);
		    }
		    break;
                    case 40: /* reduce AAmachine38Machine */
		    {
			ArrayList list = new40();
			push(goTo(1), list);
		    }
		    break;
                    case 41: /* reduce AAmachine39Machine */
		    {
			ArrayList list = new41();
			push(goTo(1), list);
		    }
		    break;
                    case 42: /* reduce AAmachine40Machine */
		    {
			ArrayList list = new42();
			push(goTo(1), list);
		    }
		    break;
                    case 43: /* reduce AAmachine41Machine */
		    {
			ArrayList list = new43();
			push(goTo(1), list);
		    }
		    break;
                    case 44: /* reduce AAmachine42Machine */
		    {
			ArrayList list = new44();
			push(goTo(1), list);
		    }
		    break;
                    case 45: /* reduce AAmachine43Machine */
		    {
			ArrayList list = new45();
			push(goTo(1), list);
		    }
		    break;
                    case 46: /* reduce AAmachine44Machine */
		    {
			ArrayList list = new46();
			push(goTo(1), list);
		    }
		    break;
                    case 47: /* reduce AAmachine45Machine */
		    {
			ArrayList list = new47();
			push(goTo(1), list);
		    }
		    break;
                    case 48: /* reduce AAmachine46Machine */
		    {
			ArrayList list = new48();
			push(goTo(1), list);
		    }
		    break;
                    case 49: /* reduce AAmachine47Machine */
		    {
			ArrayList list = new49();
			push(goTo(1), list);
		    }
		    break;
                    case 50: /* reduce AAmachine48Machine */
		    {
			ArrayList list = new50();
			push(goTo(1), list);
		    }
		    break;
                    case 51: /* reduce AAmachine49Machine */
		    {
			ArrayList list = new51();
			push(goTo(1), list);
		    }
		    break;
                    case 52: /* reduce AAmachine50Machine */
		    {
			ArrayList list = new52();
			push(goTo(1), list);
		    }
		    break;
                    case 53: /* reduce AAmachine51Machine */
		    {
			ArrayList list = new53();
			push(goTo(1), list);
		    }
		    break;
                    case 54: /* reduce AAmachine52Machine */
		    {
			ArrayList list = new54();
			push(goTo(1), list);
		    }
		    break;
                    case 55: /* reduce AAmachine53Machine */
		    {
			ArrayList list = new55();
			push(goTo(1), list);
		    }
		    break;
                    case 56: /* reduce AAmachine54Machine */
		    {
			ArrayList list = new56();
			push(goTo(1), list);
		    }
		    break;
                    case 57: /* reduce AAmachine55Machine */
		    {
			ArrayList list = new57();
			push(goTo(1), list);
		    }
		    break;
                    case 58: /* reduce AAmachine56Machine */
		    {
			ArrayList list = new58();
			push(goTo(1), list);
		    }
		    break;
                    case 59: /* reduce AAmachine57Machine */
		    {
			ArrayList list = new59();
			push(goTo(1), list);
		    }
		    break;
                    case 60: /* reduce AAmachine58Machine */
		    {
			ArrayList list = new60();
			push(goTo(1), list);
		    }
		    break;
                    case 61: /* reduce AAmachine59Machine */
		    {
			ArrayList list = new61();
			push(goTo(1), list);
		    }
		    break;
                    case 62: /* reduce AAmachine60Machine */
		    {
			ArrayList list = new62();
			push(goTo(1), list);
		    }
		    break;
                    case 63: /* reduce AAmachine61Machine */
		    {
			ArrayList list = new63();
			push(goTo(1), list);
		    }
		    break;
                    case 64: /* reduce AAmachine62Machine */
		    {
			ArrayList list = new64();
			push(goTo(1), list);
		    }
		    break;
                    case 65: /* reduce AAmachine63Machine */
		    {
			ArrayList list = new65();
			push(goTo(1), list);
		    }
		    break;
                    case 66: /* reduce AAmachine64Machine */
		    {
			ArrayList list = new66();
			push(goTo(1), list);
		    }
		    break;
                    case 67: /* reduce AAmachine65Machine */
		    {
			ArrayList list = new67();
			push(goTo(1), list);
		    }
		    break;
                    case 68: /* reduce AAmachine66Machine */
		    {
			ArrayList list = new68();
			push(goTo(1), list);
		    }
		    break;
                    case 69: /* reduce AAmachine67Machine */
		    {
			ArrayList list = new69();
			push(goTo(1), list);
		    }
		    break;
                    case 70: /* reduce AAmachine68Machine */
		    {
			ArrayList list = new70();
			push(goTo(1), list);
		    }
		    break;
                    case 71: /* reduce AAmachine69Machine */
		    {
			ArrayList list = new71();
			push(goTo(1), list);
		    }
		    break;
                    case 72: /* reduce AAmachine70Machine */
		    {
			ArrayList list = new72();
			push(goTo(1), list);
		    }
		    break;
                    case 73: /* reduce AAmachine71Machine */
		    {
			ArrayList list = new73();
			push(goTo(1), list);
		    }
		    break;
                    case 74: /* reduce AAmachine72Machine */
		    {
			ArrayList list = new74();
			push(goTo(1), list);
		    }
		    break;
                    case 75: /* reduce AAmachine73Machine */
		    {
			ArrayList list = new75();
			push(goTo(1), list);
		    }
		    break;
                    case 76: /* reduce AAmachine74Machine */
		    {
			ArrayList list = new76();
			push(goTo(1), list);
		    }
		    break;
                    case 77: /* reduce AAmachine75Machine */
		    {
			ArrayList list = new77();
			push(goTo(1), list);
		    }
		    break;
                    case 78: /* reduce AAmachine76Machine */
		    {
			ArrayList list = new78();
			push(goTo(1), list);
		    }
		    break;
                    case 79: /* reduce AAmachine77Machine */
		    {
			ArrayList list = new79();
			push(goTo(1), list);
		    }
		    break;
                    case 80: /* reduce AAmachine78Machine */
		    {
			ArrayList list = new80();
			push(goTo(1), list);
		    }
		    break;
                    case 81: /* reduce AAmachine79Machine */
		    {
			ArrayList list = new81();
			push(goTo(1), list);
		    }
		    break;
                    case 82: /* reduce AAmachine80Machine */
		    {
			ArrayList list = new82();
			push(goTo(1), list);
		    }
		    break;
                    case 83: /* reduce AAmachine81Machine */
		    {
			ArrayList list = new83();
			push(goTo(1), list);
		    }
		    break;
                    case 84: /* reduce AAmachine82Machine */
		    {
			ArrayList list = new84();
			push(goTo(1), list);
		    }
		    break;
                    case 85: /* reduce AAmachine83Machine */
		    {
			ArrayList list = new85();
			push(goTo(1), list);
		    }
		    break;
                    case 86: /* reduce AAmachine84Machine */
		    {
			ArrayList list = new86();
			push(goTo(1), list);
		    }
		    break;
                    case 87: /* reduce AAmachine85Machine */
		    {
			ArrayList list = new87();
			push(goTo(1), list);
		    }
		    break;
                    case 88: /* reduce AAmachine86Machine */
		    {
			ArrayList list = new88();
			push(goTo(1), list);
		    }
		    break;
                    case 89: /* reduce AAmachine87Machine */
		    {
			ArrayList list = new89();
			push(goTo(1), list);
		    }
		    break;
                    case 90: /* reduce AAmachine88Machine */
		    {
			ArrayList list = new90();
			push(goTo(1), list);
		    }
		    break;
                    case 91: /* reduce AAmachine89Machine */
		    {
			ArrayList list = new91();
			push(goTo(1), list);
		    }
		    break;
                    case 92: /* reduce AAmachine90Machine */
		    {
			ArrayList list = new92();
			push(goTo(1), list);
		    }
		    break;
                    case 93: /* reduce AAmachine91Machine */
		    {
			ArrayList list = new93();
			push(goTo(1), list);
		    }
		    break;
                    case 94: /* reduce AAmachine92Machine */
		    {
			ArrayList list = new94();
			push(goTo(1), list);
		    }
		    break;
                    case 95: /* reduce AAmachine93Machine */
		    {
			ArrayList list = new95();
			push(goTo(1), list);
		    }
		    break;
                    case 96: /* reduce AAmachine94Machine */
		    {
			ArrayList list = new96();
			push(goTo(1), list);
		    }
		    break;
                    case 97: /* reduce AAmachine95Machine */
		    {
			ArrayList list = new97();
			push(goTo(1), list);
		    }
		    break;
                    case 98: /* reduce AAmachine96Machine */
		    {
			ArrayList list = new98();
			push(goTo(1), list);
		    }
		    break;
                    case 99: /* reduce AAmachine97Machine */
		    {
			ArrayList list = new99();
			push(goTo(1), list);
		    }
		    break;
                    case 100: /* reduce AAmachine98Machine */
		    {
			ArrayList list = new100();
			push(goTo(1), list);
		    }
		    break;
                    case 101: /* reduce AAmachine99Machine */
		    {
			ArrayList list = new101();
			push(goTo(1), list);
		    }
		    break;
                    case 102: /* reduce AAmachine100Machine */
		    {
			ArrayList list = new102();
			push(goTo(1), list);
		    }
		    break;
                    case 103: /* reduce AAmachine101Machine */
		    {
			ArrayList list = new103();
			push(goTo(1), list);
		    }
		    break;
                    case 104: /* reduce AAmachine102Machine */
		    {
			ArrayList list = new104();
			push(goTo(1), list);
		    }
		    break;
                    case 105: /* reduce AAmachine103Machine */
		    {
			ArrayList list = new105();
			push(goTo(1), list);
		    }
		    break;
                    case 106: /* reduce AAmachine104Machine */
		    {
			ArrayList list = new106();
			push(goTo(1), list);
		    }
		    break;
                    case 107: /* reduce AAmachine105Machine */
		    {
			ArrayList list = new107();
			push(goTo(1), list);
		    }
		    break;
                    case 108: /* reduce AAmachine106Machine */
		    {
			ArrayList list = new108();
			push(goTo(1), list);
		    }
		    break;
                    case 109: /* reduce AAmachine107Machine */
		    {
			ArrayList list = new109();
			push(goTo(1), list);
		    }
		    break;
                    case 110: /* reduce AAmachine108Machine */
		    {
			ArrayList list = new110();
			push(goTo(1), list);
		    }
		    break;
                    case 111: /* reduce AAmachine109Machine */
		    {
			ArrayList list = new111();
			push(goTo(1), list);
		    }
		    break;
                    case 112: /* reduce AAmachine110Machine */
		    {
			ArrayList list = new112();
			push(goTo(1), list);
		    }
		    break;
                    case 113: /* reduce AAmachine111Machine */
		    {
			ArrayList list = new113();
			push(goTo(1), list);
		    }
		    break;
                    case 114: /* reduce AAmachine112Machine */
		    {
			ArrayList list = new114();
			push(goTo(1), list);
		    }
		    break;
                    case 115: /* reduce AAmachine113Machine */
		    {
			ArrayList list = new115();
			push(goTo(1), list);
		    }
		    break;
                    case 116: /* reduce AAmachine114Machine */
		    {
			ArrayList list = new116();
			push(goTo(1), list);
		    }
		    break;
                    case 117: /* reduce AAmachine115Machine */
		    {
			ArrayList list = new117();
			push(goTo(1), list);
		    }
		    break;
                    case 118: /* reduce AAmachine116Machine */
		    {
			ArrayList list = new118();
			push(goTo(1), list);
		    }
		    break;
                    case 119: /* reduce AAmachine117Machine */
		    {
			ArrayList list = new119();
			push(goTo(1), list);
		    }
		    break;
                    case 120: /* reduce AAmachine118Machine */
		    {
			ArrayList list = new120();
			push(goTo(1), list);
		    }
		    break;
                    case 121: /* reduce AAmachine119Machine */
		    {
			ArrayList list = new121();
			push(goTo(1), list);
		    }
		    break;
                    case 122: /* reduce AAmachine120Machine */
		    {
			ArrayList list = new122();
			push(goTo(1), list);
		    }
		    break;
                    case 123: /* reduce AAmachine121Machine */
		    {
			ArrayList list = new123();
			push(goTo(1), list);
		    }
		    break;
                    case 124: /* reduce AAmachine122Machine */
		    {
			ArrayList list = new124();
			push(goTo(1), list);
		    }
		    break;
                    case 125: /* reduce AAmachine123Machine */
		    {
			ArrayList list = new125();
			push(goTo(1), list);
		    }
		    break;
                    case 126: /* reduce AAmachine124Machine */
		    {
			ArrayList list = new126();
			push(goTo(1), list);
		    }
		    break;
                    case 127: /* reduce AAmachine125Machine */
		    {
			ArrayList list = new127();
			push(goTo(1), list);
		    }
		    break;
                    case 128: /* reduce AAmachine126Machine */
		    {
			ArrayList list = new128();
			push(goTo(1), list);
		    }
		    break;
                    case 129: /* reduce AAmachine127Machine */
		    {
			ArrayList list = new129();
			push(goTo(1), list);
		    }
		    break;
                    case 130: /* reduce AAmachine128Machine */
		    {
			ArrayList list = new130();
			push(goTo(1), list);
		    }
		    break;
                    case 131: /* reduce AAmachine129Machine */
		    {
			ArrayList list = new131();
			push(goTo(1), list);
		    }
		    break;
                    case 132: /* reduce AAmachine130Machine */
		    {
			ArrayList list = new132();
			push(goTo(1), list);
		    }
		    break;
                    case 133: /* reduce AAmachine131Machine */
		    {
			ArrayList list = new133();
			push(goTo(1), list);
		    }
		    break;
                    case 134: /* reduce AAmachine132Machine */
		    {
			ArrayList list = new134();
			push(goTo(1), list);
		    }
		    break;
                    case 135: /* reduce AAmachine133Machine */
		    {
			ArrayList list = new135();
			push(goTo(1), list);
		    }
		    break;
                    case 136: /* reduce AAmachine134Machine */
		    {
			ArrayList list = new136();
			push(goTo(1), list);
		    }
		    break;
                    case 137: /* reduce AAmachine135Machine */
		    {
			ArrayList list = new137();
			push(goTo(1), list);
		    }
		    break;
                    case 138: /* reduce AAmachine136Machine */
		    {
			ArrayList list = new138();
			push(goTo(1), list);
		    }
		    break;
                    case 139: /* reduce AAmachine137Machine */
		    {
			ArrayList list = new139();
			push(goTo(1), list);
		    }
		    break;
                    case 140: /* reduce AAmachine138Machine */
		    {
			ArrayList list = new140();
			push(goTo(1), list);
		    }
		    break;
                    case 141: /* reduce AAmachine139Machine */
		    {
			ArrayList list = new141();
			push(goTo(1), list);
		    }
		    break;
                    case 142: /* reduce AAmachine140Machine */
		    {
			ArrayList list = new142();
			push(goTo(1), list);
		    }
		    break;
                    case 143: /* reduce AAmachine141Machine */
		    {
			ArrayList list = new143();
			push(goTo(1), list);
		    }
		    break;
                    case 144: /* reduce AAmachine142Machine */
		    {
			ArrayList list = new144();
			push(goTo(1), list);
		    }
		    break;
                    case 145: /* reduce AAmachine143Machine */
		    {
			ArrayList list = new145();
			push(goTo(1), list);
		    }
		    break;
                    case 146: /* reduce AAmachine144Machine */
		    {
			ArrayList list = new146();
			push(goTo(1), list);
		    }
		    break;
                    case 147: /* reduce AAmachine145Machine */
		    {
			ArrayList list = new147();
			push(goTo(1), list);
		    }
		    break;
                    case 148: /* reduce AAmachine146Machine */
		    {
			ArrayList list = new148();
			push(goTo(1), list);
		    }
		    break;
                    case 149: /* reduce AAmachine147Machine */
		    {
			ArrayList list = new149();
			push(goTo(1), list);
		    }
		    break;
                    case 150: /* reduce AAmachine148Machine */
		    {
			ArrayList list = new150();
			push(goTo(1), list);
		    }
		    break;
                    case 151: /* reduce AAmachine149Machine */
		    {
			ArrayList list = new151();
			push(goTo(1), list);
		    }
		    break;
                    case 152: /* reduce AAmachine150Machine */
		    {
			ArrayList list = new152();
			push(goTo(1), list);
		    }
		    break;
                    case 153: /* reduce AAmachine151Machine */
		    {
			ArrayList list = new153();
			push(goTo(1), list);
		    }
		    break;
                    case 154: /* reduce AAmachine152Machine */
		    {
			ArrayList list = new154();
			push(goTo(1), list);
		    }
		    break;
                    case 155: /* reduce AAmachine153Machine */
		    {
			ArrayList list = new155();
			push(goTo(1), list);
		    }
		    break;
                    case 156: /* reduce AAmachine154Machine */
		    {
			ArrayList list = new156();
			push(goTo(1), list);
		    }
		    break;
                    case 157: /* reduce AAmachine155Machine */
		    {
			ArrayList list = new157();
			push(goTo(1), list);
		    }
		    break;
                    case 158: /* reduce AAmachine156Machine */
		    {
			ArrayList list = new158();
			push(goTo(1), list);
		    }
		    break;
                    case 159: /* reduce AAmachine157Machine */
		    {
			ArrayList list = new159();
			push(goTo(1), list);
		    }
		    break;
                    case 160: /* reduce AAmachine158Machine */
		    {
			ArrayList list = new160();
			push(goTo(1), list);
		    }
		    break;
                    case 161: /* reduce AAmachine159Machine */
		    {
			ArrayList list = new161();
			push(goTo(1), list);
		    }
		    break;
                    case 162: /* reduce AAmachine160Machine */
		    {
			ArrayList list = new162();
			push(goTo(1), list);
		    }
		    break;
                    case 163: /* reduce AAmachine161Machine */
		    {
			ArrayList list = new163();
			push(goTo(1), list);
		    }
		    break;
                    case 164: /* reduce AAmachine162Machine */
		    {
			ArrayList list = new164();
			push(goTo(1), list);
		    }
		    break;
                    case 165: /* reduce AAmachine163Machine */
		    {
			ArrayList list = new165();
			push(goTo(1), list);
		    }
		    break;
                    case 166: /* reduce AAmachine164Machine */
		    {
			ArrayList list = new166();
			push(goTo(1), list);
		    }
		    break;
                    case 167: /* reduce AAmachine165Machine */
		    {
			ArrayList list = new167();
			push(goTo(1), list);
		    }
		    break;
                    case 168: /* reduce AAmachine166Machine */
		    {
			ArrayList list = new168();
			push(goTo(1), list);
		    }
		    break;
                    case 169: /* reduce AAmachine167Machine */
		    {
			ArrayList list = new169();
			push(goTo(1), list);
		    }
		    break;
                    case 170: /* reduce AAmachine168Machine */
		    {
			ArrayList list = new170();
			push(goTo(1), list);
		    }
		    break;
                    case 171: /* reduce AAmachine169Machine */
		    {
			ArrayList list = new171();
			push(goTo(1), list);
		    }
		    break;
                    case 172: /* reduce AAmachine170Machine */
		    {
			ArrayList list = new172();
			push(goTo(1), list);
		    }
		    break;
                    case 173: /* reduce AAmachine171Machine */
		    {
			ArrayList list = new173();
			push(goTo(1), list);
		    }
		    break;
                    case 174: /* reduce AAmachine172Machine */
		    {
			ArrayList list = new174();
			push(goTo(1), list);
		    }
		    break;
                    case 175: /* reduce AAmachine173Machine */
		    {
			ArrayList list = new175();
			push(goTo(1), list);
		    }
		    break;
                    case 176: /* reduce AAmachine174Machine */
		    {
			ArrayList list = new176();
			push(goTo(1), list);
		    }
		    break;
                    case 177: /* reduce AAmachine175Machine */
		    {
			ArrayList list = new177();
			push(goTo(1), list);
		    }
		    break;
                    case 178: /* reduce AAmachine176Machine */
		    {
			ArrayList list = new178();
			push(goTo(1), list);
		    }
		    break;
                    case 179: /* reduce AAmachine177Machine */
		    {
			ArrayList list = new179();
			push(goTo(1), list);
		    }
		    break;
                    case 180: /* reduce AAmachine178Machine */
		    {
			ArrayList list = new180();
			push(goTo(1), list);
		    }
		    break;
                    case 181: /* reduce AAmachine179Machine */
		    {
			ArrayList list = new181();
			push(goTo(1), list);
		    }
		    break;
                    case 182: /* reduce AAmachine180Machine */
		    {
			ArrayList list = new182();
			push(goTo(1), list);
		    }
		    break;
                    case 183: /* reduce AAmachine181Machine */
		    {
			ArrayList list = new183();
			push(goTo(1), list);
		    }
		    break;
                    case 184: /* reduce AAmachine182Machine */
		    {
			ArrayList list = new184();
			push(goTo(1), list);
		    }
		    break;
                    case 185: /* reduce AAmachine183Machine */
		    {
			ArrayList list = new185();
			push(goTo(1), list);
		    }
		    break;
                    case 186: /* reduce AAmachine184Machine */
		    {
			ArrayList list = new186();
			push(goTo(1), list);
		    }
		    break;
                    case 187: /* reduce AAmachine185Machine */
		    {
			ArrayList list = new187();
			push(goTo(1), list);
		    }
		    break;
                    case 188: /* reduce AAmachine186Machine */
		    {
			ArrayList list = new188();
			push(goTo(1), list);
		    }
		    break;
                    case 189: /* reduce AAmachine187Machine */
		    {
			ArrayList list = new189();
			push(goTo(1), list);
		    }
		    break;
                    case 190: /* reduce AAmachine188Machine */
		    {
			ArrayList list = new190();
			push(goTo(1), list);
		    }
		    break;
                    case 191: /* reduce AAmachine189Machine */
		    {
			ArrayList list = new191();
			push(goTo(1), list);
		    }
		    break;
                    case 192: /* reduce AAmachine190Machine */
		    {
			ArrayList list = new192();
			push(goTo(1), list);
		    }
		    break;
                    case 193: /* reduce AAmachine191Machine */
		    {
			ArrayList list = new193();
			push(goTo(1), list);
		    }
		    break;
                    case 194: /* reduce AAmachine192Machine */
		    {
			ArrayList list = new194();
			push(goTo(1), list);
		    }
		    break;
                    case 195: /* reduce AAmachine193Machine */
		    {
			ArrayList list = new195();
			push(goTo(1), list);
		    }
		    break;
                    case 196: /* reduce AAmachine194Machine */
		    {
			ArrayList list = new196();
			push(goTo(1), list);
		    }
		    break;
                    case 197: /* reduce AAmachine195Machine */
		    {
			ArrayList list = new197();
			push(goTo(1), list);
		    }
		    break;
                    case 198: /* reduce AAmachine196Machine */
		    {
			ArrayList list = new198();
			push(goTo(1), list);
		    }
		    break;
                    case 199: /* reduce AAmachine197Machine */
		    {
			ArrayList list = new199();
			push(goTo(1), list);
		    }
		    break;
                    case 200: /* reduce AAmachine198Machine */
		    {
			ArrayList list = new200();
			push(goTo(1), list);
		    }
		    break;
                    case 201: /* reduce AAmachine199Machine */
		    {
			ArrayList list = new201();
			push(goTo(1), list);
		    }
		    break;
                    case 202: /* reduce AAmachine200Machine */
		    {
			ArrayList list = new202();
			push(goTo(1), list);
		    }
		    break;
                    case 203: /* reduce AAmachine201Machine */
		    {
			ArrayList list = new203();
			push(goTo(1), list);
		    }
		    break;
                    case 204: /* reduce AAmachine202Machine */
		    {
			ArrayList list = new204();
			push(goTo(1), list);
		    }
		    break;
                    case 205: /* reduce AAmachine203Machine */
		    {
			ArrayList list = new205();
			push(goTo(1), list);
		    }
		    break;
                    case 206: /* reduce AAmachine204Machine */
		    {
			ArrayList list = new206();
			push(goTo(1), list);
		    }
		    break;
                    case 207: /* reduce AAmachine205Machine */
		    {
			ArrayList list = new207();
			push(goTo(1), list);
		    }
		    break;
                    case 208: /* reduce AAmachine206Machine */
		    {
			ArrayList list = new208();
			push(goTo(1), list);
		    }
		    break;
                    case 209: /* reduce AAmachine207Machine */
		    {
			ArrayList list = new209();
			push(goTo(1), list);
		    }
		    break;
                    case 210: /* reduce AAmachine208Machine */
		    {
			ArrayList list = new210();
			push(goTo(1), list);
		    }
		    break;
                    case 211: /* reduce AAmachine209Machine */
		    {
			ArrayList list = new211();
			push(goTo(1), list);
		    }
		    break;
                    case 212: /* reduce AAmachine210Machine */
		    {
			ArrayList list = new212();
			push(goTo(1), list);
		    }
		    break;
                    case 213: /* reduce AAmachine211Machine */
		    {
			ArrayList list = new213();
			push(goTo(1), list);
		    }
		    break;
                    case 214: /* reduce AAmachine212Machine */
		    {
			ArrayList list = new214();
			push(goTo(1), list);
		    }
		    break;
                    case 215: /* reduce AAmachine213Machine */
		    {
			ArrayList list = new215();
			push(goTo(1), list);
		    }
		    break;
                    case 216: /* reduce AAmachine214Machine */
		    {
			ArrayList list = new216();
			push(goTo(1), list);
		    }
		    break;
                    case 217: /* reduce AAmachine215Machine */
		    {
			ArrayList list = new217();
			push(goTo(1), list);
		    }
		    break;
                    case 218: /* reduce AAmachine216Machine */
		    {
			ArrayList list = new218();
			push(goTo(1), list);
		    }
		    break;
                    case 219: /* reduce AAmachine217Machine */
		    {
			ArrayList list = new219();
			push(goTo(1), list);
		    }
		    break;
                    case 220: /* reduce AAmachine218Machine */
		    {
			ArrayList list = new220();
			push(goTo(1), list);
		    }
		    break;
                    case 221: /* reduce AAmachine219Machine */
		    {
			ArrayList list = new221();
			push(goTo(1), list);
		    }
		    break;
                    case 222: /* reduce AAmachine220Machine */
		    {
			ArrayList list = new222();
			push(goTo(1), list);
		    }
		    break;
                    case 223: /* reduce AAmachine221Machine */
		    {
			ArrayList list = new223();
			push(goTo(1), list);
		    }
		    break;
                    case 224: /* reduce AAmachine222Machine */
		    {
			ArrayList list = new224();
			push(goTo(1), list);
		    }
		    break;
                    case 225: /* reduce AAmachine223Machine */
		    {
			ArrayList list = new225();
			push(goTo(1), list);
		    }
		    break;
                    case 226: /* reduce AAmachine224Machine */
		    {
			ArrayList list = new226();
			push(goTo(1), list);
		    }
		    break;
                    case 227: /* reduce AAmachine225Machine */
		    {
			ArrayList list = new227();
			push(goTo(1), list);
		    }
		    break;
                    case 228: /* reduce AAmachine226Machine */
		    {
			ArrayList list = new228();
			push(goTo(1), list);
		    }
		    break;
                    case 229: /* reduce AAmachine227Machine */
		    {
			ArrayList list = new229();
			push(goTo(1), list);
		    }
		    break;
                    case 230: /* reduce AAmachine228Machine */
		    {
			ArrayList list = new230();
			push(goTo(1), list);
		    }
		    break;
                    case 231: /* reduce AAmachine229Machine */
		    {
			ArrayList list = new231();
			push(goTo(1), list);
		    }
		    break;
                    case 232: /* reduce AAmachine230Machine */
		    {
			ArrayList list = new232();
			push(goTo(1), list);
		    }
		    break;
                    case 233: /* reduce AAmachine231Machine */
		    {
			ArrayList list = new233();
			push(goTo(1), list);
		    }
		    break;
                    case 234: /* reduce AAmachine232Machine */
		    {
			ArrayList list = new234();
			push(goTo(1), list);
		    }
		    break;
                    case 235: /* reduce AAmachine233Machine */
		    {
			ArrayList list = new235();
			push(goTo(1), list);
		    }
		    break;
                    case 236: /* reduce AAmachine234Machine */
		    {
			ArrayList list = new236();
			push(goTo(1), list);
		    }
		    break;
                    case 237: /* reduce AAmachine235Machine */
		    {
			ArrayList list = new237();
			push(goTo(1), list);
		    }
		    break;
                    case 238: /* reduce AAmachine236Machine */
		    {
			ArrayList list = new238();
			push(goTo(1), list);
		    }
		    break;
                    case 239: /* reduce AAmachine237Machine */
		    {
			ArrayList list = new239();
			push(goTo(1), list);
		    }
		    break;
                    case 240: /* reduce AAmachine238Machine */
		    {
			ArrayList list = new240();
			push(goTo(1), list);
		    }
		    break;
                    case 241: /* reduce AAmachine239Machine */
		    {
			ArrayList list = new241();
			push(goTo(1), list);
		    }
		    break;
                    case 242: /* reduce AAmachine240Machine */
		    {
			ArrayList list = new242();
			push(goTo(1), list);
		    }
		    break;
                    case 243: /* reduce AAmachine241Machine */
		    {
			ArrayList list = new243();
			push(goTo(1), list);
		    }
		    break;
                    case 244: /* reduce AAmachine242Machine */
		    {
			ArrayList list = new244();
			push(goTo(1), list);
		    }
		    break;
                    case 245: /* reduce AAmachine243Machine */
		    {
			ArrayList list = new245();
			push(goTo(1), list);
		    }
		    break;
                    case 246: /* reduce AAmachine244Machine */
		    {
			ArrayList list = new246();
			push(goTo(1), list);
		    }
		    break;
                    case 247: /* reduce AAmachine245Machine */
		    {
			ArrayList list = new247();
			push(goTo(1), list);
		    }
		    break;
                    case 248: /* reduce AAmachine246Machine */
		    {
			ArrayList list = new248();
			push(goTo(1), list);
		    }
		    break;
                    case 249: /* reduce AAmachine247Machine */
		    {
			ArrayList list = new249();
			push(goTo(1), list);
		    }
		    break;
                    case 250: /* reduce AAmachine248Machine */
		    {
			ArrayList list = new250();
			push(goTo(1), list);
		    }
		    break;
                    case 251: /* reduce AAmachine249Machine */
		    {
			ArrayList list = new251();
			push(goTo(1), list);
		    }
		    break;
                    case 252: /* reduce AAmachine250Machine */
		    {
			ArrayList list = new252();
			push(goTo(1), list);
		    }
		    break;
                    case 253: /* reduce AAmachine251Machine */
		    {
			ArrayList list = new253();
			push(goTo(1), list);
		    }
		    break;
                    case 254: /* reduce AAmachine252Machine */
		    {
			ArrayList list = new254();
			push(goTo(1), list);
		    }
		    break;
                    case 255: /* reduce AAmachine253Machine */
		    {
			ArrayList list = new255();
			push(goTo(1), list);
		    }
		    break;
                    case 256: /* reduce AAmachine254Machine */
		    {
			ArrayList list = new256();
			push(goTo(1), list);
		    }
		    break;
                    case 257: /* reduce AAmachine255Machine */
		    {
			ArrayList list = new257();
			push(goTo(1), list);
		    }
		    break;
                    case 258: /* reduce AAmachine256Machine */
		    {
			ArrayList list = new258();
			push(goTo(1), list);
		    }
		    break;
                    case 259: /* reduce AAmachine257Machine */
		    {
			ArrayList list = new259();
			push(goTo(1), list);
		    }
		    break;
                    case 260: /* reduce AAmachine258Machine */
		    {
			ArrayList list = new260();
			push(goTo(1), list);
		    }
		    break;
                    case 261: /* reduce AAmachine259Machine */
		    {
			ArrayList list = new261();
			push(goTo(1), list);
		    }
		    break;
                    case 262: /* reduce AAmachine260Machine */
		    {
			ArrayList list = new262();
			push(goTo(1), list);
		    }
		    break;
                    case 263: /* reduce AAmachine261Machine */
		    {
			ArrayList list = new263();
			push(goTo(1), list);
		    }
		    break;
                    case 264: /* reduce AAmachine262Machine */
		    {
			ArrayList list = new264();
			push(goTo(1), list);
		    }
		    break;
                    case 265: /* reduce AAmachine263Machine */
		    {
			ArrayList list = new265();
			push(goTo(1), list);
		    }
		    break;
                    case 266: /* reduce AAmachine264Machine */
		    {
			ArrayList list = new266();
			push(goTo(1), list);
		    }
		    break;
                    case 267: /* reduce AAmachine265Machine */
		    {
			ArrayList list = new267();
			push(goTo(1), list);
		    }
		    break;
                    case 268: /* reduce AAmachine266Machine */
		    {
			ArrayList list = new268();
			push(goTo(1), list);
		    }
		    break;
                    case 269: /* reduce AAmachine267Machine */
		    {
			ArrayList list = new269();
			push(goTo(1), list);
		    }
		    break;
                    case 270: /* reduce AAmachine268Machine */
		    {
			ArrayList list = new270();
			push(goTo(1), list);
		    }
		    break;
                    case 271: /* reduce AAmachine269Machine */
		    {
			ArrayList list = new271();
			push(goTo(1), list);
		    }
		    break;
                    case 272: /* reduce AAmachine270Machine */
		    {
			ArrayList list = new272();
			push(goTo(1), list);
		    }
		    break;
                    case 273: /* reduce AAmachine271Machine */
		    {
			ArrayList list = new273();
			push(goTo(1), list);
		    }
		    break;
                    case 274: /* reduce AAmachine272Machine */
		    {
			ArrayList list = new274();
			push(goTo(1), list);
		    }
		    break;
                    case 275: /* reduce AAmachine273Machine */
		    {
			ArrayList list = new275();
			push(goTo(1), list);
		    }
		    break;
                    case 276: /* reduce AAmachine274Machine */
		    {
			ArrayList list = new276();
			push(goTo(1), list);
		    }
		    break;
                    case 277: /* reduce AAmachine275Machine */
		    {
			ArrayList list = new277();
			push(goTo(1), list);
		    }
		    break;
                    case 278: /* reduce AAmachine276Machine */
		    {
			ArrayList list = new278();
			push(goTo(1), list);
		    }
		    break;
                    case 279: /* reduce AAmachine277Machine */
		    {
			ArrayList list = new279();
			push(goTo(1), list);
		    }
		    break;
                    case 280: /* reduce AAmachine278Machine */
		    {
			ArrayList list = new280();
			push(goTo(1), list);
		    }
		    break;
                    case 281: /* reduce AAmachine279Machine */
		    {
			ArrayList list = new281();
			push(goTo(1), list);
		    }
		    break;
                    case 282: /* reduce AAmachine280Machine */
		    {
			ArrayList list = new282();
			push(goTo(1), list);
		    }
		    break;
                    case 283: /* reduce AAmachine281Machine */
		    {
			ArrayList list = new283();
			push(goTo(1), list);
		    }
		    break;
                    case 284: /* reduce AAmachine282Machine */
		    {
			ArrayList list = new284();
			push(goTo(1), list);
		    }
		    break;
                    case 285: /* reduce AAmachine283Machine */
		    {
			ArrayList list = new285();
			push(goTo(1), list);
		    }
		    break;
                    case 286: /* reduce AAmachine284Machine */
		    {
			ArrayList list = new286();
			push(goTo(1), list);
		    }
		    break;
                    case 287: /* reduce AAmachine285Machine */
		    {
			ArrayList list = new287();
			push(goTo(1), list);
		    }
		    break;
                    case 288: /* reduce AAmachine286Machine */
		    {
			ArrayList list = new288();
			push(goTo(1), list);
		    }
		    break;
                    case 289: /* reduce AAmachine287Machine */
		    {
			ArrayList list = new289();
			push(goTo(1), list);
		    }
		    break;
                    case 290: /* reduce AAmachine288Machine */
		    {
			ArrayList list = new290();
			push(goTo(1), list);
		    }
		    break;
                    case 291: /* reduce AAmachine289Machine */
		    {
			ArrayList list = new291();
			push(goTo(1), list);
		    }
		    break;
                    case 292: /* reduce AAmachine290Machine */
		    {
			ArrayList list = new292();
			push(goTo(1), list);
		    }
		    break;
                    case 293: /* reduce AAmachine291Machine */
		    {
			ArrayList list = new293();
			push(goTo(1), list);
		    }
		    break;
                    case 294: /* reduce AAmachine292Machine */
		    {
			ArrayList list = new294();
			push(goTo(1), list);
		    }
		    break;
                    case 295: /* reduce AAmachine293Machine */
		    {
			ArrayList list = new295();
			push(goTo(1), list);
		    }
		    break;
                    case 296: /* reduce AAmachine294Machine */
		    {
			ArrayList list = new296();
			push(goTo(1), list);
		    }
		    break;
                    case 297: /* reduce AAmachine295Machine */
		    {
			ArrayList list = new297();
			push(goTo(1), list);
		    }
		    break;
                    case 298: /* reduce AAmachine296Machine */
		    {
			ArrayList list = new298();
			push(goTo(1), list);
		    }
		    break;
                    case 299: /* reduce AAmachine297Machine */
		    {
			ArrayList list = new299();
			push(goTo(1), list);
		    }
		    break;
                    case 300: /* reduce AAmachine298Machine */
		    {
			ArrayList list = new300();
			push(goTo(1), list);
		    }
		    break;
                    case 301: /* reduce AAmachine299Machine */
		    {
			ArrayList list = new301();
			push(goTo(1), list);
		    }
		    break;
                    case 302: /* reduce AAmachine300Machine */
		    {
			ArrayList list = new302();
			push(goTo(1), list);
		    }
		    break;
                    case 303: /* reduce AAmachine301Machine */
		    {
			ArrayList list = new303();
			push(goTo(1), list);
		    }
		    break;
                    case 304: /* reduce AAmachine302Machine */
		    {
			ArrayList list = new304();
			push(goTo(1), list);
		    }
		    break;
                    case 305: /* reduce AAmachine303Machine */
		    {
			ArrayList list = new305();
			push(goTo(1), list);
		    }
		    break;
                    case 306: /* reduce AAmachine304Machine */
		    {
			ArrayList list = new306();
			push(goTo(1), list);
		    }
		    break;
                    case 307: /* reduce AAmachine305Machine */
		    {
			ArrayList list = new307();
			push(goTo(1), list);
		    }
		    break;
                    case 308: /* reduce AAmachine306Machine */
		    {
			ArrayList list = new308();
			push(goTo(1), list);
		    }
		    break;
                    case 309: /* reduce AAmachine307Machine */
		    {
			ArrayList list = new309();
			push(goTo(1), list);
		    }
		    break;
                    case 310: /* reduce AAmachine308Machine */
		    {
			ArrayList list = new310();
			push(goTo(1), list);
		    }
		    break;
                    case 311: /* reduce AAmachine309Machine */
		    {
			ArrayList list = new311();
			push(goTo(1), list);
		    }
		    break;
                    case 312: /* reduce AAmachine310Machine */
		    {
			ArrayList list = new312();
			push(goTo(1), list);
		    }
		    break;
                    case 313: /* reduce AAmachine311Machine */
		    {
			ArrayList list = new313();
			push(goTo(1), list);
		    }
		    break;
                    case 314: /* reduce AAmachine312Machine */
		    {
			ArrayList list = new314();
			push(goTo(1), list);
		    }
		    break;
                    case 315: /* reduce AAmachine313Machine */
		    {
			ArrayList list = new315();
			push(goTo(1), list);
		    }
		    break;
                    case 316: /* reduce AAmachine314Machine */
		    {
			ArrayList list = new316();
			push(goTo(1), list);
		    }
		    break;
                    case 317: /* reduce AAmachine315Machine */
		    {
			ArrayList list = new317();
			push(goTo(1), list);
		    }
		    break;
                    case 318: /* reduce AAmachine316Machine */
		    {
			ArrayList list = new318();
			push(goTo(1), list);
		    }
		    break;
                    case 319: /* reduce AAmachine317Machine */
		    {
			ArrayList list = new319();
			push(goTo(1), list);
		    }
		    break;
                    case 320: /* reduce AAmachine318Machine */
		    {
			ArrayList list = new320();
			push(goTo(1), list);
		    }
		    break;
                    case 321: /* reduce AAmachine319Machine */
		    {
			ArrayList list = new321();
			push(goTo(1), list);
		    }
		    break;
                    case 322: /* reduce AAmachine320Machine */
		    {
			ArrayList list = new322();
			push(goTo(1), list);
		    }
		    break;
                    case 323: /* reduce AAmachine321Machine */
		    {
			ArrayList list = new323();
			push(goTo(1), list);
		    }
		    break;
                    case 324: /* reduce AAmachine322Machine */
		    {
			ArrayList list = new324();
			push(goTo(1), list);
		    }
		    break;
                    case 325: /* reduce AAmachine323Machine */
		    {
			ArrayList list = new325();
			push(goTo(1), list);
		    }
		    break;
                    case 326: /* reduce AAmachine324Machine */
		    {
			ArrayList list = new326();
			push(goTo(1), list);
		    }
		    break;
                    case 327: /* reduce AAmachine325Machine */
		    {
			ArrayList list = new327();
			push(goTo(1), list);
		    }
		    break;
                    case 328: /* reduce AAmachine326Machine */
		    {
			ArrayList list = new328();
			push(goTo(1), list);
		    }
		    break;
                    case 329: /* reduce AAmachine327Machine */
		    {
			ArrayList list = new329();
			push(goTo(1), list);
		    }
		    break;
                    case 330: /* reduce AAmachine328Machine */
		    {
			ArrayList list = new330();
			push(goTo(1), list);
		    }
		    break;
                    case 331: /* reduce AAmachine329Machine */
		    {
			ArrayList list = new331();
			push(goTo(1), list);
		    }
		    break;
                    case 332: /* reduce AAmachine330Machine */
		    {
			ArrayList list = new332();
			push(goTo(1), list);
		    }
		    break;
                    case 333: /* reduce AAmachine331Machine */
		    {
			ArrayList list = new333();
			push(goTo(1), list);
		    }
		    break;
                    case 334: /* reduce AAmachine332Machine */
		    {
			ArrayList list = new334();
			push(goTo(1), list);
		    }
		    break;
                    case 335: /* reduce AAmachine333Machine */
		    {
			ArrayList list = new335();
			push(goTo(1), list);
		    }
		    break;
                    case 336: /* reduce AAmachine334Machine */
		    {
			ArrayList list = new336();
			push(goTo(1), list);
		    }
		    break;
                    case 337: /* reduce AAmachine335Machine */
		    {
			ArrayList list = new337();
			push(goTo(1), list);
		    }
		    break;
                    case 338: /* reduce AAmachine336Machine */
		    {
			ArrayList list = new338();
			push(goTo(1), list);
		    }
		    break;
                    case 339: /* reduce AAmachine337Machine */
		    {
			ArrayList list = new339();
			push(goTo(1), list);
		    }
		    break;
                    case 340: /* reduce AAmachine338Machine */
		    {
			ArrayList list = new340();
			push(goTo(1), list);
		    }
		    break;
                    case 341: /* reduce AAmachine339Machine */
		    {
			ArrayList list = new341();
			push(goTo(1), list);
		    }
		    break;
                    case 342: /* reduce AAmachine340Machine */
		    {
			ArrayList list = new342();
			push(goTo(1), list);
		    }
		    break;
                    case 343: /* reduce AAmachine341Machine */
		    {
			ArrayList list = new343();
			push(goTo(1), list);
		    }
		    break;
                    case 344: /* reduce AAmachine342Machine */
		    {
			ArrayList list = new344();
			push(goTo(1), list);
		    }
		    break;
                    case 345: /* reduce AAmachine343Machine */
		    {
			ArrayList list = new345();
			push(goTo(1), list);
		    }
		    break;
                    case 346: /* reduce AAmachine344Machine */
		    {
			ArrayList list = new346();
			push(goTo(1), list);
		    }
		    break;
                    case 347: /* reduce AAmachine345Machine */
		    {
			ArrayList list = new347();
			push(goTo(1), list);
		    }
		    break;
                    case 348: /* reduce AAmachine346Machine */
		    {
			ArrayList list = new348();
			push(goTo(1), list);
		    }
		    break;
                    case 349: /* reduce AAmachine347Machine */
		    {
			ArrayList list = new349();
			push(goTo(1), list);
		    }
		    break;
                    case 350: /* reduce AAmachine348Machine */
		    {
			ArrayList list = new350();
			push(goTo(1), list);
		    }
		    break;
                    case 351: /* reduce AAmachine349Machine */
		    {
			ArrayList list = new351();
			push(goTo(1), list);
		    }
		    break;
                    case 352: /* reduce AAmachine350Machine */
		    {
			ArrayList list = new352();
			push(goTo(1), list);
		    }
		    break;
                    case 353: /* reduce AAmachine351Machine */
		    {
			ArrayList list = new353();
			push(goTo(1), list);
		    }
		    break;
                    case 354: /* reduce AAmachine352Machine */
		    {
			ArrayList list = new354();
			push(goTo(1), list);
		    }
		    break;
                    case 355: /* reduce AAmachine353Machine */
		    {
			ArrayList list = new355();
			push(goTo(1), list);
		    }
		    break;
                    case 356: /* reduce AAmachine354Machine */
		    {
			ArrayList list = new356();
			push(goTo(1), list);
		    }
		    break;
                    case 357: /* reduce AAmachine355Machine */
		    {
			ArrayList list = new357();
			push(goTo(1), list);
		    }
		    break;
                    case 358: /* reduce AAmachine356Machine */
		    {
			ArrayList list = new358();
			push(goTo(1), list);
		    }
		    break;
                    case 359: /* reduce AAmachine357Machine */
		    {
			ArrayList list = new359();
			push(goTo(1), list);
		    }
		    break;
                    case 360: /* reduce AAmachine358Machine */
		    {
			ArrayList list = new360();
			push(goTo(1), list);
		    }
		    break;
                    case 361: /* reduce AAmachine359Machine */
		    {
			ArrayList list = new361();
			push(goTo(1), list);
		    }
		    break;
                    case 362: /* reduce AAmachine360Machine */
		    {
			ArrayList list = new362();
			push(goTo(1), list);
		    }
		    break;
                    case 363: /* reduce AAmachine361Machine */
		    {
			ArrayList list = new363();
			push(goTo(1), list);
		    }
		    break;
                    case 364: /* reduce AAmachine362Machine */
		    {
			ArrayList list = new364();
			push(goTo(1), list);
		    }
		    break;
                    case 365: /* reduce AAmachine363Machine */
		    {
			ArrayList list = new365();
			push(goTo(1), list);
		    }
		    break;
                    case 366: /* reduce AAmachine364Machine */
		    {
			ArrayList list = new366();
			push(goTo(1), list);
		    }
		    break;
                    case 367: /* reduce AAmachine365Machine */
		    {
			ArrayList list = new367();
			push(goTo(1), list);
		    }
		    break;
                    case 368: /* reduce AAmachine366Machine */
		    {
			ArrayList list = new368();
			push(goTo(1), list);
		    }
		    break;
                    case 369: /* reduce AAmachine367Machine */
		    {
			ArrayList list = new369();
			push(goTo(1), list);
		    }
		    break;
                    case 370: /* reduce AAmachine368Machine */
		    {
			ArrayList list = new370();
			push(goTo(1), list);
		    }
		    break;
                    case 371: /* reduce AAmachine369Machine */
		    {
			ArrayList list = new371();
			push(goTo(1), list);
		    }
		    break;
                    case 372: /* reduce AAmachine370Machine */
		    {
			ArrayList list = new372();
			push(goTo(1), list);
		    }
		    break;
                    case 373: /* reduce AAmachine371Machine */
		    {
			ArrayList list = new373();
			push(goTo(1), list);
		    }
		    break;
                    case 374: /* reduce AAmachine372Machine */
		    {
			ArrayList list = new374();
			push(goTo(1), list);
		    }
		    break;
                    case 375: /* reduce AAmachine373Machine */
		    {
			ArrayList list = new375();
			push(goTo(1), list);
		    }
		    break;
                    case 376: /* reduce AAmachine374Machine */
		    {
			ArrayList list = new376();
			push(goTo(1), list);
		    }
		    break;
                    case 377: /* reduce AAmachine375Machine */
		    {
			ArrayList list = new377();
			push(goTo(1), list);
		    }
		    break;
                    case 378: /* reduce AAmachine376Machine */
		    {
			ArrayList list = new378();
			push(goTo(1), list);
		    }
		    break;
                    case 379: /* reduce AAmachine377Machine */
		    {
			ArrayList list = new379();
			push(goTo(1), list);
		    }
		    break;
                    case 380: /* reduce AAmachine378Machine */
		    {
			ArrayList list = new380();
			push(goTo(1), list);
		    }
		    break;
                    case 381: /* reduce AAmachine379Machine */
		    {
			ArrayList list = new381();
			push(goTo(1), list);
		    }
		    break;
                    case 382: /* reduce AAmachine380Machine */
		    {
			ArrayList list = new382();
			push(goTo(1), list);
		    }
		    break;
                    case 383: /* reduce AAmachine381Machine */
		    {
			ArrayList list = new383();
			push(goTo(1), list);
		    }
		    break;
                    case 384: /* reduce AAmachine382Machine */
		    {
			ArrayList list = new384();
			push(goTo(1), list);
		    }
		    break;
                    case 385: /* reduce AAmachine383Machine */
		    {
			ArrayList list = new385();
			push(goTo(1), list);
		    }
		    break;
                    case 386: /* reduce AAmachine384Machine */
		    {
			ArrayList list = new386();
			push(goTo(1), list);
		    }
		    break;
                    case 387: /* reduce AAmachine385Machine */
		    {
			ArrayList list = new387();
			push(goTo(1), list);
		    }
		    break;
                    case 388: /* reduce AAmachine386Machine */
		    {
			ArrayList list = new388();
			push(goTo(1), list);
		    }
		    break;
                    case 389: /* reduce AAmachine387Machine */
		    {
			ArrayList list = new389();
			push(goTo(1), list);
		    }
		    break;
                    case 390: /* reduce AAmachine388Machine */
		    {
			ArrayList list = new390();
			push(goTo(1), list);
		    }
		    break;
                    case 391: /* reduce AAmachine389Machine */
		    {
			ArrayList list = new391();
			push(goTo(1), list);
		    }
		    break;
                    case 392: /* reduce AAmachine390Machine */
		    {
			ArrayList list = new392();
			push(goTo(1), list);
		    }
		    break;
                    case 393: /* reduce AAmachine391Machine */
		    {
			ArrayList list = new393();
			push(goTo(1), list);
		    }
		    break;
                    case 394: /* reduce AAmachine392Machine */
		    {
			ArrayList list = new394();
			push(goTo(1), list);
		    }
		    break;
                    case 395: /* reduce AAmachine393Machine */
		    {
			ArrayList list = new395();
			push(goTo(1), list);
		    }
		    break;
                    case 396: /* reduce AAmachine394Machine */
		    {
			ArrayList list = new396();
			push(goTo(1), list);
		    }
		    break;
                    case 397: /* reduce AAmachine395Machine */
		    {
			ArrayList list = new397();
			push(goTo(1), list);
		    }
		    break;
                    case 398: /* reduce AAmachine396Machine */
		    {
			ArrayList list = new398();
			push(goTo(1), list);
		    }
		    break;
                    case 399: /* reduce AAmachine397Machine */
		    {
			ArrayList list = new399();
			push(goTo(1), list);
		    }
		    break;
                    case 400: /* reduce AAmachine398Machine */
		    {
			ArrayList list = new400();
			push(goTo(1), list);
		    }
		    break;
                    case 401: /* reduce AAmachine399Machine */
		    {
			ArrayList list = new401();
			push(goTo(1), list);
		    }
		    break;
                    case 402: /* reduce AAmachine400Machine */
		    {
			ArrayList list = new402();
			push(goTo(1), list);
		    }
		    break;
                    case 403: /* reduce AAmachine401Machine */
		    {
			ArrayList list = new403();
			push(goTo(1), list);
		    }
		    break;
                    case 404: /* reduce AAmachine402Machine */
		    {
			ArrayList list = new404();
			push(goTo(1), list);
		    }
		    break;
                    case 405: /* reduce AAmachine403Machine */
		    {
			ArrayList list = new405();
			push(goTo(1), list);
		    }
		    break;
                    case 406: /* reduce AAmachine404Machine */
		    {
			ArrayList list = new406();
			push(goTo(1), list);
		    }
		    break;
                    case 407: /* reduce AAmachine405Machine */
		    {
			ArrayList list = new407();
			push(goTo(1), list);
		    }
		    break;
                    case 408: /* reduce AAmachine406Machine */
		    {
			ArrayList list = new408();
			push(goTo(1), list);
		    }
		    break;
                    case 409: /* reduce AAmachine407Machine */
		    {
			ArrayList list = new409();
			push(goTo(1), list);
		    }
		    break;
                    case 410: /* reduce AAmachine408Machine */
		    {
			ArrayList list = new410();
			push(goTo(1), list);
		    }
		    break;
                    case 411: /* reduce AAmachine409Machine */
		    {
			ArrayList list = new411();
			push(goTo(1), list);
		    }
		    break;
                    case 412: /* reduce AAmachine410Machine */
		    {
			ArrayList list = new412();
			push(goTo(1), list);
		    }
		    break;
                    case 413: /* reduce AAmachine411Machine */
		    {
			ArrayList list = new413();
			push(goTo(1), list);
		    }
		    break;
                    case 414: /* reduce AAmachine412Machine */
		    {
			ArrayList list = new414();
			push(goTo(1), list);
		    }
		    break;
                    case 415: /* reduce AAmachine413Machine */
		    {
			ArrayList list = new415();
			push(goTo(1), list);
		    }
		    break;
                    case 416: /* reduce AAmachine414Machine */
		    {
			ArrayList list = new416();
			push(goTo(1), list);
		    }
		    break;
                    case 417: /* reduce AAmachine415Machine */
		    {
			ArrayList list = new417();
			push(goTo(1), list);
		    }
		    break;
                    case 418: /* reduce AAmachine416Machine */
		    {
			ArrayList list = new418();
			push(goTo(1), list);
		    }
		    break;
                    case 419: /* reduce AAmachine417Machine */
		    {
			ArrayList list = new419();
			push(goTo(1), list);
		    }
		    break;
                    case 420: /* reduce AAmachine418Machine */
		    {
			ArrayList list = new420();
			push(goTo(1), list);
		    }
		    break;
                    case 421: /* reduce AAmachine419Machine */
		    {
			ArrayList list = new421();
			push(goTo(1), list);
		    }
		    break;
                    case 422: /* reduce AAmachine420Machine */
		    {
			ArrayList list = new422();
			push(goTo(1), list);
		    }
		    break;
                    case 423: /* reduce AAmachine421Machine */
		    {
			ArrayList list = new423();
			push(goTo(1), list);
		    }
		    break;
                    case 424: /* reduce AAmachine422Machine */
		    {
			ArrayList list = new424();
			push(goTo(1), list);
		    }
		    break;
                    case 425: /* reduce AAmachine423Machine */
		    {
			ArrayList list = new425();
			push(goTo(1), list);
		    }
		    break;
                    case 426: /* reduce AAmachine424Machine */
		    {
			ArrayList list = new426();
			push(goTo(1), list);
		    }
		    break;
                    case 427: /* reduce AAmachine425Machine */
		    {
			ArrayList list = new427();
			push(goTo(1), list);
		    }
		    break;
                    case 428: /* reduce AAmachine426Machine */
		    {
			ArrayList list = new428();
			push(goTo(1), list);
		    }
		    break;
                    case 429: /* reduce AAmachine427Machine */
		    {
			ArrayList list = new429();
			push(goTo(1), list);
		    }
		    break;
                    case 430: /* reduce AAmachine428Machine */
		    {
			ArrayList list = new430();
			push(goTo(1), list);
		    }
		    break;
                    case 431: /* reduce AAmachine429Machine */
		    {
			ArrayList list = new431();
			push(goTo(1), list);
		    }
		    break;
                    case 432: /* reduce AAmachine430Machine */
		    {
			ArrayList list = new432();
			push(goTo(1), list);
		    }
		    break;
                    case 433: /* reduce AAmachine431Machine */
		    {
			ArrayList list = new433();
			push(goTo(1), list);
		    }
		    break;
                    case 434: /* reduce AAmachine432Machine */
		    {
			ArrayList list = new434();
			push(goTo(1), list);
		    }
		    break;
                    case 435: /* reduce AAmachine433Machine */
		    {
			ArrayList list = new435();
			push(goTo(1), list);
		    }
		    break;
                    case 436: /* reduce AAmachine434Machine */
		    {
			ArrayList list = new436();
			push(goTo(1), list);
		    }
		    break;
                    case 437: /* reduce AAmachine435Machine */
		    {
			ArrayList list = new437();
			push(goTo(1), list);
		    }
		    break;
                    case 438: /* reduce AAmachine436Machine */
		    {
			ArrayList list = new438();
			push(goTo(1), list);
		    }
		    break;
                    case 439: /* reduce AAmachine437Machine */
		    {
			ArrayList list = new439();
			push(goTo(1), list);
		    }
		    break;
                    case 440: /* reduce AAmachine438Machine */
		    {
			ArrayList list = new440();
			push(goTo(1), list);
		    }
		    break;
                    case 441: /* reduce AAmachine439Machine */
		    {
			ArrayList list = new441();
			push(goTo(1), list);
		    }
		    break;
                    case 442: /* reduce AAmachine440Machine */
		    {
			ArrayList list = new442();
			push(goTo(1), list);
		    }
		    break;
                    case 443: /* reduce AAmachine441Machine */
		    {
			ArrayList list = new443();
			push(goTo(1), list);
		    }
		    break;
                    case 444: /* reduce AAmachine442Machine */
		    {
			ArrayList list = new444();
			push(goTo(1), list);
		    }
		    break;
                    case 445: /* reduce AAmachine443Machine */
		    {
			ArrayList list = new445();
			push(goTo(1), list);
		    }
		    break;
                    case 446: /* reduce AAmachine444Machine */
		    {
			ArrayList list = new446();
			push(goTo(1), list);
		    }
		    break;
                    case 447: /* reduce AAmachine445Machine */
		    {
			ArrayList list = new447();
			push(goTo(1), list);
		    }
		    break;
                    case 448: /* reduce AAmachine446Machine */
		    {
			ArrayList list = new448();
			push(goTo(1), list);
		    }
		    break;
                    case 449: /* reduce AAmachine447Machine */
		    {
			ArrayList list = new449();
			push(goTo(1), list);
		    }
		    break;
                    case 450: /* reduce AAmachine448Machine */
		    {
			ArrayList list = new450();
			push(goTo(1), list);
		    }
		    break;
                    case 451: /* reduce AAmachine449Machine */
		    {
			ArrayList list = new451();
			push(goTo(1), list);
		    }
		    break;
                    case 452: /* reduce AAmachine450Machine */
		    {
			ArrayList list = new452();
			push(goTo(1), list);
		    }
		    break;
                    case 453: /* reduce AAmachine451Machine */
		    {
			ArrayList list = new453();
			push(goTo(1), list);
		    }
		    break;
                    case 454: /* reduce AAmachine452Machine */
		    {
			ArrayList list = new454();
			push(goTo(1), list);
		    }
		    break;
                    case 455: /* reduce AAmachine453Machine */
		    {
			ArrayList list = new455();
			push(goTo(1), list);
		    }
		    break;
                    case 456: /* reduce AAmachine454Machine */
		    {
			ArrayList list = new456();
			push(goTo(1), list);
		    }
		    break;
                    case 457: /* reduce AAmachine455Machine */
		    {
			ArrayList list = new457();
			push(goTo(1), list);
		    }
		    break;
                    case 458: /* reduce AAmachine456Machine */
		    {
			ArrayList list = new458();
			push(goTo(1), list);
		    }
		    break;
                    case 459: /* reduce AAmachine457Machine */
		    {
			ArrayList list = new459();
			push(goTo(1), list);
		    }
		    break;
                    case 460: /* reduce AAmachine458Machine */
		    {
			ArrayList list = new460();
			push(goTo(1), list);
		    }
		    break;
                    case 461: /* reduce AAmachine459Machine */
		    {
			ArrayList list = new461();
			push(goTo(1), list);
		    }
		    break;
                    case 462: /* reduce AAmachine460Machine */
		    {
			ArrayList list = new462();
			push(goTo(1), list);
		    }
		    break;
                    case 463: /* reduce AAmachine461Machine */
		    {
			ArrayList list = new463();
			push(goTo(1), list);
		    }
		    break;
                    case 464: /* reduce AAmachine462Machine */
		    {
			ArrayList list = new464();
			push(goTo(1), list);
		    }
		    break;
                    case 465: /* reduce AAmachine463Machine */
		    {
			ArrayList list = new465();
			push(goTo(1), list);
		    }
		    break;
                    case 466: /* reduce AAmachine464Machine */
		    {
			ArrayList list = new466();
			push(goTo(1), list);
		    }
		    break;
                    case 467: /* reduce AAmachine465Machine */
		    {
			ArrayList list = new467();
			push(goTo(1), list);
		    }
		    break;
                    case 468: /* reduce AAmachine466Machine */
		    {
			ArrayList list = new468();
			push(goTo(1), list);
		    }
		    break;
                    case 469: /* reduce AAmachine467Machine */
		    {
			ArrayList list = new469();
			push(goTo(1), list);
		    }
		    break;
                    case 470: /* reduce AAmachine468Machine */
		    {
			ArrayList list = new470();
			push(goTo(1), list);
		    }
		    break;
                    case 471: /* reduce AAmachine469Machine */
		    {
			ArrayList list = new471();
			push(goTo(1), list);
		    }
		    break;
                    case 472: /* reduce AAmachine470Machine */
		    {
			ArrayList list = new472();
			push(goTo(1), list);
		    }
		    break;
                    case 473: /* reduce AAmachine471Machine */
		    {
			ArrayList list = new473();
			push(goTo(1), list);
		    }
		    break;
                    case 474: /* reduce AAmachine472Machine */
		    {
			ArrayList list = new474();
			push(goTo(1), list);
		    }
		    break;
                    case 475: /* reduce AAmachine473Machine */
		    {
			ArrayList list = new475();
			push(goTo(1), list);
		    }
		    break;
                    case 476: /* reduce AAmachine474Machine */
		    {
			ArrayList list = new476();
			push(goTo(1), list);
		    }
		    break;
                    case 477: /* reduce AAmachine475Machine */
		    {
			ArrayList list = new477();
			push(goTo(1), list);
		    }
		    break;
                    case 478: /* reduce AAmachine476Machine */
		    {
			ArrayList list = new478();
			push(goTo(1), list);
		    }
		    break;
                    case 479: /* reduce AAmachine477Machine */
		    {
			ArrayList list = new479();
			push(goTo(1), list);
		    }
		    break;
                    case 480: /* reduce AAmachine478Machine */
		    {
			ArrayList list = new480();
			push(goTo(1), list);
		    }
		    break;
                    case 481: /* reduce AAmachine479Machine */
		    {
			ArrayList list = new481();
			push(goTo(1), list);
		    }
		    break;
                    case 482: /* reduce AAmachine480Machine */
		    {
			ArrayList list = new482();
			push(goTo(1), list);
		    }
		    break;
                    case 483: /* reduce AAmachine481Machine */
		    {
			ArrayList list = new483();
			push(goTo(1), list);
		    }
		    break;
                    case 484: /* reduce AAmachine482Machine */
		    {
			ArrayList list = new484();
			push(goTo(1), list);
		    }
		    break;
                    case 485: /* reduce AAmachine483Machine */
		    {
			ArrayList list = new485();
			push(goTo(1), list);
		    }
		    break;
                    case 486: /* reduce AAmachine484Machine */
		    {
			ArrayList list = new486();
			push(goTo(1), list);
		    }
		    break;
                    case 487: /* reduce AAmachine485Machine */
		    {
			ArrayList list = new487();
			push(goTo(1), list);
		    }
		    break;
                    case 488: /* reduce AAmachine486Machine */
		    {
			ArrayList list = new488();
			push(goTo(1), list);
		    }
		    break;
                    case 489: /* reduce AAmachine487Machine */
		    {
			ArrayList list = new489();
			push(goTo(1), list);
		    }
		    break;
                    case 490: /* reduce AAmachine488Machine */
		    {
			ArrayList list = new490();
			push(goTo(1), list);
		    }
		    break;
                    case 491: /* reduce AAmachine489Machine */
		    {
			ArrayList list = new491();
			push(goTo(1), list);
		    }
		    break;
                    case 492: /* reduce AAmachine490Machine */
		    {
			ArrayList list = new492();
			push(goTo(1), list);
		    }
		    break;
                    case 493: /* reduce AAmachine491Machine */
		    {
			ArrayList list = new493();
			push(goTo(1), list);
		    }
		    break;
                    case 494: /* reduce AAmachine492Machine */
		    {
			ArrayList list = new494();
			push(goTo(1), list);
		    }
		    break;
                    case 495: /* reduce AAmachine493Machine */
		    {
			ArrayList list = new495();
			push(goTo(1), list);
		    }
		    break;
                    case 496: /* reduce AAmachine494Machine */
		    {
			ArrayList list = new496();
			push(goTo(1), list);
		    }
		    break;
                    case 497: /* reduce AAmachine495Machine */
		    {
			ArrayList list = new497();
			push(goTo(1), list);
		    }
		    break;
                    case 498: /* reduce AAmachine496Machine */
		    {
			ArrayList list = new498();
			push(goTo(1), list);
		    }
		    break;
                    case 499: /* reduce AAmachine497Machine */
		    {
			ArrayList list = new499();
			push(goTo(1), list);
		    }
		    break;
                    case 500: /* reduce AAmachine498Machine */
		    {
			ArrayList list = new500();
			push(goTo(1), list);
		    }
		    break;
                    case 501: /* reduce AAmachine499Machine */
		    {
			ArrayList list = new501();
			push(goTo(1), list);
		    }
		    break;
                    case 502: /* reduce AAmachine500Machine */
		    {
			ArrayList list = new502();
			push(goTo(1), list);
		    }
		    break;
                    case 503: /* reduce AAmachine501Machine */
		    {
			ArrayList list = new503();
			push(goTo(1), list);
		    }
		    break;
                    case 504: /* reduce AAmachine502Machine */
		    {
			ArrayList list = new504();
			push(goTo(1), list);
		    }
		    break;
                    case 505: /* reduce AAmachine503Machine */
		    {
			ArrayList list = new505();
			push(goTo(1), list);
		    }
		    break;
                    case 506: /* reduce AAmachine504Machine */
		    {
			ArrayList list = new506();
			push(goTo(1), list);
		    }
		    break;
                    case 507: /* reduce AAmachine505Machine */
		    {
			ArrayList list = new507();
			push(goTo(1), list);
		    }
		    break;
                    case 508: /* reduce AAmachine506Machine */
		    {
			ArrayList list = new508();
			push(goTo(1), list);
		    }
		    break;
                    case 509: /* reduce AAmachine507Machine */
		    {
			ArrayList list = new509();
			push(goTo(1), list);
		    }
		    break;
                    case 510: /* reduce AAmachine508Machine */
		    {
			ArrayList list = new510();
			push(goTo(1), list);
		    }
		    break;
                    case 511: /* reduce AAmachine509Machine */
		    {
			ArrayList list = new511();
			push(goTo(1), list);
		    }
		    break;
                    case 512: /* reduce AAmachine510Machine */
		    {
			ArrayList list = new512();
			push(goTo(1), list);
		    }
		    break;
                    case 513: /* reduce AAmachine511Machine */
		    {
			ArrayList list = new513();
			push(goTo(1), list);
		    }
		    break;
                    case 514: /* reduce AAmachine512Machine */
		    {
			ArrayList list = new514();
			push(goTo(1), list);
		    }
		    break;
                    case 515: /* reduce AArefinesclause1RefinesClause */
		    {
			ArrayList list = new515();
			push(goTo(2), list);
		    }
		    break;
                    case 516: /* reduce AArefinesclause2RefinesClause */
		    {
			ArrayList list = new516();
			push(goTo(2), list);
		    }
		    break;
                    case 517: /* reduce ARefinesClauseTail */
		    {
			ArrayList list = new517();
			push(goTo(3), list);
		    }
		    break;
                    case 518: /* reduce AAseesclause1SeesClause */
		    {
			ArrayList list = new518();
			push(goTo(4), list);
		    }
		    break;
                    case 519: /* reduce AAseesclause2SeesClause */
		    {
			ArrayList list = new519();
			push(goTo(4), list);
		    }
		    break;
                    case 520: /* reduce ASeesClauseTail */
		    {
			ArrayList list = new520();
			push(goTo(5), list);
		    }
		    break;
                    case 521: /* reduce ASequenceTypedVariables */
		    {
			ArrayList list = new521();
			push(goTo(6), list);
		    }
		    break;
                    case 522: /* reduce ASingleTypedVariables */
		    {
			ArrayList list = new522();
			push(goTo(6), list);
		    }
		    break;
                    case 523: /* reduce AAtypedvariable1TypedVariable */
		    {
			ArrayList list = new523();
			push(goTo(7), list);
		    }
		    break;
                    case 524: /* reduce AAtypedvariable2TypedVariable */
		    {
			ArrayList list = new524();
			push(goTo(7), list);
		    }
		    break;
                    case 525: /* reduce AAtypedvariable3TypedVariable */
		    {
			ArrayList list = new525();
			push(goTo(7), list);
		    }
		    break;
                    case 526: /* reduce AAtypedvariable4TypedVariable */
		    {
			ArrayList list = new526();
			push(goTo(7), list);
		    }
		    break;
                    case 527: /* reduce AAtypedvariable5TypedVariable */
		    {
			ArrayList list = new527();
			push(goTo(7), list);
		    }
		    break;
                    case 528: /* reduce AAtypedvariable6TypedVariable */
		    {
			ArrayList list = new528();
			push(goTo(7), list);
		    }
		    break;
                    case 529: /* reduce AAtypedvariable7TypedVariable */
		    {
			ArrayList list = new529();
			push(goTo(7), list);
		    }
		    break;
                    case 530: /* reduce AAtypedvariable8TypedVariable */
		    {
			ArrayList list = new530();
			push(goTo(7), list);
		    }
		    break;
                    case 531: /* reduce AVariablesClause */
		    {
			ArrayList list = new531();
			push(goTo(8), list);
		    }
		    break;
                    case 532: /* reduce AAsinglevariablelist1VariableList */
		    {
			ArrayList list = new532();
			push(goTo(9), list);
		    }
		    break;
                    case 533: /* reduce AAsinglevariablelist2VariableList */
		    {
			ArrayList list = new533();
			push(goTo(9), list);
		    }
		    break;
                    case 534: /* reduce AAmultivariablelist1VariableList */
		    {
			ArrayList list = new534();
			push(goTo(9), list);
		    }
		    break;
                    case 535: /* reduce AAmultivariablelist2VariableList */
		    {
			ArrayList list = new535();
			push(goTo(9), list);
		    }
		    break;
                    case 536: /* reduce AAinvariantsclause1InvariantsClause */
		    {
			ArrayList list = new536();
			push(goTo(10), list);
		    }
		    break;
                    case 537: /* reduce AAinvariantsclause2InvariantsClause */
		    {
			ArrayList list = new537();
			push(goTo(10), list);
		    }
		    break;
                    case 538: /* reduce AInvariantsTail */
		    {
			ArrayList list = new538();
			push(goTo(11), list);
		    }
		    break;
                    case 539: /* reduce AAinvariant1Invariant */
		    {
			ArrayList list = new539();
			push(goTo(12), list);
		    }
		    break;
                    case 540: /* reduce AAinvariant2Invariant */
		    {
			ArrayList list = new540();
			push(goTo(12), list);
		    }
		    break;
                    case 541: /* reduce AAderivedinvariant1Invariant */
		    {
			ArrayList list = new541();
			push(goTo(12), list);
		    }
		    break;
                    case 542: /* reduce AAderivedinvariant2Invariant */
		    {
			ArrayList list = new542();
			push(goTo(12), list);
		    }
		    break;
                    case 543: /* reduce AAvariantclause1VariantClause */
		    {
			ArrayList list = new543();
			push(goTo(13), list);
		    }
		    break;
                    case 544: /* reduce AAvariantclause2VariantClause */
		    {
			ArrayList list = new544();
			push(goTo(13), list);
		    }
		    break;
                    case 545: /* reduce AAeventsclause1EventsClause */
		    {
			ArrayList list = new545();
			push(goTo(14), list);
		    }
		    break;
                    case 546: /* reduce AAeventsclause2EventsClause */
		    {
			ArrayList list = new546();
			push(goTo(14), list);
		    }
		    break;
                    case 547: /* reduce AEventsTail */
		    {
			ArrayList list = new547();
			push(goTo(15), list);
		    }
		    break;
                    case 548: /* reduce AAevent1Event */
		    {
			ArrayList list = new548();
			push(goTo(16), list);
		    }
		    break;
                    case 549: /* reduce AAevent2Event */
		    {
			ArrayList list = new549();
			push(goTo(16), list);
		    }
		    break;
                    case 550: /* reduce AAevent3Event */
		    {
			ArrayList list = new550();
			push(goTo(16), list);
		    }
		    break;
                    case 551: /* reduce AAevent4Event */
		    {
			ArrayList list = new551();
			push(goTo(16), list);
		    }
		    break;
                    case 552: /* reduce AAevent5Event */
		    {
			ArrayList list = new552();
			push(goTo(16), list);
		    }
		    break;
                    case 553: /* reduce AAevent6Event */
		    {
			ArrayList list = new553();
			push(goTo(16), list);
		    }
		    break;
                    case 554: /* reduce AAevent7Event */
		    {
			ArrayList list = new554();
			push(goTo(16), list);
		    }
		    break;
                    case 555: /* reduce AAevent8Event */
		    {
			ArrayList list = new555();
			push(goTo(16), list);
		    }
		    break;
                    case 556: /* reduce AAevent9Event */
		    {
			ArrayList list = new556();
			push(goTo(16), list);
		    }
		    break;
                    case 557: /* reduce AAevent10Event */
		    {
			ArrayList list = new557();
			push(goTo(16), list);
		    }
		    break;
                    case 558: /* reduce AAevent11Event */
		    {
			ArrayList list = new558();
			push(goTo(16), list);
		    }
		    break;
                    case 559: /* reduce AAevent12Event */
		    {
			ArrayList list = new559();
			push(goTo(16), list);
		    }
		    break;
                    case 560: /* reduce AAevent13Event */
		    {
			ArrayList list = new560();
			push(goTo(16), list);
		    }
		    break;
                    case 561: /* reduce AAevent14Event */
		    {
			ArrayList list = new561();
			push(goTo(16), list);
		    }
		    break;
                    case 562: /* reduce AAevent15Event */
		    {
			ArrayList list = new562();
			push(goTo(16), list);
		    }
		    break;
                    case 563: /* reduce AAevent16Event */
		    {
			ArrayList list = new563();
			push(goTo(16), list);
		    }
		    break;
                    case 564: /* reduce AAevent17Event */
		    {
			ArrayList list = new564();
			push(goTo(16), list);
		    }
		    break;
                    case 565: /* reduce AAevent18Event */
		    {
			ArrayList list = new565();
			push(goTo(16), list);
		    }
		    break;
                    case 566: /* reduce AAevent19Event */
		    {
			ArrayList list = new566();
			push(goTo(16), list);
		    }
		    break;
                    case 567: /* reduce AAevent20Event */
		    {
			ArrayList list = new567();
			push(goTo(16), list);
		    }
		    break;
                    case 568: /* reduce AAevent21Event */
		    {
			ArrayList list = new568();
			push(goTo(16), list);
		    }
		    break;
                    case 569: /* reduce AAevent22Event */
		    {
			ArrayList list = new569();
			push(goTo(16), list);
		    }
		    break;
                    case 570: /* reduce AAevent23Event */
		    {
			ArrayList list = new570();
			push(goTo(16), list);
		    }
		    break;
                    case 571: /* reduce AAevent24Event */
		    {
			ArrayList list = new571();
			push(goTo(16), list);
		    }
		    break;
                    case 572: /* reduce AAevent25Event */
		    {
			ArrayList list = new572();
			push(goTo(16), list);
		    }
		    break;
                    case 573: /* reduce AAevent26Event */
		    {
			ArrayList list = new573();
			push(goTo(16), list);
		    }
		    break;
                    case 574: /* reduce AAevent27Event */
		    {
			ArrayList list = new574();
			push(goTo(16), list);
		    }
		    break;
                    case 575: /* reduce AAevent28Event */
		    {
			ArrayList list = new575();
			push(goTo(16), list);
		    }
		    break;
                    case 576: /* reduce AAevent29Event */
		    {
			ArrayList list = new576();
			push(goTo(16), list);
		    }
		    break;
                    case 577: /* reduce AAevent30Event */
		    {
			ArrayList list = new577();
			push(goTo(16), list);
		    }
		    break;
                    case 578: /* reduce AAevent31Event */
		    {
			ArrayList list = new578();
			push(goTo(16), list);
		    }
		    break;
                    case 579: /* reduce AAevent32Event */
		    {
			ArrayList list = new579();
			push(goTo(16), list);
		    }
		    break;
                    case 580: /* reduce AAevent33Event */
		    {
			ArrayList list = new580();
			push(goTo(16), list);
		    }
		    break;
                    case 581: /* reduce AAevent34Event */
		    {
			ArrayList list = new581();
			push(goTo(16), list);
		    }
		    break;
                    case 582: /* reduce AAevent35Event */
		    {
			ArrayList list = new582();
			push(goTo(16), list);
		    }
		    break;
                    case 583: /* reduce AAevent36Event */
		    {
			ArrayList list = new583();
			push(goTo(16), list);
		    }
		    break;
                    case 584: /* reduce AAevent37Event */
		    {
			ArrayList list = new584();
			push(goTo(16), list);
		    }
		    break;
                    case 585: /* reduce AAevent38Event */
		    {
			ArrayList list = new585();
			push(goTo(16), list);
		    }
		    break;
                    case 586: /* reduce AAevent39Event */
		    {
			ArrayList list = new586();
			push(goTo(16), list);
		    }
		    break;
                    case 587: /* reduce AAevent40Event */
		    {
			ArrayList list = new587();
			push(goTo(16), list);
		    }
		    break;
                    case 588: /* reduce AAevent41Event */
		    {
			ArrayList list = new588();
			push(goTo(16), list);
		    }
		    break;
                    case 589: /* reduce AAevent42Event */
		    {
			ArrayList list = new589();
			push(goTo(16), list);
		    }
		    break;
                    case 590: /* reduce AAevent43Event */
		    {
			ArrayList list = new590();
			push(goTo(16), list);
		    }
		    break;
                    case 591: /* reduce AAevent44Event */
		    {
			ArrayList list = new591();
			push(goTo(16), list);
		    }
		    break;
                    case 592: /* reduce AAevent45Event */
		    {
			ArrayList list = new592();
			push(goTo(16), list);
		    }
		    break;
                    case 593: /* reduce AAevent46Event */
		    {
			ArrayList list = new593();
			push(goTo(16), list);
		    }
		    break;
                    case 594: /* reduce AAevent47Event */
		    {
			ArrayList list = new594();
			push(goTo(16), list);
		    }
		    break;
                    case 595: /* reduce AAevent48Event */
		    {
			ArrayList list = new595();
			push(goTo(16), list);
		    }
		    break;
                    case 596: /* reduce AAevent49Event */
		    {
			ArrayList list = new596();
			push(goTo(16), list);
		    }
		    break;
                    case 597: /* reduce AAevent50Event */
		    {
			ArrayList list = new597();
			push(goTo(16), list);
		    }
		    break;
                    case 598: /* reduce AAevent51Event */
		    {
			ArrayList list = new598();
			push(goTo(16), list);
		    }
		    break;
                    case 599: /* reduce AAevent52Event */
		    {
			ArrayList list = new599();
			push(goTo(16), list);
		    }
		    break;
                    case 600: /* reduce AAevent53Event */
		    {
			ArrayList list = new600();
			push(goTo(16), list);
		    }
		    break;
                    case 601: /* reduce AAevent54Event */
		    {
			ArrayList list = new601();
			push(goTo(16), list);
		    }
		    break;
                    case 602: /* reduce AAevent55Event */
		    {
			ArrayList list = new602();
			push(goTo(16), list);
		    }
		    break;
                    case 603: /* reduce AAevent56Event */
		    {
			ArrayList list = new603();
			push(goTo(16), list);
		    }
		    break;
                    case 604: /* reduce AAevent57Event */
		    {
			ArrayList list = new604();
			push(goTo(16), list);
		    }
		    break;
                    case 605: /* reduce AAevent58Event */
		    {
			ArrayList list = new605();
			push(goTo(16), list);
		    }
		    break;
                    case 606: /* reduce AAevent59Event */
		    {
			ArrayList list = new606();
			push(goTo(16), list);
		    }
		    break;
                    case 607: /* reduce AAevent60Event */
		    {
			ArrayList list = new607();
			push(goTo(16), list);
		    }
		    break;
                    case 608: /* reduce AAevent61Event */
		    {
			ArrayList list = new608();
			push(goTo(16), list);
		    }
		    break;
                    case 609: /* reduce AAevent62Event */
		    {
			ArrayList list = new609();
			push(goTo(16), list);
		    }
		    break;
                    case 610: /* reduce AAevent63Event */
		    {
			ArrayList list = new610();
			push(goTo(16), list);
		    }
		    break;
                    case 611: /* reduce AAevent64Event */
		    {
			ArrayList list = new611();
			push(goTo(16), list);
		    }
		    break;
                    case 612: /* reduce AAevent65Event */
		    {
			ArrayList list = new612();
			push(goTo(16), list);
		    }
		    break;
                    case 613: /* reduce AAevent66Event */
		    {
			ArrayList list = new613();
			push(goTo(16), list);
		    }
		    break;
                    case 614: /* reduce AAevent67Event */
		    {
			ArrayList list = new614();
			push(goTo(16), list);
		    }
		    break;
                    case 615: /* reduce AAevent68Event */
		    {
			ArrayList list = new615();
			push(goTo(16), list);
		    }
		    break;
                    case 616: /* reduce AAevent69Event */
		    {
			ArrayList list = new616();
			push(goTo(16), list);
		    }
		    break;
                    case 617: /* reduce AAevent70Event */
		    {
			ArrayList list = new617();
			push(goTo(16), list);
		    }
		    break;
                    case 618: /* reduce AAevent71Event */
		    {
			ArrayList list = new618();
			push(goTo(16), list);
		    }
		    break;
                    case 619: /* reduce AAevent72Event */
		    {
			ArrayList list = new619();
			push(goTo(16), list);
		    }
		    break;
                    case 620: /* reduce AAevent73Event */
		    {
			ArrayList list = new620();
			push(goTo(16), list);
		    }
		    break;
                    case 621: /* reduce AAevent74Event */
		    {
			ArrayList list = new621();
			push(goTo(16), list);
		    }
		    break;
                    case 622: /* reduce AAevent75Event */
		    {
			ArrayList list = new622();
			push(goTo(16), list);
		    }
		    break;
                    case 623: /* reduce AAevent76Event */
		    {
			ArrayList list = new623();
			push(goTo(16), list);
		    }
		    break;
                    case 624: /* reduce AAevent77Event */
		    {
			ArrayList list = new624();
			push(goTo(16), list);
		    }
		    break;
                    case 625: /* reduce AAevent78Event */
		    {
			ArrayList list = new625();
			push(goTo(16), list);
		    }
		    break;
                    case 626: /* reduce AAevent79Event */
		    {
			ArrayList list = new626();
			push(goTo(16), list);
		    }
		    break;
                    case 627: /* reduce AAevent80Event */
		    {
			ArrayList list = new627();
			push(goTo(16), list);
		    }
		    break;
                    case 628: /* reduce AAevent81Event */
		    {
			ArrayList list = new628();
			push(goTo(16), list);
		    }
		    break;
                    case 629: /* reduce AAevent82Event */
		    {
			ArrayList list = new629();
			push(goTo(16), list);
		    }
		    break;
                    case 630: /* reduce AAevent83Event */
		    {
			ArrayList list = new630();
			push(goTo(16), list);
		    }
		    break;
                    case 631: /* reduce AAevent84Event */
		    {
			ArrayList list = new631();
			push(goTo(16), list);
		    }
		    break;
                    case 632: /* reduce AAevent85Event */
		    {
			ArrayList list = new632();
			push(goTo(16), list);
		    }
		    break;
                    case 633: /* reduce AAevent86Event */
		    {
			ArrayList list = new633();
			push(goTo(16), list);
		    }
		    break;
                    case 634: /* reduce AAevent87Event */
		    {
			ArrayList list = new634();
			push(goTo(16), list);
		    }
		    break;
                    case 635: /* reduce AAevent88Event */
		    {
			ArrayList list = new635();
			push(goTo(16), list);
		    }
		    break;
                    case 636: /* reduce AAevent89Event */
		    {
			ArrayList list = new636();
			push(goTo(16), list);
		    }
		    break;
                    case 637: /* reduce AAevent90Event */
		    {
			ArrayList list = new637();
			push(goTo(16), list);
		    }
		    break;
                    case 638: /* reduce AAevent91Event */
		    {
			ArrayList list = new638();
			push(goTo(16), list);
		    }
		    break;
                    case 639: /* reduce AAevent92Event */
		    {
			ArrayList list = new639();
			push(goTo(16), list);
		    }
		    break;
                    case 640: /* reduce AAevent93Event */
		    {
			ArrayList list = new640();
			push(goTo(16), list);
		    }
		    break;
                    case 641: /* reduce AAevent94Event */
		    {
			ArrayList list = new641();
			push(goTo(16), list);
		    }
		    break;
                    case 642: /* reduce AAevent95Event */
		    {
			ArrayList list = new642();
			push(goTo(16), list);
		    }
		    break;
                    case 643: /* reduce AAevent96Event */
		    {
			ArrayList list = new643();
			push(goTo(16), list);
		    }
		    break;
                    case 644: /* reduce AAevent97Event */
		    {
			ArrayList list = new644();
			push(goTo(16), list);
		    }
		    break;
                    case 645: /* reduce AAevent98Event */
		    {
			ArrayList list = new645();
			push(goTo(16), list);
		    }
		    break;
                    case 646: /* reduce AAevent99Event */
		    {
			ArrayList list = new646();
			push(goTo(16), list);
		    }
		    break;
                    case 647: /* reduce AAevent100Event */
		    {
			ArrayList list = new647();
			push(goTo(16), list);
		    }
		    break;
                    case 648: /* reduce AAevent101Event */
		    {
			ArrayList list = new648();
			push(goTo(16), list);
		    }
		    break;
                    case 649: /* reduce AAevent102Event */
		    {
			ArrayList list = new649();
			push(goTo(16), list);
		    }
		    break;
                    case 650: /* reduce AAevent103Event */
		    {
			ArrayList list = new650();
			push(goTo(16), list);
		    }
		    break;
                    case 651: /* reduce AAevent104Event */
		    {
			ArrayList list = new651();
			push(goTo(16), list);
		    }
		    break;
                    case 652: /* reduce AAevent105Event */
		    {
			ArrayList list = new652();
			push(goTo(16), list);
		    }
		    break;
                    case 653: /* reduce AAevent106Event */
		    {
			ArrayList list = new653();
			push(goTo(16), list);
		    }
		    break;
                    case 654: /* reduce AAevent107Event */
		    {
			ArrayList list = new654();
			push(goTo(16), list);
		    }
		    break;
                    case 655: /* reduce AAevent108Event */
		    {
			ArrayList list = new655();
			push(goTo(16), list);
		    }
		    break;
                    case 656: /* reduce AAevent109Event */
		    {
			ArrayList list = new656();
			push(goTo(16), list);
		    }
		    break;
                    case 657: /* reduce AAevent110Event */
		    {
			ArrayList list = new657();
			push(goTo(16), list);
		    }
		    break;
                    case 658: /* reduce AAevent111Event */
		    {
			ArrayList list = new658();
			push(goTo(16), list);
		    }
		    break;
                    case 659: /* reduce AAevent112Event */
		    {
			ArrayList list = new659();
			push(goTo(16), list);
		    }
		    break;
                    case 660: /* reduce AAevent113Event */
		    {
			ArrayList list = new660();
			push(goTo(16), list);
		    }
		    break;
                    case 661: /* reduce AAevent114Event */
		    {
			ArrayList list = new661();
			push(goTo(16), list);
		    }
		    break;
                    case 662: /* reduce AAevent115Event */
		    {
			ArrayList list = new662();
			push(goTo(16), list);
		    }
		    break;
                    case 663: /* reduce AAevent116Event */
		    {
			ArrayList list = new663();
			push(goTo(16), list);
		    }
		    break;
                    case 664: /* reduce AAevent117Event */
		    {
			ArrayList list = new664();
			push(goTo(16), list);
		    }
		    break;
                    case 665: /* reduce AAevent118Event */
		    {
			ArrayList list = new665();
			push(goTo(16), list);
		    }
		    break;
                    case 666: /* reduce AAevent119Event */
		    {
			ArrayList list = new666();
			push(goTo(16), list);
		    }
		    break;
                    case 667: /* reduce AAevent120Event */
		    {
			ArrayList list = new667();
			push(goTo(16), list);
		    }
		    break;
                    case 668: /* reduce AAevent121Event */
		    {
			ArrayList list = new668();
			push(goTo(16), list);
		    }
		    break;
                    case 669: /* reduce AAevent122Event */
		    {
			ArrayList list = new669();
			push(goTo(16), list);
		    }
		    break;
                    case 670: /* reduce AAevent123Event */
		    {
			ArrayList list = new670();
			push(goTo(16), list);
		    }
		    break;
                    case 671: /* reduce AAevent124Event */
		    {
			ArrayList list = new671();
			push(goTo(16), list);
		    }
		    break;
                    case 672: /* reduce AAevent125Event */
		    {
			ArrayList list = new672();
			push(goTo(16), list);
		    }
		    break;
                    case 673: /* reduce AAevent126Event */
		    {
			ArrayList list = new673();
			push(goTo(16), list);
		    }
		    break;
                    case 674: /* reduce AAevent127Event */
		    {
			ArrayList list = new674();
			push(goTo(16), list);
		    }
		    break;
                    case 675: /* reduce AAevent128Event */
		    {
			ArrayList list = new675();
			push(goTo(16), list);
		    }
		    break;
                    case 676: /* reduce AOrdinaryConvergence */
		    {
			ArrayList list = new676();
			push(goTo(17), list);
		    }
		    break;
                    case 677: /* reduce AConvergentConvergence */
		    {
			ArrayList list = new677();
			push(goTo(17), list);
		    }
		    break;
                    case 678: /* reduce AAnticipatedConvergence */
		    {
			ArrayList list = new678();
			push(goTo(17), list);
		    }
		    break;
                    case 679: /* reduce ARefinesEventRefinement */
		    {
			ArrayList list = new679();
			push(goTo(18), list);
		    }
		    break;
                    case 680: /* reduce AExtendedEventRefinement */
		    {
			ArrayList list = new680();
			push(goTo(18), list);
		    }
		    break;
                    case 681: /* reduce AAeventrefines1EventRefines */
		    {
			ArrayList list = new681();
			push(goTo(19), list);
		    }
		    break;
                    case 682: /* reduce AAeventrefines2EventRefines */
		    {
			ArrayList list = new682();
			push(goTo(19), list);
		    }
		    break;
                    case 683: /* reduce AEventRefinesTail */
		    {
			ArrayList list = new683();
			push(goTo(20), list);
		    }
		    break;
                    case 684: /* reduce AAeventany1EventAny */
		    {
			ArrayList list = new684();
			push(goTo(21), list);
		    }
		    break;
                    case 685: /* reduce AAeventany2EventAny */
		    {
			ArrayList list = new685();
			push(goTo(21), list);
		    }
		    break;
                    case 686: /* reduce AEventAnyTail */
		    {
			ArrayList list = new686();
			push(goTo(22), list);
		    }
		    break;
                    case 687: /* reduce AAparameter1Parameter */
		    {
			ArrayList list = new687();
			push(goTo(23), list);
		    }
		    break;
                    case 688: /* reduce AAparameter2Parameter */
		    {
			ArrayList list = new688();
			push(goTo(23), list);
		    }
		    break;
                    case 689: /* reduce AAeventwhere1EventWhere */
		    {
			ArrayList list = new689();
			push(goTo(24), list);
		    }
		    break;
                    case 690: /* reduce AAeventwhere2EventWhere */
		    {
			ArrayList list = new690();
			push(goTo(24), list);
		    }
		    break;
                    case 691: /* reduce AEventWhereTail */
		    {
			ArrayList list = new691();
			push(goTo(25), list);
		    }
		    break;
                    case 692: /* reduce AAguard1Guard */
		    {
			ArrayList list = new692();
			push(goTo(26), list);
		    }
		    break;
                    case 693: /* reduce AAguard2Guard */
		    {
			ArrayList list = new693();
			push(goTo(26), list);
		    }
		    break;
                    case 694: /* reduce AAderivedguard1Guard */
		    {
			ArrayList list = new694();
			push(goTo(26), list);
		    }
		    break;
                    case 695: /* reduce AAderivedguard2Guard */
		    {
			ArrayList list = new695();
			push(goTo(26), list);
		    }
		    break;
                    case 696: /* reduce AAeventwith1EventWith */
		    {
			ArrayList list = new696();
			push(goTo(27), list);
		    }
		    break;
                    case 697: /* reduce AAeventwith2EventWith */
		    {
			ArrayList list = new697();
			push(goTo(27), list);
		    }
		    break;
                    case 698: /* reduce AEventWithTail */
		    {
			ArrayList list = new698();
			push(goTo(28), list);
		    }
		    break;
                    case 699: /* reduce AAwitness1Witness */
		    {
			ArrayList list = new699();
			push(goTo(29), list);
		    }
		    break;
                    case 700: /* reduce AAwitness2Witness */
		    {
			ArrayList list = new700();
			push(goTo(29), list);
		    }
		    break;
                    case 701: /* reduce AAeventthen1EventThen */
		    {
			ArrayList list = new701();
			push(goTo(30), list);
		    }
		    break;
                    case 702: /* reduce AAeventthen2EventThen */
		    {
			ArrayList list = new702();
			push(goTo(30), list);
		    }
		    break;
                    case 703: /* reduce AEventThenTail */
		    {
			ArrayList list = new703();
			push(goTo(31), list);
		    }
		    break;
                    case 704: /* reduce AAaction1Action */
		    {
			ArrayList list = new704();
			push(goTo(32), list);
		    }
		    break;
                    case 705: /* reduce AAaction2Action */
		    {
			ArrayList list = new705();
			push(goTo(32), list);
		    }
		    break;
                    case 706: /* reduce AAprocedure1Procedure */
		    {
			ArrayList list = new706();
			push(goTo(33), list);
		    }
		    break;
                    case 707: /* reduce AAprocedure2Procedure */
		    {
			ArrayList list = new707();
			push(goTo(33), list);
		    }
		    break;
                    case 708: /* reduce AAprocedure3Procedure */
		    {
			ArrayList list = new708();
			push(goTo(33), list);
		    }
		    break;
                    case 709: /* reduce AAprocedure4Procedure */
		    {
			ArrayList list = new709();
			push(goTo(33), list);
		    }
		    break;
                    case 710: /* reduce AAprocedure5Procedure */
		    {
			ArrayList list = new710();
			push(goTo(33), list);
		    }
		    break;
                    case 711: /* reduce AAprocedure6Procedure */
		    {
			ArrayList list = new711();
			push(goTo(33), list);
		    }
		    break;
                    case 712: /* reduce AAprocedure7Procedure */
		    {
			ArrayList list = new712();
			push(goTo(33), list);
		    }
		    break;
                    case 713: /* reduce AAprocedure8Procedure */
		    {
			ArrayList list = new713();
			push(goTo(33), list);
		    }
		    break;
                    case 714: /* reduce AAprocedure9Procedure */
		    {
			ArrayList list = new714();
			push(goTo(33), list);
		    }
		    break;
                    case 715: /* reduce AAprocedure10Procedure */
		    {
			ArrayList list = new715();
			push(goTo(33), list);
		    }
		    break;
                    case 716: /* reduce AAprocedure11Procedure */
		    {
			ArrayList list = new716();
			push(goTo(33), list);
		    }
		    break;
                    case 717: /* reduce AAprocedure12Procedure */
		    {
			ArrayList list = new717();
			push(goTo(33), list);
		    }
		    break;
                    case 718: /* reduce AAprocedure13Procedure */
		    {
			ArrayList list = new718();
			push(goTo(33), list);
		    }
		    break;
                    case 719: /* reduce AAprocedure14Procedure */
		    {
			ArrayList list = new719();
			push(goTo(33), list);
		    }
		    break;
                    case 720: /* reduce AAprocedure15Procedure */
		    {
			ArrayList list = new720();
			push(goTo(33), list);
		    }
		    break;
                    case 721: /* reduce AAprocedure16Procedure */
		    {
			ArrayList list = new721();
			push(goTo(33), list);
		    }
		    break;
                    case 722: /* reduce AAprocedure17Procedure */
		    {
			ArrayList list = new722();
			push(goTo(33), list);
		    }
		    break;
                    case 723: /* reduce AAprocedure18Procedure */
		    {
			ArrayList list = new723();
			push(goTo(33), list);
		    }
		    break;
                    case 724: /* reduce AAprocedure19Procedure */
		    {
			ArrayList list = new724();
			push(goTo(33), list);
		    }
		    break;
                    case 725: /* reduce AAprocedure20Procedure */
		    {
			ArrayList list = new725();
			push(goTo(33), list);
		    }
		    break;
                    case 726: /* reduce AAprocedure21Procedure */
		    {
			ArrayList list = new726();
			push(goTo(33), list);
		    }
		    break;
                    case 727: /* reduce AAprocedure22Procedure */
		    {
			ArrayList list = new727();
			push(goTo(33), list);
		    }
		    break;
                    case 728: /* reduce AAprocedure23Procedure */
		    {
			ArrayList list = new728();
			push(goTo(33), list);
		    }
		    break;
                    case 729: /* reduce AAprocedure24Procedure */
		    {
			ArrayList list = new729();
			push(goTo(33), list);
		    }
		    break;
                    case 730: /* reduce AAprocedure25Procedure */
		    {
			ArrayList list = new730();
			push(goTo(33), list);
		    }
		    break;
                    case 731: /* reduce AAprocedure26Procedure */
		    {
			ArrayList list = new731();
			push(goTo(33), list);
		    }
		    break;
                    case 732: /* reduce AAprocedure27Procedure */
		    {
			ArrayList list = new732();
			push(goTo(33), list);
		    }
		    break;
                    case 733: /* reduce AAprocedure28Procedure */
		    {
			ArrayList list = new733();
			push(goTo(33), list);
		    }
		    break;
                    case 734: /* reduce AAprocedure29Procedure */
		    {
			ArrayList list = new734();
			push(goTo(33), list);
		    }
		    break;
                    case 735: /* reduce AAprocedure30Procedure */
		    {
			ArrayList list = new735();
			push(goTo(33), list);
		    }
		    break;
                    case 736: /* reduce AAprocedure31Procedure */
		    {
			ArrayList list = new736();
			push(goTo(33), list);
		    }
		    break;
                    case 737: /* reduce AAprocedure32Procedure */
		    {
			ArrayList list = new737();
			push(goTo(33), list);
		    }
		    break;
                    case 738: /* reduce AAsimplemachinebody1SimpleMachineBody */
		    {
			ArrayList list = new738();
			push(goTo(34), list);
		    }
		    break;
                    case 739: /* reduce AAsimplemachinebody2SimpleMachineBody */
		    {
			ArrayList list = new739();
			push(goTo(34), list);
		    }
		    break;
                    case 740: /* reduce AAsimplemachinebody3SimpleMachineBody */
		    {
			ArrayList list = new740();
			push(goTo(34), list);
		    }
		    break;
                    case 741: /* reduce AAsimplemachinebody4SimpleMachineBody */
		    {
			ArrayList list = new741();
			push(goTo(34), list);
		    }
		    break;
                    case 742: /* reduce AAsimplemachinebody5SimpleMachineBody */
		    {
			ArrayList list = new742();
			push(goTo(34), list);
		    }
		    break;
                    case 743: /* reduce AAsimplemachinebody6SimpleMachineBody */
		    {
			ArrayList list = new743();
			push(goTo(34), list);
		    }
		    break;
                    case 744: /* reduce AAsimplemachinebody7SimpleMachineBody */
		    {
			ArrayList list = new744();
			push(goTo(34), list);
		    }
		    break;
                    case 745: /* reduce AAsimplemachinebody8SimpleMachineBody */
		    {
			ArrayList list = new745();
			push(goTo(34), list);
		    }
		    break;
                    case 746: /* reduce AAsimplemachinebody9SimpleMachineBody */
		    {
			ArrayList list = new746();
			push(goTo(34), list);
		    }
		    break;
                    case 747: /* reduce AAsimplemachinebody10SimpleMachineBody */
		    {
			ArrayList list = new747();
			push(goTo(34), list);
		    }
		    break;
                    case 748: /* reduce AAsimplemachinebody11SimpleMachineBody */
		    {
			ArrayList list = new748();
			push(goTo(34), list);
		    }
		    break;
                    case 749: /* reduce AAsimplemachinebody12SimpleMachineBody */
		    {
			ArrayList list = new749();
			push(goTo(34), list);
		    }
		    break;
                    case 750: /* reduce AAsimplemachinebody13SimpleMachineBody */
		    {
			ArrayList list = new750();
			push(goTo(34), list);
		    }
		    break;
                    case 751: /* reduce AAsimplemachinebody14SimpleMachineBody */
		    {
			ArrayList list = new751();
			push(goTo(34), list);
		    }
		    break;
                    case 752: /* reduce AAsimplemachinebody15SimpleMachineBody */
		    {
			ArrayList list = new752();
			push(goTo(34), list);
		    }
		    break;
                    case 753: /* reduce AAsimplemachinebody16SimpleMachineBody */
		    {
			ArrayList list = new753();
			push(goTo(34), list);
		    }
		    break;
                    case 754: /* reduce AAsimplemachinebody17SimpleMachineBody */
		    {
			ArrayList list = new754();
			push(goTo(34), list);
		    }
		    break;
                    case 755: /* reduce AAsimplemachinebody18SimpleMachineBody */
		    {
			ArrayList list = new755();
			push(goTo(34), list);
		    }
		    break;
                    case 756: /* reduce AAsimplemachinebody19SimpleMachineBody */
		    {
			ArrayList list = new756();
			push(goTo(34), list);
		    }
		    break;
                    case 757: /* reduce AAsimplemachinebody20SimpleMachineBody */
		    {
			ArrayList list = new757();
			push(goTo(34), list);
		    }
		    break;
                    case 758: /* reduce AAsimplemachinebody21SimpleMachineBody */
		    {
			ArrayList list = new758();
			push(goTo(34), list);
		    }
		    break;
                    case 759: /* reduce AAsimplemachinebody22SimpleMachineBody */
		    {
			ArrayList list = new759();
			push(goTo(34), list);
		    }
		    break;
                    case 760: /* reduce AAsimplemachinebody23SimpleMachineBody */
		    {
			ArrayList list = new760();
			push(goTo(34), list);
		    }
		    break;
                    case 761: /* reduce AAsimplemachinebody24SimpleMachineBody */
		    {
			ArrayList list = new761();
			push(goTo(34), list);
		    }
		    break;
                    case 762: /* reduce AAsimplemachinebody25SimpleMachineBody */
		    {
			ArrayList list = new762();
			push(goTo(34), list);
		    }
		    break;
                    case 763: /* reduce AAsimplemachinebody26SimpleMachineBody */
		    {
			ArrayList list = new763();
			push(goTo(34), list);
		    }
		    break;
                    case 764: /* reduce AAsimplemachinebody27SimpleMachineBody */
		    {
			ArrayList list = new764();
			push(goTo(34), list);
		    }
		    break;
                    case 765: /* reduce AAsimplemachinebody28SimpleMachineBody */
		    {
			ArrayList list = new765();
			push(goTo(34), list);
		    }
		    break;
                    case 766: /* reduce AAsimplemachinebody29SimpleMachineBody */
		    {
			ArrayList list = new766();
			push(goTo(34), list);
		    }
		    break;
                    case 767: /* reduce AAsimplemachinebody30SimpleMachineBody */
		    {
			ArrayList list = new767();
			push(goTo(34), list);
		    }
		    break;
                    case 768: /* reduce AAsimplemachinebody31SimpleMachineBody */
		    {
			ArrayList list = new768();
			push(goTo(34), list);
		    }
		    break;
                    case 769: /* reduce AAsimplemachinebody32SimpleMachineBody */
		    {
			ArrayList list = new769();
			push(goTo(34), list);
		    }
		    break;
                    case 770: /* reduce AAsimplemachinebody33SimpleMachineBody */
		    {
			ArrayList list = new770();
			push(goTo(34), list);
		    }
		    break;
                    case 771: /* reduce AAsimplemachinebody34SimpleMachineBody */
		    {
			ArrayList list = new771();
			push(goTo(34), list);
		    }
		    break;
                    case 772: /* reduce AAsimplemachinebody35SimpleMachineBody */
		    {
			ArrayList list = new772();
			push(goTo(34), list);
		    }
		    break;
                    case 773: /* reduce AAsimplemachinebody36SimpleMachineBody */
		    {
			ArrayList list = new773();
			push(goTo(34), list);
		    }
		    break;
                    case 774: /* reduce AAsimplemachinebody37SimpleMachineBody */
		    {
			ArrayList list = new774();
			push(goTo(34), list);
		    }
		    break;
                    case 775: /* reduce AAsimplemachinebody38SimpleMachineBody */
		    {
			ArrayList list = new775();
			push(goTo(34), list);
		    }
		    break;
                    case 776: /* reduce AAsimplemachinebody39SimpleMachineBody */
		    {
			ArrayList list = new776();
			push(goTo(34), list);
		    }
		    break;
                    case 777: /* reduce AAsimplemachinebody40SimpleMachineBody */
		    {
			ArrayList list = new777();
			push(goTo(34), list);
		    }
		    break;
                    case 778: /* reduce AAsimplemachinebody41SimpleMachineBody */
		    {
			ArrayList list = new778();
			push(goTo(34), list);
		    }
		    break;
                    case 779: /* reduce AAsimplemachinebody42SimpleMachineBody */
		    {
			ArrayList list = new779();
			push(goTo(34), list);
		    }
		    break;
                    case 780: /* reduce AAsimplemachinebody43SimpleMachineBody */
		    {
			ArrayList list = new780();
			push(goTo(34), list);
		    }
		    break;
                    case 781: /* reduce AAsimplemachinebody44SimpleMachineBody */
		    {
			ArrayList list = new781();
			push(goTo(34), list);
		    }
		    break;
                    case 782: /* reduce AAsimplemachinebody45SimpleMachineBody */
		    {
			ArrayList list = new782();
			push(goTo(34), list);
		    }
		    break;
                    case 783: /* reduce AAsimplemachinebody46SimpleMachineBody */
		    {
			ArrayList list = new783();
			push(goTo(34), list);
		    }
		    break;
                    case 784: /* reduce AAsimplemachinebody47SimpleMachineBody */
		    {
			ArrayList list = new784();
			push(goTo(34), list);
		    }
		    break;
                    case 785: /* reduce AAsimplemachinebody48SimpleMachineBody */
		    {
			ArrayList list = new785();
			push(goTo(34), list);
		    }
		    break;
                    case 786: /* reduce AAsimplemachinebody49SimpleMachineBody */
		    {
			ArrayList list = new786();
			push(goTo(34), list);
		    }
		    break;
                    case 787: /* reduce AAsimplemachinebody50SimpleMachineBody */
		    {
			ArrayList list = new787();
			push(goTo(34), list);
		    }
		    break;
                    case 788: /* reduce AAsimplemachinebody51SimpleMachineBody */
		    {
			ArrayList list = new788();
			push(goTo(34), list);
		    }
		    break;
                    case 789: /* reduce AAsimplemachinebody52SimpleMachineBody */
		    {
			ArrayList list = new789();
			push(goTo(34), list);
		    }
		    break;
                    case 790: /* reduce AAsimplemachinebody53SimpleMachineBody */
		    {
			ArrayList list = new790();
			push(goTo(34), list);
		    }
		    break;
                    case 791: /* reduce AAsimplemachinebody54SimpleMachineBody */
		    {
			ArrayList list = new791();
			push(goTo(34), list);
		    }
		    break;
                    case 792: /* reduce AAsimplemachinebody55SimpleMachineBody */
		    {
			ArrayList list = new792();
			push(goTo(34), list);
		    }
		    break;
                    case 793: /* reduce AAsimplemachinebody56SimpleMachineBody */
		    {
			ArrayList list = new793();
			push(goTo(34), list);
		    }
		    break;
                    case 794: /* reduce AAsimplemachinebody57SimpleMachineBody */
		    {
			ArrayList list = new794();
			push(goTo(34), list);
		    }
		    break;
                    case 795: /* reduce AAsimplemachinebody58SimpleMachineBody */
		    {
			ArrayList list = new795();
			push(goTo(34), list);
		    }
		    break;
                    case 796: /* reduce AAsimplemachinebody59SimpleMachineBody */
		    {
			ArrayList list = new796();
			push(goTo(34), list);
		    }
		    break;
                    case 797: /* reduce AAsimplemachinebody60SimpleMachineBody */
		    {
			ArrayList list = new797();
			push(goTo(34), list);
		    }
		    break;
                    case 798: /* reduce AAsimplemachinebody61SimpleMachineBody */
		    {
			ArrayList list = new798();
			push(goTo(34), list);
		    }
		    break;
                    case 799: /* reduce AAsimplemachinebody62SimpleMachineBody */
		    {
			ArrayList list = new799();
			push(goTo(34), list);
		    }
		    break;
                    case 800: /* reduce AAsimplemachinebody63SimpleMachineBody */
		    {
			ArrayList list = new800();
			push(goTo(34), list);
		    }
		    break;
                    case 801: /* reduce AAsimplemachinebody64SimpleMachineBody */
		    {
			ArrayList list = new801();
			push(goTo(34), list);
		    }
		    break;
                    case 802: /* reduce ASequenceIdentifierList */
		    {
			ArrayList list = new802();
			push(goTo(35), list);
		    }
		    break;
                    case 803: /* reduce ASingleIdentifierList */
		    {
			ArrayList list = new803();
			push(goTo(35), list);
		    }
		    break;
                    case 804: /* reduce ATypedIdentifierDef */
		    {
			ArrayList list = new804();
			push(goTo(36), list);
		    }
		    break;
                    case 805: /* reduce AUntypedIdentifierDef */
		    {
			ArrayList list = new805();
			push(goTo(36), list);
		    }
		    break;
                    case 806: /* reduce ASequenceTypingList */
		    {
			ArrayList list = new806();
			push(goTo(37), list);
		    }
		    break;
                    case 807: /* reduce ASingleTypingList */
		    {
			ArrayList list = new807();
			push(goTo(37), list);
		    }
		    break;
                    case 808: /* reduce AAtypingstatement1TypingStatement */
		    {
			ArrayList list = new808();
			push(goTo(38), list);
		    }
		    break;
                    case 809: /* reduce AAtypingstatement2TypingStatement */
		    {
			ArrayList list = new809();
			push(goTo(38), list);
		    }
		    break;
                    case 810: /* reduce AAparseprecondition1ParsePrecondition */
		    {
			ArrayList list = new810();
			push(goTo(39), list);
		    }
		    break;
                    case 811: /* reduce AAparseprecondition2ParsePrecondition */
		    {
			ArrayList list = new811();
			push(goTo(39), list);
		    }
		    break;
                    case 812: /* reduce AAparsepostcondition1ParsePostcondition */
		    {
			ArrayList list = new812();
			push(goTo(40), list);
		    }
		    break;
                    case 813: /* reduce AAparsepostcondition2ParsePostcondition */
		    {
			ArrayList list = new813();
			push(goTo(40), list);
		    }
		    break;
                    case 814: /* reduce AAlgorithm */
		    {
			ArrayList list = new814();
			push(goTo(41), list);
		    }
		    break;
                    case 815: /* reduce AAsequencealgblock1AlgBlock */
		    {
			ArrayList list = new815();
			push(goTo(42), list);
		    }
		    break;
                    case 816: /* reduce AAsequencealgblock2AlgBlock */
		    {
			ArrayList list = new816();
			push(goTo(42), list);
		    }
		    break;
                    case 817: /* reduce ANextLevelAlgBlock */
		    {
			ArrayList list = new817();
			push(goTo(42), list);
		    }
		    break;
                    case 818: /* reduce AAassertstatement1Statement */
		    {
			ArrayList list = new818();
			push(goTo(43), list);
		    }
		    break;
                    case 819: /* reduce AAassertstatement2Statement */
		    {
			ArrayList list = new819();
			push(goTo(43), list);
		    }
		    break;
                    case 820: /* reduce AAassignstatement1Statement */
		    {
			ArrayList list = new820();
			push(goTo(43), list);
		    }
		    break;
                    case 821: /* reduce AAassignstatement2Statement */
		    {
			ArrayList list = new821();
			push(goTo(43), list);
		    }
		    break;
                    case 822: /* reduce AAsimplestatement1Statement */
		    {
			ArrayList list = new822();
			push(goTo(43), list);
		    }
		    break;
                    case 823: /* reduce AAsimplestatement2Statement */
		    {
			ArrayList list = new823();
			push(goTo(43), list);
		    }
		    break;
                    case 824: /* reduce AAwhilestatement1Statement */
		    {
			ArrayList list = new824();
			push(goTo(43), list);
		    }
		    break;
                    case 825: /* reduce AAwhilestatement2Statement */
		    {
			ArrayList list = new825();
			push(goTo(43), list);
		    }
		    break;
                    case 826: /* reduce AAwhilestatement3Statement */
		    {
			ArrayList list = new826();
			push(goTo(43), list);
		    }
		    break;
                    case 827: /* reduce AAwhilestatement4Statement */
		    {
			ArrayList list = new827();
			push(goTo(43), list);
		    }
		    break;
                    case 828: /* reduce AAwhilestatement5Statement */
		    {
			ArrayList list = new828();
			push(goTo(43), list);
		    }
		    break;
                    case 829: /* reduce AAwhilestatement6Statement */
		    {
			ArrayList list = new829();
			push(goTo(43), list);
		    }
		    break;
                    case 830: /* reduce AAwhilestatement7Statement */
		    {
			ArrayList list = new830();
			push(goTo(43), list);
		    }
		    break;
                    case 831: /* reduce AAwhilestatement8Statement */
		    {
			ArrayList list = new831();
			push(goTo(43), list);
		    }
		    break;
                    case 832: /* reduce AAifstatement1Statement */
		    {
			ArrayList list = new832();
			push(goTo(43), list);
		    }
		    break;
                    case 833: /* reduce AAifstatement2Statement */
		    {
			ArrayList list = new833();
			push(goTo(43), list);
		    }
		    break;
                    case 834: /* reduce AAifstatement3Statement */
		    {
			ArrayList list = new834();
			push(goTo(43), list);
		    }
		    break;
                    case 835: /* reduce AAifstatement4Statement */
		    {
			ArrayList list = new835();
			push(goTo(43), list);
		    }
		    break;
                    case 836: /* reduce AAreturnstatement1Statement */
		    {
			ArrayList list = new836();
			push(goTo(43), list);
		    }
		    break;
                    case 837: /* reduce AAreturnstatement2Statement */
		    {
			ArrayList list = new837();
			push(goTo(43), list);
		    }
		    break;
                    case 838: /* reduce AAreturnstatement3Statement */
		    {
			ArrayList list = new838();
			push(goTo(43), list);
		    }
		    break;
                    case 839: /* reduce AAreturnstatement4Statement */
		    {
			ArrayList list = new839();
			push(goTo(43), list);
		    }
		    break;
                    case 840: /* reduce AAcallstatement1Statement */
		    {
			ArrayList list = new840();
			push(goTo(43), list);
		    }
		    break;
                    case 841: /* reduce AAcallstatement2Statement */
		    {
			ArrayList list = new841();
			push(goTo(43), list);
		    }
		    break;
                    case 842: /* reduce AAcallstatement3Statement */
		    {
			ArrayList list = new842();
			push(goTo(43), list);
		    }
		    break;
                    case 843: /* reduce AAcallstatement4Statement */
		    {
			ArrayList list = new843();
			push(goTo(43), list);
		    }
		    break;
                    case 844: /* reduce AIfElse */
		    {
			ArrayList list = new844();
			push(goTo(44), list);
		    }
		    break;
                    case 845: /* reduce ASingleStmtTail */
		    {
			ArrayList list = new845();
			push(goTo(45), list);
		    }
		    break;
                    case 846: /* reduce AMultiStmtTail */
		    {
			ArrayList list = new846();
			push(goTo(45), list);
		    }
		    break;
                    case 847: /* reduce AAloopinvariant1LoopInvariant */
		    {
			ArrayList list = new847();
			push(goTo(46), list);
		    }
		    break;
                    case 848: /* reduce AAloopinvariant2LoopInvariant */
		    {
			ArrayList list = new848();
			push(goTo(46), list);
		    }
		    break;
                    case 849: /* reduce AAloopvariant1LoopVariant */
		    {
			ArrayList list = new849();
			push(goTo(47), list);
		    }
		    break;
                    case 850: /* reduce AAloopvariant2LoopVariant */
		    {
			ArrayList list = new850();
			push(goTo(47), list);
		    }
		    break;
                    case 851: /* reduce AMultipleIdList */
		    {
			ArrayList list = new851();
			push(goTo(48), list);
		    }
		    break;
                    case 852: /* reduce ASingleIdList */
		    {
			ArrayList list = new852();
			push(goTo(48), list);
		    }
		    break;
                    case 853: /* reduce AParseId */
		    {
			ArrayList list = new853();
			push(goTo(49), list);
		    }
		    break;
                    case 854: /* reduce AAcontext1Context */
		    {
			ArrayList list = new854();
			push(goTo(50), list);
		    }
		    break;
                    case 855: /* reduce AAcontext2Context */
		    {
			ArrayList list = new855();
			push(goTo(50), list);
		    }
		    break;
                    case 856: /* reduce AAcontext3Context */
		    {
			ArrayList list = new856();
			push(goTo(50), list);
		    }
		    break;
                    case 857: /* reduce AAcontext4Context */
		    {
			ArrayList list = new857();
			push(goTo(50), list);
		    }
		    break;
                    case 858: /* reduce AAcontext5Context */
		    {
			ArrayList list = new858();
			push(goTo(50), list);
		    }
		    break;
                    case 859: /* reduce AAcontext6Context */
		    {
			ArrayList list = new859();
			push(goTo(50), list);
		    }
		    break;
                    case 860: /* reduce AAcontext7Context */
		    {
			ArrayList list = new860();
			push(goTo(50), list);
		    }
		    break;
                    case 861: /* reduce AAcontext8Context */
		    {
			ArrayList list = new861();
			push(goTo(50), list);
		    }
		    break;
                    case 862: /* reduce AAcontext9Context */
		    {
			ArrayList list = new862();
			push(goTo(50), list);
		    }
		    break;
                    case 863: /* reduce AAcontext10Context */
		    {
			ArrayList list = new863();
			push(goTo(50), list);
		    }
		    break;
                    case 864: /* reduce AAcontext11Context */
		    {
			ArrayList list = new864();
			push(goTo(50), list);
		    }
		    break;
                    case 865: /* reduce AAcontext12Context */
		    {
			ArrayList list = new865();
			push(goTo(50), list);
		    }
		    break;
                    case 866: /* reduce AAcontext13Context */
		    {
			ArrayList list = new866();
			push(goTo(50), list);
		    }
		    break;
                    case 867: /* reduce AAcontext14Context */
		    {
			ArrayList list = new867();
			push(goTo(50), list);
		    }
		    break;
                    case 868: /* reduce AAcontext15Context */
		    {
			ArrayList list = new868();
			push(goTo(50), list);
		    }
		    break;
                    case 869: /* reduce AAcontext16Context */
		    {
			ArrayList list = new869();
			push(goTo(50), list);
		    }
		    break;
                    case 870: /* reduce AAcontext17Context */
		    {
			ArrayList list = new870();
			push(goTo(50), list);
		    }
		    break;
                    case 871: /* reduce AAcontext18Context */
		    {
			ArrayList list = new871();
			push(goTo(50), list);
		    }
		    break;
                    case 872: /* reduce AAcontext19Context */
		    {
			ArrayList list = new872();
			push(goTo(50), list);
		    }
		    break;
                    case 873: /* reduce AAcontext20Context */
		    {
			ArrayList list = new873();
			push(goTo(50), list);
		    }
		    break;
                    case 874: /* reduce AAcontext21Context */
		    {
			ArrayList list = new874();
			push(goTo(50), list);
		    }
		    break;
                    case 875: /* reduce AAcontext22Context */
		    {
			ArrayList list = new875();
			push(goTo(50), list);
		    }
		    break;
                    case 876: /* reduce AAcontext23Context */
		    {
			ArrayList list = new876();
			push(goTo(50), list);
		    }
		    break;
                    case 877: /* reduce AAcontext24Context */
		    {
			ArrayList list = new877();
			push(goTo(50), list);
		    }
		    break;
                    case 878: /* reduce AAcontext25Context */
		    {
			ArrayList list = new878();
			push(goTo(50), list);
		    }
		    break;
                    case 879: /* reduce AAcontext26Context */
		    {
			ArrayList list = new879();
			push(goTo(50), list);
		    }
		    break;
                    case 880: /* reduce AAcontext27Context */
		    {
			ArrayList list = new880();
			push(goTo(50), list);
		    }
		    break;
                    case 881: /* reduce AAcontext28Context */
		    {
			ArrayList list = new881();
			push(goTo(50), list);
		    }
		    break;
                    case 882: /* reduce AAcontext29Context */
		    {
			ArrayList list = new882();
			push(goTo(50), list);
		    }
		    break;
                    case 883: /* reduce AAcontext30Context */
		    {
			ArrayList list = new883();
			push(goTo(50), list);
		    }
		    break;
                    case 884: /* reduce AAcontext31Context */
		    {
			ArrayList list = new884();
			push(goTo(50), list);
		    }
		    break;
                    case 885: /* reduce AAcontext32Context */
		    {
			ArrayList list = new885();
			push(goTo(50), list);
		    }
		    break;
                    case 886: /* reduce AAextendsclause1ExtendsClause */
		    {
			ArrayList list = new886();
			push(goTo(51), list);
		    }
		    break;
                    case 887: /* reduce AAextendsclause2ExtendsClause */
		    {
			ArrayList list = new887();
			push(goTo(51), list);
		    }
		    break;
                    case 888: /* reduce AExtendsClauseTail */
		    {
			ArrayList list = new888();
			push(goTo(52), list);
		    }
		    break;
                    case 889: /* reduce AAsetsclause1SetsClause */
		    {
			ArrayList list = new889();
			push(goTo(53), list);
		    }
		    break;
                    case 890: /* reduce AAsetsclause2SetsClause */
		    {
			ArrayList list = new890();
			push(goTo(53), list);
		    }
		    break;
                    case 891: /* reduce ASetsClauseTail */
		    {
			ArrayList list = new891();
			push(goTo(54), list);
		    }
		    break;
                    case 892: /* reduce AAset1Set */
		    {
			ArrayList list = new892();
			push(goTo(55), list);
		    }
		    break;
                    case 893: /* reduce AAset2Set */
		    {
			ArrayList list = new893();
			push(goTo(55), list);
		    }
		    break;
                    case 894: /* reduce AAconstantsclause1ConstantsClause */
		    {
			ArrayList list = new894();
			push(goTo(56), list);
		    }
		    break;
                    case 895: /* reduce AAconstantsclause2ConstantsClause */
		    {
			ArrayList list = new895();
			push(goTo(56), list);
		    }
		    break;
                    case 896: /* reduce AConstantsClauseTail */
		    {
			ArrayList list = new896();
			push(goTo(57), list);
		    }
		    break;
                    case 897: /* reduce AAconstant1Constant */
		    {
			ArrayList list = new897();
			push(goTo(58), list);
		    }
		    break;
                    case 898: /* reduce AAconstant2Constant */
		    {
			ArrayList list = new898();
			push(goTo(58), list);
		    }
		    break;
                    case 899: /* reduce AAaxiomsclause1AxiomsClause */
		    {
			ArrayList list = new899();
			push(goTo(59), list);
		    }
		    break;
                    case 900: /* reduce AAaxiomsclause2AxiomsClause */
		    {
			ArrayList list = new900();
			push(goTo(59), list);
		    }
		    break;
                    case 901: /* reduce AAxiomsClauseTail */
		    {
			ArrayList list = new901();
			push(goTo(60), list);
		    }
		    break;
                    case 902: /* reduce AAaxiom1Axiom */
		    {
			ArrayList list = new902();
			push(goTo(61), list);
		    }
		    break;
                    case 903: /* reduce AAaxiom2Axiom */
		    {
			ArrayList list = new903();
			push(goTo(61), list);
		    }
		    break;
                    case 904: /* reduce AAderivedaxiom1Axiom */
		    {
			ArrayList list = new904();
			push(goTo(61), list);
		    }
		    break;
                    case 905: /* reduce AAderivedaxiom2Axiom */
		    {
			ArrayList list = new905();
			push(goTo(61), list);
		    }
		    break;
                    case 906: /* reduce ALabel */
		    {
			ArrayList list = new906();
			push(goTo(62), list);
		    }
		    break;
                    case 907: /* reduce ATerminal$Comment */
		    {
			ArrayList list = new907();
			push(goTo(63), list);
		    }
		    break;
                    case 908: /* reduce ANonTerminal$Comment */
		    {
			ArrayList list = new908();
			push(goTo(63), list);
		    }
		    break;
                    case 909: /* reduce ATerminal$RefinesClauseTail */
		    {
			ArrayList list = new909();
			push(goTo(64), list);
		    }
		    break;
                    case 910: /* reduce ANonTerminal$RefinesClauseTail */
		    {
			ArrayList list = new910();
			push(goTo(64), list);
		    }
		    break;
                    case 911: /* reduce ATerminal$SeesClauseTail */
		    {
			ArrayList list = new911();
			push(goTo(65), list);
		    }
		    break;
                    case 912: /* reduce ANonTerminal$SeesClauseTail */
		    {
			ArrayList list = new912();
			push(goTo(65), list);
		    }
		    break;
                    case 913: /* reduce ATerminal$InvariantsTail */
		    {
			ArrayList list = new913();
			push(goTo(66), list);
		    }
		    break;
                    case 914: /* reduce ANonTerminal$InvariantsTail */
		    {
			ArrayList list = new914();
			push(goTo(66), list);
		    }
		    break;
                    case 915: /* reduce ATerminal$EventsTail */
		    {
			ArrayList list = new915();
			push(goTo(67), list);
		    }
		    break;
                    case 916: /* reduce ANonTerminal$EventsTail */
		    {
			ArrayList list = new916();
			push(goTo(67), list);
		    }
		    break;
                    case 917: /* reduce ATerminal$EventRefinesTail */
		    {
			ArrayList list = new917();
			push(goTo(68), list);
		    }
		    break;
                    case 918: /* reduce ANonTerminal$EventRefinesTail */
		    {
			ArrayList list = new918();
			push(goTo(68), list);
		    }
		    break;
                    case 919: /* reduce ATerminal$EventAnyTail */
		    {
			ArrayList list = new919();
			push(goTo(69), list);
		    }
		    break;
                    case 920: /* reduce ANonTerminal$EventAnyTail */
		    {
			ArrayList list = new920();
			push(goTo(69), list);
		    }
		    break;
                    case 921: /* reduce ATerminal$EventWhereTail */
		    {
			ArrayList list = new921();
			push(goTo(70), list);
		    }
		    break;
                    case 922: /* reduce ANonTerminal$EventWhereTail */
		    {
			ArrayList list = new922();
			push(goTo(70), list);
		    }
		    break;
                    case 923: /* reduce ATerminal$EventWithTail */
		    {
			ArrayList list = new923();
			push(goTo(71), list);
		    }
		    break;
                    case 924: /* reduce ANonTerminal$EventWithTail */
		    {
			ArrayList list = new924();
			push(goTo(71), list);
		    }
		    break;
                    case 925: /* reduce ATerminal$EventThenTail */
		    {
			ArrayList list = new925();
			push(goTo(72), list);
		    }
		    break;
                    case 926: /* reduce ANonTerminal$EventThenTail */
		    {
			ArrayList list = new926();
			push(goTo(72), list);
		    }
		    break;
                    case 927: /* reduce ATerminal$ExtendsClauseTail */
		    {
			ArrayList list = new927();
			push(goTo(73), list);
		    }
		    break;
                    case 928: /* reduce ANonTerminal$ExtendsClauseTail */
		    {
			ArrayList list = new928();
			push(goTo(73), list);
		    }
		    break;
                    case 929: /* reduce ATerminal$SetsClauseTail */
		    {
			ArrayList list = new929();
			push(goTo(74), list);
		    }
		    break;
                    case 930: /* reduce ANonTerminal$SetsClauseTail */
		    {
			ArrayList list = new930();
			push(goTo(74), list);
		    }
		    break;
                    case 931: /* reduce ATerminal$ConstantsClauseTail */
		    {
			ArrayList list = new931();
			push(goTo(75), list);
		    }
		    break;
                    case 932: /* reduce ANonTerminal$ConstantsClauseTail */
		    {
			ArrayList list = new932();
			push(goTo(75), list);
		    }
		    break;
                    case 933: /* reduce ATerminal$AxiomsClauseTail */
		    {
			ArrayList list = new933();
			push(goTo(76), list);
		    }
		    break;
                    case 934: /* reduce ANonTerminal$AxiomsClauseTail */
		    {
			ArrayList list = new934();
			push(goTo(76), list);
		    }
		    break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) this.lexer.next();
                        PParseUnit node1 = (PParseUnit) pop().get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(this.last_token,
                        "[" + this.last_line + "," + this.last_pos + "] " ,
                        Parser.errorMessages[Parser.errors[this.action[1]]]);
            }
        }
    }



     
    ArrayList new0() /* reduce AMachineParseUnit */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        pparseunitNode1 = (PParseUnit)nodeArrayList1.get(0);
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new1() /* reduce AContextParseUnit */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        pparseunitNode1 = (PParseUnit)nodeArrayList1.get(0);
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new2() /* reduce AProcedureParseUnit */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        pparseunitNode1 = (PParseUnit)nodeArrayList1.get(0);
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new3() /* reduce AAmachine1Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode8, null, listNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new4() /* reduce AAmachine2Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode9, null, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new5() /* reduce AAmachine3Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode9, null, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new6() /* reduce AAmachine4Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new7() /* reduce AAmachine5Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode9, null, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new8() /* reduce AAmachine6Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new9() /* reduce AAmachine7Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new10() /* reduce AAmachine8Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new11() /* reduce AAmachine9Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode9, null, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new12() /* reduce AAmachine10Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new13() /* reduce AAmachine11Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new14() /* reduce AAmachine12Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new15() /* reduce AAmachine13Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new16() /* reduce AAmachine14Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new17() /* reduce AAmachine15Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new18() /* reduce AAmachine16Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new19() /* reduce AAmachine17Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode9, null, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new20() /* reduce AAmachine18Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new21() /* reduce AAmachine19Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new22() /* reduce AAmachine20Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new23() /* reduce AAmachine21Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new24() /* reduce AAmachine22Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new25() /* reduce AAmachine23Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new26() /* reduce AAmachine24Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new27() /* reduce AAmachine25Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new28() /* reduce AAmachine26Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new29() /* reduce AAmachine27Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new30() /* reduce AAmachine28Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new31() /* reduce AAmachine29Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new32() /* reduce AAmachine30Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new33() /* reduce AAmachine31Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new34() /* reduce AAmachine32Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode13, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new35() /* reduce AAmachine33Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode9, null, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new36() /* reduce AAmachine34Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new37() /* reduce AAmachine35Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new38() /* reduce AAmachine36Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new39() /* reduce AAmachine37Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new40() /* reduce AAmachine38Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new41() /* reduce AAmachine39Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new42() /* reduce AAmachine40Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new43() /* reduce AAmachine41Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new44() /* reduce AAmachine42Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new45() /* reduce AAmachine43Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new46() /* reduce AAmachine44Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new47() /* reduce AAmachine45Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new48() /* reduce AAmachine46Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new49() /* reduce AAmachine47Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new50() /* reduce AAmachine48Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode13, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new51() /* reduce AAmachine49Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode10, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new52() /* reduce AAmachine50Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new53() /* reduce AAmachine51Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new54() /* reduce AAmachine52Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new55() /* reduce AAmachine53Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new56() /* reduce AAmachine54Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new57() /* reduce AAmachine55Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new58() /* reduce AAmachine56Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode13, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new59() /* reduce AAmachine57Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode11, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new60() /* reduce AAmachine58Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new61() /* reduce AAmachine59Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new62() /* reduce AAmachine60Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode13, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new63() /* reduce AAmachine61Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode12, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new64() /* reduce AAmachine62Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode13, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new65() /* reduce AAmachine63Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode13, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new66() /* reduce AAmachine64Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
          Object nullNode15 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode14, null, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new67() /* reduce AAmachine65Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode8, pvariantNode9, listNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new68() /* reduce AAmachine66Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new69() /* reduce AAmachine67Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new70() /* reduce AAmachine68Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new71() /* reduce AAmachine69Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new72() /* reduce AAmachine70Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new73() /* reduce AAmachine71Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new74() /* reduce AAmachine72Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new75() /* reduce AAmachine73Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode9, pvariantNode10, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new76() /* reduce AAmachine74Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new77() /* reduce AAmachine75Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new78() /* reduce AAmachine76Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new79() /* reduce AAmachine77Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new80() /* reduce AAmachine78Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new81() /* reduce AAmachine79Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new82() /* reduce AAmachine80Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new83() /* reduce AAmachine81Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode9, pvariantNode10, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new84() /* reduce AAmachine82Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new85() /* reduce AAmachine83Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new86() /* reduce AAmachine84Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new87() /* reduce AAmachine85Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new88() /* reduce AAmachine86Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new89() /* reduce AAmachine87Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new90() /* reduce AAmachine88Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new91() /* reduce AAmachine89Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new92() /* reduce AAmachine90Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new93() /* reduce AAmachine91Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new94() /* reduce AAmachine92Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new95() /* reduce AAmachine93Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new96() /* reduce AAmachine94Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new97() /* reduce AAmachine95Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new98() /* reduce AAmachine96Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode13, pvariantNode14, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new99() /* reduce AAmachine97Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode9, pvariantNode10, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new100() /* reduce AAmachine98Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new101() /* reduce AAmachine99Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new102() /* reduce AAmachine100Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new103() /* reduce AAmachine101Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new104() /* reduce AAmachine102Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new105() /* reduce AAmachine103Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new106() /* reduce AAmachine104Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new107() /* reduce AAmachine105Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new108() /* reduce AAmachine106Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new109() /* reduce AAmachine107Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new110() /* reduce AAmachine108Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new111() /* reduce AAmachine109Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new112() /* reduce AAmachine110Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new113() /* reduce AAmachine111Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new114() /* reduce AAmachine112Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode13, pvariantNode14, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new115() /* reduce AAmachine113Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode10, pvariantNode11, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new116() /* reduce AAmachine114Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new117() /* reduce AAmachine115Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new118() /* reduce AAmachine116Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new119() /* reduce AAmachine117Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new120() /* reduce AAmachine118Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new121() /* reduce AAmachine119Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new122() /* reduce AAmachine120Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode13, pvariantNode14, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new123() /* reduce AAmachine121Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode11, pvariantNode12, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new124() /* reduce AAmachine122Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new125() /* reduce AAmachine123Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new126() /* reduce AAmachine124Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new127() /* reduce AAmachine125Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new128() /* reduce AAmachine126Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new129() /* reduce AAmachine127Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new130() /* reduce AAmachine128Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        PVariant pvariantNode15;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        pvariantNode15 = (PVariant)nodeArrayList9.get(0);
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode14, pvariantNode15, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new131() /* reduce AAmachine129Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList3.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode8, null, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new132() /* reduce AAmachine130Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode9, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new133() /* reduce AAmachine131Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode9, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new134() /* reduce AAmachine132Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new135() /* reduce AAmachine133Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode9, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new136() /* reduce AAmachine134Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new137() /* reduce AAmachine135Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new138() /* reduce AAmachine136Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new139() /* reduce AAmachine137Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode9, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new140() /* reduce AAmachine138Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new141() /* reduce AAmachine139Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new142() /* reduce AAmachine140Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new143() /* reduce AAmachine141Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new144() /* reduce AAmachine142Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new145() /* reduce AAmachine143Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new146() /* reduce AAmachine144Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new147() /* reduce AAmachine145Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode9, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new148() /* reduce AAmachine146Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new149() /* reduce AAmachine147Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new150() /* reduce AAmachine148Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new151() /* reduce AAmachine149Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new152() /* reduce AAmachine150Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new153() /* reduce AAmachine151Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new154() /* reduce AAmachine152Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new155() /* reduce AAmachine153Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new156() /* reduce AAmachine154Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new157() /* reduce AAmachine155Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new158() /* reduce AAmachine156Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new159() /* reduce AAmachine157Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new160() /* reduce AAmachine158Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new161() /* reduce AAmachine159Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new162() /* reduce AAmachine160Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode13, null, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new163() /* reduce AAmachine161Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode9, null, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new164() /* reduce AAmachine162Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new165() /* reduce AAmachine163Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new166() /* reduce AAmachine164Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new167() /* reduce AAmachine165Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new168() /* reduce AAmachine166Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new169() /* reduce AAmachine167Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new170() /* reduce AAmachine168Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new171() /* reduce AAmachine169Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new172() /* reduce AAmachine170Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new173() /* reduce AAmachine171Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new174() /* reduce AAmachine172Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new175() /* reduce AAmachine173Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new176() /* reduce AAmachine174Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new177() /* reduce AAmachine175Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new178() /* reduce AAmachine176Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode13, null, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new179() /* reduce AAmachine177Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode10, null, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new180() /* reduce AAmachine178Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new181() /* reduce AAmachine179Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new182() /* reduce AAmachine180Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new183() /* reduce AAmachine181Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new184() /* reduce AAmachine182Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new185() /* reduce AAmachine183Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new186() /* reduce AAmachine184Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode13, null, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new187() /* reduce AAmachine185Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode11, null, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new188() /* reduce AAmachine186Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new189() /* reduce AAmachine187Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new190() /* reduce AAmachine188Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode13, null, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new191() /* reduce AAmachine189Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode12, null, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new192() /* reduce AAmachine190Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode13, null, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new193() /* reduce AAmachine191Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode13, null, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new194() /* reduce AAmachine192Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
          Object nullNode15 = null;
        LinkedList listNode17 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        LinkedList listNode16 = new LinkedList();
        listNode16 = (LinkedList)nodeArrayList9.get(0);
	if(listNode16 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode17.addAll(listNode16);
  	  //listNode17 = listNode16;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode14, null, listNode17, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new195() /* reduce AAmachine193Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode8, pvariantNode9, listNode11, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new196() /* reduce AAmachine194Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new197() /* reduce AAmachine195Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new198() /* reduce AAmachine196Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new199() /* reduce AAmachine197Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new200() /* reduce AAmachine198Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new201() /* reduce AAmachine199Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new202() /* reduce AAmachine200Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new203() /* reduce AAmachine201Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode9, pvariantNode10, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new204() /* reduce AAmachine202Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new205() /* reduce AAmachine203Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new206() /* reduce AAmachine204Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new207() /* reduce AAmachine205Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new208() /* reduce AAmachine206Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new209() /* reduce AAmachine207Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new210() /* reduce AAmachine208Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new211() /* reduce AAmachine209Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode9, pvariantNode10, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new212() /* reduce AAmachine210Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new213() /* reduce AAmachine211Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new214() /* reduce AAmachine212Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new215() /* reduce AAmachine213Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new216() /* reduce AAmachine214Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new217() /* reduce AAmachine215Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new218() /* reduce AAmachine216Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new219() /* reduce AAmachine217Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new220() /* reduce AAmachine218Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new221() /* reduce AAmachine219Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new222() /* reduce AAmachine220Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new223() /* reduce AAmachine221Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new224() /* reduce AAmachine222Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new225() /* reduce AAmachine223Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new226() /* reduce AAmachine224Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode13, pvariantNode14, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new227() /* reduce AAmachine225Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode9, pvariantNode10, listNode12, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new228() /* reduce AAmachine226Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new229() /* reduce AAmachine227Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new230() /* reduce AAmachine228Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new231() /* reduce AAmachine229Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new232() /* reduce AAmachine230Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new233() /* reduce AAmachine231Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new234() /* reduce AAmachine232Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new235() /* reduce AAmachine233Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new236() /* reduce AAmachine234Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new237() /* reduce AAmachine235Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new238() /* reduce AAmachine236Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new239() /* reduce AAmachine237Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new240() /* reduce AAmachine238Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new241() /* reduce AAmachine239Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new242() /* reduce AAmachine240Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode13, pvariantNode14, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new243() /* reduce AAmachine241Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode10, pvariantNode11, listNode13, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new244() /* reduce AAmachine242Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new245() /* reduce AAmachine243Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new246() /* reduce AAmachine244Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new247() /* reduce AAmachine245Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new248() /* reduce AAmachine246Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new249() /* reduce AAmachine247Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new250() /* reduce AAmachine248Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode13, pvariantNode14, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new251() /* reduce AAmachine249Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode11, pvariantNode12, listNode14, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new252() /* reduce AAmachine250Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new253() /* reduce AAmachine251Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new254() /* reduce AAmachine252Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new255() /* reduce AAmachine253Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new256() /* reduce AAmachine254Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new257() /* reduce AAmachine255Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode16, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new258() /* reduce AAmachine256Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        PVariant pvariantNode15;
        LinkedList listNode17 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        pvariantNode15 = (PVariant)nodeArrayList9.get(0);
        {
            // Block
        LinkedList listNode16 = new LinkedList();
        listNode16 = (LinkedList)nodeArrayList10.get(0);
	if(listNode16 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode17.addAll(listNode16);
  	  //listNode17 = listNode16;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode14, pvariantNode15, listNode17, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new259() /* reduce AAmachine257Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode11;
        palgorithmNode11 = (PAlgorithm)nodeArrayList3.get(0);
	if(palgorithmNode11 != null)
	{
	  listNode12.add(palgorithmNode11);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode8, null, listNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new260() /* reduce AAmachine258Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList4.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode9, null, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new261() /* reduce AAmachine259Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList4.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode9, null, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new262() /* reduce AAmachine260Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new263() /* reduce AAmachine261Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList4.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode9, null, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new264() /* reduce AAmachine262Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new265() /* reduce AAmachine263Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new266() /* reduce AAmachine264Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new267() /* reduce AAmachine265Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList4.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode9, null, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new268() /* reduce AAmachine266Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new269() /* reduce AAmachine267Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new270() /* reduce AAmachine268Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new271() /* reduce AAmachine269Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new272() /* reduce AAmachine270Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new273() /* reduce AAmachine271Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new274() /* reduce AAmachine272Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new275() /* reduce AAmachine273Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList4.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode9, null, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new276() /* reduce AAmachine274Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new277() /* reduce AAmachine275Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new278() /* reduce AAmachine276Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new279() /* reduce AAmachine277Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new280() /* reduce AAmachine278Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new281() /* reduce AAmachine279Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new282() /* reduce AAmachine280Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new283() /* reduce AAmachine281Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new284() /* reduce AAmachine282Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new285() /* reduce AAmachine283Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new286() /* reduce AAmachine284Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new287() /* reduce AAmachine285Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new288() /* reduce AAmachine286Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new289() /* reduce AAmachine287Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new290() /* reduce AAmachine288Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode13, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new291() /* reduce AAmachine289Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList4.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode9, null, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new292() /* reduce AAmachine290Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new293() /* reduce AAmachine291Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new294() /* reduce AAmachine292Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new295() /* reduce AAmachine293Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new296() /* reduce AAmachine294Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new297() /* reduce AAmachine295Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new298() /* reduce AAmachine296Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new299() /* reduce AAmachine297Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new300() /* reduce AAmachine298Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new301() /* reduce AAmachine299Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new302() /* reduce AAmachine300Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new303() /* reduce AAmachine301Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new304() /* reduce AAmachine302Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new305() /* reduce AAmachine303Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new306() /* reduce AAmachine304Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode13, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new307() /* reduce AAmachine305Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode10, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new308() /* reduce AAmachine306Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new309() /* reduce AAmachine307Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new310() /* reduce AAmachine308Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new311() /* reduce AAmachine309Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new312() /* reduce AAmachine310Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new313() /* reduce AAmachine311Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new314() /* reduce AAmachine312Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode13, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new315() /* reduce AAmachine313Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode11, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new316() /* reduce AAmachine314Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new317() /* reduce AAmachine315Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new318() /* reduce AAmachine316Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode13, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new319() /* reduce AAmachine317Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode12, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new320() /* reduce AAmachine318Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode13, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new321() /* reduce AAmachine319Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode13, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new322() /* reduce AAmachine320Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
          Object nullNode15 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode14, null, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new323() /* reduce AAmachine321Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode11;
        palgorithmNode11 = (PAlgorithm)nodeArrayList4.get(0);
	if(palgorithmNode11 != null)
	{
	  listNode12.add(palgorithmNode11);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode8, pvariantNode9, listNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new324() /* reduce AAmachine322Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new325() /* reduce AAmachine323Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new326() /* reduce AAmachine324Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new327() /* reduce AAmachine325Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new328() /* reduce AAmachine326Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new329() /* reduce AAmachine327Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new330() /* reduce AAmachine328Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new331() /* reduce AAmachine329Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode9, pvariantNode10, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new332() /* reduce AAmachine330Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new333() /* reduce AAmachine331Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new334() /* reduce AAmachine332Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new335() /* reduce AAmachine333Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new336() /* reduce AAmachine334Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new337() /* reduce AAmachine335Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new338() /* reduce AAmachine336Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new339() /* reduce AAmachine337Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode9, pvariantNode10, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new340() /* reduce AAmachine338Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new341() /* reduce AAmachine339Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new342() /* reduce AAmachine340Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new343() /* reduce AAmachine341Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new344() /* reduce AAmachine342Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new345() /* reduce AAmachine343Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new346() /* reduce AAmachine344Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new347() /* reduce AAmachine345Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new348() /* reduce AAmachine346Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new349() /* reduce AAmachine347Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new350() /* reduce AAmachine348Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new351() /* reduce AAmachine349Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new352() /* reduce AAmachine350Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new353() /* reduce AAmachine351Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new354() /* reduce AAmachine352Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode13, pvariantNode14, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new355() /* reduce AAmachine353Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode9, pvariantNode10, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new356() /* reduce AAmachine354Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new357() /* reduce AAmachine355Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new358() /* reduce AAmachine356Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new359() /* reduce AAmachine357Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new360() /* reduce AAmachine358Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new361() /* reduce AAmachine359Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new362() /* reduce AAmachine360Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new363() /* reduce AAmachine361Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new364() /* reduce AAmachine362Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new365() /* reduce AAmachine363Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new366() /* reduce AAmachine364Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new367() /* reduce AAmachine365Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new368() /* reduce AAmachine366Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new369() /* reduce AAmachine367Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new370() /* reduce AAmachine368Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode13, pvariantNode14, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new371() /* reduce AAmachine369Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode10, pvariantNode11, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new372() /* reduce AAmachine370Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new373() /* reduce AAmachine371Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new374() /* reduce AAmachine372Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new375() /* reduce AAmachine373Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new376() /* reduce AAmachine374Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new377() /* reduce AAmachine375Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new378() /* reduce AAmachine376Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode13, pvariantNode14, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new379() /* reduce AAmachine377Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode11, pvariantNode12, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new380() /* reduce AAmachine378Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new381() /* reduce AAmachine379Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new382() /* reduce AAmachine380Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new383() /* reduce AAmachine381Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new384() /* reduce AAmachine382Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new385() /* reduce AAmachine383Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new386() /* reduce AAmachine384Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        PVariant pvariantNode15;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        pvariantNode15 = (PVariant)nodeArrayList9.get(0);
        {
            // Block
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList10.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode14, pvariantNode15, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new387() /* reduce AAmachine385Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList3.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList4.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode8, null, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new388() /* reduce AAmachine386Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode9, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new389() /* reduce AAmachine387Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode9, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new390() /* reduce AAmachine388Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new391() /* reduce AAmachine389Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode9, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new392() /* reduce AAmachine390Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new393() /* reduce AAmachine391Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new394() /* reduce AAmachine392Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new395() /* reduce AAmachine393Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode9, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new396() /* reduce AAmachine394Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new397() /* reduce AAmachine395Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new398() /* reduce AAmachine396Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new399() /* reduce AAmachine397Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new400() /* reduce AAmachine398Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new401() /* reduce AAmachine399Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new402() /* reduce AAmachine400Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new403() /* reduce AAmachine401Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode9, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new404() /* reduce AAmachine402Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new405() /* reduce AAmachine403Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new406() /* reduce AAmachine404Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new407() /* reduce AAmachine405Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new408() /* reduce AAmachine406Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new409() /* reduce AAmachine407Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new410() /* reduce AAmachine408Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new411() /* reduce AAmachine409Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new412() /* reduce AAmachine410Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new413() /* reduce AAmachine411Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new414() /* reduce AAmachine412Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new415() /* reduce AAmachine413Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new416() /* reduce AAmachine414Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new417() /* reduce AAmachine415Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new418() /* reduce AAmachine416Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode13, null, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new419() /* reduce AAmachine417Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList4.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode9, null, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new420() /* reduce AAmachine418Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new421() /* reduce AAmachine419Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new422() /* reduce AAmachine420Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new423() /* reduce AAmachine421Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new424() /* reduce AAmachine422Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new425() /* reduce AAmachine423Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new426() /* reduce AAmachine424Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new427() /* reduce AAmachine425Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new428() /* reduce AAmachine426Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new429() /* reduce AAmachine427Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new430() /* reduce AAmachine428Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new431() /* reduce AAmachine429Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new432() /* reduce AAmachine430Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new433() /* reduce AAmachine431Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new434() /* reduce AAmachine432Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode13, null, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new435() /* reduce AAmachine433Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
          Object nullNode11 = null;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList5.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode10, null, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new436() /* reduce AAmachine434Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new437() /* reduce AAmachine435Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new438() /* reduce AAmachine436Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new439() /* reduce AAmachine437Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new440() /* reduce AAmachine438Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new441() /* reduce AAmachine439Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new442() /* reduce AAmachine440Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode13, null, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new443() /* reduce AAmachine441Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
          Object nullNode12 = null;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList6.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode11, null, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new444() /* reduce AAmachine442Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new445() /* reduce AAmachine443Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new446() /* reduce AAmachine444Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode13, null, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new447() /* reduce AAmachine445Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
          Object nullNode13 = null;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList7.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode12, null, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new448() /* reduce AAmachine446Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode13, null, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new449() /* reduce AAmachine447Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
          Object nullNode14 = null;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList8.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode13, null, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new450() /* reduce AAmachine448Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
          Object nullNode15 = null;
        LinkedList listNode17 = new LinkedList();
        LinkedList listNode19 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        LinkedList listNode16 = new LinkedList();
        listNode16 = (LinkedList)nodeArrayList9.get(0);
	if(listNode16 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode17.addAll(listNode16);
  	  //listNode17 = listNode16;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode18;
        palgorithmNode18 = (PAlgorithm)nodeArrayList10.get(0);
	if(palgorithmNode18 != null)
	{
	  listNode19.add(palgorithmNode18);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode14, null, listNode17, listNode19);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new451() /* reduce AAmachine449Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode12;
        palgorithmNode12 = (PAlgorithm)nodeArrayList5.get(0);
	if(palgorithmNode12 != null)
	{
	  listNode13.add(palgorithmNode12);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode8, pvariantNode9, listNode11, listNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new452() /* reduce AAmachine450Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new453() /* reduce AAmachine451Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new454() /* reduce AAmachine452Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new455() /* reduce AAmachine453Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode9, pvariantNode10, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new456() /* reduce AAmachine454Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new457() /* reduce AAmachine455Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new458() /* reduce AAmachine456Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new459() /* reduce AAmachine457Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode9, pvariantNode10, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new460() /* reduce AAmachine458Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new461() /* reduce AAmachine459Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new462() /* reduce AAmachine460Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new463() /* reduce AAmachine461Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new464() /* reduce AAmachine462Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new465() /* reduce AAmachine463Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new466() /* reduce AAmachine464Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new467() /* reduce AAmachine465Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode9, pvariantNode10, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new468() /* reduce AAmachine466Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new469() /* reduce AAmachine467Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new470() /* reduce AAmachine468Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new471() /* reduce AAmachine469Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new472() /* reduce AAmachine470Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new473() /* reduce AAmachine471Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new474() /* reduce AAmachine472Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new475() /* reduce AAmachine473Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new476() /* reduce AAmachine474Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new477() /* reduce AAmachine475Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new478() /* reduce AAmachine476Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new479() /* reduce AAmachine477Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new480() /* reduce AAmachine478Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new481() /* reduce AAmachine479Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new482() /* reduce AAmachine480Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList10.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode13, pvariantNode14, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new483() /* reduce AAmachine481Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode13;
        palgorithmNode13 = (PAlgorithm)nodeArrayList6.get(0);
	if(palgorithmNode13 != null)
	{
	  listNode14.add(palgorithmNode13);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, listNode9, pvariantNode10, listNode12, listNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new484() /* reduce AAmachine482Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new485() /* reduce AAmachine483Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new486() /* reduce AAmachine484Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new487() /* reduce AAmachine485Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new488() /* reduce AAmachine486Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new489() /* reduce AAmachine487Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new490() /* reduce AAmachine488Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new491() /* reduce AAmachine489Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new492() /* reduce AAmachine490Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new493() /* reduce AAmachine491Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new494() /* reduce AAmachine492Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new495() /* reduce AAmachine493Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new496() /* reduce AAmachine494Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new497() /* reduce AAmachine495Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new498() /* reduce AAmachine496Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList10.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, listNode13, pvariantNode14, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new499() /* reduce AAmachine497Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PVariant pvariantNode11;
        LinkedList listNode13 = new LinkedList();
        LinkedList listNode15 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        pvariantNode11 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode14;
        palgorithmNode14 = (PAlgorithm)nodeArrayList7.get(0);
	if(palgorithmNode14 != null)
	{
	  listNode15.add(palgorithmNode14);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, listNode10, pvariantNode11, listNode13, listNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new500() /* reduce AAmachine498Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new501() /* reduce AAmachine499Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new502() /* reduce AAmachine500Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new503() /* reduce AAmachine501Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new504() /* reduce AAmachine502Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new505() /* reduce AAmachine503Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new506() /* reduce AAmachine504Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList10.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, listNode13, pvariantNode14, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new507() /* reduce AAmachine505Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PVariant pvariantNode12;
        LinkedList listNode14 = new LinkedList();
        LinkedList listNode16 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        pvariantNode12 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode15;
        palgorithmNode15 = (PAlgorithm)nodeArrayList8.get(0);
	if(palgorithmNode15 != null)
	{
	  listNode16.add(palgorithmNode15);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, listNode11, pvariantNode12, listNode14, listNode16);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new508() /* reduce AAmachine506Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new509() /* reduce AAmachine507Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new510() /* reduce AAmachine508Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList10.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new511() /* reduce AAmachine509Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PVariant pvariantNode13;
        LinkedList listNode15 = new LinkedList();
        LinkedList listNode17 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        pvariantNode13 = (PVariant)nodeArrayList7.get(0);
        {
            // Block
        LinkedList listNode14 = new LinkedList();
        listNode14 = (LinkedList)nodeArrayList8.get(0);
	if(listNode14 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode15.addAll(listNode14);
  	  //listNode15 = listNode14;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode16;
        palgorithmNode16 = (PAlgorithm)nodeArrayList9.get(0);
	if(palgorithmNode16 != null)
	{
	  listNode17.add(palgorithmNode16);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, listNode12, pvariantNode13, listNode15, listNode17);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new512() /* reduce AAmachine510Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList10.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new513() /* reduce AAmachine511Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        PVariant pvariantNode14;
        LinkedList listNode16 = new LinkedList();
        LinkedList listNode18 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }
        pvariantNode14 = (PVariant)nodeArrayList8.get(0);
        {
            // Block
        LinkedList listNode15 = new LinkedList();
        listNode15 = (LinkedList)nodeArrayList9.get(0);
	if(listNode15 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode16.addAll(listNode15);
  	  //listNode16 = listNode15;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode17;
        palgorithmNode17 = (PAlgorithm)nodeArrayList10.get(0);
	if(palgorithmNode17 != null)
	{
	  listNode18.add(palgorithmNode17);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, listNode13, pvariantNode14, listNode16, listNode18);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new514() /* reduce AAmachine512Machine */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        PVariant pvariantNode15;
        LinkedList listNode17 = new LinkedList();
        LinkedList listNode19 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }
        pvariantNode15 = (PVariant)nodeArrayList9.get(0);
        {
            // Block
        LinkedList listNode16 = new LinkedList();
        listNode16 = (LinkedList)nodeArrayList10.get(0);
	if(listNode16 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode17.addAll(listNode16);
  	  //listNode17 = listNode16;
	}
        }
        {
            // Block
        PAlgorithm palgorithmNode18;
        palgorithmNode18 = (PAlgorithm)nodeArrayList11.get(0);
	if(palgorithmNode18 != null)
	{
	  listNode19.add(palgorithmNode18);
	}
        }

        pparseunitNode1 = new AMachineParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, listNode14, pvariantNode15, listNode17, listNode19);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new515() /* reduce AArefinesclause1RefinesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new516() /* reduce AArefinesclause2RefinesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        LinkedList listNode2 = new LinkedList();
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode3.add(tidentifierliteralNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new517() /* reduce ARefinesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	nodeList.add(tidentifierliteralNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new518() /* reduce AAseesclause1SeesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new519() /* reduce AAseesclause2SeesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        LinkedList listNode2 = new LinkedList();
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode3.add(tidentifierliteralNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new520() /* reduce ASeesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	nodeList.add(tidentifierliteralNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new521() /* reduce ASequenceTypedVariables */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PTypedVar ptypedvarNode1;
        LinkedList listNode2 = new LinkedList();
        ptypedvarNode1 = (PTypedVar)nodeArrayList1.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(ptypedvarNode1 != null)
	{
	  listNode3.add(ptypedvarNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new522() /* reduce ASingleTypedVariables */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PTypedVar ptypedvarNode1;
        ptypedvarNode1 = (PTypedVar)nodeArrayList1.get(0);
	if(ptypedvarNode1 != null)
	{
	  listNode2.add(ptypedvarNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new523() /* reduce AAtypedvariable1TypedVariable */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypedVar ptypedvarNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        TFormula tformulaNode5;
        LinkedList listNode6 = new LinkedList();
        TFormula tformulaNode7;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        tformulaNode5 = (TFormula)nodeArrayList4.get(0);
        {
            // Block
        }
        tformulaNode7 = (TFormula)nodeArrayList6.get(0);

        ptypedvarNode1 = new ATypedVar(listNode2, tidentifierliteralNode3, listNode4, tformulaNode5, listNode6, tformulaNode7);
        }
	nodeList.add(ptypedvarNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new524() /* reduce AAtypedvariable2TypedVariable */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypedVar ptypedvarNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        TFormula tformulaNode6;
        LinkedList listNode7 = new LinkedList();
        TFormula tformulaNode8;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        tformulaNode6 = (TFormula)nodeArrayList5.get(0);
        {
            // Block
        }
        tformulaNode8 = (TFormula)nodeArrayList7.get(0);

        ptypedvarNode1 = new ATypedVar(listNode3, tidentifierliteralNode4, listNode5, tformulaNode6, listNode7, tformulaNode8);
        }
	nodeList.add(ptypedvarNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new525() /* reduce AAtypedvariable3TypedVariable */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypedVar ptypedvarNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        TFormula tformulaNode6;
        LinkedList listNode7 = new LinkedList();
        TFormula tformulaNode8;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList5.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        tformulaNode6 = (TFormula)nodeArrayList4.get(0);
        {
            // Block
        }
        tformulaNode8 = (TFormula)nodeArrayList7.get(0);

        ptypedvarNode1 = new ATypedVar(listNode2, tidentifierliteralNode3, listNode5, tformulaNode6, listNode7, tformulaNode8);
        }
	nodeList.add(ptypedvarNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new526() /* reduce AAtypedvariable4TypedVariable */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypedVar ptypedvarNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        TFormula tformulaNode7;
        LinkedList listNode8 = new LinkedList();
        TFormula tformulaNode9;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList6.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        tformulaNode7 = (TFormula)nodeArrayList5.get(0);
        {
            // Block
        }
        tformulaNode9 = (TFormula)nodeArrayList8.get(0);

        ptypedvarNode1 = new ATypedVar(listNode3, tidentifierliteralNode4, listNode6, tformulaNode7, listNode8, tformulaNode9);
        }
	nodeList.add(ptypedvarNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new527() /* reduce AAtypedvariable5TypedVariable */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypedVar ptypedvarNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        TFormula tformulaNode5;
        LinkedList listNode7 = new LinkedList();
        TFormula tformulaNode8;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        tformulaNode5 = (TFormula)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList7.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        tformulaNode8 = (TFormula)nodeArrayList6.get(0);

        ptypedvarNode1 = new ATypedVar(listNode2, tidentifierliteralNode3, listNode4, tformulaNode5, listNode7, tformulaNode8);
        }
	nodeList.add(ptypedvarNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new528() /* reduce AAtypedvariable6TypedVariable */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypedVar ptypedvarNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        TFormula tformulaNode6;
        LinkedList listNode8 = new LinkedList();
        TFormula tformulaNode9;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        tformulaNode6 = (TFormula)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList8.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        tformulaNode9 = (TFormula)nodeArrayList7.get(0);

        ptypedvarNode1 = new ATypedVar(listNode3, tidentifierliteralNode4, listNode5, tformulaNode6, listNode8, tformulaNode9);
        }
	nodeList.add(ptypedvarNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new529() /* reduce AAtypedvariable7TypedVariable */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypedVar ptypedvarNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        TFormula tformulaNode6;
        LinkedList listNode8 = new LinkedList();
        TFormula tformulaNode9;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList5.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        tformulaNode6 = (TFormula)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList8.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        tformulaNode9 = (TFormula)nodeArrayList7.get(0);

        ptypedvarNode1 = new ATypedVar(listNode2, tidentifierliteralNode3, listNode5, tformulaNode6, listNode8, tformulaNode9);
        }
	nodeList.add(ptypedvarNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new530() /* reduce AAtypedvariable8TypedVariable */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypedVar ptypedvarNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        TFormula tformulaNode7;
        LinkedList listNode9 = new LinkedList();
        TFormula tformulaNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList6.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        tformulaNode7 = (TFormula)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList9.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        tformulaNode10 = (TFormula)nodeArrayList8.get(0);

        ptypedvarNode1 = new ATypedVar(listNode3, tidentifierliteralNode4, listNode6, tformulaNode7, listNode9, tformulaNode10);
        }
	nodeList.add(ptypedvarNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new531() /* reduce AVariablesClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        listNode1 = (LinkedList)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode2.addAll(listNode1);
  	  //listNode2 = listNode1;
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new532() /* reduce AAsinglevariablelist1VariableList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode4 = new LinkedList();
        {
            // Block
        PVariable pvariableNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pvariableNode1 = new AVariable(listNode2, tidentifierliteralNode3);
        }
	if(pvariableNode1 != null)
	{
	  listNode4.add(pvariableNode1);
	}
        }
	nodeList.add(listNode4);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new533() /* reduce AAsinglevariablelist2VariableList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode5 = new LinkedList();
        {
            // Block
        PVariable pvariableNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pvariableNode1 = new AVariable(listNode3, tidentifierliteralNode4);
        }
	if(pvariableNode1 != null)
	{
	  listNode5.add(pvariableNode1);
	}
        }
	nodeList.add(listNode5);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new534() /* reduce AAmultivariablelist1VariableList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode5 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PVariable pvariableNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);

        pvariableNode2 = new AVariable(listNode3, tidentifierliteralNode4);
        }
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode1);
  	  //listNode5 = listNode1;
	}
	if(pvariableNode2 != null)
	{
	  listNode5.add(pvariableNode2);
	}
        }
	nodeList.add(listNode5);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new535() /* reduce AAmultivariablelist2VariableList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode6 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PVariable pvariableNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode5;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList3.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        tidentifierliteralNode5 = (TIdentifierLiteral)nodeArrayList2.get(0);

        pvariableNode2 = new AVariable(listNode4, tidentifierliteralNode5);
        }
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode1);
  	  //listNode6 = listNode1;
	}
	if(pvariableNode2 != null)
	{
	  listNode6.add(pvariableNode2);
	}
        }
	nodeList.add(listNode6);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new536() /* reduce AAinvariantsclause1InvariantsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PInvariant pinvariantNode1;
        pinvariantNode1 = (PInvariant)nodeArrayList2.get(0);
	if(pinvariantNode1 != null)
	{
	  listNode2.add(pinvariantNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new537() /* reduce AAinvariantsclause2InvariantsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PInvariant pinvariantNode1;
        LinkedList listNode2 = new LinkedList();
        pinvariantNode1 = (PInvariant)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pinvariantNode1 != null)
	{
	  listNode3.add(pinvariantNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new538() /* reduce AInvariantsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        pinvariantNode1 = (PInvariant)nodeArrayList1.get(0);
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new539() /* reduce AAinvariant1Invariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pinvariantNode1 = new AInvariant(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new540() /* reduce AAinvariant2Invariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pinvariantNode1 = new AInvariant(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new541() /* reduce AAderivedinvariant1Invariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList2.get(0);
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);

        pinvariantNode1 = new ADerivedInvariant(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new542() /* reduce AAderivedinvariant2Invariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PInvariant pinvariantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList2.get(0);
        tformulaNode5 = (TFormula)nodeArrayList3.get(0);

        pinvariantNode1 = new ADerivedInvariant(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new543() /* reduce AAvariantclause1VariantClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PVariant pvariantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList2.get(0);

        pvariantNode1 = new AVariant(listNode2, tformulaNode3);
        }
	nodeList.add(pvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new544() /* reduce AAvariantclause2VariantClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PVariant pvariantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pvariantNode1 = new AVariant(listNode3, tformulaNode4);
        }
	nodeList.add(pvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new545() /* reduce AAeventsclause1EventsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PEvent peventNode1;
        peventNode1 = (PEvent)nodeArrayList2.get(0);
	if(peventNode1 != null)
	{
	  listNode2.add(peventNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new546() /* reduce AAeventsclause2EventsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PEvent peventNode1;
        LinkedList listNode2 = new LinkedList();
        peventNode1 = (PEvent)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(peventNode1 != null)
	{
	  listNode3.add(peventNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new547() /* reduce AEventsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        peventNode1 = (PEvent)nodeArrayList1.get(0);
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new548() /* reduce AAevent1Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new549() /* reduce AAevent2Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new550() /* reduce AAevent3Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new551() /* reduce AAevent4Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new552() /* reduce AAevent5Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new553() /* reduce AAevent6Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new554() /* reduce AAevent7Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new555() /* reduce AAevent8Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new556() /* reduce AAevent9Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new557() /* reduce AAevent10Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new558() /* reduce AAevent11Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new559() /* reduce AAevent12Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new560() /* reduce AAevent13Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new561() /* reduce AAevent14Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new562() /* reduce AAevent15Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new563() /* reduce AAevent16Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new564() /* reduce AAevent17Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new565() /* reduce AAevent18Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new566() /* reduce AAevent19Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new567() /* reduce AAevent20Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new568() /* reduce AAevent21Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new569() /* reduce AAevent22Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new570() /* reduce AAevent23Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new571() /* reduce AAevent24Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new572() /* reduce AAevent25Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new573() /* reduce AAevent26Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new574() /* reduce AAevent27Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode10, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new575() /* reduce AAevent28Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode10, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new576() /* reduce AAevent29Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new577() /* reduce AAevent30Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode9, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new578() /* reduce AAevent31Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode10, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new579() /* reduce AAevent32Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode10, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new580() /* reduce AAevent33Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new581() /* reduce AAevent34Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new582() /* reduce AAevent35Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new583() /* reduce AAevent36Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new584() /* reduce AAevent37Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new585() /* reduce AAevent38Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new586() /* reduce AAevent39Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new587() /* reduce AAevent40Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new588() /* reduce AAevent41Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new589() /* reduce AAevent42Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new590() /* reduce AAevent43Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new591() /* reduce AAevent44Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new592() /* reduce AAevent45Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new593() /* reduce AAevent46Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new594() /* reduce AAevent47Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new595() /* reduce AAevent48Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new596() /* reduce AAevent49Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new597() /* reduce AAevent50Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new598() /* reduce AAevent51Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new599() /* reduce AAevent52Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new600() /* reduce AAevent53Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new601() /* reduce AAevent54Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new602() /* reduce AAevent55Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new603() /* reduce AAevent56Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new604() /* reduce AAevent57Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new605() /* reduce AAevent58Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new606() /* reduce AAevent59Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode10, listNode12, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new607() /* reduce AAevent60Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode10, listNode12, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new608() /* reduce AAevent61Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new609() /* reduce AAevent62Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode9, listNode11, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new610() /* reduce AAevent63Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode10, listNode12, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new611() /* reduce AAevent64Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList8.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode10, listNode12, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new612() /* reduce AAevent65Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList3.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new613() /* reduce AAevent66Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new614() /* reduce AAevent67Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new615() /* reduce AAevent68Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new616() /* reduce AAevent69Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new617() /* reduce AAevent70Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new618() /* reduce AAevent71Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new619() /* reduce AAevent72Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new620() /* reduce AAevent73Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new621() /* reduce AAevent74Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new622() /* reduce AAevent75Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new623() /* reduce AAevent76Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new624() /* reduce AAevent77Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new625() /* reduce AAevent78Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new626() /* reduce AAevent79Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new627() /* reduce AAevent80Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new628() /* reduce AAevent81Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new629() /* reduce AAevent82Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new630() /* reduce AAevent83Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new631() /* reduce AAevent84Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new632() /* reduce AAevent85Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new633() /* reduce AAevent86Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new634() /* reduce AAevent87Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new635() /* reduce AAevent88Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new636() /* reduce AAevent89Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new637() /* reduce AAevent90Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new638() /* reduce AAevent91Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode10, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new639() /* reduce AAevent92Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode10, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new640() /* reduce AAevent93Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new641() /* reduce AAevent94Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode9, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new642() /* reduce AAevent95Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode10, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new643() /* reduce AAevent96Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList8.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode10, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new644() /* reduce AAevent97Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList4.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new645() /* reduce AAevent98Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new646() /* reduce AAevent99Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new647() /* reduce AAevent100Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new648() /* reduce AAevent101Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new649() /* reduce AAevent102Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new650() /* reduce AAevent103Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new651() /* reduce AAevent104Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new652() /* reduce AAevent105Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new653() /* reduce AAevent106Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new654() /* reduce AAevent107Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new655() /* reduce AAevent108Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new656() /* reduce AAevent109Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new657() /* reduce AAevent110Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new658() /* reduce AAevent111Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new659() /* reduce AAevent112Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList8.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new660() /* reduce AAevent113Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList5.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new661() /* reduce AAevent114Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new662() /* reduce AAevent115Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new663() /* reduce AAevent116Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new664() /* reduce AAevent117Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new665() /* reduce AAevent118Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new666() /* reduce AAevent119Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new667() /* reduce AAevent120Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList8.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new668() /* reduce AAevent121Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList6.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, null, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new669() /* reduce AAevent122Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
          Object nullNode5 = null;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, null, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new670() /* reduce AAevent123Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList7.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, null, listNode8, listNode10, listNode12, listNode14);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new671() /* reduce AAevent124Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, null, listNode8, listNode10, listNode12, listNode14);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new672() /* reduce AAevent125Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
          Object nullNode4 = null;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList7.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, null, peventrefinementNode5, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new673() /* reduce AAevent126Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        PConvergence pconvergenceNode4;
        PEventRefinement peventrefinementNode5;
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        LinkedList listNode13 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode4 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode5 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList7.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        {
            // Block
        LinkedList listNode12 = new LinkedList();
        listNode12 = (LinkedList)nodeArrayList8.get(0);
	if(listNode12 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode13.addAll(listNode12);
  	  //listNode13 = listNode12;
	}
        }

        peventNode1 = new AEvent(listNode2, tidentifierliteralNode3, pconvergenceNode4, peventrefinementNode5, listNode7, listNode9, listNode11, listNode13);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new674() /* reduce AAevent127Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
          Object nullNode5 = null;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList8.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, null, peventrefinementNode6, listNode8, listNode10, listNode12, listNode14);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new675() /* reduce AAevent128Event */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEvent peventNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        PConvergence pconvergenceNode5;
        PEventRefinement peventrefinementNode6;
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        LinkedList listNode14 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        pconvergenceNode5 = (PConvergence)nodeArrayList1.get(0);
        peventrefinementNode6 = (PEventRefinement)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList8.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        {
            // Block
        LinkedList listNode13 = new LinkedList();
        listNode13 = (LinkedList)nodeArrayList9.get(0);
	if(listNode13 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode14.addAll(listNode13);
  	  //listNode14 = listNode13;
	}
        }

        peventNode1 = new AEvent(listNode3, tidentifierliteralNode4, pconvergenceNode5, peventrefinementNode6, listNode8, listNode10, listNode12, listNode14);
        }
	nodeList.add(peventNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new676() /* reduce AOrdinaryConvergence */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConvergence pconvergenceNode1;
        {
            // Block

        pconvergenceNode1 = new AOrdinaryConvergence();
        }
	nodeList.add(pconvergenceNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new677() /* reduce AConvergentConvergence */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConvergence pconvergenceNode1;
        {
            // Block

        pconvergenceNode1 = new AConvergentConvergence();
        }
	nodeList.add(pconvergenceNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new678() /* reduce AAnticipatedConvergence */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConvergence pconvergenceNode1;
        {
            // Block

        pconvergenceNode1 = new AAnticipatedConvergence();
        }
	nodeList.add(pconvergenceNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new679() /* reduce ARefinesEventRefinement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PEventRefinement peventrefinementNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList1.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }

        peventrefinementNode1 = new ARefinesEventRefinement(listNode3);
        }
	nodeList.add(peventrefinementNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new680() /* reduce AExtendedEventRefinement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PEventRefinement peventrefinementNode1;
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode2;
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);

        peventrefinementNode1 = new AExtendedEventRefinement(tidentifierliteralNode2);
        }
	nodeList.add(peventrefinementNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new681() /* reduce AAeventrefines1EventRefines */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new682() /* reduce AAeventrefines2EventRefines */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        LinkedList listNode2 = new LinkedList();
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode3.add(tidentifierliteralNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new683() /* reduce AEventRefinesTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	nodeList.add(tidentifierliteralNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new684() /* reduce AAeventany1EventAny */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PParameter pparameterNode1;
        pparameterNode1 = (PParameter)nodeArrayList2.get(0);
	if(pparameterNode1 != null)
	{
	  listNode2.add(pparameterNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new685() /* reduce AAeventany2EventAny */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PParameter pparameterNode1;
        LinkedList listNode2 = new LinkedList();
        pparameterNode1 = (PParameter)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pparameterNode1 != null)
	{
	  listNode3.add(pparameterNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new686() /* reduce AEventAnyTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParameter pparameterNode1;
        pparameterNode1 = (PParameter)nodeArrayList1.get(0);
	nodeList.add(pparameterNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new687() /* reduce AAparameter1Parameter */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PParameter pparameterNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pparameterNode1 = new AParameter(listNode2, tidentifierliteralNode3);
        }
	nodeList.add(pparameterNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new688() /* reduce AAparameter2Parameter */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParameter pparameterNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pparameterNode1 = new AParameter(listNode3, tidentifierliteralNode4);
        }
	nodeList.add(pparameterNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new689() /* reduce AAeventwhere1EventWhere */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PGuard pguardNode1;
        pguardNode1 = (PGuard)nodeArrayList2.get(0);
	if(pguardNode1 != null)
	{
	  listNode2.add(pguardNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new690() /* reduce AAeventwhere2EventWhere */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PGuard pguardNode1;
        LinkedList listNode2 = new LinkedList();
        pguardNode1 = (PGuard)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pguardNode1 != null)
	{
	  listNode3.add(pguardNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new691() /* reduce AEventWhereTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        pguardNode1 = (PGuard)nodeArrayList1.get(0);
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new692() /* reduce AAguard1Guard */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pguardNode1 = new AGuard(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new693() /* reduce AAguard2Guard */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pguardNode1 = new AGuard(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new694() /* reduce AAderivedguard1Guard */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList2.get(0);
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);

        pguardNode1 = new ADerivedGuard(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new695() /* reduce AAderivedguard2Guard */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PGuard pguardNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList2.get(0);
        tformulaNode5 = (TFormula)nodeArrayList3.get(0);

        pguardNode1 = new ADerivedGuard(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pguardNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new696() /* reduce AAeventwith1EventWith */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PWitness pwitnessNode1;
        pwitnessNode1 = (PWitness)nodeArrayList2.get(0);
	if(pwitnessNode1 != null)
	{
	  listNode2.add(pwitnessNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new697() /* reduce AAeventwith2EventWith */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PWitness pwitnessNode1;
        LinkedList listNode2 = new LinkedList();
        pwitnessNode1 = (PWitness)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pwitnessNode1 != null)
	{
	  listNode3.add(pwitnessNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new698() /* reduce AEventWithTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PWitness pwitnessNode1;
        pwitnessNode1 = (PWitness)nodeArrayList1.get(0);
	nodeList.add(pwitnessNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new699() /* reduce AAwitness1Witness */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PWitness pwitnessNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pwitnessNode1 = new AWitness(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pwitnessNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new700() /* reduce AAwitness2Witness */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PWitness pwitnessNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pwitnessNode1 = new AWitness(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pwitnessNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new701() /* reduce AAeventthen1EventThen */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PAction pactionNode1;
        pactionNode1 = (PAction)nodeArrayList2.get(0);
	if(pactionNode1 != null)
	{
	  listNode2.add(pactionNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new702() /* reduce AAeventthen2EventThen */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PAction pactionNode1;
        LinkedList listNode2 = new LinkedList();
        pactionNode1 = (PAction)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pactionNode1 != null)
	{
	  listNode3.add(pactionNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new703() /* reduce AEventThenTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PAction pactionNode1;
        pactionNode1 = (PAction)nodeArrayList1.get(0);
	nodeList.add(pactionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new704() /* reduce AAaction1Action */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAction pactionNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pactionNode1 = new AAction(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pactionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new705() /* reduce AAaction2Action */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAction pactionNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pactionNode1 = new AAction(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pactionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new706() /* reduce AAprocedure1Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PPrecondition ppreconditionNode8;
        PPostcondition ppostconditionNode9;
        PSimplifiedMachine psimplifiedmachineNode10;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        ppreconditionNode8 = (PPrecondition)nodeArrayList6.get(0);
        ppostconditionNode9 = (PPostcondition)nodeArrayList7.get(0);
        psimplifiedmachineNode10 = (PSimplifiedMachine)nodeArrayList8.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7, ppreconditionNode8, ppostconditionNode9, psimplifiedmachineNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new707() /* reduce AAprocedure2Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PPrecondition ppreconditionNode9;
        PPostcondition ppostconditionNode10;
        PSimplifiedMachine psimplifiedmachineNode11;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        ppreconditionNode9 = (PPrecondition)nodeArrayList7.get(0);
        ppostconditionNode10 = (PPostcondition)nodeArrayList8.get(0);
        psimplifiedmachineNode11 = (PSimplifiedMachine)nodeArrayList9.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8, ppreconditionNode9, ppostconditionNode10, psimplifiedmachineNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new708() /* reduce AAprocedure3Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PPrecondition ppreconditionNode9;
        PPostcondition ppostconditionNode10;
        PSimplifiedMachine psimplifiedmachineNode11;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList6.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        ppreconditionNode9 = (PPrecondition)nodeArrayList7.get(0);
        ppostconditionNode10 = (PPostcondition)nodeArrayList8.get(0);
        psimplifiedmachineNode11 = (PSimplifiedMachine)nodeArrayList9.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8, ppreconditionNode9, ppostconditionNode10, psimplifiedmachineNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new709() /* reduce AAprocedure4Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList7.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new710() /* reduce AAprocedure5Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PPrecondition ppreconditionNode9;
        PPostcondition ppostconditionNode10;
        PSimplifiedMachine psimplifiedmachineNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList6.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        ppreconditionNode9 = (PPrecondition)nodeArrayList7.get(0);
        ppostconditionNode10 = (PPostcondition)nodeArrayList8.get(0);
        psimplifiedmachineNode11 = (PSimplifiedMachine)nodeArrayList9.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8, ppreconditionNode9, ppostconditionNode10, psimplifiedmachineNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new711() /* reduce AAprocedure6Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new712() /* reduce AAprocedure7Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new713() /* reduce AAprocedure8Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList8.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList7.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new714() /* reduce AAprocedure9Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PPrecondition ppreconditionNode9;
        PPostcondition ppostconditionNode10;
        PSimplifiedMachine psimplifiedmachineNode11;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList6.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        ppreconditionNode9 = (PPrecondition)nodeArrayList7.get(0);
        ppostconditionNode10 = (PPostcondition)nodeArrayList8.get(0);
        psimplifiedmachineNode11 = (PSimplifiedMachine)nodeArrayList9.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8, ppreconditionNode9, ppostconditionNode10, psimplifiedmachineNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new715() /* reduce AAprocedure10Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList7.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new716() /* reduce AAprocedure11Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList7.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new717() /* reduce AAprocedure12Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList8.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList7.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new718() /* reduce AAprocedure13Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList6.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList7.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new719() /* reduce AAprocedure14Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList8.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new720() /* reduce AAprocedure15Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList8.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new721() /* reduce AAprocedure16Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList13 = pop();
          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PPrecondition ppreconditionNode12;
        PPostcondition ppostconditionNode13;
        PSimplifiedMachine psimplifiedmachineNode14;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList8.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList9.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }
        ppreconditionNode12 = (PPrecondition)nodeArrayList10.get(0);
        ppostconditionNode13 = (PPostcondition)nodeArrayList11.get(0);
        psimplifiedmachineNode14 = (PSimplifiedMachine)nodeArrayList12.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11, ppreconditionNode12, ppostconditionNode13, psimplifiedmachineNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new722() /* reduce AAprocedure17Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PPrecondition ppreconditionNode9;
        PPostcondition ppostconditionNode10;
        PSimplifiedMachine psimplifiedmachineNode11;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        ppreconditionNode9 = (PPrecondition)nodeArrayList7.get(0);
        ppostconditionNode10 = (PPostcondition)nodeArrayList8.get(0);
        psimplifiedmachineNode11 = (PSimplifiedMachine)nodeArrayList9.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8, ppreconditionNode9, ppostconditionNode10, psimplifiedmachineNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new723() /* reduce AAprocedure18Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList7.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new724() /* reduce AAprocedure19Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList6.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList7.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new725() /* reduce AAprocedure20Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList7.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList8.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new726() /* reduce AAprocedure21Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList6.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList7.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new727() /* reduce AAprocedure22Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList8.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new728() /* reduce AAprocedure23Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList8.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new729() /* reduce AAprocedure24Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList13 = pop();
          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PPrecondition ppreconditionNode12;
        PPostcondition ppostconditionNode13;
        PSimplifiedMachine psimplifiedmachineNode14;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList8.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList7.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList9.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        ppreconditionNode12 = (PPrecondition)nodeArrayList10.get(0);
        ppostconditionNode13 = (PPostcondition)nodeArrayList11.get(0);
        psimplifiedmachineNode14 = (PSimplifiedMachine)nodeArrayList12.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11, ppreconditionNode12, ppostconditionNode13, psimplifiedmachineNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new730() /* reduce AAprocedure25Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PPrecondition ppreconditionNode10;
        PPostcondition ppostconditionNode11;
        PSimplifiedMachine psimplifiedmachineNode12;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList6.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList7.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        ppreconditionNode10 = (PPrecondition)nodeArrayList8.get(0);
        ppostconditionNode11 = (PPostcondition)nodeArrayList9.get(0);
        psimplifiedmachineNode12 = (PSimplifiedMachine)nodeArrayList10.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9, ppreconditionNode10, ppostconditionNode11, psimplifiedmachineNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new731() /* reduce AAprocedure26Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList7.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList8.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new732() /* reduce AAprocedure27Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList7.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList6.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList8.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new733() /* reduce AAprocedure28Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList13 = pop();
          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PPrecondition ppreconditionNode12;
        PPostcondition ppostconditionNode13;
        PSimplifiedMachine psimplifiedmachineNode14;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList8.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList7.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList9.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        ppreconditionNode12 = (PPrecondition)nodeArrayList10.get(0);
        ppostconditionNode13 = (PPostcondition)nodeArrayList11.get(0);
        psimplifiedmachineNode14 = (PSimplifiedMachine)nodeArrayList12.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11, ppreconditionNode12, ppostconditionNode13, psimplifiedmachineNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new734() /* reduce AAprocedure29Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        PPrecondition ppreconditionNode11;
        PPostcondition ppostconditionNode12;
        PSimplifiedMachine psimplifiedmachineNode13;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList6.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList7.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList8.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        ppreconditionNode11 = (PPrecondition)nodeArrayList9.get(0);
        ppostconditionNode12 = (PPostcondition)nodeArrayList10.get(0);
        psimplifiedmachineNode13 = (PSimplifiedMachine)nodeArrayList11.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10, ppreconditionNode11, ppostconditionNode12, psimplifiedmachineNode13);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new735() /* reduce AAprocedure30Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList13 = pop();
          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PPrecondition ppreconditionNode12;
        PPostcondition ppostconditionNode13;
        PSimplifiedMachine psimplifiedmachineNode14;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList8.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList9.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        ppreconditionNode12 = (PPrecondition)nodeArrayList10.get(0);
        ppostconditionNode13 = (PPostcondition)nodeArrayList11.get(0);
        psimplifiedmachineNode14 = (PSimplifiedMachine)nodeArrayList12.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11, ppreconditionNode12, ppostconditionNode13, psimplifiedmachineNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new736() /* reduce AAprocedure31Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList13 = pop();
          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        PPrecondition ppreconditionNode12;
        PPostcondition ppostconditionNode13;
        PSimplifiedMachine psimplifiedmachineNode14;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList8.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList6.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList9.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        ppreconditionNode12 = (PPrecondition)nodeArrayList10.get(0);
        ppostconditionNode13 = (PPostcondition)nodeArrayList11.get(0);
        psimplifiedmachineNode14 = (PSimplifiedMachine)nodeArrayList12.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11, ppreconditionNode12, ppostconditionNode13, psimplifiedmachineNode14);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new737() /* reduce AAprocedure32Procedure */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList14 = pop();
          ArrayList nodeArrayList13 = pop();
          ArrayList nodeArrayList12 = pop();
          ArrayList nodeArrayList11 = pop();
          ArrayList nodeArrayList10 = pop();
          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        PPrecondition ppreconditionNode13;
        PPostcondition ppostconditionNode14;
        PSimplifiedMachine psimplifiedmachineNode15;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList8.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList9.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList7.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList10.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        ppreconditionNode13 = (PPrecondition)nodeArrayList11.get(0);
        ppostconditionNode14 = (PPostcondition)nodeArrayList12.get(0);
        psimplifiedmachineNode15 = (PSimplifiedMachine)nodeArrayList13.get(0);

        pparseunitNode1 = new AProcedureParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12, ppreconditionNode13, ppostconditionNode14, psimplifiedmachineNode15);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new738() /* reduce AAsimplemachinebody1SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
          Object nullNode6 = null;
        LinkedList listNode7 = new LinkedList();
        PAlgorithm palgorithmNode8;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        palgorithmNode8 = (PAlgorithm)nodeArrayList2.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode4, listNode5, null, listNode7, palgorithmNode8);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new739() /* reduce AAsimplemachinebody2SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList3.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode5, listNode6, null, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new740() /* reduce AAsimplemachinebody3SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList3.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode5, listNode6, null, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new741() /* reduce AAsimplemachinebody4SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode6, listNode7, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new742() /* reduce AAsimplemachinebody5SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList3.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode5, listNode6, null, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new743() /* reduce AAsimplemachinebody6SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode6, listNode7, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new744() /* reduce AAsimplemachinebody7SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode6, listNode7, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new745() /* reduce AAsimplemachinebody8SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode7, listNode8, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new746() /* reduce AAsimplemachinebody9SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList2.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList3.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode4, listNode6, null, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new747() /* reduce AAsimplemachinebody10SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode5, listNode7, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new748() /* reduce AAsimplemachinebody11SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode5, listNode7, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new749() /* reduce AAsimplemachinebody12SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode6, listNode8, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new750() /* reduce AAsimplemachinebody13SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode5, listNode7, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new751() /* reduce AAsimplemachinebody14SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode6, listNode8, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new752() /* reduce AAsimplemachinebody15SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode6, listNode8, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new753() /* reduce AAsimplemachinebody16SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode7, listNode9, null, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new754() /* reduce AAsimplemachinebody17SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        PVariant pvariantNode6;
        LinkedList listNode7 = new LinkedList();
        PAlgorithm palgorithmNode8;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode6 = (PVariant)nodeArrayList2.get(0);
        {
            // Block
        }
        palgorithmNode8 = (PAlgorithm)nodeArrayList3.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode4, listNode5, pvariantNode6, listNode7, palgorithmNode8);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new755() /* reduce AAsimplemachinebody18SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        PVariant pvariantNode7;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode7 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode5, listNode6, pvariantNode7, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new756() /* reduce AAsimplemachinebody19SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        PVariant pvariantNode7;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode7 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode5, listNode6, pvariantNode7, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new757() /* reduce AAsimplemachinebody20SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode6, listNode7, pvariantNode8, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new758() /* reduce AAsimplemachinebody21SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        PVariant pvariantNode7;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        pvariantNode7 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode5, listNode6, pvariantNode7, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new759() /* reduce AAsimplemachinebody22SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode6, listNode7, pvariantNode8, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new760() /* reduce AAsimplemachinebody23SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode6, listNode7, pvariantNode8, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new761() /* reduce AAsimplemachinebody24SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode7, listNode8, pvariantNode9, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new762() /* reduce AAsimplemachinebody25SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        PVariant pvariantNode7;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList2.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        pvariantNode7 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode4, listNode6, pvariantNode7, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new763() /* reduce AAsimplemachinebody26SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode5, listNode7, pvariantNode8, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new764() /* reduce AAsimplemachinebody27SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode5, listNode7, pvariantNode8, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new765() /* reduce AAsimplemachinebody28SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        pvariantNode9 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode6, listNode8, pvariantNode9, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new766() /* reduce AAsimplemachinebody29SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode5, listNode7, pvariantNode8, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new767() /* reduce AAsimplemachinebody30SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        pvariantNode9 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode6, listNode8, pvariantNode9, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new768() /* reduce AAsimplemachinebody31SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        pvariantNode9 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode6, listNode8, pvariantNode9, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new769() /* reduce AAsimplemachinebody32SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList7.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode7, listNode9, pvariantNode10, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new770() /* reduce AAsimplemachinebody33SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
          Object nullNode6 = null;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList2.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList3.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode4, listNode5, null, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new771() /* reduce AAsimplemachinebody34SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode5, listNode6, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new772() /* reduce AAsimplemachinebody35SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode5, listNode6, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new773() /* reduce AAsimplemachinebody36SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode6, listNode7, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new774() /* reduce AAsimplemachinebody37SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode5, listNode6, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new775() /* reduce AAsimplemachinebody38SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode6, listNode7, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new776() /* reduce AAsimplemachinebody39SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode6, listNode7, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new777() /* reduce AAsimplemachinebody40SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode7, listNode8, null, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new778() /* reduce AAsimplemachinebody41SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList2.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList3.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode4, listNode6, null, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new779() /* reduce AAsimplemachinebody42SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode5, listNode7, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new780() /* reduce AAsimplemachinebody43SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode5, listNode7, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new781() /* reduce AAsimplemachinebody44SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode6, listNode8, null, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new782() /* reduce AAsimplemachinebody45SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
          Object nullNode8 = null;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList4.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode5, listNode7, null, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new783() /* reduce AAsimplemachinebody46SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode6, listNode8, null, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new784() /* reduce AAsimplemachinebody47SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
          Object nullNode9 = null;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList5.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode6, listNode8, null, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new785() /* reduce AAsimplemachinebody48SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
          Object nullNode10 = null;
        LinkedList listNode12 = new LinkedList();
        PAlgorithm palgorithmNode13;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList6.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        palgorithmNode13 = (PAlgorithm)nodeArrayList7.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode7, listNode9, null, listNode12, palgorithmNode13);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new786() /* reduce AAsimplemachinebody49SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        PVariant pvariantNode6;
        LinkedList listNode8 = new LinkedList();
        PAlgorithm palgorithmNode9;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode6 = (PVariant)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        palgorithmNode9 = (PAlgorithm)nodeArrayList4.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode4, listNode5, pvariantNode6, listNode8, palgorithmNode9);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new787() /* reduce AAsimplemachinebody50SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        PVariant pvariantNode7;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode7 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode5, listNode6, pvariantNode7, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new788() /* reduce AAsimplemachinebody51SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        PVariant pvariantNode7;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode7 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode5, listNode6, pvariantNode7, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new789() /* reduce AAsimplemachinebody52SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode6, listNode7, pvariantNode8, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new790() /* reduce AAsimplemachinebody53SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        PVariant pvariantNode7;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        pvariantNode7 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode5, listNode6, pvariantNode7, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new791() /* reduce AAsimplemachinebody54SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode6, listNode7, pvariantNode8, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new792() /* reduce AAsimplemachinebody55SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode6, listNode7, pvariantNode8, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new793() /* reduce AAsimplemachinebody56SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        pvariantNode9 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList7.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode7, listNode8, pvariantNode9, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new794() /* reduce AAsimplemachinebody57SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        PVariant pvariantNode7;
        LinkedList listNode9 = new LinkedList();
        PAlgorithm palgorithmNode10;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList2.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        pvariantNode7 = (PVariant)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        palgorithmNode10 = (PAlgorithm)nodeArrayList5.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode4, listNode6, pvariantNode7, listNode9, palgorithmNode10);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new795() /* reduce AAsimplemachinebody58SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode5, listNode7, pvariantNode8, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new796() /* reduce AAsimplemachinebody59SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode5, listNode7, pvariantNode8, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new797() /* reduce AAsimplemachinebody60SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        pvariantNode9 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList7.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode6, listNode8, pvariantNode9, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new798() /* reduce AAsimplemachinebody61SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        PVariant pvariantNode8;
        LinkedList listNode10 = new LinkedList();
        PAlgorithm palgorithmNode11;
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        pvariantNode8 = (PVariant)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        palgorithmNode11 = (PAlgorithm)nodeArrayList6.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode3, listNode5, listNode7, pvariantNode8, listNode10, palgorithmNode11);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new799() /* reduce AAsimplemachinebody62SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        pvariantNode9 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList7.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode4, listNode6, listNode8, pvariantNode9, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new800() /* reduce AAsimplemachinebody63SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        PVariant pvariantNode9;
        LinkedList listNode11 = new LinkedList();
        PAlgorithm palgorithmNode12;
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        pvariantNode9 = (PVariant)nodeArrayList5.get(0);
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }
        palgorithmNode12 = (PAlgorithm)nodeArrayList7.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode2, listNode4, listNode6, listNode8, pvariantNode9, listNode11, palgorithmNode12);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new801() /* reduce AAsimplemachinebody64SimpleMachineBody */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PSimplifiedMachine psimplifiedmachineNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        PVariant pvariantNode10;
        LinkedList listNode12 = new LinkedList();
        PAlgorithm palgorithmNode13;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        pvariantNode10 = (PVariant)nodeArrayList6.get(0);
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }
        palgorithmNode13 = (PAlgorithm)nodeArrayList8.get(0);

        psimplifiedmachineNode1 = new ASimplifiedMachine(listNode3, listNode5, listNode7, listNode9, pvariantNode10, listNode12, palgorithmNode13);
        }
	nodeList.add(psimplifiedmachineNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new802() /* reduce ASequenceIdentifierList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PIdentifierDefinition pidentifierdefinitionNode1;
        LinkedList listNode2 = new LinkedList();
        pidentifierdefinitionNode1 = (PIdentifierDefinition)nodeArrayList1.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pidentifierdefinitionNode1 != null)
	{
	  listNode3.add(pidentifierdefinitionNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new803() /* reduce ASingleIdentifierList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PIdentifierDefinition pidentifierdefinitionNode1;
        pidentifierdefinitionNode1 = (PIdentifierDefinition)nodeArrayList1.get(0);
	if(pidentifierdefinitionNode1 != null)
	{
	  listNode2.add(pidentifierdefinitionNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new804() /* reduce ATypedIdentifierDef */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PIdentifierDefinition pidentifierdefinitionNode1;
        {
            // Block
        TPrimitive tprimitiveNode2;
        TIdentifierLiteral tidentifierliteralNode3;
        tprimitiveNode2 = (TPrimitive)nodeArrayList1.get(0);
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);

        pidentifierdefinitionNode1 = new ATypedIdentifierDefinition(tprimitiveNode2, tidentifierliteralNode3);
        }
	nodeList.add(pidentifierdefinitionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new805() /* reduce AUntypedIdentifierDef */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PIdentifierDefinition pidentifierdefinitionNode1;
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode2;
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pidentifierdefinitionNode1 = new AUntypedIdentifierDefinition(tidentifierliteralNode2);
        }
	nodeList.add(pidentifierdefinitionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new806() /* reduce ASequenceTypingList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PTypingStmt ptypingstmtNode1;
        LinkedList listNode2 = new LinkedList();
        ptypingstmtNode1 = (PTypingStmt)nodeArrayList1.get(0);
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(ptypingstmtNode1 != null)
	{
	  listNode3.add(ptypingstmtNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new807() /* reduce ASingleTypingList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PTypingStmt ptypingstmtNode1;
        ptypingstmtNode1 = (PTypingStmt)nodeArrayList1.get(0);
	if(ptypingstmtNode1 != null)
	{
	  listNode2.add(ptypingstmtNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new808() /* reduce AAtypingstatement1TypingStatement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypingStmt ptypingstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        tformulaNode4 = (TFormula)nodeArrayList4.get(0);

        ptypingstmtNode1 = new ATypingStmt(listNode2, tidentifierliteralNode3, tformulaNode4);
        }
	nodeList.add(ptypingstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new809() /* reduce AAtypingstatement2TypingStatement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PTypingStmt ptypingstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList5.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        tformulaNode5 = (TFormula)nodeArrayList4.get(0);

        ptypingstmtNode1 = new ATypingStmt(listNode3, tidentifierliteralNode4, tformulaNode5);
        }
	nodeList.add(ptypingstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new810() /* reduce AAparseprecondition1ParsePrecondition */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PPrecondition ppreconditionNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList2.get(0);

        ppreconditionNode1 = new APrecondition(listNode2, tformulaNode3);
        }
	nodeList.add(ppreconditionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new811() /* reduce AAparseprecondition2ParsePrecondition */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PPrecondition ppreconditionNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        ppreconditionNode1 = new APrecondition(listNode3, tformulaNode4);
        }
	nodeList.add(ppreconditionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new812() /* reduce AAparsepostcondition1ParsePostcondition */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PPostcondition ppostconditionNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList2.get(0);

        ppostconditionNode1 = new APostcondition(listNode2, tformulaNode3);
        }
	nodeList.add(ppostconditionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new813() /* reduce AAparsepostcondition2ParsePostcondition */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PPostcondition ppostconditionNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        ppostconditionNode1 = new APostcondition(listNode3, tformulaNode4);
        }
	nodeList.add(ppostconditionNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new814() /* reduce AAlgorithm */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAlgorithm palgorithmNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }

        palgorithmNode1 = new AAlgorithm(listNode3);
        }
	nodeList.add(palgorithmNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new815() /* reduce AAsequencealgblock1AlgBlock */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PStmt pstmtNode1;
        PStmt pstmtNode2;
        pstmtNode1 = (PStmt)nodeArrayList1.get(0);
        pstmtNode2 = (PStmt)nodeArrayList3.get(0);
	if(pstmtNode1 != null)
	{
	  listNode3.add(pstmtNode1);
	}
	if(pstmtNode2 != null)
	{
	  listNode3.add(pstmtNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new816() /* reduce AAsequencealgblock2AlgBlock */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode4 = new LinkedList();
        {
            // Block
        PStmt pstmtNode1;
        PStmt pstmtNode2;
        LinkedList listNode3 = new LinkedList();
        pstmtNode1 = (PStmt)nodeArrayList1.get(0);
        pstmtNode2 = (PStmt)nodeArrayList3.get(0);
        listNode3 = (LinkedList)nodeArrayList4.get(0);
	if(pstmtNode1 != null)
	{
	  listNode4.add(pstmtNode1);
	}
	if(pstmtNode2 != null)
	{
	  listNode4.add(pstmtNode2);
	}
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }
	nodeList.add(listNode4);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new817() /* reduce ANextLevelAlgBlock */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PStmt pstmtNode1;
        pstmtNode1 = (PStmt)nodeArrayList1.get(0);
	if(pstmtNode1 != null)
	{
	  listNode2.add(pstmtNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new818() /* reduce AAassertstatement1Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList3.get(0);

        pstmtNode1 = new AAssertStmt(listNode2, tformulaNode3);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new819() /* reduce AAassertstatement2Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);

        pstmtNode1 = new AAssertStmt(listNode3, tformulaNode4);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new820() /* reduce AAassignstatement1Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        pstmtNode1 = new AAssignStmt(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new821() /* reduce AAassignstatement2Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        pstmtNode1 = new AAssignStmt(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new822() /* reduce AAsimplestatement1Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList3.get(0);

        pstmtNode1 = new ASimpleAssignStmt(listNode2, tformulaNode3);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new823() /* reduce AAsimplestatement2Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);

        pstmtNode1 = new ASimpleAssignStmt(listNode3, tformulaNode4);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new824() /* reduce AAwhilestatement1Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        LinkedList listNode5 = new LinkedList();
          Object nullNode6 = null;
          Object nullNode7 = null;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList5.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }

        pstmtNode1 = new AWhileStmt(listNode2, tformulaNode3, listNode5, null, null);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new825() /* reduce AAwhilestatement2Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
          Object nullNode8 = null;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList6.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }

        pstmtNode1 = new AWhileStmt(listNode3, tformulaNode4, listNode6, null, null);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new826() /* reduce AAwhilestatement3Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        LinkedList listNode5 = new LinkedList();
        PLoopInvariant ploopinvariantNode6;
          Object nullNode7 = null;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList6.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        ploopinvariantNode6 = (PLoopInvariant)nodeArrayList4.get(0);

        pstmtNode1 = new AWhileStmt(listNode2, tformulaNode3, listNode5, ploopinvariantNode6, null);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new827() /* reduce AAwhilestatement4Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        LinkedList listNode6 = new LinkedList();
        PLoopInvariant ploopinvariantNode7;
          Object nullNode8 = null;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList7.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        ploopinvariantNode7 = (PLoopInvariant)nodeArrayList5.get(0);

        pstmtNode1 = new AWhileStmt(listNode3, tformulaNode4, listNode6, ploopinvariantNode7, null);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new828() /* reduce AAwhilestatement5Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        LinkedList listNode5 = new LinkedList();
          Object nullNode6 = null;
        PLoopVariant ploopvariantNode7;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList6.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        ploopvariantNode7 = (PLoopVariant)nodeArrayList4.get(0);

        pstmtNode1 = new AWhileStmt(listNode2, tformulaNode3, listNode5, null, ploopvariantNode7);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new829() /* reduce AAwhilestatement6Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        LinkedList listNode6 = new LinkedList();
          Object nullNode7 = null;
        PLoopVariant ploopvariantNode8;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList7.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        ploopvariantNode8 = (PLoopVariant)nodeArrayList5.get(0);

        pstmtNode1 = new AWhileStmt(listNode3, tformulaNode4, listNode6, null, ploopvariantNode8);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new830() /* reduce AAwhilestatement7Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        LinkedList listNode5 = new LinkedList();
        PLoopInvariant ploopinvariantNode6;
        PLoopVariant ploopvariantNode7;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList7.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        ploopinvariantNode6 = (PLoopInvariant)nodeArrayList4.get(0);
        ploopvariantNode7 = (PLoopVariant)nodeArrayList5.get(0);

        pstmtNode1 = new AWhileStmt(listNode2, tformulaNode3, listNode5, ploopinvariantNode6, ploopvariantNode7);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new831() /* reduce AAwhilestatement8Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList9 = pop();
          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        LinkedList listNode6 = new LinkedList();
        PLoopInvariant ploopinvariantNode7;
        PLoopVariant ploopvariantNode8;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList8.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        ploopinvariantNode7 = (PLoopInvariant)nodeArrayList5.get(0);
        ploopvariantNode8 = (PLoopVariant)nodeArrayList6.get(0);

        pstmtNode1 = new AWhileStmt(listNode3, tformulaNode4, listNode6, ploopinvariantNode7, ploopvariantNode8);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new832() /* reduce AAifstatement1Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList5.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }

        pstmtNode1 = new AIfStmt(listNode2, tformulaNode3, listNode5, listNode6);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new833() /* reduce AAifstatement2Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList6.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }

        pstmtNode1 = new AIfStmt(listNode3, tformulaNode4, listNode6, listNode7);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new834() /* reduce AAifstatement3Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList5.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList6.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }

        pstmtNode1 = new AIfStmt(listNode2, tformulaNode3, listNode5, listNode7);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new835() /* reduce AAifstatement4Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList6.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList7.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }

        pstmtNode1 = new AIfStmt(listNode3, tformulaNode4, listNode6, listNode8);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new836() /* reduce AAreturnstatement1Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        }
        {
            // Block
        }

        pstmtNode1 = new AReturnStmt(listNode2, listNode3);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new837() /* reduce AAreturnstatement2Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        {
            // Block
        }
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        listNode3 = (LinkedList)nodeArrayList2.get(0);
	if(listNode3 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode4.addAll(listNode3);
  	  //listNode4 = listNode3;
	}
        }

        pstmtNode1 = new AReturnStmt(listNode2, listNode4);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new838() /* reduce AAreturnstatement3Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode4 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        }

        pstmtNode1 = new AReturnStmt(listNode3, listNode4);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new839() /* reduce AAreturnstatement4Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList2.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }

        pstmtNode1 = new AReturnStmt(listNode3, listNode5);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new840() /* reduce AAcallstatement1Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList1.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }

        pstmtNode1 = new ACallStmt(listNode2, tidentifierliteralNode3, listNode5, listNode6);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new841() /* reduce AAcallstatement2Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList1.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }

        pstmtNode1 = new ACallStmt(listNode2, tidentifierliteralNode3, listNode5, listNode7);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new842() /* reduce AAcallstatement3Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList6.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList1.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }

        pstmtNode1 = new ACallStmt(listNode3, tidentifierliteralNode4, listNode6, listNode7);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new843() /* reduce AAcallstatement4Statement */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PStmt pstmtNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList7.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList1.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }

        pstmtNode1 = new ACallStmt(listNode3, tidentifierliteralNode4, listNode6, listNode8);
        }
	nodeList.add(pstmtNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new844() /* reduce AIfElse */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        listNode1 = (LinkedList)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode2.addAll(listNode1);
  	  //listNode2 = listNode1;
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new845() /* reduce ASingleStmtTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PStmt pstmtNode1;
        pstmtNode1 = (PStmt)nodeArrayList2.get(0);
	if(pstmtNode1 != null)
	{
	  listNode2.add(pstmtNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new846() /* reduce AMultiStmtTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PStmt pstmtNode1;
        LinkedList listNode2 = new LinkedList();
        pstmtNode1 = (PStmt)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pstmtNode1 != null)
	{
	  listNode3.add(pstmtNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new847() /* reduce AAloopinvariant1LoopInvariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PLoopInvariant ploopinvariantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList2.get(0);

        ploopinvariantNode1 = new ALoopInvariant(listNode2, tformulaNode3);
        }
	nodeList.add(ploopinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new848() /* reduce AAloopinvariant2LoopInvariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PLoopInvariant ploopinvariantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        ploopinvariantNode1 = new ALoopInvariant(listNode3, tformulaNode4);
        }
	nodeList.add(ploopinvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new849() /* reduce AAloopvariant1LoopVariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PLoopVariant ploopvariantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TFormula tformulaNode3;
        {
            // Block
        }
        tformulaNode3 = (TFormula)nodeArrayList2.get(0);

        ploopvariantNode1 = new ALoopVariant(listNode2, tformulaNode3);
        }
	nodeList.add(ploopvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new850() /* reduce AAloopvariant2LoopVariant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PLoopVariant ploopvariantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TFormula tformulaNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        ploopvariantNode1 = new ALoopVariant(listNode3, tformulaNode4);
        }
	nodeList.add(ploopvariantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new851() /* reduce AMultipleIdList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PId pidNode1;
        LinkedList listNode2 = new LinkedList();
        pidNode1 = (PId)nodeArrayList1.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pidNode1 != null)
	{
	  listNode3.add(pidNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new852() /* reduce ASingleIdList */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PId pidNode1;
        pidNode1 = (PId)nodeArrayList1.get(0);
	if(pidNode1 != null)
	{
	  listNode2.add(pidNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new853() /* reduce AParseId */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PId pidNode1;
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode2;
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pidNode1 = new AId(tidentifierliteralNode2);
        }
	nodeList.add(pidNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new854() /* reduce AAcontext1Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode7);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new855() /* reduce AAcontext2Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new856() /* reduce AAcontext3Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new857() /* reduce AAcontext4Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new858() /* reduce AAcontext5Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new859() /* reduce AAcontext6Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new860() /* reduce AAcontext7Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new861() /* reduce AAcontext8Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new862() /* reduce AAcontext9Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new863() /* reduce AAcontext10Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new864() /* reduce AAcontext11Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new865() /* reduce AAcontext12Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new866() /* reduce AAcontext13Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new867() /* reduce AAcontext14Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new868() /* reduce AAcontext15Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new869() /* reduce AAcontext16Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new870() /* reduce AAcontext17Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList3.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode6, listNode8);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new871() /* reduce AAcontext18Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode7, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new872() /* reduce AAcontext19Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode7, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new873() /* reduce AAcontext20Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new874() /* reduce AAcontext21Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode7, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new875() /* reduce AAcontext22Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new876() /* reduce AAcontext23Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new877() /* reduce AAcontext24Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new878() /* reduce AAcontext25Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList4.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode5, listNode7, listNode9);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new879() /* reduce AAcontext26Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode6, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new880() /* reduce AAcontext27Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode6, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new881() /* reduce AAcontext28Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode7, listNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new882() /* reduce AAcontext29Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList4.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList5.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode4, listNode6, listNode8, listNode10);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new883() /* reduce AAcontext30Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode5, listNode7, listNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new884() /* reduce AAcontext31Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        LinkedList listNode9 = new LinkedList();
        LinkedList listNode11 = new LinkedList();
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode5.addAll(listNode4);
  	  //listNode5 = listNode4;
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode7.addAll(listNode6);
  	  //listNode7 = listNode6;
	}
        }
        {
            // Block
        LinkedList listNode8 = new LinkedList();
        listNode8 = (LinkedList)nodeArrayList5.get(0);
	if(listNode8 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode9.addAll(listNode8);
  	  //listNode9 = listNode8;
	}
        }
        {
            // Block
        LinkedList listNode10 = new LinkedList();
        listNode10 = (LinkedList)nodeArrayList6.get(0);
	if(listNode10 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode11.addAll(listNode10);
  	  //listNode11 = listNode10;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode2, tidentifierliteralNode3, listNode5, listNode7, listNode9, listNode11);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new885() /* reduce AAcontext32Context */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList8 = pop();
          ArrayList nodeArrayList7 = pop();
          ArrayList nodeArrayList6 = pop();
          ArrayList nodeArrayList5 = pop();
          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PParseUnit pparseunitNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        LinkedList listNode6 = new LinkedList();
        LinkedList listNode8 = new LinkedList();
        LinkedList listNode10 = new LinkedList();
        LinkedList listNode12 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode6.addAll(listNode5);
  	  //listNode6 = listNode5;
	}
        }
        {
            // Block
        LinkedList listNode7 = new LinkedList();
        listNode7 = (LinkedList)nodeArrayList5.get(0);
	if(listNode7 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode8.addAll(listNode7);
  	  //listNode8 = listNode7;
	}
        }
        {
            // Block
        LinkedList listNode9 = new LinkedList();
        listNode9 = (LinkedList)nodeArrayList6.get(0);
	if(listNode9 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode10.addAll(listNode9);
  	  //listNode10 = listNode9;
	}
        }
        {
            // Block
        LinkedList listNode11 = new LinkedList();
        listNode11 = (LinkedList)nodeArrayList7.get(0);
	if(listNode11 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode12.addAll(listNode11);
  	  //listNode12 = listNode11;
	}
        }

        pparseunitNode1 = new AContextParseUnit(listNode3, tidentifierliteralNode4, listNode6, listNode8, listNode10, listNode12);
        }
	nodeList.add(pparseunitNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new886() /* reduce AAextendsclause1ExtendsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new887() /* reduce AAextendsclause2ExtendsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        LinkedList listNode2 = new LinkedList();
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode3.add(tidentifierliteralNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new888() /* reduce AExtendsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	nodeList.add(tidentifierliteralNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new889() /* reduce AAsetsclause1SetsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PCarrierSet pcarriersetNode1;
        pcarriersetNode1 = (PCarrierSet)nodeArrayList2.get(0);
	if(pcarriersetNode1 != null)
	{
	  listNode2.add(pcarriersetNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new890() /* reduce AAsetsclause2SetsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PCarrierSet pcarriersetNode1;
        LinkedList listNode2 = new LinkedList();
        pcarriersetNode1 = (PCarrierSet)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pcarriersetNode1 != null)
	{
	  listNode3.add(pcarriersetNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new891() /* reduce ASetsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PCarrierSet pcarriersetNode1;
        pcarriersetNode1 = (PCarrierSet)nodeArrayList1.get(0);
	nodeList.add(pcarriersetNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new892() /* reduce AAset1Set */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PCarrierSet pcarriersetNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pcarriersetNode1 = new ACarrierSet(listNode2, tidentifierliteralNode3);
        }
	nodeList.add(pcarriersetNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new893() /* reduce AAset2Set */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PCarrierSet pcarriersetNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pcarriersetNode1 = new ACarrierSet(listNode3, tidentifierliteralNode4);
        }
	nodeList.add(pcarriersetNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new894() /* reduce AAconstantsclause1ConstantsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PConstant pconstantNode1;
        pconstantNode1 = (PConstant)nodeArrayList2.get(0);
	if(pconstantNode1 != null)
	{
	  listNode2.add(pconstantNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new895() /* reduce AAconstantsclause2ConstantsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PConstant pconstantNode1;
        LinkedList listNode2 = new LinkedList();
        pconstantNode1 = (PConstant)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(pconstantNode1 != null)
	{
	  listNode3.add(pconstantNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new896() /* reduce AConstantsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConstant pconstantNode1;
        pconstantNode1 = (PConstant)nodeArrayList1.get(0);
	nodeList.add(pconstantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new897() /* reduce AAconstant1Constant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PConstant pconstantNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode3;
        {
            // Block
        }
        tidentifierliteralNode3 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pconstantNode1 = new AConstant(listNode2, tidentifierliteralNode3);
        }
	nodeList.add(pconstantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new898() /* reduce AAconstant2Constant */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PConstant pconstantNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode4;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList2.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tidentifierliteralNode4 = (TIdentifierLiteral)nodeArrayList1.get(0);

        pconstantNode1 = new AConstant(listNode3, tidentifierliteralNode4);
        }
	nodeList.add(pconstantNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new899() /* reduce AAaxiomsclause1AxiomsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PAxiom paxiomNode1;
        paxiomNode1 = (PAxiom)nodeArrayList2.get(0);
	if(paxiomNode1 != null)
	{
	  listNode2.add(paxiomNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new900() /* reduce AAaxiomsclause2AxiomsClause */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        PAxiom paxiomNode1;
        LinkedList listNode2 = new LinkedList();
        paxiomNode1 = (PAxiom)nodeArrayList2.get(0);
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(paxiomNode1 != null)
	{
	  listNode3.add(paxiomNode1);
	}
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new901() /* reduce AAxiomsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        paxiomNode1 = (PAxiom)nodeArrayList1.get(0);
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new902() /* reduce AAaxiom1Axiom */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList1.get(0);
        tformulaNode4 = (TFormula)nodeArrayList2.get(0);

        paxiomNode1 = new AAxiom(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new903() /* reduce AAaxiom2Axiom */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList3.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList1.get(0);
        tformulaNode5 = (TFormula)nodeArrayList2.get(0);

        paxiomNode1 = new AAxiom(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new904() /* reduce AAderivedaxiom1Axiom */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        TLabel tlabelNode3;
        TFormula tformulaNode4;
        {
            // Block
        }
        tlabelNode3 = (TLabel)nodeArrayList2.get(0);
        tformulaNode4 = (TFormula)nodeArrayList3.get(0);

        paxiomNode1 = new ADerivedAxiom(listNode2, tlabelNode3, tformulaNode4);
        }
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new905() /* reduce AAderivedaxiom2Axiom */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList4 = pop();
          ArrayList nodeArrayList3 = pop();
          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        PAxiom paxiomNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        TLabel tlabelNode4;
        TFormula tformulaNode5;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList4.get(0);
	if(listNode2 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode2);
  	  //listNode3 = listNode2;
	}
        }
        tlabelNode4 = (TLabel)nodeArrayList2.get(0);
        tformulaNode5 = (TFormula)nodeArrayList3.get(0);

        paxiomNode1 = new ADerivedAxiom(listNode3, tlabelNode4, tformulaNode5);
        }
	nodeList.add(paxiomNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new906() /* reduce ALabel */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        TLabel tlabelNode1;
        tlabelNode1 = (TLabel)nodeArrayList2.get(0);
	nodeList.add(tlabelNode1);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new907() /* reduce ATerminal$Comment */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TComment tcommentNode1;
        tcommentNode1 = (TComment)nodeArrayList1.get(0);
	if(tcommentNode1 != null)
	{
	  listNode2.add(tcommentNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new908() /* reduce ANonTerminal$Comment */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TComment tcommentNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tcommentNode2 = (TComment)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tcommentNode2 != null)
	{
	  listNode3.add(tcommentNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new909() /* reduce ATerminal$RefinesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new910() /* reduce ANonTerminal$RefinesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tidentifierliteralNode2 != null)
	{
	  listNode3.add(tidentifierliteralNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new911() /* reduce ATerminal$SeesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new912() /* reduce ANonTerminal$SeesClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tidentifierliteralNode2 != null)
	{
	  listNode3.add(tidentifierliteralNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new913() /* reduce ATerminal$InvariantsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PInvariant pinvariantNode1;
        pinvariantNode1 = (PInvariant)nodeArrayList1.get(0);
	if(pinvariantNode1 != null)
	{
	  listNode2.add(pinvariantNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new914() /* reduce ANonTerminal$InvariantsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PInvariant pinvariantNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pinvariantNode2 = (PInvariant)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pinvariantNode2 != null)
	{
	  listNode3.add(pinvariantNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new915() /* reduce ATerminal$EventsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PEvent peventNode1;
        peventNode1 = (PEvent)nodeArrayList1.get(0);
	if(peventNode1 != null)
	{
	  listNode2.add(peventNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new916() /* reduce ANonTerminal$EventsTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PEvent peventNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        peventNode2 = (PEvent)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(peventNode2 != null)
	{
	  listNode3.add(peventNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new917() /* reduce ATerminal$EventRefinesTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new918() /* reduce ANonTerminal$EventRefinesTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tidentifierliteralNode2 != null)
	{
	  listNode3.add(tidentifierliteralNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new919() /* reduce ATerminal$EventAnyTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PParameter pparameterNode1;
        pparameterNode1 = (PParameter)nodeArrayList1.get(0);
	if(pparameterNode1 != null)
	{
	  listNode2.add(pparameterNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new920() /* reduce ANonTerminal$EventAnyTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PParameter pparameterNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pparameterNode2 = (PParameter)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pparameterNode2 != null)
	{
	  listNode3.add(pparameterNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new921() /* reduce ATerminal$EventWhereTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PGuard pguardNode1;
        pguardNode1 = (PGuard)nodeArrayList1.get(0);
	if(pguardNode1 != null)
	{
	  listNode2.add(pguardNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new922() /* reduce ANonTerminal$EventWhereTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PGuard pguardNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pguardNode2 = (PGuard)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pguardNode2 != null)
	{
	  listNode3.add(pguardNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new923() /* reduce ATerminal$EventWithTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PWitness pwitnessNode1;
        pwitnessNode1 = (PWitness)nodeArrayList1.get(0);
	if(pwitnessNode1 != null)
	{
	  listNode2.add(pwitnessNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new924() /* reduce ANonTerminal$EventWithTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PWitness pwitnessNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pwitnessNode2 = (PWitness)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pwitnessNode2 != null)
	{
	  listNode3.add(pwitnessNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new925() /* reduce ATerminal$EventThenTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PAction pactionNode1;
        pactionNode1 = (PAction)nodeArrayList1.get(0);
	if(pactionNode1 != null)
	{
	  listNode2.add(pactionNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new926() /* reduce ANonTerminal$EventThenTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PAction pactionNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pactionNode2 = (PAction)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pactionNode2 != null)
	{
	  listNode3.add(pactionNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new927() /* reduce ATerminal$ExtendsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        TIdentifierLiteral tidentifierliteralNode1;
        tidentifierliteralNode1 = (TIdentifierLiteral)nodeArrayList1.get(0);
	if(tidentifierliteralNode1 != null)
	{
	  listNode2.add(tidentifierliteralNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new928() /* reduce ANonTerminal$ExtendsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        TIdentifierLiteral tidentifierliteralNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        tidentifierliteralNode2 = (TIdentifierLiteral)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(tidentifierliteralNode2 != null)
	{
	  listNode3.add(tidentifierliteralNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new929() /* reduce ATerminal$SetsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PCarrierSet pcarriersetNode1;
        pcarriersetNode1 = (PCarrierSet)nodeArrayList1.get(0);
	if(pcarriersetNode1 != null)
	{
	  listNode2.add(pcarriersetNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new930() /* reduce ANonTerminal$SetsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PCarrierSet pcarriersetNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pcarriersetNode2 = (PCarrierSet)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pcarriersetNode2 != null)
	{
	  listNode3.add(pcarriersetNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new931() /* reduce ATerminal$ConstantsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PConstant pconstantNode1;
        pconstantNode1 = (PConstant)nodeArrayList1.get(0);
	if(pconstantNode1 != null)
	{
	  listNode2.add(pconstantNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new932() /* reduce ANonTerminal$ConstantsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PConstant pconstantNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pconstantNode2 = (PConstant)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(pconstantNode2 != null)
	{
	  listNode3.add(pconstantNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new933() /* reduce ATerminal$AxiomsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PAxiom paxiomNode1;
        paxiomNode1 = (PAxiom)nodeArrayList1.get(0);
	if(paxiomNode1 != null)
	{
	  listNode2.add(paxiomNode1);
	}
        }
	nodeList.add(listNode2);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


     
    ArrayList new934() /* reduce ANonTerminal$AxiomsClauseTail */
    {
        this.firstPopped = null;
        this.lastPopped = null;
          ArrayList nodeList = new ArrayList();

          ArrayList nodeArrayList2 = pop();
          ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PAxiom paxiomNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        paxiomNode2 = (PAxiom)nodeArrayList2.get(0);
	if(listNode1 != null) //Macro:ParserTypedLinkedListAddAll
	{
      listNode3.addAll(listNode1);
  	  //listNode3 = listNode1;
	}
	if(paxiomNode2 != null)
	{
	  listNode3.add(paxiomNode2);
	}
        }
	nodeList.add(listNode3);
        // return nodeList;
        final ArrayList containerList = nodeList;
        Object elementToCheck = containerList.get(0);
        checkResult(elementToCheck);
        
        return containerList;
    }


    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {15, SHIFT, 1}, {25, SHIFT, 2}, {43, SHIFT, 3}, },
			{{-1, ERROR, 1}, {52, SHIFT, 8}, },
			{{-1, ERROR, 2}, {52, SHIFT, 9}, },
			{{-1, ERROR, 3}, {52, SHIFT, 10}, },
			{{-1, ERROR, 4}, {55, ACCEPT, -1}, },
			{{-1, REDUCE, 0}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 1}, },
			{{-1, ERROR, 8}, {0, SHIFT, 11}, {16, SHIFT, 12}, {17, SHIFT, 13}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 18}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, ERROR, 9}, {0, SHIFT, 11}, {24, SHIFT, 31}, {26, SHIFT, 32}, {27, SHIFT, 33}, {28, SHIFT, 34}, {29, SHIFT, 35}, },
			{{-1, ERROR, 10}, {5, SHIFT, 41}, },
			{{-1, REDUCE, 907}, },
			{{-1, ERROR, 12}, {52, SHIFT, 42}, },
			{{-1, ERROR, 13}, {52, SHIFT, 43}, },
			{{-1, ERROR, 14}, {52, SHIFT, 44}, },
			{{-1, ERROR, 15}, {3, SHIFT, 46}, {20, SHIFT, 47}, },
			{{-1, ERROR, 16}, {12, SHIFT, 50}, {13, SHIFT, 51}, {14, SHIFT, 52}, {30, SHIFT, 53}, },
			{{-1, ERROR, 17}, {54, SHIFT, 56}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 19}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 20}, {52, SHIFT, 68}, },
			{{-1, ERROR, 21}, {17, SHIFT, 13}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 69}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, ERROR, 22}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 77}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, ERROR, 23}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 84}, {39, SHIFT, 19}, },
			{{-1, REDUCE, 522}, {9, SHIFT, 90}, },
			{{-1, ERROR, 25}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 91}, {39, SHIFT, 19}, },
			{{-1, ERROR, 26}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 96}, {39, SHIFT, 19}, },
			{{-1, ERROR, 27}, {21, SHIFT, 16}, {24, SHIFT, 100}, {39, SHIFT, 19}, },
			{{-1, ERROR, 28}, {24, SHIFT, 103}, {39, SHIFT, 19}, },
			{{-1, ERROR, 29}, {24, SHIFT, 105}, },
			{{-1, ERROR, 30}, {0, SHIFT, 106}, {16, SHIFT, 12}, {17, SHIFT, 13}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 107}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, REDUCE, 854}, },
			{{-1, ERROR, 32}, {52, SHIFT, 116}, },
			{{-1, ERROR, 33}, {52, SHIFT, 117}, },
			{{-1, ERROR, 34}, {52, SHIFT, 119}, },
			{{-1, ERROR, 35}, {3, SHIFT, 46}, {20, SHIFT, 121}, },
			{{-1, ERROR, 36}, {24, SHIFT, 124}, {27, SHIFT, 33}, {28, SHIFT, 34}, {29, SHIFT, 35}, },
			{{-1, ERROR, 37}, {24, SHIFT, 128}, {28, SHIFT, 34}, {29, SHIFT, 35}, },
			{{-1, ERROR, 38}, {24, SHIFT, 131}, {29, SHIFT, 35}, },
			{{-1, ERROR, 39}, {24, SHIFT, 133}, },
			{{-1, ERROR, 40}, {0, SHIFT, 106}, {24, SHIFT, 134}, {26, SHIFT, 32}, {27, SHIFT, 33}, {28, SHIFT, 34}, {29, SHIFT, 35}, },
			{{-1, ERROR, 41}, {6, SHIFT, 139}, {48, SHIFT, 140}, {52, SHIFT, 141}, },
			{{-1, REDUCE, 515}, {52, SHIFT, 144}, },
			{{-1, REDUCE, 518}, {52, SHIFT, 147}, },
			{{-1, REDUCE, 532}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 531}, {52, SHIFT, 151}, },
			{{-1, ERROR, 46}, {53, SHIFT, 152}, },
			{{-1, ERROR, 47}, {3, SHIFT, 46}, },
			{{-1, REDUCE, 536}, {3, SHIFT, 46}, {20, SHIFT, 47}, },
			{{-1, ERROR, 49}, {54, SHIFT, 157}, },
			{{-1, REDUCE, 676}, },
			{{-1, REDUCE, 677}, },
			{{-1, REDUCE, 678}, },
			{{-1, ERROR, 53}, {52, SHIFT, 158}, },
			{{-1, REDUCE, 545}, {12, SHIFT, 50}, {13, SHIFT, 51}, {14, SHIFT, 52}, {30, SHIFT, 53}, },
			{{-1, ERROR, 55}, {30, SHIFT, 162}, },
			{{-1, REDUCE, 543}, {0, SHIFT, 11}, },
			{{-1, ERROR, 57}, {8, SHIFT, 164}, },
			{{-1, ERROR, 58}, {8, SHIFT, 165}, },
			{{-1, REDUCE, 836}, {0, SHIFT, 11}, {52, SHIFT, 62}, },
			{{-1, ERROR, 60}, {8, SHIFT, 168}, },
			{{-1, ERROR, 61}, {8, SHIFT, 169}, },
			{{-1, REDUCE, 853}, },
			{{-1, ERROR, 63}, {24, SHIFT, 170}, },
			{{-1, REDUCE, 817}, {9, SHIFT, 171}, },
			{{-1, ERROR, 65}, {10, SHIFT, 172}, },
			{{-1, REDUCE, 852}, {4, SHIFT, 173}, },
			{{-1, ERROR, 67}, {54, SHIFT, 174}, },
			{{-1, ERROR, 68}, {0, SHIFT, 11}, {50, SHIFT, 175}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 70}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 177}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, ERROR, 71}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 184}, {39, SHIFT, 19}, },
			{{-1, ERROR, 72}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 190}, {39, SHIFT, 19}, },
			{{-1, ERROR, 73}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 195}, {39, SHIFT, 19}, },
			{{-1, ERROR, 74}, {21, SHIFT, 16}, {24, SHIFT, 199}, {39, SHIFT, 19}, },
			{{-1, ERROR, 75}, {24, SHIFT, 202}, {39, SHIFT, 19}, },
			{{-1, ERROR, 76}, {24, SHIFT, 204}, },
			{{-1, REDUCE, 7}, },
			{{-1, ERROR, 78}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 205}, {39, SHIFT, 19}, },
			{{-1, ERROR, 79}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 211}, {39, SHIFT, 19}, },
			{{-1, ERROR, 80}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 216}, {39, SHIFT, 19}, },
			{{-1, ERROR, 81}, {21, SHIFT, 16}, {24, SHIFT, 220}, {39, SHIFT, 19}, },
			{{-1, ERROR, 82}, {24, SHIFT, 223}, {39, SHIFT, 19}, },
			{{-1, ERROR, 83}, {24, SHIFT, 225}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 85}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 226}, {39, SHIFT, 19}, },
			{{-1, ERROR, 86}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 231}, {39, SHIFT, 19}, },
			{{-1, ERROR, 87}, {21, SHIFT, 16}, {24, SHIFT, 235}, {39, SHIFT, 19}, },
			{{-1, ERROR, 88}, {24, SHIFT, 238}, {39, SHIFT, 19}, },
			{{-1, ERROR, 89}, {24, SHIFT, 240}, },
			{{-1, ERROR, 90}, {49, SHIFT, 20}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 92}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 242}, {39, SHIFT, 19}, },
			{{-1, ERROR, 93}, {21, SHIFT, 16}, {24, SHIFT, 246}, {39, SHIFT, 19}, },
			{{-1, ERROR, 94}, {24, SHIFT, 249}, {39, SHIFT, 19}, },
			{{-1, ERROR, 95}, {24, SHIFT, 251}, },
			{{-1, REDUCE, 35}, },
			{{-1, ERROR, 97}, {21, SHIFT, 16}, {24, SHIFT, 252}, {39, SHIFT, 19}, },
			{{-1, ERROR, 98}, {24, SHIFT, 255}, {39, SHIFT, 19}, },
			{{-1, ERROR, 99}, {24, SHIFT, 257}, },
			{{-1, REDUCE, 67}, },
			{{-1, ERROR, 101}, {24, SHIFT, 258}, {39, SHIFT, 19}, },
			{{-1, ERROR, 102}, {24, SHIFT, 260}, },
			{{-1, REDUCE, 131}, },
			{{-1, ERROR, 104}, {24, SHIFT, 261}, },
			{{-1, REDUCE, 259}, },
			{{-1, REDUCE, 908}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 108}, {17, SHIFT, 13}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 262}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, ERROR, 109}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 270}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, ERROR, 110}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 277}, {39, SHIFT, 19}, },
			{{-1, ERROR, 111}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 283}, {39, SHIFT, 19}, },
			{{-1, ERROR, 112}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 288}, {39, SHIFT, 19}, },
			{{-1, ERROR, 113}, {21, SHIFT, 16}, {24, SHIFT, 292}, {39, SHIFT, 19}, },
			{{-1, ERROR, 114}, {24, SHIFT, 295}, {39, SHIFT, 19}, },
			{{-1, ERROR, 115}, {24, SHIFT, 297}, },
			{{-1, REDUCE, 886}, {52, SHIFT, 298}, },
			{{-1, REDUCE, 892}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 889}, {52, SHIFT, 117}, },
			{{-1, REDUCE, 897}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 894}, {52, SHIFT, 119}, },
			{{-1, ERROR, 121}, {3, SHIFT, 46}, },
			{{-1, REDUCE, 899}, {3, SHIFT, 46}, {20, SHIFT, 121}, },
			{{-1, ERROR, 123}, {54, SHIFT, 313}, },
			{{-1, REDUCE, 856}, },
			{{-1, ERROR, 125}, {24, SHIFT, 314}, {28, SHIFT, 34}, {29, SHIFT, 35}, },
			{{-1, ERROR, 126}, {24, SHIFT, 317}, {29, SHIFT, 35}, },
			{{-1, ERROR, 127}, {24, SHIFT, 319}, },
			{{-1, REDUCE, 858}, },
			{{-1, ERROR, 129}, {24, SHIFT, 320}, {29, SHIFT, 35}, },
			{{-1, ERROR, 130}, {24, SHIFT, 322}, },
			{{-1, REDUCE, 862}, },
			{{-1, ERROR, 132}, {24, SHIFT, 323}, },
			{{-1, REDUCE, 870}, },
			{{-1, REDUCE, 855}, },
			{{-1, ERROR, 135}, {24, SHIFT, 324}, {27, SHIFT, 33}, {28, SHIFT, 34}, {29, SHIFT, 35}, },
			{{-1, ERROR, 136}, {24, SHIFT, 328}, {28, SHIFT, 34}, {29, SHIFT, 35}, },
			{{-1, ERROR, 137}, {24, SHIFT, 331}, {29, SHIFT, 35}, },
			{{-1, ERROR, 138}, {24, SHIFT, 333}, },
			{{-1, ERROR, 139}, {7, SHIFT, 334}, },
			{{-1, ERROR, 140}, {52, SHIFT, 335}, },
			{{-1, REDUCE, 805}, },
			{{-1, ERROR, 142}, {6, SHIFT, 336}, },
			{{-1, REDUCE, 803}, {4, SHIFT, 337}, },
			{{-1, REDUCE, 517}, },
			{{-1, REDUCE, 909}, },
			{{-1, REDUCE, 516}, {52, SHIFT, 144}, },
			{{-1, REDUCE, 520}, },
			{{-1, REDUCE, 911}, },
			{{-1, REDUCE, 519}, {52, SHIFT, 147}, },
			{{-1, REDUCE, 533}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 534}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 906}, },
			{{-1, ERROR, 153}, {54, SHIFT, 341}, },
			{{-1, REDUCE, 913}, },
			{{-1, REDUCE, 538}, },
			{{-1, REDUCE, 537}, {3, SHIFT, 46}, {20, SHIFT, 47}, },
			{{-1, REDUCE, 539}, {0, SHIFT, 11}, },
			{{-1, ERROR, 158}, {0, SHIFT, 11}, {16, SHIFT, 344}, {24, SHIFT, 345}, {26, SHIFT, 346}, {31, SHIFT, 347}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, REDUCE, 915}, },
			{{-1, REDUCE, 547}, },
			{{-1, REDUCE, 546}, {12, SHIFT, 50}, {13, SHIFT, 51}, {14, SHIFT, 52}, {30, SHIFT, 53}, },
			{{-1, ERROR, 162}, {52, SHIFT, 359}, },
			{{-1, REDUCE, 544}, {0, SHIFT, 106}, },
			{{-1, ERROR, 164}, {54, SHIFT, 360}, },
			{{-1, ERROR, 165}, {54, SHIFT, 361}, },
			{{-1, REDUCE, 837}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 838}, {0, SHIFT, 106}, },
			{{-1, ERROR, 168}, {54, SHIFT, 363}, },
			{{-1, ERROR, 169}, {54, SHIFT, 364}, },
			{{-1, REDUCE, 814}, },
			{{-1, ERROR, 171}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 172}, {52, SHIFT, 366}, },
			{{-1, ERROR, 173}, {52, SHIFT, 62}, },
			{{-1, REDUCE, 820}, {0, SHIFT, 11}, },
			{{-1, ERROR, 175}, {54, SHIFT, 369}, },
			{{-1, ERROR, 176}, {0, SHIFT, 106}, {50, SHIFT, 370}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 178}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 371}, {39, SHIFT, 19}, },
			{{-1, ERROR, 179}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 377}, {39, SHIFT, 19}, },
			{{-1, ERROR, 180}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 382}, {39, SHIFT, 19}, },
			{{-1, ERROR, 181}, {21, SHIFT, 16}, {24, SHIFT, 386}, {39, SHIFT, 19}, },
			{{-1, ERROR, 182}, {24, SHIFT, 389}, {39, SHIFT, 19}, },
			{{-1, ERROR, 183}, {24, SHIFT, 391}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 185}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 392}, {39, SHIFT, 19}, },
			{{-1, ERROR, 186}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 397}, {39, SHIFT, 19}, },
			{{-1, ERROR, 187}, {21, SHIFT, 16}, {24, SHIFT, 401}, {39, SHIFT, 19}, },
			{{-1, ERROR, 188}, {24, SHIFT, 404}, {39, SHIFT, 19}, },
			{{-1, ERROR, 189}, {24, SHIFT, 406}, },
			{{-1, REDUCE, 21}, },
			{{-1, ERROR, 191}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 407}, {39, SHIFT, 19}, },
			{{-1, ERROR, 192}, {21, SHIFT, 16}, {24, SHIFT, 411}, {39, SHIFT, 19}, },
			{{-1, ERROR, 193}, {24, SHIFT, 414}, {39, SHIFT, 19}, },
			{{-1, ERROR, 194}, {24, SHIFT, 416}, },
			{{-1, REDUCE, 37}, },
			{{-1, ERROR, 196}, {21, SHIFT, 16}, {24, SHIFT, 417}, {39, SHIFT, 19}, },
			{{-1, ERROR, 197}, {24, SHIFT, 420}, {39, SHIFT, 19}, },
			{{-1, ERROR, 198}, {24, SHIFT, 422}, },
			{{-1, REDUCE, 69}, },
			{{-1, ERROR, 200}, {24, SHIFT, 423}, {39, SHIFT, 19}, },
			{{-1, ERROR, 201}, {24, SHIFT, 425}, },
			{{-1, REDUCE, 133}, },
			{{-1, ERROR, 203}, {24, SHIFT, 426}, },
			{{-1, REDUCE, 261}, },
			{{-1, REDUCE, 15}, },
			{{-1, ERROR, 206}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 427}, {39, SHIFT, 19}, },
			{{-1, ERROR, 207}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 432}, {39, SHIFT, 19}, },
			{{-1, ERROR, 208}, {21, SHIFT, 16}, {24, SHIFT, 436}, {39, SHIFT, 19}, },
			{{-1, ERROR, 209}, {24, SHIFT, 439}, {39, SHIFT, 19}, },
			{{-1, ERROR, 210}, {24, SHIFT, 441}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 212}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 442}, {39, SHIFT, 19}, },
			{{-1, ERROR, 213}, {21, SHIFT, 16}, {24, SHIFT, 446}, {39, SHIFT, 19}, },
			{{-1, ERROR, 214}, {24, SHIFT, 449}, {39, SHIFT, 19}, },
			{{-1, ERROR, 215}, {24, SHIFT, 451}, },
			{{-1, REDUCE, 39}, },
			{{-1, ERROR, 217}, {21, SHIFT, 16}, {24, SHIFT, 452}, {39, SHIFT, 19}, },
			{{-1, ERROR, 218}, {24, SHIFT, 455}, {39, SHIFT, 19}, },
			{{-1, ERROR, 219}, {24, SHIFT, 457}, },
			{{-1, REDUCE, 71}, },
			{{-1, ERROR, 221}, {24, SHIFT, 458}, {39, SHIFT, 19}, },
			{{-1, ERROR, 222}, {24, SHIFT, 460}, },
			{{-1, REDUCE, 135}, },
			{{-1, ERROR, 224}, {24, SHIFT, 461}, },
			{{-1, REDUCE, 263}, },
			{{-1, REDUCE, 27}, },
			{{-1, ERROR, 227}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 462}, {39, SHIFT, 19}, },
			{{-1, ERROR, 228}, {21, SHIFT, 16}, {24, SHIFT, 466}, {39, SHIFT, 19}, },
			{{-1, ERROR, 229}, {24, SHIFT, 469}, {39, SHIFT, 19}, },
			{{-1, ERROR, 230}, {24, SHIFT, 471}, },
			{{-1, REDUCE, 43}, },
			{{-1, ERROR, 232}, {21, SHIFT, 16}, {24, SHIFT, 472}, {39, SHIFT, 19}, },
			{{-1, ERROR, 233}, {24, SHIFT, 475}, {39, SHIFT, 19}, },
			{{-1, ERROR, 234}, {24, SHIFT, 477}, },
			{{-1, REDUCE, 75}, },
			{{-1, ERROR, 236}, {24, SHIFT, 478}, {39, SHIFT, 19}, },
			{{-1, ERROR, 237}, {24, SHIFT, 480}, },
			{{-1, REDUCE, 139}, },
			{{-1, ERROR, 239}, {24, SHIFT, 481}, },
			{{-1, REDUCE, 267}, },
			{{-1, REDUCE, 521}, },
			{{-1, REDUCE, 51}, },
			{{-1, ERROR, 243}, {21, SHIFT, 16}, {24, SHIFT, 482}, {39, SHIFT, 19}, },
			{{-1, ERROR, 244}, {24, SHIFT, 485}, {39, SHIFT, 19}, },
			{{-1, ERROR, 245}, {24, SHIFT, 487}, },
			{{-1, REDUCE, 83}, },
			{{-1, ERROR, 247}, {24, SHIFT, 488}, {39, SHIFT, 19}, },
			{{-1, ERROR, 248}, {24, SHIFT, 490}, },
			{{-1, REDUCE, 147}, },
			{{-1, ERROR, 250}, {24, SHIFT, 491}, },
			{{-1, REDUCE, 275}, },
			{{-1, REDUCE, 99}, },
			{{-1, ERROR, 253}, {24, SHIFT, 492}, {39, SHIFT, 19}, },
			{{-1, ERROR, 254}, {24, SHIFT, 494}, },
			{{-1, REDUCE, 163}, },
			{{-1, ERROR, 256}, {24, SHIFT, 495}, },
			{{-1, REDUCE, 291}, },
			{{-1, REDUCE, 195}, },
			{{-1, ERROR, 259}, {24, SHIFT, 496}, },
			{{-1, REDUCE, 323}, },
			{{-1, REDUCE, 387}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 263}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 497}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, ERROR, 264}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 504}, {39, SHIFT, 19}, },
			{{-1, ERROR, 265}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 510}, {39, SHIFT, 19}, },
			{{-1, ERROR, 266}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 515}, {39, SHIFT, 19}, },
			{{-1, ERROR, 267}, {21, SHIFT, 16}, {24, SHIFT, 519}, {39, SHIFT, 19}, },
			{{-1, ERROR, 268}, {24, SHIFT, 522}, {39, SHIFT, 19}, },
			{{-1, ERROR, 269}, {24, SHIFT, 524}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 271}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 525}, {39, SHIFT, 19}, },
			{{-1, ERROR, 272}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 531}, {39, SHIFT, 19}, },
			{{-1, ERROR, 273}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 536}, {39, SHIFT, 19}, },
			{{-1, ERROR, 274}, {21, SHIFT, 16}, {24, SHIFT, 540}, {39, SHIFT, 19}, },
			{{-1, ERROR, 275}, {24, SHIFT, 543}, {39, SHIFT, 19}, },
			{{-1, ERROR, 276}, {24, SHIFT, 545}, },
			{{-1, REDUCE, 12}, },
			{{-1, ERROR, 278}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 546}, {39, SHIFT, 19}, },
			{{-1, ERROR, 279}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 551}, {39, SHIFT, 19}, },
			{{-1, ERROR, 280}, {21, SHIFT, 16}, {24, SHIFT, 555}, {39, SHIFT, 19}, },
			{{-1, ERROR, 281}, {24, SHIFT, 558}, {39, SHIFT, 19}, },
			{{-1, ERROR, 282}, {24, SHIFT, 560}, },
			{{-1, REDUCE, 20}, },
			{{-1, ERROR, 284}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 561}, {39, SHIFT, 19}, },
			{{-1, ERROR, 285}, {21, SHIFT, 16}, {24, SHIFT, 565}, {39, SHIFT, 19}, },
			{{-1, ERROR, 286}, {24, SHIFT, 568}, {39, SHIFT, 19}, },
			{{-1, ERROR, 287}, {24, SHIFT, 570}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 289}, {21, SHIFT, 16}, {24, SHIFT, 571}, {39, SHIFT, 19}, },
			{{-1, ERROR, 290}, {24, SHIFT, 574}, {39, SHIFT, 19}, },
			{{-1, ERROR, 291}, {24, SHIFT, 576}, },
			{{-1, REDUCE, 68}, },
			{{-1, ERROR, 293}, {24, SHIFT, 577}, {39, SHIFT, 19}, },
			{{-1, ERROR, 294}, {24, SHIFT, 579}, },
			{{-1, REDUCE, 132}, },
			{{-1, ERROR, 296}, {24, SHIFT, 580}, },
			{{-1, REDUCE, 260}, },
			{{-1, REDUCE, 888}, },
			{{-1, REDUCE, 927}, },
			{{-1, REDUCE, 887}, {52, SHIFT, 298}, },
			{{-1, REDUCE, 893}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 929}, },
			{{-1, REDUCE, 891}, },
			{{-1, REDUCE, 890}, {52, SHIFT, 117}, },
			{{-1, REDUCE, 898}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 931}, },
			{{-1, REDUCE, 896}, },
			{{-1, REDUCE, 895}, {52, SHIFT, 119}, },
			{{-1, ERROR, 309}, {54, SHIFT, 584}, },
			{{-1, REDUCE, 933}, },
			{{-1, REDUCE, 901}, },
			{{-1, REDUCE, 900}, {3, SHIFT, 46}, {20, SHIFT, 121}, },
			{{-1, REDUCE, 902}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 860}, },
			{{-1, ERROR, 315}, {24, SHIFT, 587}, {29, SHIFT, 35}, },
			{{-1, ERROR, 316}, {24, SHIFT, 589}, },
			{{-1, REDUCE, 864}, },
			{{-1, ERROR, 318}, {24, SHIFT, 590}, },
			{{-1, REDUCE, 872}, },
			{{-1, REDUCE, 866}, },
			{{-1, ERROR, 321}, {24, SHIFT, 591}, },
			{{-1, REDUCE, 874}, },
			{{-1, REDUCE, 878}, },
			{{-1, REDUCE, 857}, },
			{{-1, ERROR, 325}, {24, SHIFT, 592}, {28, SHIFT, 34}, {29, SHIFT, 35}, },
			{{-1, ERROR, 326}, {24, SHIFT, 595}, {29, SHIFT, 35}, },
			{{-1, ERROR, 327}, {24, SHIFT, 597}, },
			{{-1, REDUCE, 859}, },
			{{-1, ERROR, 329}, {24, SHIFT, 598}, {29, SHIFT, 35}, },
			{{-1, ERROR, 330}, {24, SHIFT, 600}, },
			{{-1, REDUCE, 863}, },
			{{-1, ERROR, 332}, {24, SHIFT, 601}, },
			{{-1, REDUCE, 871}, },
			{{-1, ERROR, 334}, {0, SHIFT, 11}, {17, SHIFT, 13}, {44, SHIFT, 602}, {47, SHIFT, 603}, {48, SHIFT, 140}, {52, SHIFT, 141}, },
			{{-1, REDUCE, 804}, },
			{{-1, ERROR, 336}, {7, SHIFT, 610}, },
			{{-1, ERROR, 337}, {48, SHIFT, 140}, {52, SHIFT, 141}, },
			{{-1, REDUCE, 910}, },
			{{-1, REDUCE, 912}, },
			{{-1, REDUCE, 535}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 541}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 914}, },
			{{-1, REDUCE, 540}, {0, SHIFT, 106}, },
			{{-1, ERROR, 344}, {52, SHIFT, 613}, },
			{{-1, REDUCE, 548}, },
			{{-1, ERROR, 346}, {52, SHIFT, 614}, },
			{{-1, ERROR, 347}, {52, SHIFT, 615}, },
			{{-1, ERROR, 348}, {3, SHIFT, 46}, {20, SHIFT, 617}, },
			{{-1, ERROR, 349}, {3, SHIFT, 46}, },
			{{-1, ERROR, 350}, {3, SHIFT, 46}, },
			{{-1, ERROR, 351}, {24, SHIFT, 624}, {31, SHIFT, 347}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, REDUCE, 679}, },
			{{-1, ERROR, 353}, {24, SHIFT, 629}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 354}, {24, SHIFT, 633}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 355}, {24, SHIFT, 636}, {34, SHIFT, 350}, },
			{{-1, ERROR, 356}, {24, SHIFT, 638}, },
			{{-1, ERROR, 357}, {0, SHIFT, 106}, {16, SHIFT, 344}, {24, SHIFT, 639}, {26, SHIFT, 346}, {31, SHIFT, 347}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, REDUCE, 916}, },
			{{-1, ERROR, 359}, {0, SHIFT, 11}, {16, SHIFT, 344}, {24, SHIFT, 645}, {26, SHIFT, 346}, {31, SHIFT, 347}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, REDUCE, 818}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 822}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 839}, {0, SHIFT, 106}, },
			{{-1, ERROR, 363}, {0, SHIFT, 11}, {22, SHIFT, 654}, {23, SHIFT, 655}, {35, SHIFT, 656}, },
			{{-1, ERROR, 364}, {0, SHIFT, 11}, {34, SHIFT, 660}, },
			{{-1, REDUCE, 815}, {9, SHIFT, 662}, },
			{{-1, ERROR, 366}, {5, SHIFT, 664}, },
			{{-1, REDUCE, 851}, },
			{{-1, REDUCE, 821}, {0, SHIFT, 106}, },
			{{-1, ERROR, 369}, {0, SHIFT, 11}, {51, SHIFT, 665}, },
			{{-1, ERROR, 370}, {54, SHIFT, 667}, },
			{{-1, REDUCE, 17}, },
			{{-1, ERROR, 372}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 668}, {39, SHIFT, 19}, },
			{{-1, ERROR, 373}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 673}, {39, SHIFT, 19}, },
			{{-1, ERROR, 374}, {21, SHIFT, 16}, {24, SHIFT, 677}, {39, SHIFT, 19}, },
			{{-1, ERROR, 375}, {24, SHIFT, 680}, {39, SHIFT, 19}, },
			{{-1, ERROR, 376}, {24, SHIFT, 682}, },
			{{-1, REDUCE, 25}, },
			{{-1, ERROR, 378}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 683}, {39, SHIFT, 19}, },
			{{-1, ERROR, 379}, {21, SHIFT, 16}, {24, SHIFT, 687}, {39, SHIFT, 19}, },
			{{-1, ERROR, 380}, {24, SHIFT, 690}, {39, SHIFT, 19}, },
			{{-1, ERROR, 381}, {24, SHIFT, 692}, },
			{{-1, REDUCE, 41}, },
			{{-1, ERROR, 383}, {21, SHIFT, 16}, {24, SHIFT, 693}, {39, SHIFT, 19}, },
			{{-1, ERROR, 384}, {24, SHIFT, 696}, {39, SHIFT, 19}, },
			{{-1, ERROR, 385}, {24, SHIFT, 698}, },
			{{-1, REDUCE, 73}, },
			{{-1, ERROR, 387}, {24, SHIFT, 699}, {39, SHIFT, 19}, },
			{{-1, ERROR, 388}, {24, SHIFT, 701}, },
			{{-1, REDUCE, 137}, },
			{{-1, ERROR, 390}, {24, SHIFT, 702}, },
			{{-1, REDUCE, 265}, },
			{{-1, REDUCE, 29}, },
			{{-1, ERROR, 393}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 703}, {39, SHIFT, 19}, },
			{{-1, ERROR, 394}, {21, SHIFT, 16}, {24, SHIFT, 707}, {39, SHIFT, 19}, },
			{{-1, ERROR, 395}, {24, SHIFT, 710}, {39, SHIFT, 19}, },
			{{-1, ERROR, 396}, {24, SHIFT, 712}, },
			{{-1, REDUCE, 45}, },
			{{-1, ERROR, 398}, {21, SHIFT, 16}, {24, SHIFT, 713}, {39, SHIFT, 19}, },
			{{-1, ERROR, 399}, {24, SHIFT, 716}, {39, SHIFT, 19}, },
			{{-1, ERROR, 400}, {24, SHIFT, 718}, },
			{{-1, REDUCE, 77}, },
			{{-1, ERROR, 402}, {24, SHIFT, 719}, {39, SHIFT, 19}, },
			{{-1, ERROR, 403}, {24, SHIFT, 721}, },
			{{-1, REDUCE, 141}, },
			{{-1, ERROR, 405}, {24, SHIFT, 722}, },
			{{-1, REDUCE, 269}, },
			{{-1, REDUCE, 53}, },
			{{-1, ERROR, 408}, {21, SHIFT, 16}, {24, SHIFT, 723}, {39, SHIFT, 19}, },
			{{-1, ERROR, 409}, {24, SHIFT, 726}, {39, SHIFT, 19}, },
			{{-1, ERROR, 410}, {24, SHIFT, 728}, },
			{{-1, REDUCE, 85}, },
			{{-1, ERROR, 412}, {24, SHIFT, 729}, {39, SHIFT, 19}, },
			{{-1, ERROR, 413}, {24, SHIFT, 731}, },
			{{-1, REDUCE, 149}, },
			{{-1, ERROR, 415}, {24, SHIFT, 732}, },
			{{-1, REDUCE, 277}, },
			{{-1, REDUCE, 101}, },
			{{-1, ERROR, 418}, {24, SHIFT, 733}, {39, SHIFT, 19}, },
			{{-1, ERROR, 419}, {24, SHIFT, 735}, },
			{{-1, REDUCE, 165}, },
			{{-1, ERROR, 421}, {24, SHIFT, 736}, },
			{{-1, REDUCE, 293}, },
			{{-1, REDUCE, 197}, },
			{{-1, ERROR, 424}, {24, SHIFT, 737}, },
			{{-1, REDUCE, 325}, },
			{{-1, REDUCE, 389}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 428}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 738}, {39, SHIFT, 19}, },
			{{-1, ERROR, 429}, {21, SHIFT, 16}, {24, SHIFT, 742}, {39, SHIFT, 19}, },
			{{-1, ERROR, 430}, {24, SHIFT, 745}, {39, SHIFT, 19}, },
			{{-1, ERROR, 431}, {24, SHIFT, 747}, },
			{{-1, REDUCE, 47}, },
			{{-1, ERROR, 433}, {21, SHIFT, 16}, {24, SHIFT, 748}, {39, SHIFT, 19}, },
			{{-1, ERROR, 434}, {24, SHIFT, 751}, {39, SHIFT, 19}, },
			{{-1, ERROR, 435}, {24, SHIFT, 753}, },
			{{-1, REDUCE, 79}, },
			{{-1, ERROR, 437}, {24, SHIFT, 754}, {39, SHIFT, 19}, },
			{{-1, ERROR, 438}, {24, SHIFT, 756}, },
			{{-1, REDUCE, 143}, },
			{{-1, ERROR, 440}, {24, SHIFT, 757}, },
			{{-1, REDUCE, 271}, },
			{{-1, REDUCE, 55}, },
			{{-1, ERROR, 443}, {21, SHIFT, 16}, {24, SHIFT, 758}, {39, SHIFT, 19}, },
			{{-1, ERROR, 444}, {24, SHIFT, 761}, {39, SHIFT, 19}, },
			{{-1, ERROR, 445}, {24, SHIFT, 763}, },
			{{-1, REDUCE, 87}, },
			{{-1, ERROR, 447}, {24, SHIFT, 764}, {39, SHIFT, 19}, },
			{{-1, ERROR, 448}, {24, SHIFT, 766}, },
			{{-1, REDUCE, 151}, },
			{{-1, ERROR, 450}, {24, SHIFT, 767}, },
			{{-1, REDUCE, 279}, },
			{{-1, REDUCE, 103}, },
			{{-1, ERROR, 453}, {24, SHIFT, 768}, {39, SHIFT, 19}, },
			{{-1, ERROR, 454}, {24, SHIFT, 770}, },
			{{-1, REDUCE, 167}, },
			{{-1, ERROR, 456}, {24, SHIFT, 771}, },
			{{-1, REDUCE, 295}, },
			{{-1, REDUCE, 199}, },
			{{-1, ERROR, 459}, {24, SHIFT, 772}, },
			{{-1, REDUCE, 327}, },
			{{-1, REDUCE, 391}, },
			{{-1, REDUCE, 59}, },
			{{-1, ERROR, 463}, {21, SHIFT, 16}, {24, SHIFT, 773}, {39, SHIFT, 19}, },
			{{-1, ERROR, 464}, {24, SHIFT, 776}, {39, SHIFT, 19}, },
			{{-1, ERROR, 465}, {24, SHIFT, 778}, },
			{{-1, REDUCE, 91}, },
			{{-1, ERROR, 467}, {24, SHIFT, 779}, {39, SHIFT, 19}, },
			{{-1, ERROR, 468}, {24, SHIFT, 781}, },
			{{-1, REDUCE, 155}, },
			{{-1, ERROR, 470}, {24, SHIFT, 782}, },
			{{-1, REDUCE, 283}, },
			{{-1, REDUCE, 107}, },
			{{-1, ERROR, 473}, {24, SHIFT, 783}, {39, SHIFT, 19}, },
			{{-1, ERROR, 474}, {24, SHIFT, 785}, },
			{{-1, REDUCE, 171}, },
			{{-1, ERROR, 476}, {24, SHIFT, 786}, },
			{{-1, REDUCE, 299}, },
			{{-1, REDUCE, 203}, },
			{{-1, ERROR, 479}, {24, SHIFT, 787}, },
			{{-1, REDUCE, 331}, },
			{{-1, REDUCE, 395}, },
			{{-1, REDUCE, 115}, },
			{{-1, ERROR, 483}, {24, SHIFT, 788}, {39, SHIFT, 19}, },
			{{-1, ERROR, 484}, {24, SHIFT, 790}, },
			{{-1, REDUCE, 179}, },
			{{-1, ERROR, 486}, {24, SHIFT, 791}, },
			{{-1, REDUCE, 307}, },
			{{-1, REDUCE, 211}, },
			{{-1, ERROR, 489}, {24, SHIFT, 792}, },
			{{-1, REDUCE, 339}, },
			{{-1, REDUCE, 403}, },
			{{-1, REDUCE, 227}, },
			{{-1, ERROR, 493}, {24, SHIFT, 793}, },
			{{-1, REDUCE, 355}, },
			{{-1, REDUCE, 419}, },
			{{-1, REDUCE, 451}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 498}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 794}, {39, SHIFT, 19}, },
			{{-1, ERROR, 499}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 800}, {39, SHIFT, 19}, },
			{{-1, ERROR, 500}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 805}, {39, SHIFT, 19}, },
			{{-1, ERROR, 501}, {21, SHIFT, 16}, {24, SHIFT, 809}, {39, SHIFT, 19}, },
			{{-1, ERROR, 502}, {24, SHIFT, 812}, {39, SHIFT, 19}, },
			{{-1, ERROR, 503}, {24, SHIFT, 814}, },
			{{-1, REDUCE, 14}, },
			{{-1, ERROR, 505}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 815}, {39, SHIFT, 19}, },
			{{-1, ERROR, 506}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 820}, {39, SHIFT, 19}, },
			{{-1, ERROR, 507}, {21, SHIFT, 16}, {24, SHIFT, 824}, {39, SHIFT, 19}, },
			{{-1, ERROR, 508}, {24, SHIFT, 827}, {39, SHIFT, 19}, },
			{{-1, ERROR, 509}, {24, SHIFT, 829}, },
			{{-1, REDUCE, 22}, },
			{{-1, ERROR, 511}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 830}, {39, SHIFT, 19}, },
			{{-1, ERROR, 512}, {21, SHIFT, 16}, {24, SHIFT, 834}, {39, SHIFT, 19}, },
			{{-1, ERROR, 513}, {24, SHIFT, 837}, {39, SHIFT, 19}, },
			{{-1, ERROR, 514}, {24, SHIFT, 839}, },
			{{-1, REDUCE, 38}, },
			{{-1, ERROR, 516}, {21, SHIFT, 16}, {24, SHIFT, 840}, {39, SHIFT, 19}, },
			{{-1, ERROR, 517}, {24, SHIFT, 843}, {39, SHIFT, 19}, },
			{{-1, ERROR, 518}, {24, SHIFT, 845}, },
			{{-1, REDUCE, 70}, },
			{{-1, ERROR, 520}, {24, SHIFT, 846}, {39, SHIFT, 19}, },
			{{-1, ERROR, 521}, {24, SHIFT, 848}, },
			{{-1, REDUCE, 134}, },
			{{-1, ERROR, 523}, {24, SHIFT, 849}, },
			{{-1, REDUCE, 262}, },
			{{-1, REDUCE, 16}, },
			{{-1, ERROR, 526}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 850}, {39, SHIFT, 19}, },
			{{-1, ERROR, 527}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 855}, {39, SHIFT, 19}, },
			{{-1, ERROR, 528}, {21, SHIFT, 16}, {24, SHIFT, 859}, {39, SHIFT, 19}, },
			{{-1, ERROR, 529}, {24, SHIFT, 862}, {39, SHIFT, 19}, },
			{{-1, ERROR, 530}, {24, SHIFT, 864}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 532}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 865}, {39, SHIFT, 19}, },
			{{-1, ERROR, 533}, {21, SHIFT, 16}, {24, SHIFT, 869}, {39, SHIFT, 19}, },
			{{-1, ERROR, 534}, {24, SHIFT, 872}, {39, SHIFT, 19}, },
			{{-1, ERROR, 535}, {24, SHIFT, 874}, },
			{{-1, REDUCE, 40}, },
			{{-1, ERROR, 537}, {21, SHIFT, 16}, {24, SHIFT, 875}, {39, SHIFT, 19}, },
			{{-1, ERROR, 538}, {24, SHIFT, 878}, {39, SHIFT, 19}, },
			{{-1, ERROR, 539}, {24, SHIFT, 880}, },
			{{-1, REDUCE, 72}, },
			{{-1, ERROR, 541}, {24, SHIFT, 881}, {39, SHIFT, 19}, },
			{{-1, ERROR, 542}, {24, SHIFT, 883}, },
			{{-1, REDUCE, 136}, },
			{{-1, ERROR, 544}, {24, SHIFT, 884}, },
			{{-1, REDUCE, 264}, },
			{{-1, REDUCE, 28}, },
			{{-1, ERROR, 547}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 885}, {39, SHIFT, 19}, },
			{{-1, ERROR, 548}, {21, SHIFT, 16}, {24, SHIFT, 889}, {39, SHIFT, 19}, },
			{{-1, ERROR, 549}, {24, SHIFT, 892}, {39, SHIFT, 19}, },
			{{-1, ERROR, 550}, {24, SHIFT, 894}, },
			{{-1, REDUCE, 44}, },
			{{-1, ERROR, 552}, {21, SHIFT, 16}, {24, SHIFT, 895}, {39, SHIFT, 19}, },
			{{-1, ERROR, 553}, {24, SHIFT, 898}, {39, SHIFT, 19}, },
			{{-1, ERROR, 554}, {24, SHIFT, 900}, },
			{{-1, REDUCE, 76}, },
			{{-1, ERROR, 556}, {24, SHIFT, 901}, {39, SHIFT, 19}, },
			{{-1, ERROR, 557}, {24, SHIFT, 903}, },
			{{-1, REDUCE, 140}, },
			{{-1, ERROR, 559}, {24, SHIFT, 904}, },
			{{-1, REDUCE, 268}, },
			{{-1, REDUCE, 52}, },
			{{-1, ERROR, 562}, {21, SHIFT, 16}, {24, SHIFT, 905}, {39, SHIFT, 19}, },
			{{-1, ERROR, 563}, {24, SHIFT, 908}, {39, SHIFT, 19}, },
			{{-1, ERROR, 564}, {24, SHIFT, 910}, },
			{{-1, REDUCE, 84}, },
			{{-1, ERROR, 566}, {24, SHIFT, 911}, {39, SHIFT, 19}, },
			{{-1, ERROR, 567}, {24, SHIFT, 913}, },
			{{-1, REDUCE, 148}, },
			{{-1, ERROR, 569}, {24, SHIFT, 914}, },
			{{-1, REDUCE, 276}, },
			{{-1, REDUCE, 100}, },
			{{-1, ERROR, 572}, {24, SHIFT, 915}, {39, SHIFT, 19}, },
			{{-1, ERROR, 573}, {24, SHIFT, 917}, },
			{{-1, REDUCE, 164}, },
			{{-1, ERROR, 575}, {24, SHIFT, 918}, },
			{{-1, REDUCE, 292}, },
			{{-1, REDUCE, 196}, },
			{{-1, ERROR, 578}, {24, SHIFT, 919}, },
			{{-1, REDUCE, 324}, },
			{{-1, REDUCE, 388}, },
			{{-1, REDUCE, 928}, },
			{{-1, REDUCE, 930}, },
			{{-1, REDUCE, 932}, },
			{{-1, REDUCE, 904}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 934}, },
			{{-1, REDUCE, 903}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 868}, },
			{{-1, ERROR, 588}, {24, SHIFT, 921}, },
			{{-1, REDUCE, 876}, },
			{{-1, REDUCE, 880}, },
			{{-1, REDUCE, 882}, },
			{{-1, REDUCE, 861}, },
			{{-1, ERROR, 593}, {24, SHIFT, 922}, {29, SHIFT, 35}, },
			{{-1, ERROR, 594}, {24, SHIFT, 924}, },
			{{-1, REDUCE, 865}, },
			{{-1, ERROR, 596}, {24, SHIFT, 925}, },
			{{-1, REDUCE, 873}, },
			{{-1, REDUCE, 867}, },
			{{-1, ERROR, 599}, {24, SHIFT, 926}, },
			{{-1, REDUCE, 875}, },
			{{-1, REDUCE, 879}, },
			{{-1, ERROR, 602}, {54, SHIFT, 927}, },
			{{-1, ERROR, 603}, {52, SHIFT, 928}, },
			{{-1, ERROR, 604}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 605}, {0, SHIFT, 11}, {17, SHIFT, 13}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 606}, {44, SHIFT, 602}, },
			{{-1, REDUCE, 807}, {47, SHIFT, 603}, },
			{{-1, ERROR, 608}, {45, SHIFT, 937}, },
			{{-1, ERROR, 609}, {0, SHIFT, 106}, {17, SHIFT, 13}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 610}, {0, SHIFT, 11}, {17, SHIFT, 13}, {44, SHIFT, 602}, {47, SHIFT, 603}, {48, SHIFT, 140}, {52, SHIFT, 141}, },
			{{-1, REDUCE, 802}, },
			{{-1, REDUCE, 542}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 681}, {52, SHIFT, 947}, },
			{{-1, REDUCE, 680}, },
			{{-1, REDUCE, 687}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 684}, {52, SHIFT, 615}, },
			{{-1, ERROR, 617}, {3, SHIFT, 46}, },
			{{-1, REDUCE, 689}, {3, SHIFT, 46}, {20, SHIFT, 617}, },
			{{-1, ERROR, 619}, {54, SHIFT, 958}, },
			{{-1, REDUCE, 696}, {3, SHIFT, 46}, },
			{{-1, ERROR, 621}, {54, SHIFT, 962}, },
			{{-1, REDUCE, 701}, {3, SHIFT, 46}, },
			{{-1, ERROR, 623}, {54, SHIFT, 966}, },
			{{-1, REDUCE, 552}, },
			{{-1, ERROR, 625}, {24, SHIFT, 967}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 626}, {24, SHIFT, 971}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 627}, {24, SHIFT, 974}, {34, SHIFT, 350}, },
			{{-1, ERROR, 628}, {24, SHIFT, 976}, },
			{{-1, REDUCE, 556}, },
			{{-1, ERROR, 630}, {24, SHIFT, 977}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 631}, {24, SHIFT, 980}, {34, SHIFT, 350}, },
			{{-1, ERROR, 632}, {24, SHIFT, 982}, },
			{{-1, REDUCE, 564}, },
			{{-1, ERROR, 634}, {24, SHIFT, 983}, {34, SHIFT, 350}, },
			{{-1, ERROR, 635}, {24, SHIFT, 985}, },
			{{-1, REDUCE, 580}, },
			{{-1, ERROR, 637}, {24, SHIFT, 986}, },
			{{-1, REDUCE, 612}, },
			{{-1, REDUCE, 550}, },
			{{-1, ERROR, 640}, {24, SHIFT, 987}, {31, SHIFT, 347}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 641}, {24, SHIFT, 992}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 642}, {24, SHIFT, 996}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 643}, {24, SHIFT, 999}, {34, SHIFT, 350}, },
			{{-1, ERROR, 644}, {24, SHIFT, 1001}, },
			{{-1, REDUCE, 549}, },
			{{-1, ERROR, 646}, {24, SHIFT, 1002}, {31, SHIFT, 347}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 647}, {24, SHIFT, 1007}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 648}, {24, SHIFT, 1011}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 649}, {24, SHIFT, 1014}, {34, SHIFT, 350}, },
			{{-1, ERROR, 650}, {24, SHIFT, 1016}, },
			{{-1, ERROR, 651}, {0, SHIFT, 106}, {16, SHIFT, 344}, {24, SHIFT, 1017}, {26, SHIFT, 346}, {31, SHIFT, 347}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, REDUCE, 819}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 823}, {0, SHIFT, 106}, },
			{{-1, ERROR, 654}, {54, SHIFT, 1023}, },
			{{-1, ERROR, 655}, {54, SHIFT, 1024}, },
			{{-1, ERROR, 656}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 657}, {22, SHIFT, 654}, {35, SHIFT, 1026}, },
			{{-1, ERROR, 658}, {35, SHIFT, 1028}, },
			{{-1, ERROR, 659}, {0, SHIFT, 106}, {22, SHIFT, 654}, {23, SHIFT, 655}, {35, SHIFT, 1029}, },
			{{-1, ERROR, 660}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 661}, {0, SHIFT, 106}, {34, SHIFT, 1033}, },
			{{-1, ERROR, 662}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, REDUCE, 816}, },
			{{-1, ERROR, 664}, {6, SHIFT, 1035}, {52, SHIFT, 62}, },
			{{-1, ERROR, 665}, {54, SHIFT, 1037}, },
			{{-1, ERROR, 666}, {0, SHIFT, 106}, {51, SHIFT, 1038}, },
			{{-1, ERROR, 667}, {0, SHIFT, 11}, {51, SHIFT, 1039}, },
			{{-1, REDUCE, 33}, },
			{{-1, ERROR, 669}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 1041}, {39, SHIFT, 19}, },
			{{-1, ERROR, 670}, {21, SHIFT, 16}, {24, SHIFT, 1045}, {39, SHIFT, 19}, },
			{{-1, ERROR, 671}, {24, SHIFT, 1048}, {39, SHIFT, 19}, },
			{{-1, ERROR, 672}, {24, SHIFT, 1050}, },
			{{-1, REDUCE, 49}, },
			{{-1, ERROR, 674}, {21, SHIFT, 16}, {24, SHIFT, 1051}, {39, SHIFT, 19}, },
			{{-1, ERROR, 675}, {24, SHIFT, 1054}, {39, SHIFT, 19}, },
			{{-1, ERROR, 676}, {24, SHIFT, 1056}, },
			{{-1, REDUCE, 81}, },
			{{-1, ERROR, 678}, {24, SHIFT, 1057}, {39, SHIFT, 19}, },
			{{-1, ERROR, 679}, {24, SHIFT, 1059}, },
			{{-1, REDUCE, 145}, },
			{{-1, ERROR, 681}, {24, SHIFT, 1060}, },
			{{-1, REDUCE, 273}, },
			{{-1, REDUCE, 57}, },
			{{-1, ERROR, 684}, {21, SHIFT, 16}, {24, SHIFT, 1061}, {39, SHIFT, 19}, },
			{{-1, ERROR, 685}, {24, SHIFT, 1064}, {39, SHIFT, 19}, },
			{{-1, ERROR, 686}, {24, SHIFT, 1066}, },
			{{-1, REDUCE, 89}, },
			{{-1, ERROR, 688}, {24, SHIFT, 1067}, {39, SHIFT, 19}, },
			{{-1, ERROR, 689}, {24, SHIFT, 1069}, },
			{{-1, REDUCE, 153}, },
			{{-1, ERROR, 691}, {24, SHIFT, 1070}, },
			{{-1, REDUCE, 281}, },
			{{-1, REDUCE, 105}, },
			{{-1, ERROR, 694}, {24, SHIFT, 1071}, {39, SHIFT, 19}, },
			{{-1, ERROR, 695}, {24, SHIFT, 1073}, },
			{{-1, REDUCE, 169}, },
			{{-1, ERROR, 697}, {24, SHIFT, 1074}, },
			{{-1, REDUCE, 297}, },
			{{-1, REDUCE, 201}, },
			{{-1, ERROR, 700}, {24, SHIFT, 1075}, },
			{{-1, REDUCE, 329}, },
			{{-1, REDUCE, 393}, },
			{{-1, REDUCE, 61}, },
			{{-1, ERROR, 704}, {21, SHIFT, 16}, {24, SHIFT, 1076}, {39, SHIFT, 19}, },
			{{-1, ERROR, 705}, {24, SHIFT, 1079}, {39, SHIFT, 19}, },
			{{-1, ERROR, 706}, {24, SHIFT, 1081}, },
			{{-1, REDUCE, 93}, },
			{{-1, ERROR, 708}, {24, SHIFT, 1082}, {39, SHIFT, 19}, },
			{{-1, ERROR, 709}, {24, SHIFT, 1084}, },
			{{-1, REDUCE, 157}, },
			{{-1, ERROR, 711}, {24, SHIFT, 1085}, },
			{{-1, REDUCE, 285}, },
			{{-1, REDUCE, 109}, },
			{{-1, ERROR, 714}, {24, SHIFT, 1086}, {39, SHIFT, 19}, },
			{{-1, ERROR, 715}, {24, SHIFT, 1088}, },
			{{-1, REDUCE, 173}, },
			{{-1, ERROR, 717}, {24, SHIFT, 1089}, },
			{{-1, REDUCE, 301}, },
			{{-1, REDUCE, 205}, },
			{{-1, ERROR, 720}, {24, SHIFT, 1090}, },
			{{-1, REDUCE, 333}, },
			{{-1, REDUCE, 397}, },
			{{-1, REDUCE, 117}, },
			{{-1, ERROR, 724}, {24, SHIFT, 1091}, {39, SHIFT, 19}, },
			{{-1, ERROR, 725}, {24, SHIFT, 1093}, },
			{{-1, REDUCE, 181}, },
			{{-1, ERROR, 727}, {24, SHIFT, 1094}, },
			{{-1, REDUCE, 309}, },
			{{-1, REDUCE, 213}, },
			{{-1, ERROR, 730}, {24, SHIFT, 1095}, },
			{{-1, REDUCE, 341}, },
			{{-1, REDUCE, 405}, },
			{{-1, REDUCE, 229}, },
			{{-1, ERROR, 734}, {24, SHIFT, 1096}, },
			{{-1, REDUCE, 357}, },
			{{-1, REDUCE, 421}, },
			{{-1, REDUCE, 453}, },
			{{-1, REDUCE, 63}, },
			{{-1, ERROR, 739}, {21, SHIFT, 16}, {24, SHIFT, 1097}, {39, SHIFT, 19}, },
			{{-1, ERROR, 740}, {24, SHIFT, 1100}, {39, SHIFT, 19}, },
			{{-1, ERROR, 741}, {24, SHIFT, 1102}, },
			{{-1, REDUCE, 95}, },
			{{-1, ERROR, 743}, {24, SHIFT, 1103}, {39, SHIFT, 19}, },
			{{-1, ERROR, 744}, {24, SHIFT, 1105}, },
			{{-1, REDUCE, 159}, },
			{{-1, ERROR, 746}, {24, SHIFT, 1106}, },
			{{-1, REDUCE, 287}, },
			{{-1, REDUCE, 111}, },
			{{-1, ERROR, 749}, {24, SHIFT, 1107}, {39, SHIFT, 19}, },
			{{-1, ERROR, 750}, {24, SHIFT, 1109}, },
			{{-1, REDUCE, 175}, },
			{{-1, ERROR, 752}, {24, SHIFT, 1110}, },
			{{-1, REDUCE, 303}, },
			{{-1, REDUCE, 207}, },
			{{-1, ERROR, 755}, {24, SHIFT, 1111}, },
			{{-1, REDUCE, 335}, },
			{{-1, REDUCE, 399}, },
			{{-1, REDUCE, 119}, },
			{{-1, ERROR, 759}, {24, SHIFT, 1112}, {39, SHIFT, 19}, },
			{{-1, ERROR, 760}, {24, SHIFT, 1114}, },
			{{-1, REDUCE, 183}, },
			{{-1, ERROR, 762}, {24, SHIFT, 1115}, },
			{{-1, REDUCE, 311}, },
			{{-1, REDUCE, 215}, },
			{{-1, ERROR, 765}, {24, SHIFT, 1116}, },
			{{-1, REDUCE, 343}, },
			{{-1, REDUCE, 407}, },
			{{-1, REDUCE, 231}, },
			{{-1, ERROR, 769}, {24, SHIFT, 1117}, },
			{{-1, REDUCE, 359}, },
			{{-1, REDUCE, 423}, },
			{{-1, REDUCE, 455}, },
			{{-1, REDUCE, 123}, },
			{{-1, ERROR, 774}, {24, SHIFT, 1118}, {39, SHIFT, 19}, },
			{{-1, ERROR, 775}, {24, SHIFT, 1120}, },
			{{-1, REDUCE, 187}, },
			{{-1, ERROR, 777}, {24, SHIFT, 1121}, },
			{{-1, REDUCE, 315}, },
			{{-1, REDUCE, 219}, },
			{{-1, ERROR, 780}, {24, SHIFT, 1122}, },
			{{-1, REDUCE, 347}, },
			{{-1, REDUCE, 411}, },
			{{-1, REDUCE, 235}, },
			{{-1, ERROR, 784}, {24, SHIFT, 1123}, },
			{{-1, REDUCE, 363}, },
			{{-1, REDUCE, 427}, },
			{{-1, REDUCE, 459}, },
			{{-1, REDUCE, 243}, },
			{{-1, ERROR, 789}, {24, SHIFT, 1124}, },
			{{-1, REDUCE, 371}, },
			{{-1, REDUCE, 435}, },
			{{-1, REDUCE, 467}, },
			{{-1, REDUCE, 483}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 795}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 1125}, {39, SHIFT, 19}, },
			{{-1, ERROR, 796}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 1130}, {39, SHIFT, 19}, },
			{{-1, ERROR, 797}, {21, SHIFT, 16}, {24, SHIFT, 1134}, {39, SHIFT, 19}, },
			{{-1, ERROR, 798}, {24, SHIFT, 1137}, {39, SHIFT, 19}, },
			{{-1, ERROR, 799}, {24, SHIFT, 1139}, },
			{{-1, REDUCE, 26}, },
			{{-1, ERROR, 801}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 1140}, {39, SHIFT, 19}, },
			{{-1, ERROR, 802}, {21, SHIFT, 16}, {24, SHIFT, 1144}, {39, SHIFT, 19}, },
			{{-1, ERROR, 803}, {24, SHIFT, 1147}, {39, SHIFT, 19}, },
			{{-1, ERROR, 804}, {24, SHIFT, 1149}, },
			{{-1, REDUCE, 42}, },
			{{-1, ERROR, 806}, {21, SHIFT, 16}, {24, SHIFT, 1150}, {39, SHIFT, 19}, },
			{{-1, ERROR, 807}, {24, SHIFT, 1153}, {39, SHIFT, 19}, },
			{{-1, ERROR, 808}, {24, SHIFT, 1155}, },
			{{-1, REDUCE, 74}, },
			{{-1, ERROR, 810}, {24, SHIFT, 1156}, {39, SHIFT, 19}, },
			{{-1, ERROR, 811}, {24, SHIFT, 1158}, },
			{{-1, REDUCE, 138}, },
			{{-1, ERROR, 813}, {24, SHIFT, 1159}, },
			{{-1, REDUCE, 266}, },
			{{-1, REDUCE, 30}, },
			{{-1, ERROR, 816}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 1160}, {39, SHIFT, 19}, },
			{{-1, ERROR, 817}, {21, SHIFT, 16}, {24, SHIFT, 1164}, {39, SHIFT, 19}, },
			{{-1, ERROR, 818}, {24, SHIFT, 1167}, {39, SHIFT, 19}, },
			{{-1, ERROR, 819}, {24, SHIFT, 1169}, },
			{{-1, REDUCE, 46}, },
			{{-1, ERROR, 821}, {21, SHIFT, 16}, {24, SHIFT, 1170}, {39, SHIFT, 19}, },
			{{-1, ERROR, 822}, {24, SHIFT, 1173}, {39, SHIFT, 19}, },
			{{-1, ERROR, 823}, {24, SHIFT, 1175}, },
			{{-1, REDUCE, 78}, },
			{{-1, ERROR, 825}, {24, SHIFT, 1176}, {39, SHIFT, 19}, },
			{{-1, ERROR, 826}, {24, SHIFT, 1178}, },
			{{-1, REDUCE, 142}, },
			{{-1, ERROR, 828}, {24, SHIFT, 1179}, },
			{{-1, REDUCE, 270}, },
			{{-1, REDUCE, 54}, },
			{{-1, ERROR, 831}, {21, SHIFT, 16}, {24, SHIFT, 1180}, {39, SHIFT, 19}, },
			{{-1, ERROR, 832}, {24, SHIFT, 1183}, {39, SHIFT, 19}, },
			{{-1, ERROR, 833}, {24, SHIFT, 1185}, },
			{{-1, REDUCE, 86}, },
			{{-1, ERROR, 835}, {24, SHIFT, 1186}, {39, SHIFT, 19}, },
			{{-1, ERROR, 836}, {24, SHIFT, 1188}, },
			{{-1, REDUCE, 150}, },
			{{-1, ERROR, 838}, {24, SHIFT, 1189}, },
			{{-1, REDUCE, 278}, },
			{{-1, REDUCE, 102}, },
			{{-1, ERROR, 841}, {24, SHIFT, 1190}, {39, SHIFT, 19}, },
			{{-1, ERROR, 842}, {24, SHIFT, 1192}, },
			{{-1, REDUCE, 166}, },
			{{-1, ERROR, 844}, {24, SHIFT, 1193}, },
			{{-1, REDUCE, 294}, },
			{{-1, REDUCE, 198}, },
			{{-1, ERROR, 847}, {24, SHIFT, 1194}, },
			{{-1, REDUCE, 326}, },
			{{-1, REDUCE, 390}, },
			{{-1, REDUCE, 32}, },
			{{-1, ERROR, 851}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 1195}, {39, SHIFT, 19}, },
			{{-1, ERROR, 852}, {21, SHIFT, 16}, {24, SHIFT, 1199}, {39, SHIFT, 19}, },
			{{-1, ERROR, 853}, {24, SHIFT, 1202}, {39, SHIFT, 19}, },
			{{-1, ERROR, 854}, {24, SHIFT, 1204}, },
			{{-1, REDUCE, 48}, },
			{{-1, ERROR, 856}, {21, SHIFT, 16}, {24, SHIFT, 1205}, {39, SHIFT, 19}, },
			{{-1, ERROR, 857}, {24, SHIFT, 1208}, {39, SHIFT, 19}, },
			{{-1, ERROR, 858}, {24, SHIFT, 1210}, },
			{{-1, REDUCE, 80}, },
			{{-1, ERROR, 860}, {24, SHIFT, 1211}, {39, SHIFT, 19}, },
			{{-1, ERROR, 861}, {24, SHIFT, 1213}, },
			{{-1, REDUCE, 144}, },
			{{-1, ERROR, 863}, {24, SHIFT, 1214}, },
			{{-1, REDUCE, 272}, },
			{{-1, REDUCE, 56}, },
			{{-1, ERROR, 866}, {21, SHIFT, 16}, {24, SHIFT, 1215}, {39, SHIFT, 19}, },
			{{-1, ERROR, 867}, {24, SHIFT, 1218}, {39, SHIFT, 19}, },
			{{-1, ERROR, 868}, {24, SHIFT, 1220}, },
			{{-1, REDUCE, 88}, },
			{{-1, ERROR, 870}, {24, SHIFT, 1221}, {39, SHIFT, 19}, },
			{{-1, ERROR, 871}, {24, SHIFT, 1223}, },
			{{-1, REDUCE, 152}, },
			{{-1, ERROR, 873}, {24, SHIFT, 1224}, },
			{{-1, REDUCE, 280}, },
			{{-1, REDUCE, 104}, },
			{{-1, ERROR, 876}, {24, SHIFT, 1225}, {39, SHIFT, 19}, },
			{{-1, ERROR, 877}, {24, SHIFT, 1227}, },
			{{-1, REDUCE, 168}, },
			{{-1, ERROR, 879}, {24, SHIFT, 1228}, },
			{{-1, REDUCE, 296}, },
			{{-1, REDUCE, 200}, },
			{{-1, ERROR, 882}, {24, SHIFT, 1229}, },
			{{-1, REDUCE, 328}, },
			{{-1, REDUCE, 392}, },
			{{-1, REDUCE, 60}, },
			{{-1, ERROR, 886}, {21, SHIFT, 16}, {24, SHIFT, 1230}, {39, SHIFT, 19}, },
			{{-1, ERROR, 887}, {24, SHIFT, 1233}, {39, SHIFT, 19}, },
			{{-1, ERROR, 888}, {24, SHIFT, 1235}, },
			{{-1, REDUCE, 92}, },
			{{-1, ERROR, 890}, {24, SHIFT, 1236}, {39, SHIFT, 19}, },
			{{-1, ERROR, 891}, {24, SHIFT, 1238}, },
			{{-1, REDUCE, 156}, },
			{{-1, ERROR, 893}, {24, SHIFT, 1239}, },
			{{-1, REDUCE, 284}, },
			{{-1, REDUCE, 108}, },
			{{-1, ERROR, 896}, {24, SHIFT, 1240}, {39, SHIFT, 19}, },
			{{-1, ERROR, 897}, {24, SHIFT, 1242}, },
			{{-1, REDUCE, 172}, },
			{{-1, ERROR, 899}, {24, SHIFT, 1243}, },
			{{-1, REDUCE, 300}, },
			{{-1, REDUCE, 204}, },
			{{-1, ERROR, 902}, {24, SHIFT, 1244}, },
			{{-1, REDUCE, 332}, },
			{{-1, REDUCE, 396}, },
			{{-1, REDUCE, 116}, },
			{{-1, ERROR, 906}, {24, SHIFT, 1245}, {39, SHIFT, 19}, },
			{{-1, ERROR, 907}, {24, SHIFT, 1247}, },
			{{-1, REDUCE, 180}, },
			{{-1, ERROR, 909}, {24, SHIFT, 1248}, },
			{{-1, REDUCE, 308}, },
			{{-1, REDUCE, 212}, },
			{{-1, ERROR, 912}, {24, SHIFT, 1249}, },
			{{-1, REDUCE, 340}, },
			{{-1, REDUCE, 404}, },
			{{-1, REDUCE, 228}, },
			{{-1, ERROR, 916}, {24, SHIFT, 1250}, },
			{{-1, REDUCE, 356}, },
			{{-1, REDUCE, 420}, },
			{{-1, REDUCE, 452}, },
			{{-1, REDUCE, 905}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 884}, },
			{{-1, REDUCE, 869}, },
			{{-1, ERROR, 923}, {24, SHIFT, 1251}, },
			{{-1, REDUCE, 877}, },
			{{-1, REDUCE, 881}, },
			{{-1, REDUCE, 883}, },
			{{-1, REDUCE, 810}, {0, SHIFT, 11}, },
			{{-1, ERROR, 928}, {8, SHIFT, 1253}, },
			{{-1, ERROR, 929}, {44, SHIFT, 602}, },
			{{-1, ERROR, 930}, {45, SHIFT, 937}, },
			{{-1, ERROR, 931}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 932}, {44, SHIFT, 602}, },
			{{-1, ERROR, 933}, {45, SHIFT, 937}, },
			{{-1, ERROR, 934}, {0, SHIFT, 106}, {17, SHIFT, 13}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 935}, {45, SHIFT, 937}, },
			{{-1, REDUCE, 806}, },
			{{-1, ERROR, 937}, {54, SHIFT, 1264}, },
			{{-1, ERROR, 938}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 939}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 940}, {44, SHIFT, 602}, },
			{{-1, ERROR, 941}, {45, SHIFT, 937}, },
			{{-1, ERROR, 942}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 943}, {0, SHIFT, 11}, {17, SHIFT, 13}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 944}, {44, SHIFT, 602}, },
			{{-1, ERROR, 945}, {45, SHIFT, 937}, },
			{{-1, ERROR, 946}, {0, SHIFT, 106}, {17, SHIFT, 13}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, REDUCE, 683}, },
			{{-1, REDUCE, 917}, },
			{{-1, REDUCE, 682}, {52, SHIFT, 947}, },
			{{-1, REDUCE, 688}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 919}, },
			{{-1, REDUCE, 686}, },
			{{-1, REDUCE, 685}, {52, SHIFT, 615}, },
			{{-1, ERROR, 954}, {54, SHIFT, 1284}, },
			{{-1, REDUCE, 921}, },
			{{-1, REDUCE, 691}, },
			{{-1, REDUCE, 690}, {3, SHIFT, 46}, {20, SHIFT, 617}, },
			{{-1, REDUCE, 692}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 923}, },
			{{-1, REDUCE, 698}, },
			{{-1, REDUCE, 697}, {3, SHIFT, 46}, },
			{{-1, REDUCE, 699}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 925}, },
			{{-1, REDUCE, 703}, },
			{{-1, REDUCE, 702}, {3, SHIFT, 46}, },
			{{-1, REDUCE, 704}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 560}, },
			{{-1, ERROR, 968}, {24, SHIFT, 1291}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 969}, {24, SHIFT, 1294}, {34, SHIFT, 350}, },
			{{-1, ERROR, 970}, {24, SHIFT, 1296}, },
			{{-1, REDUCE, 568}, },
			{{-1, ERROR, 972}, {24, SHIFT, 1297}, {34, SHIFT, 350}, },
			{{-1, ERROR, 973}, {24, SHIFT, 1299}, },
			{{-1, REDUCE, 584}, },
			{{-1, ERROR, 975}, {24, SHIFT, 1300}, },
			{{-1, REDUCE, 616}, },
			{{-1, REDUCE, 572}, },
			{{-1, ERROR, 978}, {24, SHIFT, 1301}, {34, SHIFT, 350}, },
			{{-1, ERROR, 979}, {24, SHIFT, 1303}, },
			{{-1, REDUCE, 588}, },
			{{-1, ERROR, 981}, {24, SHIFT, 1304}, },
			{{-1, REDUCE, 620}, },
			{{-1, REDUCE, 596}, },
			{{-1, ERROR, 984}, {24, SHIFT, 1305}, },
			{{-1, REDUCE, 628}, },
			{{-1, REDUCE, 644}, },
			{{-1, REDUCE, 554}, },
			{{-1, ERROR, 988}, {24, SHIFT, 1306}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 989}, {24, SHIFT, 1310}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 990}, {24, SHIFT, 1313}, {34, SHIFT, 350}, },
			{{-1, ERROR, 991}, {24, SHIFT, 1315}, },
			{{-1, REDUCE, 558}, },
			{{-1, ERROR, 993}, {24, SHIFT, 1316}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 994}, {24, SHIFT, 1319}, {34, SHIFT, 350}, },
			{{-1, ERROR, 995}, {24, SHIFT, 1321}, },
			{{-1, REDUCE, 566}, },
			{{-1, ERROR, 997}, {24, SHIFT, 1322}, {34, SHIFT, 350}, },
			{{-1, ERROR, 998}, {24, SHIFT, 1324}, },
			{{-1, REDUCE, 582}, },
			{{-1, ERROR, 1000}, {24, SHIFT, 1325}, },
			{{-1, REDUCE, 614}, },
			{{-1, REDUCE, 553}, },
			{{-1, ERROR, 1003}, {24, SHIFT, 1326}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1004}, {24, SHIFT, 1330}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1005}, {24, SHIFT, 1333}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1006}, {24, SHIFT, 1335}, },
			{{-1, REDUCE, 557}, },
			{{-1, ERROR, 1008}, {24, SHIFT, 1336}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1009}, {24, SHIFT, 1339}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1010}, {24, SHIFT, 1341}, },
			{{-1, REDUCE, 565}, },
			{{-1, ERROR, 1012}, {24, SHIFT, 1342}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1013}, {24, SHIFT, 1344}, },
			{{-1, REDUCE, 581}, },
			{{-1, ERROR, 1015}, {24, SHIFT, 1345}, },
			{{-1, REDUCE, 613}, },
			{{-1, REDUCE, 551}, },
			{{-1, ERROR, 1018}, {24, SHIFT, 1346}, {31, SHIFT, 347}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1019}, {24, SHIFT, 1351}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1020}, {24, SHIFT, 1355}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1021}, {24, SHIFT, 1358}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1022}, {24, SHIFT, 1360}, },
			{{-1, REDUCE, 849}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 847}, {0, SHIFT, 11}, },
			{{-1, ERROR, 1025}, {24, SHIFT, 1363}, },
			{{-1, ERROR, 1026}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 1027}, {35, SHIFT, 1365}, },
			{{-1, ERROR, 1028}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 1029}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 1030}, {22, SHIFT, 654}, {35, SHIFT, 1368}, },
			{{-1, ERROR, 1031}, {35, SHIFT, 1370}, },
			{{-1, ERROR, 1032}, {24, SHIFT, 1371}, {42, SHIFT, 1372}, },
			{{-1, ERROR, 1033}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, REDUCE, 845}, {9, SHIFT, 662}, },
			{{-1, REDUCE, 840}, {0, SHIFT, 11}, },
			{{-1, ERROR, 1036}, {6, SHIFT, 1377}, },
			{{-1, REDUCE, 523}, {0, SHIFT, 11}, },
			{{-1, ERROR, 1038}, {54, SHIFT, 1379}, },
			{{-1, ERROR, 1039}, {54, SHIFT, 1380}, },
			{{-1, ERROR, 1040}, {0, SHIFT, 106}, {51, SHIFT, 1381}, },
			{{-1, REDUCE, 65}, },
			{{-1, ERROR, 1042}, {21, SHIFT, 16}, {24, SHIFT, 1382}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1043}, {24, SHIFT, 1385}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1044}, {24, SHIFT, 1387}, },
			{{-1, REDUCE, 97}, },
			{{-1, ERROR, 1046}, {24, SHIFT, 1388}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1047}, {24, SHIFT, 1390}, },
			{{-1, REDUCE, 161}, },
			{{-1, ERROR, 1049}, {24, SHIFT, 1391}, },
			{{-1, REDUCE, 289}, },
			{{-1, REDUCE, 113}, },
			{{-1, ERROR, 1052}, {24, SHIFT, 1392}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1053}, {24, SHIFT, 1394}, },
			{{-1, REDUCE, 177}, },
			{{-1, ERROR, 1055}, {24, SHIFT, 1395}, },
			{{-1, REDUCE, 305}, },
			{{-1, REDUCE, 209}, },
			{{-1, ERROR, 1058}, {24, SHIFT, 1396}, },
			{{-1, REDUCE, 337}, },
			{{-1, REDUCE, 401}, },
			{{-1, REDUCE, 121}, },
			{{-1, ERROR, 1062}, {24, SHIFT, 1397}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1063}, {24, SHIFT, 1399}, },
			{{-1, REDUCE, 185}, },
			{{-1, ERROR, 1065}, {24, SHIFT, 1400}, },
			{{-1, REDUCE, 313}, },
			{{-1, REDUCE, 217}, },
			{{-1, ERROR, 1068}, {24, SHIFT, 1401}, },
			{{-1, REDUCE, 345}, },
			{{-1, REDUCE, 409}, },
			{{-1, REDUCE, 233}, },
			{{-1, ERROR, 1072}, {24, SHIFT, 1402}, },
			{{-1, REDUCE, 361}, },
			{{-1, REDUCE, 425}, },
			{{-1, REDUCE, 457}, },
			{{-1, REDUCE, 125}, },
			{{-1, ERROR, 1077}, {24, SHIFT, 1403}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1078}, {24, SHIFT, 1405}, },
			{{-1, REDUCE, 189}, },
			{{-1, ERROR, 1080}, {24, SHIFT, 1406}, },
			{{-1, REDUCE, 317}, },
			{{-1, REDUCE, 221}, },
			{{-1, ERROR, 1083}, {24, SHIFT, 1407}, },
			{{-1, REDUCE, 349}, },
			{{-1, REDUCE, 413}, },
			{{-1, REDUCE, 237}, },
			{{-1, ERROR, 1087}, {24, SHIFT, 1408}, },
			{{-1, REDUCE, 365}, },
			{{-1, REDUCE, 429}, },
			{{-1, REDUCE, 461}, },
			{{-1, REDUCE, 245}, },
			{{-1, ERROR, 1092}, {24, SHIFT, 1409}, },
			{{-1, REDUCE, 373}, },
			{{-1, REDUCE, 437}, },
			{{-1, REDUCE, 469}, },
			{{-1, REDUCE, 485}, },
			{{-1, REDUCE, 127}, },
			{{-1, ERROR, 1098}, {24, SHIFT, 1410}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1099}, {24, SHIFT, 1412}, },
			{{-1, REDUCE, 191}, },
			{{-1, ERROR, 1101}, {24, SHIFT, 1413}, },
			{{-1, REDUCE, 319}, },
			{{-1, REDUCE, 223}, },
			{{-1, ERROR, 1104}, {24, SHIFT, 1414}, },
			{{-1, REDUCE, 351}, },
			{{-1, REDUCE, 415}, },
			{{-1, REDUCE, 239}, },
			{{-1, ERROR, 1108}, {24, SHIFT, 1415}, },
			{{-1, REDUCE, 367}, },
			{{-1, REDUCE, 431}, },
			{{-1, REDUCE, 463}, },
			{{-1, REDUCE, 247}, },
			{{-1, ERROR, 1113}, {24, SHIFT, 1416}, },
			{{-1, REDUCE, 375}, },
			{{-1, REDUCE, 439}, },
			{{-1, REDUCE, 471}, },
			{{-1, REDUCE, 487}, },
			{{-1, REDUCE, 251}, },
			{{-1, ERROR, 1119}, {24, SHIFT, 1417}, },
			{{-1, REDUCE, 379}, },
			{{-1, REDUCE, 443}, },
			{{-1, REDUCE, 475}, },
			{{-1, REDUCE, 491}, },
			{{-1, REDUCE, 499}, },
			{{-1, REDUCE, 34}, },
			{{-1, ERROR, 1126}, {21, SHIFT, 16}, {22, SHIFT, 17}, {24, SHIFT, 1418}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1127}, {21, SHIFT, 16}, {24, SHIFT, 1422}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1128}, {24, SHIFT, 1425}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1129}, {24, SHIFT, 1427}, },
			{{-1, REDUCE, 50}, },
			{{-1, ERROR, 1131}, {21, SHIFT, 16}, {24, SHIFT, 1428}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1132}, {24, SHIFT, 1431}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1133}, {24, SHIFT, 1433}, },
			{{-1, REDUCE, 82}, },
			{{-1, ERROR, 1135}, {24, SHIFT, 1434}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1136}, {24, SHIFT, 1436}, },
			{{-1, REDUCE, 146}, },
			{{-1, ERROR, 1138}, {24, SHIFT, 1437}, },
			{{-1, REDUCE, 274}, },
			{{-1, REDUCE, 58}, },
			{{-1, ERROR, 1141}, {21, SHIFT, 16}, {24, SHIFT, 1438}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1142}, {24, SHIFT, 1441}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1143}, {24, SHIFT, 1443}, },
			{{-1, REDUCE, 90}, },
			{{-1, ERROR, 1145}, {24, SHIFT, 1444}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1146}, {24, SHIFT, 1446}, },
			{{-1, REDUCE, 154}, },
			{{-1, ERROR, 1148}, {24, SHIFT, 1447}, },
			{{-1, REDUCE, 282}, },
			{{-1, REDUCE, 106}, },
			{{-1, ERROR, 1151}, {24, SHIFT, 1448}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1152}, {24, SHIFT, 1450}, },
			{{-1, REDUCE, 170}, },
			{{-1, ERROR, 1154}, {24, SHIFT, 1451}, },
			{{-1, REDUCE, 298}, },
			{{-1, REDUCE, 202}, },
			{{-1, ERROR, 1157}, {24, SHIFT, 1452}, },
			{{-1, REDUCE, 330}, },
			{{-1, REDUCE, 394}, },
			{{-1, REDUCE, 62}, },
			{{-1, ERROR, 1161}, {21, SHIFT, 16}, {24, SHIFT, 1453}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1162}, {24, SHIFT, 1456}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1163}, {24, SHIFT, 1458}, },
			{{-1, REDUCE, 94}, },
			{{-1, ERROR, 1165}, {24, SHIFT, 1459}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1166}, {24, SHIFT, 1461}, },
			{{-1, REDUCE, 158}, },
			{{-1, ERROR, 1168}, {24, SHIFT, 1462}, },
			{{-1, REDUCE, 286}, },
			{{-1, REDUCE, 110}, },
			{{-1, ERROR, 1171}, {24, SHIFT, 1463}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1172}, {24, SHIFT, 1465}, },
			{{-1, REDUCE, 174}, },
			{{-1, ERROR, 1174}, {24, SHIFT, 1466}, },
			{{-1, REDUCE, 302}, },
			{{-1, REDUCE, 206}, },
			{{-1, ERROR, 1177}, {24, SHIFT, 1467}, },
			{{-1, REDUCE, 334}, },
			{{-1, REDUCE, 398}, },
			{{-1, REDUCE, 118}, },
			{{-1, ERROR, 1181}, {24, SHIFT, 1468}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1182}, {24, SHIFT, 1470}, },
			{{-1, REDUCE, 182}, },
			{{-1, ERROR, 1184}, {24, SHIFT, 1471}, },
			{{-1, REDUCE, 310}, },
			{{-1, REDUCE, 214}, },
			{{-1, ERROR, 1187}, {24, SHIFT, 1472}, },
			{{-1, REDUCE, 342}, },
			{{-1, REDUCE, 406}, },
			{{-1, REDUCE, 230}, },
			{{-1, ERROR, 1191}, {24, SHIFT, 1473}, },
			{{-1, REDUCE, 358}, },
			{{-1, REDUCE, 422}, },
			{{-1, REDUCE, 454}, },
			{{-1, REDUCE, 64}, },
			{{-1, ERROR, 1196}, {21, SHIFT, 16}, {24, SHIFT, 1474}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1197}, {24, SHIFT, 1477}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1198}, {24, SHIFT, 1479}, },
			{{-1, REDUCE, 96}, },
			{{-1, ERROR, 1200}, {24, SHIFT, 1480}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1201}, {24, SHIFT, 1482}, },
			{{-1, REDUCE, 160}, },
			{{-1, ERROR, 1203}, {24, SHIFT, 1483}, },
			{{-1, REDUCE, 288}, },
			{{-1, REDUCE, 112}, },
			{{-1, ERROR, 1206}, {24, SHIFT, 1484}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1207}, {24, SHIFT, 1486}, },
			{{-1, REDUCE, 176}, },
			{{-1, ERROR, 1209}, {24, SHIFT, 1487}, },
			{{-1, REDUCE, 304}, },
			{{-1, REDUCE, 208}, },
			{{-1, ERROR, 1212}, {24, SHIFT, 1488}, },
			{{-1, REDUCE, 336}, },
			{{-1, REDUCE, 400}, },
			{{-1, REDUCE, 120}, },
			{{-1, ERROR, 1216}, {24, SHIFT, 1489}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1217}, {24, SHIFT, 1491}, },
			{{-1, REDUCE, 184}, },
			{{-1, ERROR, 1219}, {24, SHIFT, 1492}, },
			{{-1, REDUCE, 312}, },
			{{-1, REDUCE, 216}, },
			{{-1, ERROR, 1222}, {24, SHIFT, 1493}, },
			{{-1, REDUCE, 344}, },
			{{-1, REDUCE, 408}, },
			{{-1, REDUCE, 232}, },
			{{-1, ERROR, 1226}, {24, SHIFT, 1494}, },
			{{-1, REDUCE, 360}, },
			{{-1, REDUCE, 424}, },
			{{-1, REDUCE, 456}, },
			{{-1, REDUCE, 124}, },
			{{-1, ERROR, 1231}, {24, SHIFT, 1495}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1232}, {24, SHIFT, 1497}, },
			{{-1, REDUCE, 188}, },
			{{-1, ERROR, 1234}, {24, SHIFT, 1498}, },
			{{-1, REDUCE, 316}, },
			{{-1, REDUCE, 220}, },
			{{-1, ERROR, 1237}, {24, SHIFT, 1499}, },
			{{-1, REDUCE, 348}, },
			{{-1, REDUCE, 412}, },
			{{-1, REDUCE, 236}, },
			{{-1, ERROR, 1241}, {24, SHIFT, 1500}, },
			{{-1, REDUCE, 364}, },
			{{-1, REDUCE, 428}, },
			{{-1, REDUCE, 460}, },
			{{-1, REDUCE, 244}, },
			{{-1, ERROR, 1246}, {24, SHIFT, 1501}, },
			{{-1, REDUCE, 372}, },
			{{-1, REDUCE, 436}, },
			{{-1, REDUCE, 468}, },
			{{-1, REDUCE, 484}, },
			{{-1, REDUCE, 885}, },
			{{-1, REDUCE, 811}, {0, SHIFT, 106}, },
			{{-1, ERROR, 1253}, {54, SHIFT, 1502}, },
			{{-1, ERROR, 1254}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1255}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1256}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1257}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1258}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1259}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1260}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 1261}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1262}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1263}, {46, SHIFT, 1265}, },
			{{-1, REDUCE, 812}, {0, SHIFT, 11}, },
			{{-1, ERROR, 1265}, {0, SHIFT, 11}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, ERROR, 1266}, {24, SHIFT, 1522}, },
			{{-1, ERROR, 1267}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1268}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1269}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1270}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1271}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1272}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1273}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 1274}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1275}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1276}, {0, SHIFT, 106}, {17, SHIFT, 13}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 1277}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1278}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1279}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 1280}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1281}, {45, SHIFT, 937}, },
			{{-1, REDUCE, 918}, },
			{{-1, REDUCE, 920}, },
			{{-1, REDUCE, 694}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 922}, },
			{{-1, REDUCE, 693}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 924}, },
			{{-1, REDUCE, 700}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 926}, },
			{{-1, REDUCE, 705}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 576}, },
			{{-1, ERROR, 1292}, {24, SHIFT, 1543}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1293}, {24, SHIFT, 1545}, },
			{{-1, REDUCE, 592}, },
			{{-1, ERROR, 1295}, {24, SHIFT, 1546}, },
			{{-1, REDUCE, 624}, },
			{{-1, REDUCE, 600}, },
			{{-1, ERROR, 1298}, {24, SHIFT, 1547}, },
			{{-1, REDUCE, 632}, },
			{{-1, REDUCE, 648}, },
			{{-1, REDUCE, 604}, },
			{{-1, ERROR, 1302}, {24, SHIFT, 1548}, },
			{{-1, REDUCE, 636}, },
			{{-1, REDUCE, 652}, },
			{{-1, REDUCE, 660}, },
			{{-1, REDUCE, 562}, },
			{{-1, ERROR, 1307}, {24, SHIFT, 1549}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1308}, {24, SHIFT, 1552}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1309}, {24, SHIFT, 1554}, },
			{{-1, REDUCE, 570}, },
			{{-1, ERROR, 1311}, {24, SHIFT, 1555}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1312}, {24, SHIFT, 1557}, },
			{{-1, REDUCE, 586}, },
			{{-1, ERROR, 1314}, {24, SHIFT, 1558}, },
			{{-1, REDUCE, 618}, },
			{{-1, REDUCE, 574}, },
			{{-1, ERROR, 1317}, {24, SHIFT, 1559}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1318}, {24, SHIFT, 1561}, },
			{{-1, REDUCE, 590}, },
			{{-1, ERROR, 1320}, {24, SHIFT, 1562}, },
			{{-1, REDUCE, 622}, },
			{{-1, REDUCE, 598}, },
			{{-1, ERROR, 1323}, {24, SHIFT, 1563}, },
			{{-1, REDUCE, 630}, },
			{{-1, REDUCE, 646}, },
			{{-1, REDUCE, 561}, },
			{{-1, ERROR, 1327}, {24, SHIFT, 1564}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1328}, {24, SHIFT, 1567}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1329}, {24, SHIFT, 1569}, },
			{{-1, REDUCE, 569}, },
			{{-1, ERROR, 1331}, {24, SHIFT, 1570}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1332}, {24, SHIFT, 1572}, },
			{{-1, REDUCE, 585}, },
			{{-1, ERROR, 1334}, {24, SHIFT, 1573}, },
			{{-1, REDUCE, 617}, },
			{{-1, REDUCE, 573}, },
			{{-1, ERROR, 1337}, {24, SHIFT, 1574}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1338}, {24, SHIFT, 1576}, },
			{{-1, REDUCE, 589}, },
			{{-1, ERROR, 1340}, {24, SHIFT, 1577}, },
			{{-1, REDUCE, 621}, },
			{{-1, REDUCE, 597}, },
			{{-1, ERROR, 1343}, {24, SHIFT, 1578}, },
			{{-1, REDUCE, 629}, },
			{{-1, REDUCE, 645}, },
			{{-1, REDUCE, 555}, },
			{{-1, ERROR, 1347}, {24, SHIFT, 1579}, {32, SHIFT, 348}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1348}, {24, SHIFT, 1583}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1349}, {24, SHIFT, 1586}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1350}, {24, SHIFT, 1588}, },
			{{-1, REDUCE, 559}, },
			{{-1, ERROR, 1352}, {24, SHIFT, 1589}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1353}, {24, SHIFT, 1592}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1354}, {24, SHIFT, 1594}, },
			{{-1, REDUCE, 567}, },
			{{-1, ERROR, 1356}, {24, SHIFT, 1595}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1357}, {24, SHIFT, 1597}, },
			{{-1, REDUCE, 583}, },
			{{-1, ERROR, 1359}, {24, SHIFT, 1598}, },
			{{-1, REDUCE, 615}, },
			{{-1, REDUCE, 850}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 848}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 824}, },
			{{-1, ERROR, 1364}, {24, SHIFT, 1599}, },
			{{-1, ERROR, 1365}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 1366}, {24, SHIFT, 1601}, },
			{{-1, ERROR, 1367}, {24, SHIFT, 1602}, },
			{{-1, ERROR, 1368}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 1369}, {35, SHIFT, 1604}, },
			{{-1, ERROR, 1370}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, REDUCE, 832}, },
			{{-1, ERROR, 1372}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 1373}, {24, SHIFT, 1607}, },
			{{-1, ERROR, 1374}, {24, SHIFT, 1608}, {42, SHIFT, 1372}, },
			{{-1, REDUCE, 846}, },
			{{-1, REDUCE, 842}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 841}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 527}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 525}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 524}, {0, SHIFT, 11}, },
			{{-1, ERROR, 1381}, {54, SHIFT, 1613}, },
			{{-1, REDUCE, 129}, },
			{{-1, ERROR, 1383}, {24, SHIFT, 1614}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1384}, {24, SHIFT, 1616}, },
			{{-1, REDUCE, 193}, },
			{{-1, ERROR, 1386}, {24, SHIFT, 1617}, },
			{{-1, REDUCE, 321}, },
			{{-1, REDUCE, 225}, },
			{{-1, ERROR, 1389}, {24, SHIFT, 1618}, },
			{{-1, REDUCE, 353}, },
			{{-1, REDUCE, 417}, },
			{{-1, REDUCE, 241}, },
			{{-1, ERROR, 1393}, {24, SHIFT, 1619}, },
			{{-1, REDUCE, 369}, },
			{{-1, REDUCE, 433}, },
			{{-1, REDUCE, 465}, },
			{{-1, REDUCE, 249}, },
			{{-1, ERROR, 1398}, {24, SHIFT, 1620}, },
			{{-1, REDUCE, 377}, },
			{{-1, REDUCE, 441}, },
			{{-1, REDUCE, 473}, },
			{{-1, REDUCE, 489}, },
			{{-1, REDUCE, 253}, },
			{{-1, ERROR, 1404}, {24, SHIFT, 1621}, },
			{{-1, REDUCE, 381}, },
			{{-1, REDUCE, 445}, },
			{{-1, REDUCE, 477}, },
			{{-1, REDUCE, 493}, },
			{{-1, REDUCE, 501}, },
			{{-1, REDUCE, 255}, },
			{{-1, ERROR, 1411}, {24, SHIFT, 1622}, },
			{{-1, REDUCE, 383}, },
			{{-1, REDUCE, 447}, },
			{{-1, REDUCE, 479}, },
			{{-1, REDUCE, 495}, },
			{{-1, REDUCE, 503}, },
			{{-1, REDUCE, 507}, },
			{{-1, REDUCE, 66}, },
			{{-1, ERROR, 1419}, {21, SHIFT, 16}, {24, SHIFT, 1623}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1420}, {24, SHIFT, 1626}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1421}, {24, SHIFT, 1628}, },
			{{-1, REDUCE, 98}, },
			{{-1, ERROR, 1423}, {24, SHIFT, 1629}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1424}, {24, SHIFT, 1631}, },
			{{-1, REDUCE, 162}, },
			{{-1, ERROR, 1426}, {24, SHIFT, 1632}, },
			{{-1, REDUCE, 290}, },
			{{-1, REDUCE, 114}, },
			{{-1, ERROR, 1429}, {24, SHIFT, 1633}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1430}, {24, SHIFT, 1635}, },
			{{-1, REDUCE, 178}, },
			{{-1, ERROR, 1432}, {24, SHIFT, 1636}, },
			{{-1, REDUCE, 306}, },
			{{-1, REDUCE, 210}, },
			{{-1, ERROR, 1435}, {24, SHIFT, 1637}, },
			{{-1, REDUCE, 338}, },
			{{-1, REDUCE, 402}, },
			{{-1, REDUCE, 122}, },
			{{-1, ERROR, 1439}, {24, SHIFT, 1638}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1440}, {24, SHIFT, 1640}, },
			{{-1, REDUCE, 186}, },
			{{-1, ERROR, 1442}, {24, SHIFT, 1641}, },
			{{-1, REDUCE, 314}, },
			{{-1, REDUCE, 218}, },
			{{-1, ERROR, 1445}, {24, SHIFT, 1642}, },
			{{-1, REDUCE, 346}, },
			{{-1, REDUCE, 410}, },
			{{-1, REDUCE, 234}, },
			{{-1, ERROR, 1449}, {24, SHIFT, 1643}, },
			{{-1, REDUCE, 362}, },
			{{-1, REDUCE, 426}, },
			{{-1, REDUCE, 458}, },
			{{-1, REDUCE, 126}, },
			{{-1, ERROR, 1454}, {24, SHIFT, 1644}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1455}, {24, SHIFT, 1646}, },
			{{-1, REDUCE, 190}, },
			{{-1, ERROR, 1457}, {24, SHIFT, 1647}, },
			{{-1, REDUCE, 318}, },
			{{-1, REDUCE, 222}, },
			{{-1, ERROR, 1460}, {24, SHIFT, 1648}, },
			{{-1, REDUCE, 350}, },
			{{-1, REDUCE, 414}, },
			{{-1, REDUCE, 238}, },
			{{-1, ERROR, 1464}, {24, SHIFT, 1649}, },
			{{-1, REDUCE, 366}, },
			{{-1, REDUCE, 430}, },
			{{-1, REDUCE, 462}, },
			{{-1, REDUCE, 246}, },
			{{-1, ERROR, 1469}, {24, SHIFT, 1650}, },
			{{-1, REDUCE, 374}, },
			{{-1, REDUCE, 438}, },
			{{-1, REDUCE, 470}, },
			{{-1, REDUCE, 486}, },
			{{-1, REDUCE, 128}, },
			{{-1, ERROR, 1475}, {24, SHIFT, 1651}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1476}, {24, SHIFT, 1653}, },
			{{-1, REDUCE, 192}, },
			{{-1, ERROR, 1478}, {24, SHIFT, 1654}, },
			{{-1, REDUCE, 320}, },
			{{-1, REDUCE, 224}, },
			{{-1, ERROR, 1481}, {24, SHIFT, 1655}, },
			{{-1, REDUCE, 352}, },
			{{-1, REDUCE, 416}, },
			{{-1, REDUCE, 240}, },
			{{-1, ERROR, 1485}, {24, SHIFT, 1656}, },
			{{-1, REDUCE, 368}, },
			{{-1, REDUCE, 432}, },
			{{-1, REDUCE, 464}, },
			{{-1, REDUCE, 248}, },
			{{-1, ERROR, 1490}, {24, SHIFT, 1657}, },
			{{-1, REDUCE, 376}, },
			{{-1, REDUCE, 440}, },
			{{-1, REDUCE, 472}, },
			{{-1, REDUCE, 488}, },
			{{-1, REDUCE, 252}, },
			{{-1, ERROR, 1496}, {24, SHIFT, 1658}, },
			{{-1, REDUCE, 380}, },
			{{-1, REDUCE, 444}, },
			{{-1, REDUCE, 476}, },
			{{-1, REDUCE, 492}, },
			{{-1, REDUCE, 500}, },
			{{-1, REDUCE, 808}, {0, SHIFT, 11}, },
			{{-1, ERROR, 1503}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1504}, {24, SHIFT, 1661}, },
			{{-1, ERROR, 1505}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1506}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1507}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1508}, {24, SHIFT, 1665}, },
			{{-1, ERROR, 1509}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1510}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1511}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1512}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1513}, {24, SHIFT, 1670}, },
			{{-1, REDUCE, 813}, {0, SHIFT, 106}, },
			{{-1, ERROR, 1515}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1516}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1517}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1518}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1519}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1520}, {24, SHIFT, 1686}, },
			{{-1, ERROR, 1521}, {0, SHIFT, 106}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, {49, SHIFT, 20}, },
			{{-1, REDUCE, 706}, },
			{{-1, ERROR, 1523}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1524}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1525}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1526}, {24, SHIFT, 1696}, },
			{{-1, ERROR, 1527}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1528}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1529}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1530}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1531}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1532}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1533}, {44, SHIFT, 602}, {47, SHIFT, 603}, },
			{{-1, ERROR, 1534}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1535}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1536}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1537}, {24, SHIFT, 1708}, },
			{{-1, ERROR, 1538}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1539}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1540}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1541}, {46, SHIFT, 1265}, },
			{{-1, REDUCE, 695}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 608}, },
			{{-1, ERROR, 1544}, {24, SHIFT, 1713}, },
			{{-1, REDUCE, 640}, },
			{{-1, REDUCE, 656}, },
			{{-1, REDUCE, 664}, },
			{{-1, REDUCE, 668}, },
			{{-1, REDUCE, 578}, },
			{{-1, ERROR, 1550}, {24, SHIFT, 1714}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1551}, {24, SHIFT, 1716}, },
			{{-1, REDUCE, 594}, },
			{{-1, ERROR, 1553}, {24, SHIFT, 1717}, },
			{{-1, REDUCE, 626}, },
			{{-1, REDUCE, 602}, },
			{{-1, ERROR, 1556}, {24, SHIFT, 1718}, },
			{{-1, REDUCE, 634}, },
			{{-1, REDUCE, 650}, },
			{{-1, REDUCE, 606}, },
			{{-1, ERROR, 1560}, {24, SHIFT, 1719}, },
			{{-1, REDUCE, 638}, },
			{{-1, REDUCE, 654}, },
			{{-1, REDUCE, 662}, },
			{{-1, REDUCE, 577}, },
			{{-1, ERROR, 1565}, {24, SHIFT, 1720}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1566}, {24, SHIFT, 1722}, },
			{{-1, REDUCE, 593}, },
			{{-1, ERROR, 1568}, {24, SHIFT, 1723}, },
			{{-1, REDUCE, 625}, },
			{{-1, REDUCE, 601}, },
			{{-1, ERROR, 1571}, {24, SHIFT, 1724}, },
			{{-1, REDUCE, 633}, },
			{{-1, REDUCE, 649}, },
			{{-1, REDUCE, 605}, },
			{{-1, ERROR, 1575}, {24, SHIFT, 1725}, },
			{{-1, REDUCE, 637}, },
			{{-1, REDUCE, 653}, },
			{{-1, REDUCE, 661}, },
			{{-1, REDUCE, 563}, },
			{{-1, ERROR, 1580}, {24, SHIFT, 1726}, {33, SHIFT, 349}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1581}, {24, SHIFT, 1729}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1582}, {24, SHIFT, 1731}, },
			{{-1, REDUCE, 571}, },
			{{-1, ERROR, 1584}, {24, SHIFT, 1732}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1585}, {24, SHIFT, 1734}, },
			{{-1, REDUCE, 587}, },
			{{-1, ERROR, 1587}, {24, SHIFT, 1735}, },
			{{-1, REDUCE, 619}, },
			{{-1, REDUCE, 575}, },
			{{-1, ERROR, 1590}, {24, SHIFT, 1736}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1591}, {24, SHIFT, 1738}, },
			{{-1, REDUCE, 591}, },
			{{-1, ERROR, 1593}, {24, SHIFT, 1739}, },
			{{-1, REDUCE, 623}, },
			{{-1, REDUCE, 599}, },
			{{-1, ERROR, 1596}, {24, SHIFT, 1740}, },
			{{-1, REDUCE, 631}, },
			{{-1, REDUCE, 647}, },
			{{-1, REDUCE, 826}, },
			{{-1, ERROR, 1600}, {24, SHIFT, 1741}, },
			{{-1, REDUCE, 828}, },
			{{-1, REDUCE, 825}, },
			{{-1, ERROR, 1603}, {24, SHIFT, 1742}, },
			{{-1, ERROR, 1604}, {3, SHIFT, 46}, {36, SHIFT, 57}, {37, SHIFT, 58}, {38, SHIFT, 59}, {40, SHIFT, 60}, {41, SHIFT, 61}, {52, SHIFT, 62}, },
			{{-1, ERROR, 1605}, {24, SHIFT, 1744}, },
			{{-1, REDUCE, 844}, },
			{{-1, REDUCE, 834}, },
			{{-1, REDUCE, 833}, },
			{{-1, ERROR, 1609}, {24, SHIFT, 1745}, },
			{{-1, REDUCE, 843}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 529}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 528}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 526}, {0, SHIFT, 11}, },
			{{-1, REDUCE, 257}, },
			{{-1, ERROR, 1615}, {24, SHIFT, 1747}, },
			{{-1, REDUCE, 385}, },
			{{-1, REDUCE, 449}, },
			{{-1, REDUCE, 481}, },
			{{-1, REDUCE, 497}, },
			{{-1, REDUCE, 505}, },
			{{-1, REDUCE, 509}, },
			{{-1, REDUCE, 511}, },
			{{-1, REDUCE, 130}, },
			{{-1, ERROR, 1624}, {24, SHIFT, 1748}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1625}, {24, SHIFT, 1750}, },
			{{-1, REDUCE, 194}, },
			{{-1, ERROR, 1627}, {24, SHIFT, 1751}, },
			{{-1, REDUCE, 322}, },
			{{-1, REDUCE, 226}, },
			{{-1, ERROR, 1630}, {24, SHIFT, 1752}, },
			{{-1, REDUCE, 354}, },
			{{-1, REDUCE, 418}, },
			{{-1, REDUCE, 242}, },
			{{-1, ERROR, 1634}, {24, SHIFT, 1753}, },
			{{-1, REDUCE, 370}, },
			{{-1, REDUCE, 434}, },
			{{-1, REDUCE, 466}, },
			{{-1, REDUCE, 250}, },
			{{-1, ERROR, 1639}, {24, SHIFT, 1754}, },
			{{-1, REDUCE, 378}, },
			{{-1, REDUCE, 442}, },
			{{-1, REDUCE, 474}, },
			{{-1, REDUCE, 490}, },
			{{-1, REDUCE, 254}, },
			{{-1, ERROR, 1645}, {24, SHIFT, 1755}, },
			{{-1, REDUCE, 382}, },
			{{-1, REDUCE, 446}, },
			{{-1, REDUCE, 478}, },
			{{-1, REDUCE, 494}, },
			{{-1, REDUCE, 502}, },
			{{-1, REDUCE, 256}, },
			{{-1, ERROR, 1652}, {24, SHIFT, 1756}, },
			{{-1, REDUCE, 384}, },
			{{-1, REDUCE, 448}, },
			{{-1, REDUCE, 480}, },
			{{-1, REDUCE, 496}, },
			{{-1, REDUCE, 504}, },
			{{-1, REDUCE, 508}, },
			{{-1, REDUCE, 809}, {0, SHIFT, 106}, },
			{{-1, ERROR, 1660}, {24, SHIFT, 1757}, },
			{{-1, REDUCE, 714}, },
			{{-1, ERROR, 1662}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1663}, {24, SHIFT, 1759}, },
			{{-1, ERROR, 1664}, {24, SHIFT, 1760}, },
			{{-1, REDUCE, 708}, },
			{{-1, ERROR, 1666}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1667}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1668}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1669}, {24, SHIFT, 1764}, },
			{{-1, REDUCE, 722}, },
			{{-1, ERROR, 1671}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1672}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1673}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1674}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1675}, {24, SHIFT, 1775}, },
			{{-1, ERROR, 1676}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1677}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1678}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1679}, {24, SHIFT, 1782}, },
			{{-1, ERROR, 1680}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1681}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1682}, {24, SHIFT, 1786}, },
			{{-1, ERROR, 1683}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1684}, {24, SHIFT, 1788}, },
			{{-1, ERROR, 1685}, {24, SHIFT, 1789}, },
			{{-1, REDUCE, 738}, },
			{{-1, ERROR, 1687}, {18, SHIFT, 14}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1688}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1689}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1690}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1691}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1692}, {24, SHIFT, 1805}, },
			{{-1, ERROR, 1693}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1694}, {24, SHIFT, 1807}, },
			{{-1, ERROR, 1695}, {24, SHIFT, 1808}, },
			{{-1, REDUCE, 710}, },
			{{-1, ERROR, 1697}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1698}, {24, SHIFT, 1810}, },
			{{-1, ERROR, 1699}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1700}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1701}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1702}, {24, SHIFT, 1814}, },
			{{-1, ERROR, 1703}, {44, SHIFT, 602}, },
			{{-1, ERROR, 1704}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1705}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1706}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1707}, {24, SHIFT, 1819}, },
			{{-1, REDUCE, 707}, },
			{{-1, ERROR, 1709}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1710}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1711}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1712}, {24, SHIFT, 1823}, },
			{{-1, REDUCE, 672}, },
			{{-1, REDUCE, 610}, },
			{{-1, ERROR, 1715}, {24, SHIFT, 1824}, },
			{{-1, REDUCE, 642}, },
			{{-1, REDUCE, 658}, },
			{{-1, REDUCE, 666}, },
			{{-1, REDUCE, 670}, },
			{{-1, REDUCE, 609}, },
			{{-1, ERROR, 1721}, {24, SHIFT, 1825}, },
			{{-1, REDUCE, 641}, },
			{{-1, REDUCE, 657}, },
			{{-1, REDUCE, 665}, },
			{{-1, REDUCE, 669}, },
			{{-1, REDUCE, 579}, },
			{{-1, ERROR, 1727}, {24, SHIFT, 1826}, {34, SHIFT, 350}, },
			{{-1, ERROR, 1728}, {24, SHIFT, 1828}, },
			{{-1, REDUCE, 595}, },
			{{-1, ERROR, 1730}, {24, SHIFT, 1829}, },
			{{-1, REDUCE, 627}, },
			{{-1, REDUCE, 603}, },
			{{-1, ERROR, 1733}, {24, SHIFT, 1830}, },
			{{-1, REDUCE, 635}, },
			{{-1, REDUCE, 651}, },
			{{-1, REDUCE, 607}, },
			{{-1, ERROR, 1737}, {24, SHIFT, 1831}, },
			{{-1, REDUCE, 639}, },
			{{-1, REDUCE, 655}, },
			{{-1, REDUCE, 663}, },
			{{-1, REDUCE, 830}, },
			{{-1, REDUCE, 827}, },
			{{-1, ERROR, 1743}, {24, SHIFT, 1832}, },
			{{-1, REDUCE, 829}, },
			{{-1, REDUCE, 835}, },
			{{-1, REDUCE, 530}, {0, SHIFT, 106}, },
			{{-1, REDUCE, 513}, },
			{{-1, REDUCE, 258}, },
			{{-1, ERROR, 1749}, {24, SHIFT, 1833}, },
			{{-1, REDUCE, 386}, },
			{{-1, REDUCE, 450}, },
			{{-1, REDUCE, 482}, },
			{{-1, REDUCE, 498}, },
			{{-1, REDUCE, 506}, },
			{{-1, REDUCE, 510}, },
			{{-1, REDUCE, 512}, },
			{{-1, REDUCE, 730}, },
			{{-1, ERROR, 1758}, {24, SHIFT, 1834}, },
			{{-1, REDUCE, 716}, },
			{{-1, REDUCE, 724}, },
			{{-1, ERROR, 1761}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1762}, {24, SHIFT, 1836}, },
			{{-1, ERROR, 1763}, {24, SHIFT, 1837}, },
			{{-1, REDUCE, 712}, },
			{{-1, ERROR, 1765}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1766}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1767}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1768}, {24, SHIFT, 1844}, },
			{{-1, ERROR, 1769}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1770}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1771}, {24, SHIFT, 1848}, },
			{{-1, ERROR, 1772}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1773}, {24, SHIFT, 1850}, },
			{{-1, ERROR, 1774}, {24, SHIFT, 1851}, },
			{{-1, REDUCE, 740}, },
			{{-1, ERROR, 1776}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1777}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1778}, {24, SHIFT, 1855}, },
			{{-1, ERROR, 1779}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1780}, {24, SHIFT, 1857}, },
			{{-1, ERROR, 1781}, {24, SHIFT, 1858}, },
			{{-1, REDUCE, 742}, },
			{{-1, ERROR, 1783}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1784}, {24, SHIFT, 1860}, },
			{{-1, ERROR, 1785}, {24, SHIFT, 1861}, },
			{{-1, REDUCE, 746}, },
			{{-1, ERROR, 1787}, {24, SHIFT, 1862}, },
			{{-1, REDUCE, 754}, },
			{{-1, REDUCE, 770}, },
			{{-1, ERROR, 1790}, {19, SHIFT, 15}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1791}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1792}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1793}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1794}, {24, SHIFT, 1873}, },
			{{-1, ERROR, 1795}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1796}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1797}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1798}, {24, SHIFT, 1880}, },
			{{-1, ERROR, 1799}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1800}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1801}, {24, SHIFT, 1884}, },
			{{-1, ERROR, 1802}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1803}, {24, SHIFT, 1886}, },
			{{-1, ERROR, 1804}, {24, SHIFT, 1887}, },
			{{-1, REDUCE, 739}, },
			{{-1, ERROR, 1806}, {24, SHIFT, 1888}, },
			{{-1, REDUCE, 718}, },
			{{-1, REDUCE, 726}, },
			{{-1, ERROR, 1809}, {24, SHIFT, 1889}, },
			{{-1, REDUCE, 715}, },
			{{-1, ERROR, 1811}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1812}, {24, SHIFT, 1891}, },
			{{-1, ERROR, 1813}, {24, SHIFT, 1892}, },
			{{-1, REDUCE, 709}, },
			{{-1, ERROR, 1815}, {45, SHIFT, 937}, },
			{{-1, ERROR, 1816}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1817}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1818}, {24, SHIFT, 1896}, },
			{{-1, REDUCE, 723}, },
			{{-1, ERROR, 1820}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1821}, {24, SHIFT, 1898}, },
			{{-1, ERROR, 1822}, {24, SHIFT, 1899}, },
			{{-1, REDUCE, 711}, },
			{{-1, REDUCE, 674}, },
			{{-1, REDUCE, 673}, },
			{{-1, REDUCE, 611}, },
			{{-1, ERROR, 1827}, {24, SHIFT, 1900}, },
			{{-1, REDUCE, 643}, },
			{{-1, REDUCE, 659}, },
			{{-1, REDUCE, 667}, },
			{{-1, REDUCE, 671}, },
			{{-1, REDUCE, 831}, },
			{{-1, REDUCE, 514}, },
			{{-1, REDUCE, 732}, },
			{{-1, ERROR, 1835}, {24, SHIFT, 1901}, },
			{{-1, REDUCE, 720}, },
			{{-1, REDUCE, 728}, },
			{{-1, ERROR, 1838}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1839}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1840}, {24, SHIFT, 1905}, },
			{{-1, ERROR, 1841}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1842}, {24, SHIFT, 1907}, },
			{{-1, ERROR, 1843}, {24, SHIFT, 1908}, },
			{{-1, REDUCE, 744}, },
			{{-1, ERROR, 1845}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1846}, {24, SHIFT, 1910}, },
			{{-1, ERROR, 1847}, {24, SHIFT, 1911}, },
			{{-1, REDUCE, 748}, },
			{{-1, ERROR, 1849}, {24, SHIFT, 1912}, },
			{{-1, REDUCE, 756}, },
			{{-1, REDUCE, 772}, },
			{{-1, ERROR, 1852}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1853}, {24, SHIFT, 1914}, },
			{{-1, ERROR, 1854}, {24, SHIFT, 1915}, },
			{{-1, REDUCE, 750}, },
			{{-1, ERROR, 1856}, {24, SHIFT, 1916}, },
			{{-1, REDUCE, 758}, },
			{{-1, REDUCE, 774}, },
			{{-1, ERROR, 1859}, {24, SHIFT, 1917}, },
			{{-1, REDUCE, 762}, },
			{{-1, REDUCE, 778}, },
			{{-1, REDUCE, 786}, },
			{{-1, ERROR, 1863}, {21, SHIFT, 16}, {22, SHIFT, 17}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1864}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1865}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1866}, {24, SHIFT, 1924}, },
			{{-1, ERROR, 1867}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1868}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1869}, {24, SHIFT, 1928}, },
			{{-1, ERROR, 1870}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1871}, {24, SHIFT, 1930}, },
			{{-1, ERROR, 1872}, {24, SHIFT, 1931}, },
			{{-1, REDUCE, 741}, },
			{{-1, ERROR, 1874}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1875}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1876}, {24, SHIFT, 1935}, },
			{{-1, ERROR, 1877}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1878}, {24, SHIFT, 1937}, },
			{{-1, ERROR, 1879}, {24, SHIFT, 1938}, },
			{{-1, REDUCE, 743}, },
			{{-1, ERROR, 1881}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1882}, {24, SHIFT, 1940}, },
			{{-1, ERROR, 1883}, {24, SHIFT, 1941}, },
			{{-1, REDUCE, 747}, },
			{{-1, ERROR, 1885}, {24, SHIFT, 1942}, },
			{{-1, REDUCE, 755}, },
			{{-1, REDUCE, 771}, },
			{{-1, REDUCE, 734}, },
			{{-1, REDUCE, 731}, },
			{{-1, ERROR, 1890}, {24, SHIFT, 1943}, },
			{{-1, REDUCE, 717}, },
			{{-1, REDUCE, 725}, },
			{{-1, ERROR, 1893}, {46, SHIFT, 1265}, },
			{{-1, ERROR, 1894}, {24, SHIFT, 1945}, },
			{{-1, ERROR, 1895}, {24, SHIFT, 1946}, },
			{{-1, REDUCE, 713}, },
			{{-1, ERROR, 1897}, {24, SHIFT, 1947}, },
			{{-1, REDUCE, 719}, },
			{{-1, REDUCE, 727}, },
			{{-1, REDUCE, 675}, },
			{{-1, REDUCE, 736}, },
			{{-1, ERROR, 1902}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1903}, {24, SHIFT, 1949}, },
			{{-1, ERROR, 1904}, {24, SHIFT, 1950}, },
			{{-1, REDUCE, 752}, },
			{{-1, ERROR, 1906}, {24, SHIFT, 1951}, },
			{{-1, REDUCE, 760}, },
			{{-1, REDUCE, 776}, },
			{{-1, ERROR, 1909}, {24, SHIFT, 1952}, },
			{{-1, REDUCE, 764}, },
			{{-1, REDUCE, 780}, },
			{{-1, REDUCE, 788}, },
			{{-1, ERROR, 1913}, {24, SHIFT, 1953}, },
			{{-1, REDUCE, 766}, },
			{{-1, REDUCE, 782}, },
			{{-1, REDUCE, 790}, },
			{{-1, REDUCE, 794}, },
			{{-1, ERROR, 1918}, {21, SHIFT, 16}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1919}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1920}, {24, SHIFT, 1957}, },
			{{-1, ERROR, 1921}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1922}, {24, SHIFT, 1959}, },
			{{-1, ERROR, 1923}, {24, SHIFT, 1960}, },
			{{-1, REDUCE, 745}, },
			{{-1, ERROR, 1925}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1926}, {24, SHIFT, 1962}, },
			{{-1, ERROR, 1927}, {24, SHIFT, 1963}, },
			{{-1, REDUCE, 749}, },
			{{-1, ERROR, 1929}, {24, SHIFT, 1964}, },
			{{-1, REDUCE, 757}, },
			{{-1, REDUCE, 773}, },
			{{-1, ERROR, 1932}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1933}, {24, SHIFT, 1966}, },
			{{-1, ERROR, 1934}, {24, SHIFT, 1967}, },
			{{-1, REDUCE, 751}, },
			{{-1, ERROR, 1936}, {24, SHIFT, 1968}, },
			{{-1, REDUCE, 759}, },
			{{-1, REDUCE, 775}, },
			{{-1, ERROR, 1939}, {24, SHIFT, 1969}, },
			{{-1, REDUCE, 763}, },
			{{-1, REDUCE, 779}, },
			{{-1, REDUCE, 787}, },
			{{-1, REDUCE, 733}, },
			{{-1, ERROR, 1944}, {24, SHIFT, 1970}, },
			{{-1, REDUCE, 721}, },
			{{-1, REDUCE, 729}, },
			{{-1, REDUCE, 735}, },
			{{-1, ERROR, 1948}, {24, SHIFT, 1971}, },
			{{-1, REDUCE, 768}, },
			{{-1, REDUCE, 784}, },
			{{-1, REDUCE, 792}, },
			{{-1, REDUCE, 796}, },
			{{-1, REDUCE, 798}, },
			{{-1, ERROR, 1954}, {39, SHIFT, 19}, },
			{{-1, ERROR, 1955}, {24, SHIFT, 1973}, },
			{{-1, ERROR, 1956}, {24, SHIFT, 1974}, },
			{{-1, REDUCE, 753}, },
			{{-1, ERROR, 1958}, {24, SHIFT, 1975}, },
			{{-1, REDUCE, 761}, },
			{{-1, REDUCE, 777}, },
			{{-1, ERROR, 1961}, {24, SHIFT, 1976}, },
			{{-1, REDUCE, 765}, },
			{{-1, REDUCE, 781}, },
			{{-1, REDUCE, 789}, },
			{{-1, ERROR, 1965}, {24, SHIFT, 1977}, },
			{{-1, REDUCE, 767}, },
			{{-1, REDUCE, 783}, },
			{{-1, REDUCE, 791}, },
			{{-1, REDUCE, 795}, },
			{{-1, REDUCE, 737}, },
			{{-1, REDUCE, 800}, },
			{{-1, ERROR, 1972}, {24, SHIFT, 1978}, },
			{{-1, REDUCE, 769}, },
			{{-1, REDUCE, 785}, },
			{{-1, REDUCE, 793}, },
			{{-1, REDUCE, 797}, },
			{{-1, REDUCE, 799}, },
			{{-1, REDUCE, 801}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 4}, },
			{{-1, 5}, },
			{{-1, 21}, {30, 108}, },
			{{-1, 145}, {146, 338}, },
			{{-1, 22}, {21, 70}, {30, 109}, {108, 263}, {334, 604}, {605, 931}, {609, 939}, {610, 942}, {934, 1260}, {943, 1273}, {946, 1279}, {1276, 1533}, },
			{{-1, 148}, {149, 339}, },
			{{-1, 23}, {21, 71}, {22, 78}, {30, 110}, {70, 178}, {90, 241}, {108, 264}, {109, 271}, {263, 498}, {1265, 1515}, {1521, 1687}, },
			{{-1, 24}, },
			{{-1, 25}, {21, 72}, {22, 79}, {23, 85}, {30, 111}, {70, 179}, {71, 185}, {78, 206}, {108, 265}, {109, 272}, {110, 278}, {178, 372}, {263, 499}, {264, 505}, {271, 526}, {498, 795}, {1265, 1516}, {1515, 1671}, {1521, 1688}, {1687, 1790}, },
			{{-1, 45}, },
			{{-1, 26}, {21, 73}, {22, 80}, {23, 86}, {25, 92}, {30, 112}, {70, 180}, {71, 186}, {72, 191}, {78, 207}, {79, 212}, {85, 227}, {108, 266}, {109, 273}, {110, 279}, {111, 284}, {178, 373}, {179, 378}, {185, 393}, {206, 428}, {263, 500}, {264, 506}, {265, 511}, {271, 527}, {272, 532}, {278, 547}, {372, 669}, {498, 796}, {499, 801}, {505, 816}, {526, 851}, {795, 1126}, {1265, 1517}, {1515, 1672}, {1516, 1676}, {1521, 1689}, {1671, 1765}, {1687, 1791}, {1688, 1795}, {1790, 1863}, },
			{{-1, 154}, {156, 342}, },
			{{-1, 155}, {15, 48}, },
			{{-1, 27}, {21, 74}, {22, 81}, {23, 87}, {25, 93}, {26, 97}, {30, 113}, {70, 181}, {71, 187}, {72, 192}, {73, 196}, {78, 208}, {79, 213}, {80, 217}, {85, 228}, {86, 232}, {92, 243}, {108, 267}, {109, 274}, {110, 280}, {111, 285}, {112, 289}, {178, 374}, {179, 379}, {180, 383}, {185, 394}, {186, 398}, {191, 408}, {206, 429}, {207, 433}, {212, 443}, {227, 463}, {263, 501}, {264, 507}, {265, 512}, {266, 516}, {271, 528}, {272, 533}, {273, 537}, {278, 548}, {279, 552}, {284, 562}, {372, 670}, {373, 674}, {378, 684}, {393, 704}, {428, 739}, {498, 797}, {499, 802}, {500, 806}, {505, 817}, {506, 821}, {511, 831}, {526, 852}, {527, 856}, {532, 866}, {547, 886}, {669, 1042}, {795, 1127}, {796, 1131}, {801, 1141}, {816, 1161}, {851, 1196}, {1126, 1419}, {1265, 1518}, {1515, 1673}, {1516, 1677}, {1517, 1680}, {1521, 1690}, {1671, 1766}, {1672, 1769}, {1676, 1776}, {1687, 1792}, {1688, 1796}, {1689, 1799}, {1765, 1838}, {1790, 1864}, {1791, 1867}, {1795, 1874}, {1863, 1918}, },
			{{-1, 28}, {21, 75}, {22, 82}, {23, 88}, {25, 94}, {26, 98}, {27, 101}, {30, 114}, {70, 182}, {71, 188}, {72, 193}, {73, 197}, {74, 200}, {78, 209}, {79, 214}, {80, 218}, {81, 221}, {85, 229}, {86, 233}, {87, 236}, {92, 244}, {93, 247}, {97, 253}, {108, 268}, {109, 275}, {110, 281}, {111, 286}, {112, 290}, {113, 293}, {178, 375}, {179, 380}, {180, 384}, {181, 387}, {185, 395}, {186, 399}, {187, 402}, {191, 409}, {192, 412}, {196, 418}, {206, 430}, {207, 434}, {208, 437}, {212, 444}, {213, 447}, {217, 453}, {227, 464}, {228, 467}, {232, 473}, {243, 483}, {263, 502}, {264, 508}, {265, 513}, {266, 517}, {267, 520}, {271, 529}, {272, 534}, {273, 538}, {274, 541}, {278, 549}, {279, 553}, {280, 556}, {284, 563}, {285, 566}, {289, 572}, {372, 671}, {373, 675}, {374, 678}, {378, 685}, {379, 688}, {383, 694}, {393, 705}, {394, 708}, {398, 714}, {408, 724}, {428, 740}, {429, 743}, {433, 749}, {443, 759}, {463, 774}, {498, 798}, {499, 803}, {500, 807}, {501, 810}, {505, 818}, {506, 822}, {507, 825}, {511, 832}, {512, 835}, {516, 841}, {526, 853}, {527, 857}, {528, 860}, {532, 867}, {533, 870}, {537, 876}, {547, 887}, {548, 890}, {552, 896}, {562, 906}, {669, 1043}, {670, 1046}, {674, 1052}, {684, 1062}, {704, 1077}, {739, 1098}, {795, 1128}, {796, 1132}, {797, 1135}, {801, 1142}, {802, 1145}, {806, 1151}, {816, 1162}, {817, 1165}, {821, 1171}, {831, 1181}, {851, 1197}, {852, 1200}, {856, 1206}, {866, 1216}, {886, 1231}, {1042, 1383}, {1126, 1420}, {1127, 1423}, {1131, 1429}, {1141, 1439}, {1161, 1454}, {1196, 1475}, {1265, 1519}, {1419, 1624}, {1515, 1674}, {1516, 1678}, {1517, 1681}, {1518, 1683}, {1521, 1691}, {1671, 1767}, {1672, 1770}, {1673, 1772}, {1676, 1777}, {1677, 1779}, {1680, 1783}, {1687, 1793}, {1688, 1797}, {1689, 1800}, {1690, 1802}, {1765, 1839}, {1766, 1841}, {1769, 1845}, {1776, 1852}, {1790, 1865}, {1791, 1868}, {1792, 1870}, {1795, 1875}, {1796, 1877}, {1799, 1881}, {1838, 1902}, {1863, 1919}, {1864, 1921}, {1867, 1925}, {1874, 1932}, {1918, 1954}, },
			{{-1, 159}, {161, 358}, },
			{{-1, 160}, {16, 54}, },
			{{-1, 55}, },
			{{-1, 351}, {357, 640}, {359, 646}, {651, 1018}, },
			{{-1, 352}, },
			{{-1, 948}, {949, 1282}, },
			{{-1, 353}, {351, 625}, {357, 641}, {359, 647}, {640, 988}, {646, 1003}, {651, 1019}, {1018, 1347}, },
			{{-1, 951}, {953, 1283}, },
			{{-1, 952}, {347, 616}, },
			{{-1, 354}, {351, 626}, {353, 630}, {357, 642}, {359, 648}, {625, 968}, {640, 989}, {641, 993}, {646, 1004}, {647, 1008}, {651, 1020}, {988, 1307}, {1003, 1327}, {1018, 1348}, {1019, 1352}, {1347, 1580}, },
			{{-1, 955}, {957, 1285}, },
			{{-1, 956}, {348, 618}, },
			{{-1, 355}, {351, 627}, {353, 631}, {354, 634}, {357, 643}, {359, 649}, {625, 969}, {626, 972}, {630, 978}, {640, 990}, {641, 994}, {642, 997}, {646, 1005}, {647, 1009}, {648, 1012}, {651, 1021}, {968, 1292}, {988, 1308}, {989, 1311}, {993, 1317}, {1003, 1328}, {1004, 1331}, {1008, 1337}, {1018, 1349}, {1019, 1353}, {1020, 1356}, {1307, 1550}, {1327, 1565}, {1347, 1581}, {1348, 1584}, {1352, 1590}, {1580, 1727}, },
			{{-1, 959}, {961, 1287}, },
			{{-1, 960}, {349, 620}, },
			{{-1, 356}, {351, 628}, {353, 632}, {354, 635}, {355, 637}, {357, 644}, {359, 650}, {625, 970}, {626, 973}, {627, 975}, {630, 979}, {631, 981}, {634, 984}, {640, 991}, {641, 995}, {642, 998}, {643, 1000}, {646, 1006}, {647, 1010}, {648, 1013}, {649, 1015}, {651, 1022}, {968, 1293}, {969, 1295}, {972, 1298}, {978, 1302}, {988, 1309}, {989, 1312}, {990, 1314}, {993, 1318}, {994, 1320}, {997, 1323}, {1003, 1329}, {1004, 1332}, {1005, 1334}, {1008, 1338}, {1009, 1340}, {1012, 1343}, {1018, 1350}, {1019, 1354}, {1020, 1357}, {1021, 1359}, {1292, 1544}, {1307, 1551}, {1308, 1553}, {1311, 1556}, {1317, 1560}, {1327, 1566}, {1328, 1568}, {1331, 1571}, {1337, 1575}, {1347, 1582}, {1348, 1585}, {1349, 1587}, {1352, 1591}, {1353, 1593}, {1356, 1596}, {1550, 1715}, {1565, 1721}, {1580, 1728}, {1581, 1730}, {1584, 1733}, {1590, 1737}, {1727, 1827}, },
			{{-1, 963}, {965, 1289}, },
			{{-1, 964}, {350, 622}, },
			{{-1, 6}, },
			{{-1, 1266}, {1255, 1504}, {1259, 1508}, {1263, 1513}, {1270, 1526}, {1278, 1537}, {1503, 1660}, {1506, 1663}, {1507, 1664}, {1512, 1669}, {1524, 1694}, {1525, 1695}, {1528, 1698}, {1532, 1702}, {1536, 1707}, {1541, 1712}, {1662, 1758}, {1667, 1762}, {1668, 1763}, {1693, 1806}, {1697, 1809}, {1700, 1812}, {1701, 1813}, {1706, 1818}, {1710, 1821}, {1711, 1822}, {1761, 1835}, {1811, 1890}, {1816, 1894}, {1817, 1895}, {1820, 1897}, {1893, 1944}, },
			{{-1, 142}, {334, 605}, {337, 611}, {610, 943}, },
			{{-1, 143}, },
			{{-1, 606}, {604, 929}, {605, 932}, {607, 936}, {609, 940}, {610, 944}, {931, 1256}, {934, 1261}, {939, 1267}, {942, 1271}, {943, 1274}, {946, 1280}, {1260, 1509}, {1273, 1529}, {1276, 1534}, {1279, 1538}, {1533, 1703}, },
			{{-1, 607}, },
			{{-1, 608}, {604, 930}, {605, 933}, {606, 935}, {609, 941}, {610, 945}, {929, 1254}, {931, 1257}, {932, 1258}, {934, 1262}, {939, 1268}, {940, 1269}, {942, 1272}, {943, 1275}, {944, 1277}, {946, 1281}, {1256, 1505}, {1260, 1510}, {1261, 1511}, {1267, 1523}, {1271, 1527}, {1273, 1530}, {1274, 1531}, {1276, 1535}, {1279, 1539}, {1280, 1540}, {1509, 1666}, {1529, 1699}, {1533, 1704}, {1534, 1705}, {1538, 1709}, {1703, 1815}, },
			{{-1, 938}, {930, 1255}, {933, 1259}, {935, 1263}, {941, 1270}, {945, 1278}, {1254, 1503}, {1257, 1506}, {1258, 1507}, {1262, 1512}, {1268, 1524}, {1269, 1525}, {1272, 1528}, {1275, 1532}, {1277, 1536}, {1281, 1541}, {1505, 1662}, {1510, 1667}, {1511, 1668}, {1523, 1693}, {1527, 1697}, {1530, 1700}, {1531, 1701}, {1535, 1706}, {1539, 1710}, {1540, 1711}, {1666, 1761}, {1699, 1811}, {1704, 1816}, {1705, 1817}, {1709, 1820}, {1815, 1893}, },
			{{-1, 29}, {21, 76}, {22, 83}, {23, 89}, {25, 95}, {26, 99}, {27, 102}, {28, 104}, {30, 115}, {70, 183}, {71, 189}, {72, 194}, {73, 198}, {74, 201}, {75, 203}, {78, 210}, {79, 215}, {80, 219}, {81, 222}, {82, 224}, {85, 230}, {86, 234}, {87, 237}, {88, 239}, {92, 245}, {93, 248}, {94, 250}, {97, 254}, {98, 256}, {101, 259}, {108, 269}, {109, 276}, {110, 282}, {111, 287}, {112, 291}, {113, 294}, {114, 296}, {178, 376}, {179, 381}, {180, 385}, {181, 388}, {182, 390}, {185, 396}, {186, 400}, {187, 403}, {188, 405}, {191, 410}, {192, 413}, {193, 415}, {196, 419}, {197, 421}, {200, 424}, {206, 431}, {207, 435}, {208, 438}, {209, 440}, {212, 445}, {213, 448}, {214, 450}, {217, 454}, {218, 456}, {221, 459}, {227, 465}, {228, 468}, {229, 470}, {232, 474}, {233, 476}, {236, 479}, {243, 484}, {244, 486}, {247, 489}, {253, 493}, {263, 503}, {264, 509}, {265, 514}, {266, 518}, {267, 521}, {268, 523}, {271, 530}, {272, 535}, {273, 539}, {274, 542}, {275, 544}, {278, 550}, {279, 554}, {280, 557}, {281, 559}, {284, 564}, {285, 567}, {286, 569}, {289, 573}, {290, 575}, {293, 578}, {372, 672}, {373, 676}, {374, 679}, {375, 681}, {378, 686}, {379, 689}, {380, 691}, {383, 695}, {384, 697}, {387, 700}, {393, 706}, {394, 709}, {395, 711}, {398, 715}, {399, 717}, {402, 720}, {408, 725}, {409, 727}, {412, 730}, {418, 734}, {428, 741}, {429, 744}, {430, 746}, {433, 750}, {434, 752}, {437, 755}, {443, 760}, {444, 762}, {447, 765}, {453, 769}, {463, 775}, {464, 777}, {467, 780}, {473, 784}, {483, 789}, {498, 799}, {499, 804}, {500, 808}, {501, 811}, {502, 813}, {505, 819}, {506, 823}, {507, 826}, {508, 828}, {511, 833}, {512, 836}, {513, 838}, {516, 842}, {517, 844}, {520, 847}, {526, 854}, {527, 858}, {528, 861}, {529, 863}, {532, 868}, {533, 871}, {534, 873}, {537, 877}, {538, 879}, {541, 882}, {547, 888}, {548, 891}, {549, 893}, {552, 897}, {553, 899}, {556, 902}, {562, 907}, {563, 909}, {566, 912}, {572, 916}, {669, 1044}, {670, 1047}, {671, 1049}, {674, 1053}, {675, 1055}, {678, 1058}, {684, 1063}, {685, 1065}, {688, 1068}, {694, 1072}, {704, 1078}, {705, 1080}, {708, 1083}, {714, 1087}, {724, 1092}, {739, 1099}, {740, 1101}, {743, 1104}, {749, 1108}, {759, 1113}, {774, 1119}, {795, 1129}, {796, 1133}, {797, 1136}, {798, 1138}, {801, 1143}, {802, 1146}, {803, 1148}, {806, 1152}, {807, 1154}, {810, 1157}, {816, 1163}, {817, 1166}, {818, 1168}, {821, 1172}, {822, 1174}, {825, 1177}, {831, 1182}, {832, 1184}, {835, 1187}, {841, 1191}, {851, 1198}, {852, 1201}, {853, 1203}, {856, 1207}, {857, 1209}, {860, 1212}, {866, 1217}, {867, 1219}, {870, 1222}, {876, 1226}, {886, 1232}, {887, 1234}, {890, 1237}, {896, 1241}, {906, 1246}, {1042, 1384}, {1043, 1386}, {1046, 1389}, {1052, 1393}, {1062, 1398}, {1077, 1404}, {1098, 1411}, {1126, 1421}, {1127, 1424}, {1128, 1426}, {1131, 1430}, {1132, 1432}, {1135, 1435}, {1141, 1440}, {1142, 1442}, {1145, 1445}, {1151, 1449}, {1161, 1455}, {1162, 1457}, {1165, 1460}, {1171, 1464}, {1181, 1469}, {1196, 1476}, {1197, 1478}, {1200, 1481}, {1206, 1485}, {1216, 1490}, {1231, 1496}, {1265, 1520}, {1383, 1615}, {1419, 1625}, {1420, 1627}, {1423, 1630}, {1429, 1634}, {1439, 1639}, {1454, 1645}, {1475, 1652}, {1515, 1675}, {1516, 1679}, {1517, 1682}, {1518, 1684}, {1519, 1685}, {1521, 1692}, {1624, 1749}, {1671, 1768}, {1672, 1771}, {1673, 1773}, {1674, 1774}, {1676, 1778}, {1677, 1780}, {1678, 1781}, {1680, 1784}, {1681, 1785}, {1683, 1787}, {1687, 1794}, {1688, 1798}, {1689, 1801}, {1690, 1803}, {1691, 1804}, {1765, 1840}, {1766, 1842}, {1767, 1843}, {1769, 1846}, {1770, 1847}, {1772, 1849}, {1776, 1853}, {1777, 1854}, {1779, 1856}, {1783, 1859}, {1790, 1866}, {1791, 1869}, {1792, 1871}, {1793, 1872}, {1795, 1876}, {1796, 1878}, {1797, 1879}, {1799, 1882}, {1800, 1883}, {1802, 1885}, {1838, 1903}, {1839, 1904}, {1841, 1906}, {1845, 1909}, {1852, 1913}, {1863, 1920}, {1864, 1922}, {1865, 1923}, {1867, 1926}, {1868, 1927}, {1870, 1929}, {1874, 1933}, {1875, 1934}, {1877, 1936}, {1881, 1939}, {1902, 1948}, {1918, 1955}, {1919, 1956}, {1921, 1958}, {1925, 1961}, {1932, 1965}, {1954, 1972}, },
			{{-1, 63}, {656, 1025}, {660, 1032}, {1026, 1364}, {1028, 1366}, {1029, 1367}, {1033, 1374}, {1365, 1600}, {1368, 1603}, {1370, 1605}, {1372, 1606}, {1604, 1743}, },
			{{-1, 64}, {171, 365}, {662, 1034}, },
			{{-1, 1373}, {1374, 1609}, },
			{{-1, 663}, {1034, 1375}, },
			{{-1, 657}, {659, 1030}, },
			{{-1, 658}, {657, 1027}, {659, 1031}, {1030, 1369}, },
			{{-1, 65}, {59, 166}, {173, 367}, {664, 1036}, },
			{{-1, 66}, },
			{{-1, 7}, },
			{{-1, 36}, {40, 135}, },
			{{-1, 299}, {300, 581}, },
			{{-1, 37}, {36, 125}, {40, 136}, {135, 325}, },
			{{-1, 302}, {304, 582}, },
			{{-1, 303}, {33, 118}, },
			{{-1, 38}, {36, 126}, {37, 129}, {40, 137}, {125, 315}, {135, 326}, {136, 329}, {325, 593}, },
			{{-1, 306}, {308, 583}, },
			{{-1, 307}, {34, 120}, },
			{{-1, 39}, {36, 127}, {37, 130}, {38, 132}, {40, 138}, {125, 316}, {126, 318}, {129, 321}, {135, 327}, {136, 330}, {137, 332}, {315, 588}, {325, 594}, {326, 596}, {329, 599}, {593, 923}, },
			{{-1, 310}, {312, 585}, },
			{{-1, 311}, {35, 122}, },
			{{-1, 67}, {15, 49}, {35, 123}, {47, 153}, {48, 49}, {121, 309}, {122, 123}, {156, 49}, {312, 123}, {348, 619}, {349, 621}, {350, 623}, {617, 954}, {618, 619}, {620, 621}, {622, 623}, {957, 619}, {961, 621}, {965, 623}, },
			{{-1, 30}, {9, 40}, {44, 150}, {56, 163}, {59, 167}, {68, 176}, {117, 301}, {119, 305}, {151, 340}, {157, 343}, {158, 357}, {166, 362}, {174, 368}, {313, 586}, {334, 609}, {341, 612}, {359, 651}, {360, 652}, {361, 653}, {363, 659}, {364, 661}, {369, 666}, {584, 920}, {605, 934}, {610, 946}, {615, 950}, {667, 1040}, {927, 1252}, {943, 1276}, {958, 1286}, {962, 1288}, {966, 1290}, {1023, 1361}, {1024, 1362}, {1035, 1376}, {1037, 1378}, {1264, 1514}, {1265, 1521}, {1284, 1542}, {1377, 1610}, {1379, 1611}, {1380, 1612}, {1502, 1659}, {1613, 1746}, },
			{{-1, 146}, },
			{{-1, 149}, },
			{{-1, 156}, },
			{{-1, 161}, },
			{{-1, 949}, },
			{{-1, 953}, },
			{{-1, 957}, },
			{{-1, 961}, },
			{{-1, 965}, },
			{{-1, 300}, },
			{{-1, 304}, },
			{{-1, 308}, },
			{{-1, 312}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'machine', 'context', 'procedure'",
			"expecting: identifier literal",
			"expecting: EOF",
			"expecting: comment, 'refines', 'sees', 'variables', 'invariants', 'events', 'variant', 'end', 'algorithm', 'var'",
			"expecting: comment, 'end', 'extends', 'sets', 'constants', 'axioms'",
			"expecting: '('",
			"expecting: comment, at, ';', 'refines', 'sees', 'variables', 'invariants', 'theorem', 'events', 'variant', 'invariant', 'end', 'extends', 'sets', 'constants', 'axioms', 'any', where, 'with', then, 'do', 'algorithm', 'else', 'precondition', 'postcondition', 'implementation', 'typing', 'var', 'type', 'init', identifier literal",
			"expecting: at, 'theorem'",
			"expecting: 'ordinary', 'convergent', 'anticipated', 'event'",
			"expecting: formula",
			"expecting: at, 'assert', 'assign', 'return', 'while', 'if', identifier literal",
			"expecting: 'sees', 'variables', 'invariants', 'events', 'variant', 'end', 'algorithm', 'var'",
			"expecting: 'variables', 'invariants', 'events', 'variant', 'end', 'algorithm', 'var'",
			"expecting: 'variables', 'invariants', 'events', 'variant', 'end', 'algorithm'",
			"expecting: ';', 'variables', 'invariants', 'events', 'variant', 'end', 'algorithm'",
			"expecting: 'invariants', 'events', 'variant', 'end', 'algorithm'",
			"expecting: 'events', 'variant', 'end', 'algorithm'",
			"expecting: 'events', 'end', 'algorithm'",
			"expecting: 'end', 'algorithm'",
			"expecting: 'end'",
			"expecting: 'end', 'sets', 'constants', 'axioms'",
			"expecting: 'end', 'constants', 'axioms'",
			"expecting: 'end', 'axioms'",
			"expecting: ')', primitive, identifier literal",
			"expecting: 'sees', 'variables', 'invariants', 'events', 'variant', 'end', 'algorithm', 'var', identifier literal",
			"expecting: 'variables', 'invariants', 'events', 'variant', 'end', 'algorithm', 'precondition', 'typing', 'var', identifier literal",
			"expecting: comment, 'invariants', 'events', 'variant', 'end', 'algorithm', identifier literal",
			"expecting: 'invariants', 'events', 'variant', 'end', 'algorithm', identifier literal",
			"expecting: label",
			"expecting: at",
			"expecting: at, 'theorem', 'events', 'variant', 'end', 'algorithm'",
			"expecting: 'event'",
			"expecting: 'ordinary', 'convergent', 'anticipated', 'end', 'event', 'algorithm'",
			"expecting: comment, 'events', 'end', 'algorithm'",
			"expecting: ':'",
			"expecting: comment, ';', 'end', 'else', identifier literal",
			"expecting: comment, ',', ')', ';', bcmeq, 'end', 'else'",
			"expecting: ';', 'end', 'else'",
			"expecting: bcmeq",
			"expecting: comment, 'type'",
			"expecting: 'var'",
			"expecting: 'end', 'sets', 'constants', 'axioms', identifier literal",
			"expecting: comment, 'end', 'constants', 'axioms', identifier literal",
			"expecting: 'end', 'constants', 'axioms', identifier literal",
			"expecting: comment, 'end', 'axioms', identifier literal",
			"expecting: 'end', 'axioms', identifier literal",
			"expecting: at, 'theorem', 'end'",
			"expecting: '=>'",
			"expecting: comment, ',', ')', 'sees', 'precondition', 'typing'",
			"expecting: ')'",
			"expecting: comment, at, 'theorem', 'events', 'variant', 'end', 'algorithm'",
			"expecting: comment, 'refines', 'end', 'extends', 'any', where, 'with', then",
			"expecting: comment, ';', 'end', 'else'",
			"expecting: comment, at, 'theorem', 'end'",
			"expecting: comment, 'sees', 'precondition', 'typing', primitive, identifier literal",
			"expecting: primitive, identifier literal",
			"expecting: 'end', 'any', where, 'with', then",
			"expecting: 'end', where, 'with', then",
			"expecting: 'end', 'with', then",
			"expecting: 'end', then",
			"expecting: comment, 'variant', 'invariant', 'do'",
			"expecting: comment, then",
			"expecting: comment, ')', ';', bcmeq, 'end', 'else'",
			"expecting: comment, 'init'",
			"expecting: 'precondition', 'typing'",
			"expecting: comment, 'sees', 'precondition', 'typing'",
			"expecting: 'precondition'",
			"expecting: 'postcondition'",
			"expecting: comment, ')', 'sees', 'precondition', 'typing'",
			"expecting: 'end', 'any', where, 'with', then, identifier literal",
			"expecting: comment, 'end', where, 'with', then, identifier literal",
			"expecting: 'end', where, 'with', then, identifier literal",
			"expecting: at, 'theorem', 'end', 'with', then",
			"expecting: at, 'end', then",
			"expecting: at, 'end'",
			"expecting: 'variant', 'do'",
			"expecting: 'do'",
			"expecting: 'end', 'else'",
			"expecting: ')', identifier literal",
			"expecting: comment, 'postcondition'",
			"expecting: 'implementation'",
			"expecting: comment, at, 'theorem', 'end', 'with', then",
			"expecting: comment, at, 'end', then",
			"expecting: comment, at, 'end'",
			"expecting: comment, 'do'",
			"expecting: comment, 'variant', 'do'",
			"expecting: comment, ';', 'variables', 'invariants', 'events', 'variant', 'end', 'algorithm'",
			"expecting: comment, 'implementation'",
			"expecting: comment, 'variables', 'invariants', 'events', 'variant', 'algorithm', 'var'",
			"expecting: comment, 'precondition', 'typing'",
			"expecting: 'variables', 'invariants', 'events', 'variant', 'algorithm'",
			"expecting: 'invariants', 'events', 'variant', 'algorithm'",
			"expecting: 'events', 'variant', 'algorithm'",
			"expecting: 'events', 'algorithm'",
			"expecting: 'algorithm'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 1, 1, 2, 2, 2, 2, 3, 4, 5, 6, 1, 1, 1, 7, 8, 9, 2, 10, 1, 11, 12, 13, 14, 15, 16, 17, 18, 19, 3, 2, 1, 1, 1, 7, 20, 21, 22, 19, 4, 23, 24, 25, 26, 27, 28, 29, 30, 9, 31, 31, 31, 1, 32, 31, 33, 34, 34, 35, 34, 34, 36, 19, 37, 38, 36, 9, 39, 2, 12, 13, 15, 16, 17, 18, 19, 2, 13, 15, 16, 17, 18, 19, 2, 15, 16, 17, 18, 19, 40, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 6, 2, 11, 12, 13, 15, 16, 17, 18, 19, 41, 42, 43, 44, 45, 29, 46, 9, 2, 21, 22, 19, 2, 22, 19, 2, 19, 2, 2, 20, 21, 22, 19, 47, 1, 48, 49, 48, 24, 24, 24, 25, 25, 25, 26, 26, 9, 9, 30, 30, 30, 50, 51, 32, 32, 32, 1, 33, 9, 9, 52, 52, 9, 9, 19, 10, 1, 1, 52, 9, 39, 2, 13, 15, 16, 17, 18, 19, 2, 15, 16, 17, 18, 19, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 15, 16, 17, 18, 19, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 13, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 12, 13, 15, 16, 17, 18, 19, 2, 13, 15, 16, 17, 18, 19, 2, 15, 16, 17, 18, 19, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 41, 41, 41, 42, 43, 43, 43, 44, 45, 45, 45, 9, 46, 46, 46, 53, 2, 22, 19, 2, 19, 2, 2, 19, 2, 2, 2, 21, 22, 19, 2, 22, 19, 2, 19, 2, 54, 48, 47, 55, 24, 25, 26, 50, 30, 50, 1, 32, 1, 1, 7, 29, 29, 56, 56, 57, 58, 59, 19, 51, 32, 51, 52, 52, 52, 60, 61, 37, 5, 62, 52, 63, 9, 2, 15, 16, 17, 18, 19, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 13, 15, 16, 17, 18, 19, 2, 15, 16, 17, 18, 19, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 15, 16, 17, 18, 19, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 41, 43, 45, 53, 46, 53, 2, 19, 2, 2, 2, 2, 22, 19, 2, 19, 2, 2, 19, 2, 2, 9, 1, 64, 65, 66, 64, 67, 65, 54, 68, 50, 69, 56, 70, 71, 29, 72, 9, 73, 9, 74, 9, 32, 57, 58, 59, 19, 32, 58, 59, 19, 32, 59, 19, 32, 19, 32, 32, 56, 57, 58, 59, 19, 32, 56, 57, 58, 59, 19, 51, 52, 52, 9, 9, 10, 75, 76, 60, 10, 61, 10, 77, 78, 9, 63, 63, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 15, 16, 17, 18, 19, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 53, 2, 2, 19, 2, 2, 2, 79, 34, 66, 67, 64, 66, 67, 65, 67, 66, 9, 80, 64, 66, 67, 64, 65, 66, 67, 65, 69, 69, 69, 70, 71, 71, 71, 9, 72, 72, 72, 81, 73, 73, 73, 82, 74, 74, 74, 83, 32, 58, 59, 19, 32, 59, 19, 32, 19, 32, 32, 59, 19, 32, 19, 32, 32, 19, 32, 32, 32, 57, 58, 59, 19, 32, 58, 59, 19, 32, 59, 19, 32, 19, 32, 32, 57, 58, 59, 19, 32, 58, 59, 19, 32, 59, 19, 32, 19, 32, 32, 56, 57, 58, 59, 19, 84, 85, 19, 10, 76, 10, 10, 75, 76, 77, 10, 37, 52, 49, 86, 9, 9, 63, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 2, 16, 17, 18, 19, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 79, 9, 67, 80, 66, 67, 67, 80, 64, 66, 67, 80, 87, 88, 19, 66, 67, 67, 80, 66, 67, 64, 66, 67, 65, 67, 80, 64, 66, 67, 69, 71, 81, 72, 81, 73, 82, 74, 83, 32, 59, 19, 32, 19, 32, 32, 19, 32, 32, 32, 19, 32, 32, 32, 32, 58, 59, 19, 32, 59, 19, 32, 19, 32, 32, 59, 19, 32, 19, 32, 32, 19, 32, 32, 32, 58, 59, 19, 32, 59, 19, 32, 19, 32, 32, 59, 19, 32, 19, 32, 32, 19, 32, 32, 32, 57, 58, 59, 19, 32, 58, 59, 19, 32, 59, 19, 32, 19, 32, 84, 85, 37, 19, 10, 19, 19, 10, 76, 10, 37, 10, 19, 77, 77, 52, 52, 86, 86, 86, 9, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 2, 2, 17, 18, 19, 2, 18, 19, 2, 19, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 89, 80, 19, 67, 80, 80, 19, 66, 67, 67, 80, 19, 87, 90, 91, 92, 93, 94, 19, 88, 2, 67, 80, 80, 19, 67, 80, 66, 67, 67, 80, 64, 66, 67, 80, 19, 66, 67, 67, 80, 81, 32, 19, 32, 32, 32, 32, 32, 59, 19, 32, 19, 32, 32, 19, 32, 32, 32, 19, 32, 32, 32, 32, 59, 19, 32, 19, 32, 32, 19, 32, 32, 32, 19, 32, 32, 32, 32, 58, 59, 19, 32, 59, 19, 32, 19, 32, 32, 59, 19, 32, 19, 32, 32, 19, 32, 32, 37, 19, 37, 37, 19, 10, 19, 19, 37, 37, 19, 52, 86, 86, 86, 2, 19, 2, 2, 2, 2, 2, 2, 2, 2, 18, 19, 2, 19, 2, 2, 19, 2, 2, 2, 19, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 2, 19, 2, 2, 2, 2, 2, 2, 89, 19, 2, 80, 19, 19, 2, 67, 80, 80, 19, 2, 91, 92, 93, 94, 19, 92, 93, 94, 19, 93, 94, 19, 94, 19, 19, 19, 90, 91, 92, 93, 94, 19, 80, 19, 19, 2, 80, 19, 67, 80, 80, 19, 66, 67, 67, 80, 19, 2, 67, 80, 80, 19, 32, 32, 19, 32, 32, 32, 32, 32, 19, 32, 32, 32, 32, 32, 59, 19, 32, 19, 32, 32, 19, 32, 32, 32, 19, 32, 32, 32, 37, 37, 19, 37, 37, 86, 2, 2, 19, 2, 2, 2, 2, 2, 2, 2, 2, 19, 2, 2, 80, 19, 19, 2, 92, 93, 94, 19, 93, 94, 19, 94, 19, 19, 19, 93, 94, 19, 94, 19, 19, 19, 94, 19, 19, 19, 19, 19, 19, 91, 92, 93, 94, 19, 92, 93, 94, 19, 93, 94, 19, 94, 19, 19, 19, 19, 2, 2, 19, 2, 80, 19, 19, 2, 67, 80, 80, 19, 2, 80, 19, 19, 2, 32, 32, 32, 19, 32, 32, 32, 32, 37, 2, 2, 19, 2, 2, 93, 94, 19, 94, 19, 19, 19, 94, 19, 19, 19, 19, 19, 19, 94, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 92, 93, 94, 19, 93, 94, 19, 94, 19, 19, 19, 93, 94, 19, 94, 19, 19, 19, 94, 19, 19, 19, 19, 19, 19, 2, 2, 19, 2, 2, 80, 19, 19, 2, 19, 2, 2, 32, 2, 94, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 93, 94, 19, 94, 19, 19, 19, 94, 19, 19, 19, 19, 19, 19, 94, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 2, 19, 2, 2, 2, 19, 19, 19, 19, 19, 19, 94, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 2, 19, 19, 19, 19, 19, 19, 19, 19, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            Parser.actionTable = new int[length][][];
            for(int i = 0; i < Parser.actionTable.length; i++)
            {
                length = s.readInt();
                Parser.actionTable[i] = new int[length][3];
                for(int j = 0; j < Parser.actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    Parser.actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
